<?php

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_plugins', 'cptn_po_assistant_get_plugins' );
add_action( 'wp_ajax_cptn_po_assistant_get_plugins', 'cptn_po_assistant_get_plugins' );
function cptn_po_assistant_get_plugins()
{
    global  $wpdb ;
    $query = "SELECT option_name, option_value FROM " . $wpdb->prefix . "options WHERE option_name LIKE 'cptn_%'";
    $options = $wpdb->get_results( $query, ARRAY_A );
    $output = array();
    // get all plugins
    $query = "SELECT pluginname, pluginslug, fullpluginslug, mailcategory, mailcatfull FROM " . $wpdb->prefix . "cptn_po_plugin_mailcategory";
    $output["cptn_po_plugins"] = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $output["cptn_po_plugins"] as $key => $value ) {
        $output["cptn_po_plugins"][$key]['mailcatfull'] = htmlspecialchars_decode( esc_html__( $output["cptn_po_plugins"][$key]['mailcatfull'], "campation-postoffice" ) );
    }
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_toggle_info_developer', 'cptn_po_assistant_toggle_info_developer' );
add_action( 'wp_ajax_cptn_po_assistant_toggle_info_developer', 'cptn_po_assistant_toggle_info_developer' );
function cptn_po_assistant_toggle_info_developer()
{
    update_option( "cptn_po_opt_info_developer", intval( $_POST['status'] ) );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_toggle_delete_data', 'cptn_po_assistant_toggle_delete_data' );
add_action( 'wp_ajax_cptn_po_assistant_toggle_delete_data', 'cptn_po_assistant_toggle_delete_data' );
function cptn_po_assistant_toggle_delete_data()
{
    update_option( "cptn_po_opt_delete_data_uninstall", intval( $_POST['status'] ) );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_dns', 'cptn_po_assistant_get_dns' );
add_action( 'wp_ajax_cptn_po_assistant_get_dns', 'cptn_po_assistant_get_dns' );
function cptn_po_assistant_get_dns()
{
    global  $wpdb ;
    $output = "";
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE status = 1";
    if ( intval( get_option( "cptn_po_opt_domain_protect" ) ) != 1 ) {
        $query .= " AND id=1";
    }
    $domains = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $domains as $domain ) {
        $output .= '<tr class="cptn_po_assistant_dns_row"><td style="width:16%;">' . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . '<br><br><br><center><a href="' . CPTNPOPATH . 'bind-dns/BIND-DNS-' . $domain['domain'] . '.txt" download="BIND-DNS-' . $domain['domain'] . '.txt"><button type="button" class="button bind-zone-file-button" title="' . esc_attr__( "Download a BIND zone file for upload into your DNS", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "BIND zone file", "campation-postoffice" ) ) . '</button></a></center></td>';
        // MX
        
        if ( $domain['mx_record'] ) {
            $mx_recommendation = '<span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . htmlspecialchars_decode( esc_html__( "MX record found", "campation-postoffice" ) ) . '</u></span>';
        } else {
            $mx_recommendation = '<div id="copy_mx_' . esc_attr( $domain['id'] ) . '" style="background-color:#555;color:white;padding:5px;max-width:100%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;">' . esc_html( get_option( "cptn_po_opt_envelope_account_server" ) ) . ' [10]</div>
		                      <center><button type="button" class="button cptn-copy-button" data-copy="copy_mx_' . esc_attr( $domain['id'] ) . '" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "COPY", "campation-postoffice" ) ) . '</button></center>';
        }
        
        
        if ( !empty(htmlspecialchars_decode( esc_html( $domain['mx_record'] ) )) ) {
            $found = htmlspecialchars_decode( esc_html( $domain['mx_record'] ) );
        } else {
            $found = '<span id="cptn-po-mx-not-found" style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '<td style="width:21%;font-size:12px;">
					 <table cellspacing="2" width="100%" style="table-layout: fixed;">
						<tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "Name", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td valign="top" style="max-width:80%;"><strong>' . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . '</strong></td></tr>
					    <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "found", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . esc_attr__( $domain['mx_record'] ) . '" style="max-width:80%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;" valign="top"><strong>' . $found . '</strong></td></tr>
					    <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html_x( "set to", "assistant", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td valign="top" style="max-width:80%;">' . htmlspecialchars_decode( esc_html( $mx_recommendation ) ) . '</td></tr>
					 </table>	 
                  </td>
      ';
        // SPF
        
        if ( cptn_po_clean_dns_record( $domain['spf_record'] ) == cptn_po_clean_dns_record( $domain['spf_recommendation'] ) and !empty($domain['spf_record']) ) {
            $spf_recommendation = '<span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . htmlspecialchars_decode( esc_html__( "SPF record is correct", "campation-postoffice" ) ) . '</u></span>';
        } else {
            $spf_recommendation = '<div id="copy_spf_' . esc_attr( $domain['id'] ) . '" style="background-color:#555;color:white;padding:5px;max-width:100%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;">' . $domain['spf_recommendation'] . '</div><center><button type="button" class="button cptn-copy-button" data-copy="copy_spf_' . esc_attr( $domain['id'] ) . '" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "COPY", "campation-postoffice" ) ) . '</button></center>';
        }
        
        
        if ( !empty(htmlspecialchars_decode( esc_html( $domain['spf_record'] ) )) ) {
            $found = htmlspecialchars_decode( esc_html( $domain['spf_record'] ) );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '<td style="width:21%;font-size:12px;">
					 <table cellspacing="2" width="100%" style="table-layout: fixed;">
						<tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "Name", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td valign="top" style="max-width:80%;"><strong>' . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . '</strong></td></tr>
					    <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "found", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . esc_attr( $domain['spf_record'] ) . '" style="max-width:80%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;" valign="top"><strong>' . $found . '</strong></td></tr>
					    <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html_x( "set to", "assistant", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . $domain['spf_recommendation'] . '" valign="top" style="max-width:80%;">' . $spf_recommendation . '</td></tr>
					 </table>	 
                  </td>
      ';
        // DMARC
        
        if ( cptn_po_clean_dns_record( $domain['dmarc_record'] ) == cptn_po_clean_dns_record( $domain['dmarc_recommendation'] ) and !empty($domain['dmarc_record']) ) {
            $dmarc_recommendation = '<span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . htmlspecialchars_decode( esc_html__( "DMARC record is correct", "campation-postoffice" ) ) . '</u></span>';
        } else {
            $dmarc_recommendation = '<div id="copy_dmarc_' . esc_attr( $domain['id'] ) . '" style="background-color:#555;color:white;padding:5px;max-width:100%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;">' . htmlspecialchars_decode( esc_html( $domain['dmarc_recommendation'] ) ) . '</div><center><button type="button" class="button cptn-copy-button" data-copy="copy_dmarc_' . esc_attr( $domain['id'] ) . '" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "COPY", "campation-postoffice" ) ) . '</button></center>';
        }
        
        
        if ( !empty(htmlspecialchars_decode( esc_html( $domain['dmarc_record'] ) )) ) {
            $found = htmlspecialchars_decode( esc_html( $domain['dmarc_record'] ) );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '<td style="width:21%;font-size:12px;">
					 <table cellspacing="2" width="100%" style="table-layout: fixed;">
						<tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "Name", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="_dmarc.' . esc_attr( $domain['domain'] ) . '" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;"><strong>_dmarc.' . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . '</strong></td></tr>
					    <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "found", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . esc_attr( $domain['dmarc_record'] ) . '" style="max-width:80%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;" valign="top"><strong>' . $found . '</strong></td></tr>
					    <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html_x( "set to", "assistant", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . esc_attr( $domain['dmarc_recommendation'] ) . '" valign="top" style="max-width:80%;">' . htmlspecialchars_decode( esc_html( $dmarc_recommendation ) ) . '</td></tr>
					 </table>	 
                  </td>
      ';
        // DKIM policy
        $output .= '<td style="width:21%;font-size:12px;">';
        
        if ( cptn_po_clean_dns_record( $domain['dkim_policy'] ) == cptn_po_clean_dns_record( $domain['dkim_policy_recommendation'] ) and !empty($domain['dkim_policy']) ) {
            $dkim_policy_recommendation = '<span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . htmlspecialchars_decode( esc_html__( "DKIM policy record is correct", "campation-postoffice" ) ) . '</u></span>';
        } else {
            $dkim_policy_recommendation = '<div id="copy_dkim_policy_' . esc_attr( $domain['id'] ) . '" style="background-color:#555;color:white;padding:5px;max-width:100%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;">' . htmlspecialchars_decode( esc_html( $domain['dkim_policy_recommendation'] ) ) . '</div><center><button type="button" class="button cptn-copy-button" data-copy="copy_dkim_policy_' . esc_attr( $domain['id'] ) . '" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "COPY", "campation-postoffice" ) ) . '</button></center>';
        }
        
        
        if ( !empty(htmlspecialchars_decode( esc_html( $domain['dkim_policy'] ) )) ) {
            $found = htmlspecialchars_decode( esc_html( $domain['dkim_policy'] ) );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '<table cellspacing="2" width="100%" style="table-layout: fixed;">
				     <tr><td valign="top" style="width:15%;">' . esc_html__( "Type", "campation-postoffice" ) . '</td><td style="width:5%;">&nbsp;</td><td title="DKIM policy" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;overflow-wrap:break-word;"><strong>DKIM policy</strong></td></tr>
					 <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "Name", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="_domainkey.' . esc_attr( $domain['domain'] ) . '" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;"><strong>_domainkey.' . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . '</strong></td></tr>
					 <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html__( "found", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . esc_attr( $domain['dkim_policy'] ) . '" style="max-width:80%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;" valign="top"><strong>' . $found . '</strong></td></tr>
					 <tr><td valign="top" style="width:15%;">' . htmlspecialchars_decode( esc_html_x( "set to", "assistant", "campation-postoffice" ) ) . '</td><td style="width:5%;">&nbsp;</td><td title="' . esc_attr( $domain['dkim_policy_recommendation'] ) . '" valign="top" style="max-width:80%;">' . htmlspecialchars_decode( esc_html( $dkim_policy_recommendation ) ) . '</td></tr>
				  </table>
				  <hr>	 
      ';
        // DKIM selectors
        $query = "SELECT sdm.*, ms.address, ms.server_type \r\n\t              FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm \r\n\t             INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdm.mailserver_id \r\n\t\t\t\t WHERE sdm.domain_id = " . intval( $domain['id'] ) . "\r\n\t\t\t\t   ";
        $servers = $wpdb->get_results( $query, ARRAY_A );
        $servercount = 1;
        foreach ( $servers as $server ) {
            
            if ( !empty($server['dkim_record']) and cptn_po_clean_dns_record( $server['dkim_record'] ) == cptn_po_clean_dns_record( $server['dkim_recommendation'] ) ) {
                $dkim_recommendation = '<span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . htmlspecialchars_decode( esc_html__( "DKIM selector record is correct", "campation-postoffice" ) ) . '</u></span>';
            } else {
                $dkim_recommendation = '<div id="copy_dkim_' . esc_attr( $domain['id'] ) . '_' . esc_attr( $server['id'] ) . '" style="background-color:#555;color:white;padding:5px;max-width:100%;overflow:hidden;text-overflow:ellipsis; white-space: nowrap;">' . htmlspecialchars_decode( esc_html( $server['dkim_recommendation'] ) ) . '</div><center><button type="button" class="button cptn-copy-button" data-copy="copy_dkim_' . esc_attr( $domain['id'] ) . '_' . esc_attr( $server['id'] ) . '" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "COPY", "campation-postoffice" ) ) . '</button></center>';
            }
            
            if ( $servercount > 1 ) {
                $output .= "<hr>" . PHP_EOL;
            }
            
            if ( !empty(esc_html( $server['dkim_record'] )) ) {
                $found = esc_html( $server['dkim_record'] );
            } else {
                $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
            }
            
            $selector = '<span style="color:#aa0000;font-weight:bold;">???????</span>';
            $selectortitle = '???????';
            
            if ( $server['dkim_selector'] ) {
                $selector = esc_attr( $server['dkim_selector'] );
                $selectortitle = esc_attr( $server['dkim_selector'] );
            }
            
            $output .= '<table cellspacing="2" width="100%" style="table-layout: fixed;">
						<tr>
						   <td valign="top" style="width:15%;">' . esc_html__( "Server", "campation-postoffice" ) . '</td>
						   <td style="width:5%;">&nbsp;</td>
						   <td title="' . esc_attr( $server['address'] . ' (' . $server['server_type'] ) . ')" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;overflow-wrap:break-word;"><strong>' . esc_html( $server['address'] ) . '</strong> (<i>' . esc_html( strtoupper( $server['server_type'] ) ) . '</i>)</td>
						</tr>
						<tr>
						   <td valign="top" style="width:15%;">' . esc_html__( "Name", "campation-postoffice" ) . '</td>
						   <td style="width:5%;">&nbsp;</td>
						   <td title="' . $selectortitle . '._domainkey.' . esc_attr( $domain['domain'] ) . '" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;overflow-wrap:break-word;"><strong>' . $selector . '._domainkey.' . esc_html( $domain['domain'] ) . '</strong></td>
						</tr>
					    <tr>
						   <td valign="top" style="width:15%;">' . esc_html__( "found", "campation-postoffice" ) . '</td>
						   <td style="width:5%;">&nbsp;</td>
						   <td title="' . esc_attr( str_replace( '"', "", str_replace( "'", "", str_replace( " ", "", $server['dkim_record'] ) ) ) ) . '" style="max-width:80%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;overflow-wrap:break-word;" valign="top"><strong>' . $found . '</strong></td>
						</tr>
						';
            
            if ( $server['server_type'] != "smtp" ) {
                $output .= '<tr>
			 		       <td valign="top" style="width:15%;">' . esc_html_x( "set to", "assistant", "campation-postoffice" ) . '</td>
						   <td style="width:5%;">&nbsp;</td>
						   <td title="' . esc_attr( str_replace( '"', "", str_replace( "'", "", str_replace( " ", "", $server['dkim_recommendation'] ) ) ) ) . '" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;overflow-wrap:break-word;">' . htmlspecialchars_decode( esc_html( $dkim_recommendation ) ) . '</td>
					   </tr>
						';
            } else {
                $output .= '<tr>
			 		       <td valign="top" colspan="3" title="' . htmlspecialchars_decode( esc_html__( "No recommendation for external SMTP server", "campation-postoffice" ) ) . '" valign="top" style="max-width:80%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;overflow-wrap:break-word;"><i>' . htmlspecialchars_decode( esc_html__( "No recommendation for external SMTP server", "campation-postoffice" ) ) . '</i></td>
					   </tr>
						';
            }
            
            $output .= '</table>
					 ';
            $servercount++;
        }
        $output .= '</td>';
    }
    $output .= '</tr>';
    $output .= '<tr class="cptn_po_assistant_dns_row"><td colspan="5"><hr></td></tr>';
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_rdns', 'cptn_po_assistant_get_rdns' );
add_action( 'wp_ajax_cptn_po_assistant_get_rdns', 'cptn_po_assistant_get_rdns' );
function cptn_po_assistant_get_rdns()
{
    global  $wpdb ;
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver WHERE status = 1";
    $servers = $wpdb->get_results( $query, ARRAY_A );
    $output = "";
    foreach ( $servers as $server ) {
        $output .= '<tr><td>' . htmlspecialchars_decode( esc_html( $server['shortname'] ) ) . '</td><td align="center">' . htmlspecialchars_decode( esc_html( strtoupper( $server['server_type'] ) ) ) . '</td>';
        
        if ( $server['rdns'] == 1 ) {
            $output .= '<td align="center"><span style="color:darkgreen;font-weight:bold;">&#10004;</span></td><td>' . esc_attr__( "has a FQDN and rDNS record - the basic requirement for successful e-mail delivery", "campation-postoffice" ) . '</td>';
        } else {
            $output .= '<td align="center"><span style="color:#aa0000;font-weight:bold;">&#10007;</span></td><td>' . esc_attr__( "FQDN / rDNS record is missing - emails might go to spam", "campation-postoffice" ) . '</td>';
        }
        
        $output .= '</tr>';
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_recheck_dns', 'cptn_po_assistant_recheck_dns' );
add_action( 'wp_ajax_cptn_po_assistant_recheck_dns', 'cptn_po_assistant_recheck_dns' );
function cptn_po_assistant_recheck_dns()
{
    global  $wpdb ;
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE status = 1";
    if ( intval( get_option( "cptn_po_opt_domain_protect" ) ) != 1 ) {
        $query .= " AND id=1";
    }
    $domains = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $domains as $domain ) {
        echo  wp_kses_post( cptn_po_sender_check( $domain['id'] ) ) ;
    }
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_check_mailserver', 'cptn_po_assistant_get_check_mailserver' );
add_action( 'wp_ajax_cptn_po_assistant_get_check_mailserver', 'cptn_po_assistant_get_check_mailserver' );
function cptn_po_assistant_get_check_mailserver()
{
    global  $wpdb ;
    // get all mail server
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver WHERE status = 1";
    $mailservers = $wpdb->get_results( $query, ARRAY_A );
    $output = "";
    foreach ( $mailservers as $mailserver ) {
        $status = '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>';
        
        if ( $mailserver['connectable'] == 1 ) {
            
            if ( $mailserver['rdns'] == 1 and ($mailserver['test_mail_success'] or $mailserver['id'] > 0) ) {
                $status = '<span style="color:green;font-weight:bold;">&#10004;</span>';
                $result = htmlspecialchars_decode( esc_html__( "This mail server is perfectly configured for high email delivery performance!", "campation-postoffice" ) );
            } elseif ( $mailserver['rdns'] == 0 and ($mailserver['test_mail_success'] or $mailserver['id'] > 0) ) {
                $status = '<span style="color:#aa0000;font-weight:bold;">&#x3f;</span>';
                $result = htmlspecialchars_decode( esc_html__( "This mail server is ready to use but does not have a FQDN / rDNS record (reverse lookup) - this has a high risk of emails from this server being blocked or marked as spam - please contact your administrator", "campation-postoffice" ) );
            } else {
                $status = '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>';
                $result = htmlspecialchars_decode( esc_html__( "This mail server is connectable but <strong>not able to send emails through the operating system</strong> which is required for Campation SpeedMail&trade; - probably the generic wp_mail() function is blocked for your WordPress - please contact your administrator", "campation-postoffice" ) );
            }
        
        } else {
            $result = htmlspecialchars_decode( esc_html__( "This mail server is not connectable or cannot send emails", "campation-postoffice" ) );
        }
        
        $output .= '<tr class="cptn_po_assistant_check_row"><td valign="top">' . htmlspecialchars_decode( esc_html( $mailserver['shortname'] ) ) . '</td><td valign="top">' . strtoupper( $mailserver['server_type'] ) . '</td><td valign="top" align="center">' . wp_kses_post( $status ) . '</td><td valign="top">' . htmlspecialchars_decode( esc_html( $result ) ) . '</td></tr>' . PHP_EOL;
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_check_email', 'cptn_po_assistant_get_check_email' );
add_action( 'wp_ajax_cptn_po_assistant_get_check_email', 'cptn_po_assistant_get_check_email' );
function cptn_po_assistant_get_check_email()
{
    global  $wpdb ;
    // get all email addresses
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain \r\n              WHERE status = 1";
    
    if ( intval( get_option( "cptn_po_opt_domain_protect" ) ) != 1 or !cptn_po_fs()->is_plan( 'business' ) ) {
        $query .= " AND id=1";
    } else {
        $query .= " AND (id=1 OR mailcategory>'')";
    }
    
    $domains = $wpdb->get_results( $query, ARRAY_A );
    $emails = array();
    $output = "";
    // system addresses
    foreach ( $domains as $domain ) {
        $emails[$domain['envelope_address']] = $domain['envelope_address'];
        $emails[$domain['unsubscribe_address']] = $domain['unsubscribe_address'];
        $emails[$domain['dmarc_address']] = $domain['dmarc_address'];
    }
    $emails = array_unique( $emails );
    asort( $emails );
    foreach ( $emails as $email ) {
        // send email to one address
        $content = '<p><center>' . htmlspecialchars_decode( esc_html__( "This is a test email sent by Campation PostOffice&trade; setup wizard", "campation-postoffice" ) ) . '</center></p><br><br> ' . PHP_EOL;
        $content = '<center><img src="' . CPTNPOPATH . 'img/campation-postoffice-logo-mail.png"><br><br>' . wp_kses_post( $content ) . '</center>';
        $content = '<body style="margin:20px auto;width:90%;">' . $content . '</body>';
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE id=1";
        $domain = $wpdb->get_row( $query, ARRAY_A );
        $headers = "From: Campation PostOffice (" . mb_encode_mimeheader( trim( $domain['domain'] ) ) . ") <" . sanitize_email( $domain['from_address'] ) . ">" . PHP_EOL;
        $headers .= "MIME-Version: 1.0" . PHP_EOL;
        $headers .= "Content-Transfer-Encoding: 8bit" . PHP_EOL;
        $headers .= "Content-Type: text/html; charset=utf-8" . PHP_EOL;
        $headers .= "Return-Path: " . sanitize_email( $domain['envelope_address'] ) . PHP_EOL;
        $subject = htmlspecialchars_decode( esc_html__( 'Campation PostOffice Test Email from', "campation-postoffice" ) ) . " " . sanitize_email( $domain['from_address'] );
        $randomstring = preg_replace( "/[^a-zA-Z0-9]+/", "", substr( str_shuffle( str_repeat( implode( '', range( '!', 'z' ) ), 30 ) ), 0, 30 ) );
        $phpmailresult = cptn_po_mail(
            $email,
            "Campation PostOffice Test Email -> " . esc_html( $email ) . " (#" . esc_html( $randomstring ) . "#)",
            wp_kses_post( $content ),
            $headers,
            array(),
            "test",
            esc_html__( "Setup wizard", "campation-postoffice" )
        );
        
        if ( $phpmailresult ) {
            $output .= '<tr class="cptn_po_assistant_check_row"><td valign="top">' . esc_html( $email ) . ' <small>[system]</small></td><td class="cptn_po_assistant_check_email_status" data-email="' . esc_attr( $email ) . '" data-emailtype="system" data-emailrandom="' . esc_attr( $randomstring ) . '" data-process="start" valign="top" align=center><img src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/cptn-spinner.svg" height=25></td><td class="cptn_po_assistant_check_email_result" data-email="' . esc_attr( $email ) . '" valign="top">' . htmlspecialchars_decode( esc_html__( "sending and receiving test email - system IMAP account", "campation-postoffice" ) ) . '</td></tr>' . PHP_EOL;
        } else {
            $output .= '<tr class="cptn_po_assistant_check_row"><td valign="top">' . esc_html( $email ) . ' <small>[system]</small></td><td class="cptn_po_assistant_check_email_status" data-email="' . esc_attr( $email ) . '" data-emailtype="system" data-emailrandom="' . esc_attr( $randomstring ) . '" data-process="done" valign="top" align=center><img src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/cptn-spinner.svg" height=25></td><td class="cptn_po_assistant_check_email_result" data-email="' . esc_attr( $email ) . '" valign="top">' . htmlspecialchars_decode( esc_html__( "mail sending error", "campation-postoffice" ) ) . '</td></tr>' . PHP_EOL;
        }
    
    }
    // contact addresses
    $emails = array();
    foreach ( $domains as $domain ) {
        $emails[$domain['from_address']] = $domain['from_address'];
        $emails[$domain['replyto_address']] = $domain['replyto_address'];
    }
    $emails = array_unique( $emails );
    asort( $emails );
    foreach ( $emails as $email ) {
        // send email to one address
        $content = '<p><center>' . htmlspecialchars_decode( esc_html__( "This is a test email sent by Campation PostOffice&trade; setup wizard", "campation-postoffice" ) ) . '</center></p><br><br> ' . PHP_EOL;
        $content = '<center><img src="' . CPTNPOPATH . 'img/campation-postoffice-logo-mail.png"><br><br>' . wp_kses_post( $content ) . '</center>';
        $content = '<body style="margin:20px auto;width:90%;">' . $content . '</body>';
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE id=1";
        $domain = $wpdb->get_row( $query, ARRAY_A );
        $headers = "From: Campation PostOffice (" . mb_encode_mimeheader( trim( $domain['domain'] ) ) . ") <" . sanitize_email( $domain['from_address'] ) . ">" . PHP_EOL;
        $headers .= "MIME-Version: 1.0" . PHP_EOL;
        $headers .= "Content-Transfer-Encoding: 8bit" . PHP_EOL;
        $headers .= "Content-Type: text/html; charset=utf-8" . PHP_EOL;
        $headers .= "Return-Path: " . sanitize_email( $domain['envelope_address'] ) . PHP_EOL;
        $subject = htmlspecialchars_decode( esc_html__( 'Campation PostOffice Test Email from', "campation-postoffice" ) ) . " " . sanitize_email( $domain['from_address'] );
        $randomstring = preg_replace( "/[^a-zA-Z0-9]+/", "", substr( str_shuffle( str_repeat( implode( '', range( '!', 'z' ) ), 30 ) ), 0, 30 ) );
        $phpmailresult = cptn_po_mail(
            $email,
            "Campation PostOffice Test Email -> " . esc_html( $email ) . " (#" . esc_html( $randomstring ) . "#)",
            wp_kses_post( $content ),
            $headers,
            array(),
            "test",
            esc_html__( "Setup wizard", "campation-postoffice" )
        );
        
        if ( $phpmailresult ) {
            $output .= '<tr class="cptn_po_assistant_check_row"><td valign="top">' . esc_html( $email ) . ' <small>[contact]</small></td><td class="cptn_po_assistant_check_email_status" data-email="' . esc_attr( $email ) . '" data-emailtype="contact" data-emailrandom="' . esc_attr( $randomstring ) . '" data-process="start" valign="top" align=center><img src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/cptn-spinner.svg" height=25></td><td class="cptn_po_assistant_check_email_result" data-email="' . esc_attr( $email ) . '" valign="top">' . htmlspecialchars_decode( esc_html__( "sending test email - business IMAP account", "campation-postoffice" ) ) . '</td></tr>' . PHP_EOL;
        } else {
            $output .= '<tr class="cptn_po_assistant_check_row"><td valign="top">' . esc_html( $email ) . ' <small>[contact]</small></td><td class="cptn_po_assistant_check_email_status" data-email="' . esc_attr( $email ) . '" data-emailtype="contact" data-emailrandom="' . esc_attr( $randomstring ) . '" data-process="done" valign="top" align=center><img src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/cptn-spinner.svg" height=25></td><td class="cptn_po_assistant_check_email_result" data-email="' . esc_attr( $email ) . '" valign="top">' . htmlspecialchars_decode( esc_html__( "mail sending error", "campation-postoffice" ) ) . '</td></tr>' . PHP_EOL;
        }
    
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_check_email_address', 'cptn_po_assistant_get_check_email_address' );
add_action( 'wp_ajax_cptn_po_assistant_get_check_email_address', 'cptn_po_assistant_get_check_email_address' );
function cptn_po_assistant_get_check_email_address()
{
    global  $wpdb ;
    $sentemails = cptn_recursive_sanitize_array( $_POST['sentemails'] );
    // open IMAP account
    
    if ( !empty(esc_html( get_option( "cptn_po_opt_envelope_account_server" ) )) and !empty(esc_html( get_option( "cptn_po_opt_envelope_account_name" ) )) and !empty(esc_html( get_option( "cptn_po_opt_envelope_account_password" ) )) and !empty(esc_html( get_option( "cptn_po_opt_envelope_account_port" ) )) and !empty(esc_html( get_option( "cptn_po_opt_envelope_account_security" ) )) ) {
        $mail_server = esc_html( get_option( "cptn_po_opt_envelope_account_server" ) );
        $mail_account = esc_html( get_option( "cptn_po_opt_envelope_account_name" ) );
        $mail_password = esc_html( get_option( "cptn_po_opt_envelope_account_password" ) );
        $mail_port = esc_html( get_option( "cptn_po_opt_envelope_account_port" ) );
        $mail_security = esc_html( get_option( "cptn_po_opt_envelope_account_security" ) );
    } else {
        error_log( __( "Campation PostOffice: envelope IMAP account is not properly configured", "campation-postoffice" ) );
        wp_die();
    }
    
    imap_timeout( IMAP_OPENTIMEOUT, 60 );
    imap_timeout( IMAP_READTIMEOUT, 60 );
    imap_timeout( IMAP_WRITETIMEOUT, 60 );
    imap_timeout( IMAP_CLOSETIMEOUT, 60 );
    // connect to envelope mailbox
    $mailbox = "{" . $mail_server . ":" . $mail_port . "/imap/" . strtolower( $mail_security ) . "}";
    $inbox = @imap_open( $mailbox, $mail_account, $mail_password );
    if ( !$inbox ) {
        $emailstatus = "IMAPERROR";
    }
    foreach ( $sentemails as $key => $sentemail ) {
        $email = $sentemail['email'];
        $emailtype = $sentemail['emailtype'];
        $randomstring = $sentemail['emailrandom'];
        $withsubject = array();
        $withbody = array();
        $withtext = array();
        $emailstatus = "";
        $sentemails[$key]['status'] = "";
        $sentemails[$key]['result'] = "";
        if ( intval( $sentemails[$key]['counter'] ) == 1 ) {
            $emailstatus = "DELAY";
        }
        $withsubject = imap_search( $inbox, 'SUBJECT "Campation PostOffice Test Email -> ' . $email . ' (#' . $randomstring . '#)"' );
        if ( $withsubject ) {
            foreach ( $withsubject as $msgno ) {
                $emailstatus = "OK";
                imap_delete( $inbox, $msgno );
                break;
            }
        }
        $withbody = imap_search( $inbox, 'BODY "' . $randomstring . '"' );
        if ( $withbody ) {
            foreach ( $withbody as $msgno ) {
                $emailstatus = "BOUNCE";
                imap_delete( $inbox, $msgno );
                break;
            }
        }
        
        if ( $emailstatus == "OK" ) {
            $sentemails[$key]['status'] = "<span style='color:green;font-weight:bold;'>&#10004;</span>";
            $sentemails[$key]['result'] = "<span style='color:green;font-weight:bold;'>" . htmlspecialchars_decode( esc_html__( "Email was received with success !", "campation-postoffice" ) ) . "</span>";
        } elseif ( $emailstatus == "BOUNCE" ) {
            $sentemails[$key]['status'] = "<span style='color:#aa0000;font-weight:bold;'>&#10007;</span>";
            $sentemails[$key]['result'] = "<span style='color:#aa0000;font-weight:bold;'>" . htmlspecialchars_decode( esc_html__( "Email was undeliverable - seems that the email address does not exist", "campation-postoffice" ) ) . "</span>";
        } elseif ( $emailstatus == "DELAY" && $emailtype == "system" ) {
            $sentemails[$key]['status'] = "<span style='color:#aa0000;font-weight:bold;'>&#10007;</span>";
            $sentemails[$key]['result'] = "<span style='color:#aa0000;font-weight:bold;'>" . htmlspecialchars_decode( esc_html__( "Email did not arrive until now - please re-run the check", "campation-postoffice" ) ) . "</span>";
        } elseif ( $emailstatus == "DELAY" && $emailtype == "contact" ) {
            $sentemails[$key]['status'] = "<span style='color:#aa0000;font-weight:bold;'>&#x3f;</span>";
            $sentemails[$key]['result'] = htmlspecialchars_decode( esc_html__( "Email was deliverable - email address seems to exist. Please check your business mailbox", "campation-postoffice" ) ) . "</span>";
        } elseif ( $emailstatus == "IMAPERROR" && $emailtype == "system" ) {
            $sentemails[$key]['status'] = "<span style='color:#aa0000;font-weight:bold;'>&#10007;</span>";
            $sentemails[$key]['result'] = htmlspecialchars_decode( esc_html__( "cannot open envelope IMAP account", "campation-postoffice" ) ) . "</span>";
        }
    
    }
    imap_expunge( $inbox );
    imap_close( $inbox );
    echo  cptn_json_output( $sentemails ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_get_check_domain', 'cptn_po_assistant_get_check_domain' );
add_action( 'wp_ajax_cptn_po_assistant_get_check_domain', 'cptn_po_assistant_get_check_domain' );
function cptn_po_assistant_get_check_domain()
{
    global  $wpdb ;
    // get all domains
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE status = 1";
    if ( intval( get_option( "cptn_po_opt_domain_protect" ) ) != 1 ) {
        $query .= " AND id=1";
    }
    $domains = $wpdb->get_results( $query, ARRAY_A );
    $output = "";
    foreach ( $domains as $domain ) {
        
        if ( $domain['domain_status'] == "OK" ) {
            $status = "<span style='color:green;font-weight:bold;'>&#10004;</span>";
        } else {
            $status = "<span style='color:#aa0000;font-weight:bold;'>&#10007;</span>";
        }
        
        
        if ( empty($domain['last_check_result']) ) {
            $result = __( "This domain is perfectly configured for high email delivery performance!", "campation-postoffice" );
        } else {
            $result = '<ul class="cptn-ul">' . htmlspecialchars_decode( esc_html( $domain['last_check_result'] ) ) . "</ul>";
        }
        
        $output .= '<tr class="cptn_po_assistant_check_row"><td valign="top">' . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . '</td><td valign="top" align=center>' . htmlspecialchars_decode( esc_html( $status ) ) . '</td><td valign="top">' . htmlspecialchars_decode( esc_html( $result ) ) . '</td></tr>' . PHP_EOL;
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_mailserver_save', 'cptn_po_cptn_po_assistant_mailserver_save' );
add_action( 'wp_ajax_cptn_po_assistant_mailserver_save', 'cptn_po_assistant_mailserver_save' );
function cptn_po_assistant_mailserver_save()
{
    global  $wpdb ;
    if ( empty(esc_html( $_POST['ms_address'] )) ) {
        wp_die();
    }
    update_option( "cptn_opt_timezone_server", esc_html( $_POST['cptn_opt_timezone_server'] ) );
    update_option( "cptn_opt_timezone_staff", esc_html( $_POST['cptn_opt_timezone_staff'] ) );
    if ( !isset( $_POST['ms_contingent'] ) ) {
        $_POST['ms_contingent'] = 0;
    }
    if ( !isset( $_POST['ms_contingent_exceed'] ) ) {
        $_POST['ms_contingent_exceed'] = 0;
    }
    if ( !isset( $_POST['ms_contingent_period'] ) ) {
        $_POST['ms_contingent_period'] = "";
    }
    if ( !isset( $_POST['ms_status'] ) ) {
        $_POST['ms_status'] = 0;
    }
    if ( empty($_POST['ms_ip']) ) {
        $_POST['ms_ip'] = esc_html( gethostbyname( sanitize_text_field( $_POST['ms_address'] ) ) );
    }
    
    if ( intval( $_POST['ms_id'] ) == 9999 ) {
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t       SET shortname = '" . esc_sql( sanitize_text_field( $_POST['ms_shortname'] ) ) . "',\r\n\t\t\t\t   \t   server_type = '" . esc_sql( sanitize_text_field( $_POST['ms_server_type'] ) ) . "',\r\n\t\t\t\t\t   address = '" . esc_sql( sanitize_text_field( $_POST['ms_address'] ) ) . "',\r\n\t\t\t\t\t   ip = '" . esc_sql( sanitize_text_field( $_POST['ms_ip'] ) ) . "',\r\n\t\t\t\t\t   port = '" . esc_sql( sanitize_text_field( $_POST['ms_port'] ) ) . "',\r\n\t\t\t\t\t   encryption = '" . esc_sql( sanitize_text_field( $_POST['ms_encryption'] ) ) . "',\r\n\t\t\t\t\t   account = '" . esc_sql( sanitize_text_field( $_POST['ms_account'] ) ) . "',\r\n\t\t\t\t\t   password = '" . esc_sql( sanitize_text_field( $_POST['ms_password'] ) ) . "',\r\n\t\t\t\t\t   processes = '1',\r\n\t\t\t\t\t   contingent = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent'] ) ) . "',\r\n\t\t\t\t\t   contingent_exceed = " . intval( $_POST['ms_contingent_exceed'] ) . ",\r\n\t\t\t\t\t   contingent_period = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent_period'] ) ) . "',\r\n  \t\t\t\t\t   status = " . intval( $_POST['ms_status'] ) . ",\r\n\t\t\t\t\t   connectable = " . intval( $_POST['ms_connectable'] ) . ",\r\n\t\t\t\t \t   created = NOW(),\r\n\t\t\t\t\t   updated = NOW()\r\n\t\t\t\t\t   ";
        $wpdb->query( $query );
        $id = $wpdb->insert_id;
        // join with all domains
        $query = "SELECT id FROM " . $wpdb->prefix . "cptn_po_sender_domain";
        $domains = $wpdb->get_results( $query, ARRAY_A );
        foreach ( $domains as $domain ) {
            $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t \t\t    WHERE domain_id = " . $domain['id'] . " AND mailserver_id = " . $id;
            $domains_ms = $wpdb->get_results( $query, ARRAY_A );
            
            if ( !$domains_ms ) {
                $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t \t\t         SET domain_id = " . $domain['id'] . ",\r\n\t\t\t\t\t\t mailserver_id = " . $id . ",\r\n\t\t\t\t\t\t status = 1";
                $wpdb->query( $query );
            }
        
        }
    } else {
        $id = intval( $_POST['ms_id'] );
        $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t       SET shortname = '" . esc_sql( sanitize_text_field( $_POST['ms_shortname'] ) ) . "',\r\n\t\t\t\t\t   address = '" . esc_sql( sanitize_text_field( $_POST['ms_address'] ) ) . "',\r\n\t\t\t\t\t   ip = '" . esc_sql( sanitize_text_field( $_POST['ms_ip'] ) ) . "',\r\n\t\t\t\t\t   port = '" . esc_sql( sanitize_text_field( $_POST['ms_port'] ) ) . "',\r\n\t\t\t\t\t   encryption = '" . esc_sql( sanitize_text_field( $_POST['ms_encryption'] ) ) . "',\r\n\t\t\t\t\t   account = '" . esc_sql( sanitize_text_field( $_POST['ms_account'] ) ) . "',\r\n\t\t\t\t\t   password = '" . esc_sql( sanitize_text_field( $_POST['ms_password'] ) ) . "',\r\n\t\t\t\t\t   processes = '1',\r\n\t\t\t\t\t   contingent = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent'] ) ) . "',\r\n\t\t\t\t\t   contingent_exceed = " . intval( $_POST['ms_contingent_exceed'] ) . ",\r\n\t\t\t\t\t   contingent_period = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent_period'] ) ) . "',\r\n  \t\t\t\t\t   status = " . intval( $_POST['ms_status'] ) . ",\r\n\t\t\t\t\t   connectable = " . intval( $_POST['ms_connectable'] ) . ",\r\n\t\t\t\t\t   updated = NOW()\r\n\t\t\t     WHERE id = " . $id;
        $wpdb->query( $query );
    }
    
    // check if relation mailserver-mxdomain is already known
    $query = "SELECT DISTINCT mx.mxdomain\r\n               FROM " . $wpdb->prefix . "cptn_po_mailserver_mxdomain mx\r\n              WHERE NOT EXISTS (SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver_mxdomain WHERE mailserver = " . $id . " AND mxdomain = mx.mxdomain)\r\n\t\t\t\t\t   ";
    $missing = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $missing as $toadd ) {
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_mxdomain\r\n\t\t\t   \t\t    SET mailserver = " . $id . ",\r\n\t\t\t\t\t\t\tmxdomain = '" . $toadd['mxdomain'] . "',\r\n\t\t\t\t\t\t    minute_allowed = " . get_option( "cptn_po_opt_throttle_max_min" ) . ",\r\n\t\t\t\t\t\t\tcreated = NOW(),\r\n\t\t\t\t\t\t\tupdated = NOW()\r\n\t\t\t\t\t\t\t";
        $wpdb->query( $query );
    }
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_domain_save', 'cptn_po_cptn_po_assistant_domain_save' );
add_action( 'wp_ajax_cptn_po_assistant_domain_save', 'cptn_po_assistant_domain_save' );
function cptn_po_assistant_domain_save()
{
    global  $wpdb ;
    update_option( "cptn_opt_email_sendername", sanitize_text_field( $_POST["cptn_opt_email_sendername"] ) );
    update_option( "cptn_opt_email_sender", sanitize_email( $_POST["cptn_opt_email_sender"] ) );
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n   \t\t  \t    SET domain = '" . esc_sql( sanitize_text_field( $_POST['cptn_sender_domain'] ) ) . "',\r\n\t\t\t\t    envelope_address = '" . esc_sql( sanitize_email( $_POST['envelope_address'] ) ) . "',";
    $query .= "\t    from_address = '" . esc_sql( sanitize_email( $_POST['from_address'] ) ) . "',\r\n\t\t\t\t    replyto_address = '" . esc_sql( sanitize_email( $_POST['replyto_address'] ) ) . "'\r\n\t\t\t  WHERE id = " . intval( $_POST['id'] );
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_plugins_save', 'cptn_po_cptn_po_assistant_plugins_save' );
add_action( 'wp_ajax_cptn_po_assistant_plugins_save', 'cptn_po_assistant_plugins_save' );
function cptn_po_assistant_plugins_save()
{
    global  $wpdb ;
    $keys = array_map( 'sanitize_text_field', $_POST['mailcategory'] );
    foreach ( $keys as $key => $cat ) {
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t             WHERE pluginslug = '" . esc_sql( $key ) . "'";
        $row = $wpdb->get_row( $query, ARRAY_A );
        
        if ( $row ) {
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t\t              SET mailcategory = '" . esc_sql( $cat ) . "',\r\n\t\t\t\t\t  \t  mailcatfull = '" . cptn_po_abbreviations( $cat ) . "',\r\n\t\t\t\t\t      pluginname = '" . esc_sql( sanitize_text_field( $_POST['pluginname'][$key] ) ) . "'\r\n\t                WHERE pluginslug = '" . esc_sql( $key ) . "'";
            $wpdb->query( $query );
        } else {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t\t              SET plugin = '" . esc_sql( $key ) . "',\r\n\t\t\t\t\t      pluginname = '" . esc_sql( sanitize_text_field( $_POST['pluginname'][$key] ) ) . "',\r\n\t\t\t\t\t  \t  mailcatfull = '" . esc_sql( cptn_po_abbreviations( $cat ) ) . "',\r\n\t\t\t\t\t      mailcategory = '" . esc_sql( $cat ) . "'\r\n\t                \t  ";
            $wpdb->query( $query );
        }
    
    }
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_subdomain_save', 'cptn_po_cptn_po_assistant_subdomain_save' );
add_action( 'wp_ajax_cptn_po_assistant_subdomain_save', 'cptn_po_assistant_subdomain_save' );
function cptn_po_assistant_subdomain_save()
{
    global  $wpdb ;
    if ( intval( get_option( "cptn_po_opt_domain_protect" ) ) != 1 ) {
        // do not save when deactivated
        wp_die();
    }
    foreach ( [
        "trans",
        "marke",
        "bulk",
        "cold"
    ] as $cat ) {
        if ( !isset( $_POST['cptn_subdomain_' . $cat . '_status'] ) ) {
            $_POST['cptn_subdomain_' . $cat . '_status'] = 0;
        }
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t             WHERE id = " . intval( $_POST['cptn_subdomain_' . $cat . '_id'] );
        $row = $wpdb->get_row( $query, ARRAY_A );
        
        if ( $row ) {
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t              SET domain = '" . esc_sql( sanitize_text_field( $_POST['cptn_subdomain_' . $cat . '_domain'] ) ) . "',\r\n\t\t\t\t\t  \t  status = '" . esc_sql( sanitize_text_field( $_POST['cptn_subdomain_' . $cat . '_status'] ) ) . "',\r\n\t\t\t\t\t  \t  envelope_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_envelope_address'] ) ) . "',\r\n\t\t\t\t\t  \t  unsubscribe_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_unsubscribe_address'] ) ) . "',\r\n\t\t\t\t\t  \t  dmarc_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_dmarc_address'] ) ) . "',\r\n\t\t\t\t\t  \t  from_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_from_address'] ) ) . "',\r\n\t\t\t\t\t  \t  replyto_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_replyto_address'] ) ) . "',\r\n\t\t\t\t\t  \t  updated = NOW()\r\n\t                WHERE id = " . intval( $_POST['cptn_subdomain_' . $cat . '_id'] );
            $wpdb->query( $query );
        } else {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t              SET domain = '" . esc_sql( sanitize_text_field( $_POST['cptn_subdomain_' . $cat . '_domain'] ) ) . "',\r\n\t\t\t\t\t  \t  status = '" . esc_sql( sanitize_text_field( $_POST['cptn_subdomain_' . $cat . '_status'] ) ) . "',\r\n\t\t\t\t\t  \t  envelope_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_envelope_address'] ) ) . "',\r\n\t\t\t\t\t  \t  unsubscribe_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_unsubscribe_address'] ) ) . "',\r\n\t\t\t\t\t  \t  dmarc_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_dmarc_address'] ) ) . "',\r\n\t\t\t\t\t  \t  from_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_from_address'] ) ) . "',\r\n\t\t\t\t\t  \t  replyto_address = '" . esc_sql( sanitize_email( $_POST['cptn_subdomain_' . $cat . '_replyto_address'] ) ) . "',\r\n\t\t\t\t\t\t  created = NOW(),\r\n\t\t\t\t\t  \t  updated = NOW()\r\n\t                \t  ";
            $wpdb->query( $query );
        }
    
    }
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_status_save', 'cptn_po_cptn_po_assistant_status_save' );
add_action( 'wp_ajax_cptn_po_assistant_status_save', 'cptn_po_assistant_status_save' );
function cptn_po_assistant_status_save()
{
    global  $wpdb ;
    if ( isset( $_POST['step'] ) and intval( $_POST['step'] ) ) {
        update_option( "cptn_po_opt_assistant_step", intval( $_POST['step'] ) );
    }
    if ( isset( $_POST['status'] ) and $_POST['status'] > "" ) {
        update_option( "cptn_po_opt_assistant_status", sanitize_text_field( $_POST['status'] ) );
    }
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_assistant_final_test_mails', 'cptn_po_assistant_final_test_mails' );
add_action( 'wp_ajax_cptn_po_assistant_final_test_mails', 'cptn_po_assistant_final_test_mails' );
function cptn_po_assistant_final_test_mails()
{
    global  $wpdb ;
    $recipient = sanitize_email( $_POST['externalemail'] );
    $message = htmlspecialchars_decode( esc_html__( "This is a test message from Campation PostOffice&trade;", "campation-postoffice" ) );
    $message = "<center><img src='" . CPTNPOPATH . "img/campation-postoffice-logo-mail.png'><br><br>" . htmlspecialchars_decode( esc_html( $message ) ) . "</center>";
    $message = '<body style="margin:20px auto;width:90%;">' . wp_kses_post( $message ) . "</body>";
    // send email to one address
    $content = '<p><center>' . htmlspecialchars_decode( esc_html__( "This is a test email sent by Campation PostOffice&trade; setup wizard", "campation-postoffice" ) ) . '</center></p><br><br> ' . PHP_EOL;
    $content = '<center><img src="' . CPTNPOPATH . 'img/campation-postoffice-logo-mail.png"><br><br>' . wp_kses_post( $content ) . '</center>';
    $content = '<body style="margin:20px auto;width:90%;">' . $content . '</body>';
    // 5 mails domain protect
    
    if ( intval( get_option( "cptn_po_opt_domain_protect" ) ) == 1 ) {
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE status=1";
        $domains = $wpdb->get_results( $query, ARRAY_A );
        foreach ( $domains as $domain ) {
            $headers = "From: Campation PostOffice (" . mb_encode_mimeheader( trim( $domain['domain'] ) ) . ") <" . sanitize_email( $domain['from_address'] ) . ">" . PHP_EOL;
            $headers .= "MIME-Version: 1.0" . PHP_EOL;
            $headers .= "Content-Transfer-Encoding: 8bit" . PHP_EOL;
            $headers .= "Content-Type: text/html; charset=utf-8" . PHP_EOL;
            $headers .= "Return-Path: " . sanitize_email( $domain['envelope_address'] ) . PHP_EOL;
            $mailcategory = __( "None", "campation-postoffice" );
            if ( $domain['mailcategory'] ) {
                $mailcategory = esc_html( $domain['mailcategory'] );
            }
            $subject = htmlspecialchars_decode( esc_html__( 'Campation PostOffice Test Email from', "campation-postoffice" ) ) . " " . sanitize_email( $domain['from_address'] ) . " - " . htmlspecialchars_decode( esc_html__( 'Mail category', "campation-postoffice" ) ) . " '" . $mailcategory . "'";
            cptn_po_mail(
                get_bloginfo( 'name' ) . " Admin <" . $recipient . ">",
                $subject,
                $message,
                $headers,
                "",
                "test",
                esc_html__( "Setup wizard", "campation-postoffice" ),
                0
            );
        }
    } else {
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain WHERE id=1";
        $domain = $wpdb->get_row( $query, ARRAY_A );
        $headers = "From: Campation PostOffice (" . mb_encode_mimeheader( trim( $domain['domain'] ) ) . ") <" . sanitize_email( $domain['from_address'] ) . ">" . PHP_EOL;
        $headers .= "MIME-Version: 1.0" . PHP_EOL;
        $headers .= "Content-Transfer-Encoding: 8bit" . PHP_EOL;
        $headers .= "Content-Type: text/html; charset=utf-8" . PHP_EOL;
        $headers .= "Return-Path: " . sanitize_email( $domain['envelope_address'] ) . PHP_EOL;
        $subject = htmlspecialchars_decode( esc_html__( 'Campation PostOffice Test Email from', "campation-postoffice" ) ) . " " . sanitize_email( $domain['from_address'] );
        cptn_po_mail(
            get_bloginfo( 'name' ) . " Admin <" . $recipient . ">",
            $subject,
            $message,
            $headers,
            "",
            "test",
            esc_html__( "Setup wizard", "campation-postoffice" ),
            0
        );
    }
    
    wp_die();
}
