<?php

add_action( 'wp_ajax_nopriv_cptn_po_cockpit_switch', 'cptn_po_cockpit_switch' );
add_action( 'wp_ajax_cptn_po_cockpit_switch', 'cptn_po_cockpit_switch' );
function cptn_po_cockpit_switch()
{
    global  $wpdb ;
    $switchname = sanitize_text_field( $_POST['name'] );
    $switchstatus = sanitize_text_field( $_POST['value'] );
    update_option( "cptn_po_opt_cockpit_switch_" . $switchname, $switchstatus );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_cockpit_date', 'cptn_po_cockpit_date' );
add_action( 'wp_ajax_cptn_po_cockpit_date', 'cptn_po_cockpit_date' );
function cptn_po_cockpit_date()
{
    global  $wpdb ;
    $datename = sanitize_text_field( $_POST['name'] );
    $datevalue = sanitize_text_field( $_POST['value'] );
    update_option( "cptn_po_opt_cockpit_date_" . $datename, $datevalue );
    wp_die();
}

// outbox chart
add_action( 'wp_ajax_nopriv_cptn_po_cockpit_outbox', 'cptn_po_cockpit_outbox' );
add_action( 'wp_ajax_cptn_po_cockpit_outbox', 'cptn_po_cockpit_outbox' );
function cptn_po_cockpit_outbox()
{
    global  $wpdb ;
    $output = array();
    $mindate = date( 'Y-m-d', strtotime( date( 'Y-m-d' ) . ' -30 days' ) );
    if ( esc_html( get_option( "cptn_po_opt_cockpit_date_from" ) ) ) {
        $mindate = esc_html( get_option( "cptn_po_opt_cockpit_date_from" ) );
    }
    $maxdate = date( 'Y-m-d' );
    if ( esc_html( get_option( "cptn_po_opt_cockpit_date_to" ) ) ) {
        $maxdate = esc_html( get_option( "cptn_po_opt_cockpit_date_to" ) );
    }
    $data = array();
    $labels = array();
    for ( $day = $mindate ;  $day <= $maxdate ;  $day = date( 'Y-m-d', strtotime( $day . ' +1 day' ) ) ) {
        $labels[] = cptn_date_format( $day, "D" );
        $data[cptn_date_format( $day, "D" )] = 0;
    }
    $datarecover = $data;
    // filter switches
    $queryadditional = "";
    if ( intval( get_option( "cptn_po_opt_cockpit_switch_without" ) ) == 1 ) {
        //      $queryadditional .= " mailcategory = '' OR ";
        $queryadditional .= " mailcategory NOT IN ('trans','marke','bulk','cold') OR ";
    }
    if ( intval( get_option( "cptn_po_opt_cockpit_switch_trans" ) ) == 1 ) {
        $queryadditional .= " mailcategory = 'trans' OR ";
    }
    if ( intval( get_option( "cptn_po_opt_cockpit_switch_marke" ) ) == 1 ) {
        $queryadditional .= " mailcategory = 'marke' OR ";
    }
    if ( intval( get_option( "cptn_po_opt_cockpit_switch_bulk" ) ) == 1 ) {
        $queryadditional .= " mailcategory = 'bulk' OR ";
    }
    if ( intval( get_option( "cptn_po_opt_cockpit_switch_cold" ) ) == 1 ) {
        $queryadditional .= " mailcategory = 'cold' OR ";
    }
    
    if ( $queryadditional ) {
        $queryadditional = " AND (" . substr( $queryadditional, 0, -3 ) . ") ";
    } else {
        $queryadditional = " AND false ";
    }
    
    // omit all not valid mailcategories, tests etc.
    // sent mails
    $query = "SELECT substring(q.executed,1,10) AS date,\r\n       \t            (SELECT count(id) FROM " . $wpdb->prefix . "cptn_po_queue WHERE substring(executed,1,10) = substring(q.executed,1,10) " . $queryadditional . ") AS cnt\r\n               FROM " . $wpdb->prefix . "cptn_po_queue q \r\n\t\t\t  WHERE substring(q.executed,1,10) >= '" . esc_sql( $mindate ) . "'\r\n\t\t\t    AND substring(q.executed,1,10) <= '" . esc_sql( $maxdate ) . "'\r\n\t\t\t  GROUP BY substring(q.executed,1,10)\r\n\t\t\t  ORDER BY substring(q.executed,1,10) \r\n \t\t\t\t ";
    $outbox = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $outbox as $value ) {
        $data[cptn_date_format( $value['date'], "D" )] = $value['cnt'];
    }
    $outbox_sent = array();
    setlocale( LC_TIME, substr( get_user_locale( wp_get_current_user() ), 0, 5 ) );
    foreach ( $data as $key => $value ) {
        $outbox_sent[] = $value;
    }
    // bounced
    $data = $datarecover;
    // reset array
    $query = "SELECT substring(q.executed,1,10) AS date,\r\n       \t            (SELECT count(id) FROM " . $wpdb->prefix . "cptn_po_queue WHERE substring(executed,1,10) = substring(q.executed,1,10) AND errors = 9999 " . $queryadditional . ") AS cnt\r\n               FROM " . $wpdb->prefix . "cptn_po_queue q \r\n\t\t\t  WHERE substring(q.executed,1,10) >= '" . esc_sql( $mindate ) . "'\r\n\t\t\t    AND substring(q.executed,1,10) <= '" . esc_sql( $maxdate ) . "'\r\n\t\t\t  GROUP BY substring(q.executed,1,10)\r\n\t\t\t  ORDER BY substring(q.executed,1,10) \r\n \t\t\t\t ";
    $outbox = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $outbox as $value ) {
        $data[cptn_date_format( $value['date'], "D" )] = $value['cnt'];
    }
    $outbox_bounced = array();
    foreach ( $data as $key => $value ) {
        $outbox_bounced[] = $value;
    }
    // unsubscribed
    $data = $datarecover;
    // reset array
    $query = "SELECT substring(q.executed,1,10) AS date,\r\n       \t            (SELECT count(id) FROM " . $wpdb->prefix . "cptn_po_queue WHERE substring(executed,1,10) = substring(q.executed,1,10) AND unsubscribed = 1 " . $queryadditional . ") AS cnt\r\n               FROM " . $wpdb->prefix . "cptn_po_queue q \r\n\t\t\t  WHERE substring(q.executed,1,10) >= '" . esc_sql( $mindate ) . "'\r\n\t\t\t    AND substring(q.executed,1,10) <= '" . esc_sql( $maxdate ) . "'\r\n\t\t\t  GROUP BY substring(q.executed,1,10)\r\n\t\t\t  ORDER BY substring(q.executed,1,10) \r\n \t\t\t\t ";
    $outbox = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $outbox as $value ) {
        $data[cptn_date_format( $value['date'], "D" )] = $value['cnt'];
    }
    $outbox_unsubscribed = array();
    foreach ( $data as $key => $value ) {
        $outbox_unsubscribed[] = $value;
    }
    // opened
    $data = $datarecover;
    // reset array
    $query = "SELECT substring(q.executed,1,10) AS date,\r\n       \t            (SELECT count(id) FROM " . $wpdb->prefix . "cptn_po_queue WHERE substring(executed,1,10) = substring(q.executed,1,10) AND opened IS NOT NULL " . $queryadditional . ") AS cnt\r\n               FROM " . $wpdb->prefix . "cptn_po_queue q \r\n\t\t\t  WHERE substring(q.executed,1,10) >= '" . esc_sql( $mindate ) . "'\r\n\t\t\t    AND substring(q.executed,1,10) <= '" . esc_sql( $maxdate ) . "'\r\n\t\t\t  GROUP BY substring(q.executed,1,10)\r\n\t\t\t  ORDER BY substring(q.executed,1,10) \r\n \t\t\t\t ";
    $outbox = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $outbox as $value ) {
        $data[cptn_date_format( $value['date'], "D" )] = $value['cnt'];
    }
    $outbox_opened = array();
    foreach ( $data as $key => $value ) {
        $outbox_opened[] = $value;
    }
    // clicked
    $data = $datarecover;
    // reset array
    $query = "SELECT substring(q.executed,1,10) AS date,\r\n       \t            (SELECT count(id) FROM " . $wpdb->prefix . "cptn_po_queue WHERE substring(executed,1,10) = substring(q.executed,1,10) AND clicked IS NOT NULL " . $queryadditional . ") AS cnt\r\n               FROM " . $wpdb->prefix . "cptn_po_queue q \r\n\t\t\t  WHERE substring(q.executed,1,10) >= '" . esc_sql( $mindate ) . "'\r\n\t\t\t    AND substring(q.executed,1,10) <= '" . esc_sql( $maxdate ) . "'\r\n\t\t\t  GROUP BY substring(q.executed,1,10)\r\n\t\t\t  ORDER BY substring(q.executed,1,10) \r\n \t\t\t\t ";
    $outbox = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $outbox as $value ) {
        $data[cptn_date_format( $value['date'], "D" )] = $value['cnt'];
    }
    $outbox_clicked = array();
    foreach ( $data as $key => $value ) {
        $outbox_clicked[] = $value;
    }
    $output = array(
        'labels'   => $labels,
        'datasets' => array(
        array(
        'data'            => $outbox_sent,
        'type'            => 'line',
        'borderColor'     => '#8EB4D6',
        'backgroundColor' => '#8EB4D6',
        'label'           => htmlspecialchars_decode( esc_html__( "Sent", "campation-postoffice" ) ),
        'fill'            => true,
        'order'           => 99,
    ),
        array(
        'data'            => $outbox_bounced,
        'type'            => 'bar',
        'barThickness'    => 8,
        'maxBarThickness' => 10,
        'backgroundColor' => '#770000',
        'label'           => htmlspecialchars_decode( esc_html__( "Bounced", "campation-postoffice" ) ),
        'fill'            => true,
    ),
        array(
        'data'            => $outbox_unsubscribed,
        'type'            => 'bar',
        'barThickness'    => 8,
        'maxBarThickness' => 10,
        'backgroundColor' => '#aa0000',
        'label'           => htmlspecialchars_decode( esc_html__( "Unsubscribed", "campation-postoffice" ) ),
        'fill'            => true,
    ),
        array(
        'data'            => $outbox_opened,
        'type'            => 'bar',
        'barThickness'    => 8,
        'maxBarThickness' => 10,
        'backgroundColor' => '#51AD5C',
        'label'           => htmlspecialchars_decode( esc_html__( "Opened", "campation-postoffice" ) ),
        'fill'            => true,
    ),
        array(
        'data'            => $outbox_clicked,
        'type'            => 'bar',
        'barThickness'    => 8,
        'maxBarThickness' => 10,
        'backgroundColor' => 'darkgreen',
        'label'           => htmlspecialchars_decode( esc_html__( "Clicked", "campation-postoffice" ) ),
        'fill'            => true,
    )
    ),
    );
    echo  json_encode( cptn_recursive_sanitize_array( $output ), JSON_UNESCAPED_UNICODE ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_cockpit_system_health', 'cptn_po_cockpit_system_health' );
add_action( 'wp_ajax_cptn_po_cockpit_system_health', 'cptn_po_cockpit_system_health' );
function cptn_po_cockpit_system_health()
{
    global  $wpdb ;
    $output = "";
    $system_status = '<span style="color:green;float:right;font-size:36px;font-weight:bold;">&#10004;</span>';
    $detail_good_status = ' <span style="color:green;float:right;font-weight:bold;">&#10004;</span>';
    $detail_bad_status = ' <span style="color:#aa0000;float:right;font-weight:bold;">&#10007;</span>';
    $system_color = "white";
    $last_check_result = "";
    // at least 1 active healthy mailserver?
    $query = "SELECT *\r\n\t           FROM " . $wpdb->prefix . "cptn_po_mailserver \r\n\t\t\t  WHERE rdns = 1 \r\n\t\t\t    AND connectable = 1\r\n\t\t\t\tAND status = 1\r\n \t\t\t\t ";
    $mailservers = $wpdb->get_results( $query, ARRAY_A );
    
    if ( !$mailservers ) {
        $system_status = '<span style="color:#aa0000;float:right;font-size:36px;font-weight:bold;">&#10007;</span>';
        $system_color = "rgb(255,0,0,0.08)";
        $last_check_result .= "<li><span style='color:#aa0000;'>" . htmlspecialchars_decode( esc_html__( "No working / active mail server available", "campation-postoffice" ) ) . htmlspecialchars_decode( esc_html( $detail_bad_status ) ) . "</span></li>";
    } else {
        $last_check_result .= "<li>" . count( $mailservers ) . " " . htmlspecialchars_decode( esc_html__( "mail server(s)", "campation-postoffice" ) ) . htmlspecialchars_decode( esc_html( $detail_good_status ) ) . "</li>";
    }
    
    // at least 1 active healthy SpeedMail?
    $query = "SELECT *\r\n\t           FROM " . $wpdb->prefix . "cptn_po_mailserver \r\n\t\t\t  WHERE rdns = 1 \r\n\t\t\t    AND connectable = 1\r\n\t\t\t\tAND status = 1\r\n\t\t\t\tAND server_type='spmail'\r\n \t\t\t\t ";
    $mailservers = $wpdb->get_results( $query, ARRAY_A );
    
    if ( !$mailservers ) {
        $domain_status = '<span style="color:#aa0000;float:right;font-size:36px;font-weight:bold;">&#10007;</span>';
        $domain_color = "rgb(255,0,0,0.08)";
        $last_check_result .= "<li><span style='color:#aa0000;'>" . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade; server not active", "campation-postoffice" ) ) . htmlspecialchars_decode( esc_html( $detail_bad_status ) ) . "</span> - <a href='/wp-admin/admin.php?page=campation-postoffice-mailserver'>" . htmlspecialchars_decode( esc_html__( "activate", "campation-postoffice" ) ) . "</a></li>";
    } else {
        $last_check_result .= "<li>1 " . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade; server", "campation-postoffice" ) ) . htmlspecialchars_decode( esc_html( $detail_good_status ) ) . "</li>";
    }
    
    // invalid recipients
    $query = "SELECT count(id)\r\n\t           FROM " . $wpdb->prefix . "cptn_po_recipient\r\n\t\t\t  WHERE recipient_status != 'OK'\r\n \t\t\t\t ";
    $recipients = $wpdb->get_var( $query );
    if ( $recipients > 0 ) {
        $last_check_result .= "<li><span style='color:#aa0000;'>" . htmlspecialchars_decode( esc_html( $recipients ) ) . " " . htmlspecialchars_decode( esc_html__( "invalid recipient addresses", "campation-postoffice" ) ) . htmlspecialchars_decode( esc_html( $detail_bad_status ) ) . "</span> - <a href='/wp-admin/admin.php?page=campation-postoffice-recipient'>" . htmlspecialchars_decode( esc_html__( "edit", "campation-postoffice" ) ) . "</a></li>";
    }
    $output .= "<div style='-webkit-box-shadow: 6px 6px 4px -3px #9E9E9E; box-shadow: 6px 6px 4px -3px #9E9E9E;-webkit-box-shadow: 6px 6px 4px -3px #9E9E9E; box-shadow: 6px 6px 4px -3px #9E9E9E;background-color: rgba(0,0,0,0.03);border:1px solid #ddd;border-radius:10px;padding:5px;background-color:" . htmlspecialchars_decode( esc_html( $system_color ) ) . "'>" . PHP_EOL;
    $output .= "<h3 style='margin-bottom:-8px;'>" . htmlspecialchars_decode( esc_html__( "System", "campation-postoffice" ) ) . " " . htmlspecialchars_decode( esc_html( $system_status ) ) . "</h3>" . PHP_EOL;
    $output .= '<ul class="cptn-ul" style="font-size:12px;margin-top:-10px;margin-bottom:-15px;line-height:90%;">' . PHP_EOL;
    $output .= $last_check_result . PHP_EOL;
    $output .= "</ul>" . PHP_EOL;
    $output .= "</div>" . PHP_EOL;
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_cockpit_sender_health', 'cptn_po_cockpit_sender_health' );
add_action( 'wp_ajax_cptn_po_cockpit_sender_health', 'cptn_po_cockpit_sender_health' );
function cptn_po_cockpit_sender_health()
{
    global  $wpdb ;
    $query = "SELECT sd.domain, sd.status, sd.domain_status, sd.last_checked, sd.last_check_result,\r\n       \t\t\t\t   (SELECT count(*) \r\n\t      \t\t\t      FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm \r\n\t\t  \t\t\t\t  INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdm.mailserver_id AND ms.rdns = 1 AND ms.connectable = 1 AND ms.status = 1 \r\n\t\t  \t\t\t\t  WHERE sdm.domain_id = sd.id\r\n            \t\t\t  AND sdm.status = 1 \r\n            \t\t\t  AND sdm.server_status = 'OK'\r\n\t\t\t\t\t\t  ) AS server \r\n\t           FROM " . $wpdb->prefix . "cptn_po_sender_domain sd\r\n\t\t\t  ORDER BY sd.status DESC, IF(sd.mailcategory='',0,1) ASC, sd.domain ASC\r\n \t\t\t\t ";
    $domains = $wpdb->get_results( $query, ARRAY_A );
    $output = "";
    foreach ( $domains as $domain ) {
        
        if ( $domain['domain_status'] == "OK" and $domain['status'] == 1 and $domain['server'] > 0 ) {
            $domain_status = '<span style="color:green;float:right;font-size:36px;font-weight:bold;">&#10004;</span>';
            $domain_color = "white";
        } else {
            $domain_status = '<span style="color:#aa0000;float:right;font-size:36px;font-weight:bold;">&#10007;</span>';
            $domain_color = "rgb(255,0,0,0.08)";
        }
        
        $output .= "<div style='-webkit-box-shadow: 6px 6px 4px -3px #9E9E9E; box-shadow: 6px 6px 4px -3px #9E9E9E;-webkit-box-shadow: 6px 6px 4px -3px #9E9E9E; box-shadow: 6px 6px 4px -3px #9E9E9E;background-color: rgba(0,0,0,0.03);border:1px solid #ddd;border-radius:10px;padding:5px;background-color:" . htmlspecialchars_decode( esc_html( $domain_color ) ) . "'>" . PHP_EOL;
        $output .= "<h3 style='margin-bottom:-8px;'>" . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . " " . htmlspecialchars_decode( esc_html( $domain_status ) ) . "</h3>" . PHP_EOL;
        $output .= "<small>" . htmlspecialchars_decode( esc_html__( "Last checked", "campation-postoffice" ) ) . ": <strong>" . cptn_date_format( $domain['last_checked'], "T" ) . "</strong></small>" . PHP_EOL;
        if ( $domain['status'] == 0 ) {
            $output .= '<span style="color:#aa0000;float:right;font-size:12px;font-weight:bold;margin-left:5px;">' . strtoupper( htmlspecialchars_decode( esc_html__( "not active", "campation-postoffice" ) ) ) . "</span>";
        }
        if ( $domain['server'] == 0 ) {
            $output .= '<span style="color:#aa0000;float:right;font-size:12px;font-weight:bold;margin-left:5px;">' . strtoupper( htmlspecialchars_decode( esc_html__( "no mail server", "campation-postoffice" ) ) ) . "</span>";
        }
        
        if ( $domain['last_check_result'] ) {
            $output .= '<ul class="cptn-ul" style="font-size:12px;margin-top:-10px;margin-bottom:-15px;">' . PHP_EOL;
            $output .= $domain['last_check_result'] . PHP_EOL;
            $output .= "</ul>" . PHP_EOL;
        } elseif ( $domain['last_checked'] ) {
            $output .= "<p><strong><center>" . htmlspecialchars_decode( esc_html__( "Domain is perfectly configured", "campation-postoffice" ) ) . "!</center></strong></p>" . PHP_EOL;
        } else {
            $output .= "<p><strong><center>" . htmlspecialchars_decode( esc_html__( "Domain is not configured yet", "campation-postoffice" ) ) . "!</center></strong></p>" . PHP_EOL;
        }
        
        $output .= "</div>" . PHP_EOL;
        $output .= "<hr>" . PHP_EOL;
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_cockpit_last_bounces', 'cptn_po_cockpit_last_bounces' );
add_action( 'wp_ajax_cptn_po_cockpit_last_bounces', 'cptn_po_cockpit_last_bounces' );
function cptn_po_cockpit_last_bounces()
{
    global  $wpdb ;
    $query = "SELECT bounce_date, recipient_email \r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_recipient\r\n\t\t\t  WHERE bounce_date IS NOT NULL \t\t\r\n\t\t\t\tAND recipient_status = 'BOUNCE'\r\n\t\t\t  ORDER BY bounce_date DESC\r\n\t\t\t  LIMIT 20\r\n   \t\t     ";
    $recipients = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
        error_log( $wpdb->print_error() );
        wp_die();
    }
    
    $output = '<table class="table table-sm table-striped table-hover table-compact" align="center" width=100%> ' . PHP_EOL;
    $output .= "<tr style='background-color:#8EB4D6;color:white;font-size:12px;'>\r\n\t\t          <th style='text-align:left;'>" . htmlspecialchars_decode( esc_html__( "Date / time", "campation-postoffice" ) ) . "</th>\r\n\t\t\t\t  <th style='text-align:left;'>" . htmlspecialchars_decode( esc_html__( "Recipient", "campation-postoffice" ) ) . "</th>\r\n\t\t\t   </tr> " . PHP_EOL;
    foreach ( $recipients as $recipient ) {
        $output .= "<tr style='font-size:12px;'>\r\n\t\t             <td style='text-align:left;'>" . htmlspecialchars_decode( esc_html( cptn_date_format( $recipient['bounce_date'], "T" ) ) ) . "</td>\r\n\t\t\t\t  \t <td style='text-align:left;'>" . htmlspecialchars_decode( esc_html( $recipient['recipient_email'] ) ) . "</td>\r\n\t\t\t\t  </tr> " . PHP_EOL;
    }
    $output .= "</table> " . PHP_EOL;
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_cockpit_last_server_errors', 'cptn_po_cockpit_last_server_errors' );
add_action( 'wp_ajax_cptn_po_cockpit_last_server_errors', 'cptn_po_cockpit_last_server_errors' );
function cptn_po_cockpit_last_server_errors()
{
    global  $wpdb ;
    // mail server errors
    $query = "SELECT ms.shortname, ms.address, mse.error_date, mse.error_reason, mse.error_full \r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_mailserver_error mse\r\n   \t\t      INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = mse.mailserver\r\n\t\t\t  ORDER BY ms.id, mse.error_date DESC\r\n\t\t\t  LIMIT 20\r\n   \t\t     ";
    $errors = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
        error_log( $wpdb->print_error() );
        wp_die();
    }
    
    $output = '<table class="table table-sm table-striped table-hover table-compact" align="center" width=100%> ' . PHP_EOL;
    $output .= "<tr style='background-color:#8EB4D6;color:white;font-size:12px;'>\r\n      \t\t      <th style='text-align:left;'>" . htmlspecialchars_decode( esc_html__( "Mail server", "campation-postoffice" ) ) . "</th>\r\n\t  \t\t\t  <th style='text-align:left;'>" . htmlspecialchars_decode( esc_html__( "Date / time", "campation-postoffice" ) ) . "</th>\r\n\t\t\t\t  <th style='text-align:left;'>" . htmlspecialchars_decode( esc_html__( "Reason", "campation-postoffice" ) ) . "</th>\r\n\t\t\t\t  <th style='text-align:left;'>" . htmlspecialchars_decode( esc_html__( "Error full", "campation-postoffice" ) ) . "</th>\r\n\t\t\t   </tr> " . PHP_EOL;
    foreach ( $errors as $error ) {
        $output .= "<tr style='font-size:12px;'>\r\n\t                 <td valign=top>" . htmlspecialchars_decode( esc_html( $error['shortname'] . " (" . $error['address'] ) ) . ")</td>\r\n\t\t\t\t\t <td valign=top>" . htmlspecialchars_decode( esc_html( cptn_date_format( $error['error_date'], "T" ) ) ) . "</td>\r\n\t\t\t\t\t <td valign=top>" . htmlspecialchars_decode( esc_html( $error['error_reason'] ) ) . "</td>\r\n\t\t\t\t\t <td valign=top>" . htmlspecialchars_decode( esc_html( $error['error_full'] ) ) . "</td>\r\n\t\t\t\t  </tr> " . PHP_EOL;
    }
    $output .= "</table> " . PHP_EOL;
    echo  wp_kses_post( $output ) ;
    wp_die();
}
