<?php

add_action( 'wp_ajax_nopriv_cptn_po_config_get_general', 'cptn_po_config_get_general' );
add_action( 'wp_ajax_cptn_po_config_get_general', 'cptn_po_config_get_general' );
function cptn_po_config_get_general()
{
    global  $wpdb ;
    $output = array();
    $output["cptn_opt_timezone_server"] = esc_html( get_option( "cptn_opt_timezone_server" ) );
    $output["cptn_opt_timezone_staff"] = esc_html( get_option( "cptn_opt_timezone_staff" ) );
    $output["cptn_po_opt_delete_data_uninstall"] = esc_html( get_option( "cptn_po_opt_delete_data_uninstall" ) );
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_general_save', 'cptn_po_config_general_save' );
add_action( 'wp_ajax_cptn_po_config_general_save', 'cptn_po_config_general_save' );
function cptn_po_config_general_save()
{
    global  $wpdb ;
    update_option( "cptn_opt_timezone_server", sanitize_text_field( $_POST["cptn_opt_timezone_server"] ) );
    update_option( "cptn_opt_timezone_staff", sanitize_text_field( $_POST["cptn_opt_timezone_staff"] ) );
    if ( !isset( $_POST["cptn_po_opt_delete_data_uninstall"] ) ) {
        $_POST["cptn_po_opt_delete_data_uninstall"] = 0;
    }
    update_option( "cptn_po_opt_delete_data_uninstall", sanitize_text_field( $_POST["cptn_po_opt_delete_data_uninstall"] ) );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_get_mail', 'cptn_po_config_get_mail' );
add_action( 'wp_ajax_cptn_po_config_get_mail', 'cptn_po_config_get_mail' );
function cptn_po_config_get_mail()
{
    global  $wpdb ;
    $output = array();
    $output["cptn_opt_email_sendername"] = esc_html( get_option( "cptn_opt_email_sendername" ) );
    $output["cptn_opt_email_sender"] = esc_html( get_option( "cptn_opt_email_sender" ) );
    $output["cptn_po_opt_email_bcc"] = esc_html( get_option( 'cptn_po_opt_email_bcc' ) );
    $output["cptn_po_opt_purge_queue_days"] = intval( get_option( "cptn_po_opt_purge_queue_days" ) );
    $output["cptn_po_opt_mailserver_off_errors"] = intval( get_option( "cptn_po_opt_mailserver_off_errors" ) );
    $output["cptn_po_opt_envelope_account_email"] = esc_html( get_option( "cptn_po_opt_envelope_account_email" ) );
    $output["cptn_po_opt_envelope_account_name"] = esc_html( get_option( "cptn_po_opt_envelope_account_name" ) );
    $output["cptn_po_opt_envelope_account_password"] = esc_html( get_option( "cptn_po_opt_envelope_account_password" ) );
    $output["cptn_po_opt_envelope_account_server"] = esc_html( get_option( "cptn_po_opt_envelope_account_server" ) );
    $output["cptn_po_opt_envelope_account_port"] = esc_html( get_option( "cptn_po_opt_envelope_account_port" ) );
    $output["cptn_po_opt_envelope_account_security"] = esc_html( get_option( "cptn_po_opt_envelope_account_security" ) );
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_mail_save', 'cptn_po_config_mail_save' );
add_action( 'wp_ajax_cptn_po_config_mail_save', 'cptn_po_config_mail_save' );
function cptn_po_config_mail_save()
{
    global  $wpdb ;
    update_option( "cptn_opt_email_sendername", sanitize_text_field( $_POST["cptn_opt_email_sendername"] ) );
    update_option( "cptn_opt_email_sender", sanitize_email( $_POST["cptn_opt_email_sender"] ) );
    update_option( "cptn_po_opt_email_bcc", sanitize_email( $_POST["cptn_po_opt_email_bcc"] ) );
    update_option( "cptn_po_opt_purge_queue_days", intval( $_POST["cptn_po_opt_purge_queue_days"] ) );
    update_option( "cptn_po_opt_mailserver_off_errors", intval( $_POST["cptn_po_opt_mailserver_off_errors"] ) );
    update_option( "cptn_po_opt_envelope_account_email", sanitize_email( $_POST["cptn_po_opt_envelope_account_email"] ) );
    update_option( "cptn_po_opt_envelope_account_name", sanitize_text_field( $_POST["cptn_po_opt_envelope_account_name"] ) );
    update_option( "cptn_po_opt_envelope_account_password", sanitize_text_field( $_POST["cptn_po_opt_envelope_account_password"] ) );
    update_option( "cptn_po_opt_envelope_account_server", sanitize_text_field( $_POST["cptn_po_opt_envelope_account_server"] ) );
    update_option( "cptn_po_opt_envelope_account_port", sanitize_text_field( $_POST["cptn_po_opt_envelope_account_port"] ) );
    update_option( "cptn_po_opt_envelope_account_security", sanitize_text_field( $_POST["cptn_po_opt_envelope_account_security"] ) );
    cptn_po_sender_check( 9999 );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_get_headerfooter', 'cptn_po_config_get_headerfooter' );
add_action( 'wp_ajax_cptn_po_config_get_headerfooter', 'cptn_po_config_get_headerfooter' );
function cptn_po_config_get_headerfooter()
{
    global  $wpdb ;
    $output = array();
    $output["cptn_po_opt_affiliate_footer"] = esc_html( get_option( "cptn_po_opt_affiliate_footer" ) );
    $output["cptn_po_opt_affiliate_id"] = esc_html( get_option( "cptn_po_opt_affiliate_id" ) );
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_headerfooter_save', 'cptn_po_config_headerfooter_save' );
add_action( 'wp_ajax_cptn_po_config_headerfooter_save', 'cptn_po_config_headerfooter_save' );
function cptn_po_config_headerfooter_save()
{
    global  $wpdb ;
    if ( !isset( $_POST["cptn_po_opt_affiliate_footer"] ) ) {
        $_POST["cptn_po_opt_affiliate_footer"] = 0;
    }
    update_option( "cptn_po_opt_affiliate_footer", sanitize_text_field( $_POST["cptn_po_opt_affiliate_footer"] ) );
    update_option( "cptn_po_opt_affiliate_id", sanitize_text_field( $_POST["cptn_po_opt_affiliate_id"] ) );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_get_optimization', 'cptn_po_config_get_optimization' );
add_action( 'wp_ajax_cptn_po_config_get_optimization', 'cptn_po_config_get_optimization' );
function cptn_po_config_get_optimization()
{
    global  $wpdb ;
    $output = array();
    $query = "SELECT pluginname, pluginslug, mailcategory, mailcatfull FROM " . $wpdb->prefix . "cptn_po_plugin_mailcategory";
    $output["cptn_po_plugins"] = $wpdb->get_results( $query, ARRAY_A );
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_optimization_save', 'cptn_po_config_optimization_save' );
add_action( 'wp_ajax_cptn_po_config_optimization_save', 'cptn_po_config_optimization_save' );
function cptn_po_config_optimization_save()
{
    global  $wpdb ;
    $keys = array_map( 'sanitize_text_field', $_POST['mailcategory'] );
    foreach ( $keys as $key => $cat ) {
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t             WHERE pluginslug = '" . esc_sql( $key ) . "'";
        $row = $wpdb->get_row( $query, ARRAY_A );
        
        if ( $row ) {
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t\t              SET mailcategory = '" . esc_sql( $cat ) . "',\r\n\t\t\t\t\t  \t  mailcatfull = '" . esc_sql( cptn_po_abbreviations( $cat ) ) . "',\r\n\t\t\t\t\t      pluginname = '" . esc_sql( sanitize_text_field( $_POST['pluginname'][$key] ) ) . "'\r\n\t                WHERE pluginslug = '" . esc_sql( $key ) . "'";
            $wpdb->query( $query );
        } else {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t\t              SET plugin = '" . esc_sql( $key ) . "',\r\n\t\t\t\t\t      pluginname = '" . esc_sql( sanitize_text_field( $_POST['pluginname'][$key] ) ) . "',\r\n\t\t\t\t\t  \t  mailcatfull = '" . esc_sql( cptn_po_abbreviations( $cat ) ) . "',\r\n\t\t\t\t\t      mailcategory = '" . esc_sql( $cat ) . "'\r\n\t                \t  ";
            $wpdb->query( $query );
        }
    
    }
    cptn_po_sender_check( 9999 );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_get_report', 'cptn_po_config_get_report' );
add_action( 'wp_ajax_cptn_po_config_get_report', 'cptn_po_config_get_report' );
function cptn_po_config_get_report()
{
    global  $wpdb ;
    $output = array();
    $output["cptn_po_opt_admin_alerts"] = intval( get_option( "cptn_po_opt_admin_alerts" ) );
    $output["cptn_po_opt_admin_alerts_to"] = esc_html( get_option( "cptn_po_opt_admin_alerts_to" ) );
    $output["cptn_po_opt_info_developer"] = intval( get_option( "cptn_po_opt_info_developer" ) );
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_report_save', 'cptn_po_config_report_save' );
add_action( 'wp_ajax_cptn_po_config_report_save', 'cptn_po_config_report_save' );
function cptn_po_config_report_save()
{
    global  $wpdb ;
    update_option( "cptn_po_opt_admin_alerts_to", sanitize_email( $_POST["cptn_po_opt_admin_alerts_to"] ) );
    if ( !isset( $_POST["cptn_po_opt_info_developer"] ) ) {
        $_POST["cptn_po_opt_info_developer"] = 0;
    }
    if ( !isset( $_POST["cptn_po_opt_admin_alerts"] ) ) {
        $_POST["cptn_po_opt_admin_alerts"] = 0;
    }
    update_option( "cptn_po_opt_info_developer", intval( $_POST["cptn_po_opt_info_developer"] ) );
    update_option( "cptn_po_opt_admin_alerts", intval( $_POST["cptn_po_opt_admin_alerts"] ) );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_get_statistics', 'cptn_po_config_get_statistics' );
add_action( 'wp_ajax_cptn_po_config_get_statistics', 'cptn_po_config_get_statistics' );
function cptn_po_config_get_statistics()
{
    global  $wpdb ;
    $output = array();
    $output["cptn_po_opt_max_bounce"] = sanitize_text_field( get_option( "cptn_po_opt_max_bounce" ) );
    $output["cptn_po_opt_min_open"] = sanitize_text_field( get_option( "cptn_po_opt_min_open" ) );
    $output["cptn_po_opt_max_unsubscribe"] = sanitize_text_field( get_option( "cptn_po_opt_max_unsubscribe" ) );
    $output["cptn_po_opt_min_click"] = sanitize_text_field( get_option( "cptn_po_opt_min_click" ) );
    $output["cptn_po_opt_statistics_days"] = intval( get_option( "cptn_po_opt_statistics_days" ) );
    // local db size
    $query = "SHOW TABLE STATUS WHERE Name LIKE '" . $wpdb->prefix . "cptn_po_%'";
    $result = $wpdb->get_results( $query, ARRAY_A );
    $dbSize = 0;
    foreach ( $result as $key => $value ) {
        if ( strpos( strtolower( $value["Name"] ), "_cptn_po_" ) ) {
            $dbSize += $value["Data_length"];
        }
    }
    $output["cptn_po_config_statistics_db_size"] = $dbSize / 1024 / 1024;
    $output["cptn_po_config_statistics_recipients"] = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_recipient" );
    $output["cptn_po_config_statistics_mailserver"] = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_mailserver" );
    $output["cptn_po_config_statistics_domains"] = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_sender_domain" );
    $output["cptn_po_config_statistics_queue_wait"] = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_queue WHERE executed IS NULL AND error_date IS NULL" );
    $output["cptn_po_config_statistics_queue_sent"] = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_queue WHERE executed IS NOT NULL AND error_date IS NULL" );
    $output["cptn_po_config_statistics_queue_error"] = $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_queue WHERE error_date IS NOT NULL" );
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_config_statistics_save', 'cptn_po_config_statistics_save' );
add_action( 'wp_ajax_cptn_po_config_statistics_save', 'cptn_po_config_statistics_save' );
function cptn_po_config_statistics_save()
{
    global  $wpdb ;
    update_option( "cptn_po_opt_max_bounce", str_replace( ",", ".", sanitize_text_field( $_POST["cptn_po_opt_max_bounce"] ) ) );
    update_option( "cptn_po_opt_min_open", str_replace( ",", ".", sanitize_text_field( $_POST["cptn_po_opt_min_open"] ) ) );
    update_option( "cptn_po_opt_max_unsubscribe", str_replace( ",", ".", sanitize_text_field( $_POST["cptn_po_opt_max_unsubscribe"] ) ) );
    update_option( "cptn_po_opt_min_click", str_replace( ",", ".", sanitize_text_field( $_POST["cptn_po_opt_min_click"] ) ) );
    update_option( "cptn_po_opt_statistics_days", intval( $_POST["cptn_po_opt_statistics_days"] ) );
    wp_die();
}
