<?php

add_action( 'wp_ajax_nopriv_cptn_po_domains', 'cptn_po_domains' );
add_action( 'wp_ajax_cptn_po_domains', 'cptn_po_domains' );
function cptn_po_domains()
{
    global  $wpdb ;
    // +++++++++++++++++++ CONFIGURE ++++++++++++++++++++++++++
    function actionbuttons( $id, $status )
    {
        // main domain cannot be disabled or deleted
        
        if ( $id == 1 ) {
            $startstopbuttonstatus = " disabled";
        } else {
            $startstopbuttonstatus = "";
        }
        
        // start/stop-button for domain
        
        if ( $status == 0 ) {
            $startstopbutton = "fa-play-circle";
            $deletebuttonstatus = "";
            $startstopbuttoncolor = "btn-secondary";
            $startstopbuttontitle = __( "Unblock this domain", "campation-postoffice" );
        } else {
            $startstopbutton = "fa-pause";
            $deletebuttonstatus = " disabled";
            $startstopbuttoncolor = "btn-success";
            $startstopbuttontitle = __( "Block this domain", "campation-postoffice" );
        }
        
        return '<button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-primary btn_edit_domain" title="' . esc_attr__( "Edit / change this domain", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-todo="edit" data-reload="cptn-po-datatable-domains"><i class="fas fa-edit"></i></button>
	          <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-info btn_info_domain" title="' . esc_attr__( "Show domain details", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="cptn-po-datatable-domains"><i class="fas fa-info"></i></button>
	          <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-warning btn_server_domain" title="' . esc_attr__( "Configure mail servers for this domain", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="cptn-po-datatable-domains"><i class="fas fa-server"></i></button>
  		  	  <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-danger btn_delete_domain confirm-btn" title="' . esc_attr__( "Delete this domain - block it before", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="virelin-datatable-person"' . esc_attr( $deletebuttonstatus ) . '><i class="fas fa-trash-alt"></i></button>&nbsp;
		  	  <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs ' . esc_attr( $startstopbuttoncolor ) . ' btn_startstop_domain" title="' . esc_attr( $startstopbuttontitle ) . '" data-id="' . esc_attr( $id ) . '" data-startstop="' . esc_attr( $status ) . '" data-reload="cptn-po-datatable-domains"' . esc_attr( $startstopbuttonstatus ) . '><i class="fas ' . esc_attr( $startstopbutton ) . '"></i></button>
			  ';
    }
    
    $tables = $wpdb->prefix . "cptn_po_sender_domain sd\r\n\t\t\t\t   \t";
    // tablename in  database
    $primaryKey = 'sd.id';
    // timezone offset in hours
    $timezone_offset = cptn_timezone_offset( esc_html( get_option( "cptn_opt_timezone_staff" ) ), esc_html( get_option( "cptn_opt_timezone_server" ) ) );
    $columns = array(
        "action",
        "sd.id",
        "sd.domain",
        "sd.mailcategory",
        "(SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver dms INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = dms.mailserver_id WHERE dms.domain_id=sd.id AND dms.status=1 AND dms.server_status='OK' AND ms.status=1) AS count",
        "sd.domain_status",
        "sd.spf_record",
        "sd.dmarc_record",
        "sd.dkim_policy",
        "sd.mails_sent",
        "sd.mails_error",
        "CONCAT(sd.mails_bounced,' <i>(',ROUND(sd.mails_bounced/sd.mails_sent*100,1),'%</i> ',IF(ROUND(sd.mails_bounced/sd.mails_sent*100,1)<=" . esc_html( get_option( "cptn_po_opt_max_bounce" ) ) . ",'&#10004;','&#10071;'),')') AS mails_bounced",
        "CONCAT(sd.mails_opened,' <i>(',ROUND(sd.mails_opened/(sd.mails_sent-sd.mails_bounced)*100,1),'%</i> ',IF(ROUND(sd.mails_opened/(sd.mails_sent-sd.mails_bounced)*100,1)>=" . esc_html( get_option( "cptn_po_opt_min_open" ) ) . ",'&#10004;','&#10071;'),')') AS mails_opened",
        "IF(sd.open_delay>0,CONCAT(FLOOR(TIME_FORMAT(SEC_TO_TIME(sd.open_delay), '%H') / 24), 'd ',MOD(TIME_FORMAT(SEC_TO_TIME(sd.open_delay), '%H'), 24), 'h ',TIME_FORMAT(SEC_TO_TIME(sd.open_delay), '%im')),'') AS open_delay",
        "CONCAT(sd.mails_unsubscribed,' <i>(',ROUND(sd.mails_unsubscribed/(sd.mails_sent-sd.mails_bounced)*100,1),'%</i> ',IF(ROUND(sd.mails_unsubscribed/(sd.mails_sent-sd.mails_bounced)*100,1)<=" . esc_html( get_option( "cptn_po_opt_max_unsubscribe" ) ) . ",'&#10004;','&#10071;'),')') AS mails_unsubscribed",
        "CONCAT(sd.mails_clicked,' <i>(',ROUND(sd.mails_clicked/(sd.mails_sent-sd.mails_bounced)*100,1),'%</i> ',IF(ROUND(sd.mails_clicked/(sd.mails_sent-sd.mails_bounced)*100,1)>=" . esc_html( get_option( "cptn_po_opt_min_click" ) ) . ",'&#10004;','&#10071;'),')') AS mails_clicked",
        "IF(sd.click_delay>0,CONCAT(FLOOR(TIME_FORMAT(SEC_TO_TIME(sd.click_delay), '%H') / 24), 'd ',MOD(TIME_FORMAT(SEC_TO_TIME(sd.click_delay), '%H'), 24), 'h ',TIME_FORMAT(SEC_TO_TIME(sd.click_delay), '%im')),'') AS click_delay",
        "IF('" . CPTNPO_FS . "'='premium' OR '" . CPTNPO_FS . "'='business',CONCAT(sd.best_time_open+" . $timezone_offset . ",':00h'),'<span class=\"cptn-po-icon-pro-premium\"></span>') AS best_time_open",
        "IF('" . CPTNPO_FS . "'='premium' OR '" . CPTNPO_FS . "'='business',CONCAT(sd.best_time_click+" . $timezone_offset . ",':00h'),'<span class=\"cptn-po-icon-pro-premium\"></span>') AS best_time_click",
        "sd.status"
    );
    $fields = implode( ", ", $columns );
    $fields = str_replace( "action,", "", $fields );
    // action is not a database field
    $additionalfields = "\r\n   \t\t\t\t\t    ";
    // z.B. ", (SELECT COUNT(distinct url) FROM clicks WHERE company_id = c.id) AS cnt ";
    // this query is added first to all queries - MUST NOT BE EMPTY, at least "true"
    $querycomplex = " true\r\n\t\t\t\t    ";
    // this query is added second to all queries
    $queryrelation = "  \r\n\t\t\t\t    ";
    // this query is added third to all queries
    $queryadditional = "  ";
    include CPTNPODIR . "common/ajax/db-generate-json.php";
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domain_add', 'cptn_po_domain_add' );
add_action( 'wp_ajax_cptn_po_domain_add', 'cptn_po_domain_add' );
function cptn_po_domain_add()
{
    global  $wpdb ;
    $output = "";
    $query = "SELECT count(*) FROM " . $wpdb->prefix . "cptn_po_sender_domain";
    $count = $wpdb->get_var( $query );
    if ( $count ) {
        $output = "none";
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domain_modal_save', 'cptn_po_domain_modal_save' );
add_action( 'wp_ajax_cptn_po_domain_modal_save', 'cptn_po_domain_modal_save' );
function cptn_po_domain_modal_save()
{
    global  $wpdb ;
    
    if ( !$_POST['id'] ) {
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t       SET domain = '" . esc_sql( sanitize_text_field( $_POST['domainname'] ) ) . "',\r\n\t\t\t\t\t   mailcategory = '" . esc_sql( sanitize_text_field( $_POST['mailcategory'] ) ) . "',\r\n  \t\t\t\t\t   status = 1,\r\n\t\t\t\t \t   created = NOW(),\r\n\t\t\t\t\t   updated = NOW()\r\n\t\t\t\t\t   ";
        if ( isset( $_POST["envelope_address"] ) ) {
            $query .= ", envelope_address = '" . esc_sql( sanitize_email( $_POST["envelope_address"] ) ) . "'";
        }
        if ( isset( $_POST["unsubscribe_address"] ) ) {
            $query .= ", unsubscribe_address = '" . esc_sql( sanitize_email( $_POST["unsubscribe_address"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_address"] ) ) {
            $query .= ", dmarc_address = '" . esc_sql( sanitize_email( $_POST["dmarc_address"] ) ) . "'";
        }
        if ( isset( $_POST["from_address"] ) ) {
            $query .= ", from_address = '" . esc_sql( sanitize_email( $_POST["from_address"] ) ) . "'";
        }
        if ( isset( $_POST["replyto_address"] ) ) {
            $query .= ", replyto_address = '" . esc_sql( sanitize_email( $_POST["replyto_address"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_policy"] ) ) {
            $query .= ", dmarc_policy = '" . esc_sql( sanitize_text_field( $_POST["dmarc_policy"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_percent"] ) ) {
            $query .= ", dmarc_percent = '" . esc_sql( sanitize_text_field( $_POST["dmarc_percent"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_aspf"] ) ) {
            $query .= ", dmarc_aspf = '" . esc_sql( sanitize_text_field( $_POST["dmarc_aspf"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_adkim"] ) ) {
            $query .= ", dmarc_adkim = '" . esc_sql( sanitize_text_field( $_POST["dmarc_adkim"] ) ) . "'";
        }
        $wpdb->query( $query );
        $id = $wpdb->insert_id;
        // join with all mailservers
        $query = "SELECT id FROM " . $wpdb->prefix . "cptn_po_mailserver";
        $mailservers = $wpdb->get_results( $query, ARRAY_A );
        foreach ( $mailservers as $mailserver ) {
            $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t \t\t    WHERE mailserver_id = " . $mailserver['id'] . " AND domain_id = " . $id;
            $domains_ms = $wpdb->get_results( $query, ARRAY_A );
            
            if ( !$domains_ms ) {
                $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t \t\t         SET mailserver_id = " . $mailserver['id'] . ",\r\n\t\t\t\t\t\t \t domain_id = " . $id . ",\r\n\t\t\t\t\t\t \t status = 1";
                $wpdb->query( $query );
            }
        
        }
        cptn_po_sender_check( $id );
    } else {
        $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t       SET domain = '" . esc_sql( sanitize_text_field( $_POST['domainname'] ) ) . "',\r\n\t\t\t\t\t   mailcategory = '" . esc_sql( sanitize_text_field( $_POST['mailcategory'] ) ) . "',\r\n\t\t\t\t\t   updated = NOW()";
        if ( isset( $_POST["envelope_address"] ) ) {
            $query .= ", envelope_address = '" . esc_sql( sanitize_email( $_POST["envelope_address"] ) ) . "'";
        }
        if ( isset( $_POST["from_address"] ) ) {
            $query .= ", from_address = '" . esc_sql( sanitize_email( $_POST["from_address"] ) ) . "'";
        }
        if ( isset( $_POST["replyto_address"] ) ) {
            $query .= ", replyto_address = '" . esc_sql( sanitize_email( $_POST["replyto_address"] ) ) . "'";
        }
        if ( isset( $_POST["unsubscribe_address"] ) ) {
            $query .= ", unsubscribe_address = '" . esc_sql( sanitize_email( $_POST["unsubscribe_address"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_address"] ) ) {
            $query .= ", dmarc_address = '" . esc_sql( sanitize_email( $_POST["dmarc_address"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_policy"] ) ) {
            $query .= ", dmarc_policy = '" . esc_sql( sanitize_text_field( $_POST["dmarc_policy"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_percent"] ) ) {
            $query .= ", dmarc_percent = '" . esc_sql( sanitize_text_field( $_POST["dmarc_percent"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_aspf"] ) ) {
            $query .= ", dmarc_aspf = '" . esc_sql( sanitize_text_field( $_POST["dmarc_aspf"] ) ) . "'";
        }
        if ( isset( $_POST["dmarc_adkim"] ) ) {
            $query .= ", dmarc_adkim = '" . esc_sql( sanitize_text_field( $_POST["dmarc_adkim"] ) ) . "'";
        }
        $query .= " WHERE id = " . intval( $_POST['id'] );
        $wpdb->query( $query );
    }
    
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_startstop', 'cptn_po_domains_startstop' );
add_action( 'wp_ajax_cptn_po_domains_startstop', 'cptn_po_domains_startstop' );
function cptn_po_domains_startstop()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    
    if ( intval( $_POST['status'] ) == 0 ) {
        $status = 1;
        cptn_po_sender_check( $id );
    } else {
        $status = 0;
    }
    
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n   \t\t        SET status = " . $status . "\r\n\t\t\t  WHERE id = " . $id;
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_delete', 'cptn_po_domains_delete' );
add_action( 'wp_ajax_cptn_po_domains_delete', 'cptn_po_domains_delete' );
function cptn_po_domains_delete()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t  WHERE id = " . $id;
    $wpdb->query( $query );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t\t  WHERE domain_id = " . $id;
    $wpdb->query( $query );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_queue\r\n\t\t\t  WHERE sender_domain_id = " . $id . "\r\n\t\t\t    AND executed IS NULL\r\n\t\t\t\t";
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_info', 'cptn_po_domains_info' );
add_action( 'wp_ajax_cptn_po_domains_info', 'cptn_po_domains_info' );
function cptn_po_domains_info()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $query = "SELECT *\r\n   \t           FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t  WHERE id = " . $id . "\r\n\t\t\t  \t ";
    $domain = $wpdb->get_row( $query, ARRAY_A );
    $query = "SELECT ms.* FROM " . $wpdb->prefix . "cptn_po_mailserver ms\r\n   \t\t     INNER JOIN  " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm ON sdm.mailserver_id = ms.id AND sdm.domain_id = " . $id;
    $mailservers = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
        error_log( $wpdb->print_error() );
        wp_die();
    }
    
    $dnscolumns = "col-md-4";
    if ( intval( get_option( "cptn_po_opt_bimi" ) ) != 1 ) {
        $dnscolumns = "col-md-6";
    }
    $output = '

<div style="display:inline-block;float:right;text-align:right;"><button type="button" class="button" data-id="' . esc_attr( $id ) . '" id="cptn-po-reedit-domain">' . esc_html__( "RE-EDIT DOMAIN", "campation-postoffice" ) . '</button><br><small><i>' . esc_html__( "will close this and open edit window", "campation-postoffice" ) . '</i></small></div>

   <ul class="nav nav-pills" id="myTab1" role="tablist">
      <li class="nav-item" role="presentation">
         <button class="nav-link active" id="dns-tab" data-bs-toggle="tab" data-bs-target="#dns" type="button" role="tab" aria-controls="dns" aria-selected="true">' . esc_html__( "DNS", "campation-postoffice" ) . '</a>
      </li>
      <li class="nav-item" role="presentation">
         <button class="nav-link" id="dmarc-tab" data-bs-toggle="tab" data-bs-target="#dmarc" type="button" role="tab" aria-controls="dmarc" aria-selected="false">' . esc_html__( "DMARC reports", "campation-postoffice" ) . '</a>
      </li>
      <li class="nav-item" role="presentation">
         <button class="nav-link" id="health-tab" data-bs-toggle="tab" data-bs-target="#health" type="button" role="tab" aria-controls="health" aria-selected="false">' . esc_html__( "Health", "campation-postoffice" ) . '</a>
      </li>
   </ul>


   <div class="tab-content" id="myTab1Content">

      <div class="tab-pane fade show active" id="dns" role="tabpanel" aria-labelledby="dns-tab">          
         <br>
	     <div class="row">
            <div class="col-12 ' . esc_attr( $dnscolumns ) . '">                   <!-- 1st column -->
      		   <div class="cptn-admin-box-header">' . esc_html__( "MX record", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "Every sender domain needs a valid MX record to receive emails through the addresses defined in configuration tab", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      		   <div class="cptn-admin-box-dotted-border">
';
    
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
        $output .= '		      
			      <table width=100%>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Host name", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . esc_html( $domain['domain'] ) . '</strong></td></tr>';
        
        if ( $domain['mx_record'] ) {
            $output .= '    <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . esc_html( $domain['mx_record'] ) . '</strong></td></tr>
                 	 <tr><td valign=top style="font-size:12px;" colspan=2><br><center><span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . esc_html__( "MX record found", "campation-postoffice" ) . '</u></span></center></td></tr>';
        } else {
            $output .= '    <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;color:#aa0000;"><strong>' . esc_html__( "record not found", "campation-postoffice" ) . '</strong></td></tr>';
        }
        
        $output .= '    </table>';
    } else {
        $output .= '    <div style="font-size:12px;text-align:center;margin-top:10px;">' . esc_html__( "Data will be available 5-10min after background check", "campation-postoffice" ) . '</div>';
    }
    
    $output .= '		      
               </div>

      		   <div class="cptn-admin-box-header">' . esc_html__( "SPF record", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The Sender Policy Framework (SPF) is a DNS record that prevents the falsification of the sender address of an email, more precisely: the sending of emails via unauthorized mail servers is to be prevented. In the DNS it is determined for a domain which mail servers are authorized and what should be done with emails that originate from unauthorized servers.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      		   <div class="cptn-admin-box-dotted-border">
';
    
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
        $output .= '		      
			      <table width=100%>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Host name", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . esc_html( $domain['domain'] ) . '</strong></td></tr>
';
        
        if ( !empty(esc_html( $domain['spf_record'] )) ) {
            $found = esc_html( $domain['spf_record'] );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '	 <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . $found . '</strong></td></tr>
';
        
        if ( $domain['spf_record'] and cptn_po_clean_dns_record( $domain['spf_record'] ) == cptn_po_clean_dns_record( $domain['spf_recommendation'] ) ) {
            $output .= '    <tr><td valign=top style="font-size:12px;" colspan=2><br><center><span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . esc_html__( "SPF record is correct", "campation-postoffice" ) . '</u></span></center></td></tr>';
        } else {
            $output .= '	 <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Recommended", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" id="copy_spf_recommendation"><strong>' . esc_html( $domain['spf_recommendation'] ) . '</strong></td></tr>
				     <tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-spf-record" data-copy="copy_spf_recommendation" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>';
        }
        
        $output .= '    </table>';
    } else {
        $output .= '    <div style="font-size:12px;text-align:center;margin-top:10px;">' . esc_html__( "Data will be available 5-10min after background check", "campation-postoffice" ) . '</div>';
    }
    
    $output .= '		      
               </div>
			</div>                                         <!-- end 1st column -->   

   	        <div class="col-12 ' . esc_attr( $dnscolumns ) . '">           <!-- 2nd column -->
      		   <div class="cptn-admin-box-header">
         	      ' . esc_html__( "DMARC record", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "DMARC, which stands for Domain-based Message Authentication, Reporting, and Conformance, is a DNS TXT Record that can be published for a domain to control what happens if a message fails authentication (i.e. the recipient server can't verify that the message's sender is who they say they are).", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
               </div>
      		   <div class="cptn-admin-box-dotted-border">
			   	  <table width=100%>
';
    
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
        $output .= '		      
			      <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Host name", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>_dmarc.' . esc_html( $domain['domain'] ) . '</strong></td></tr>
';
        
        if ( !empty(esc_html( $domain['dmarc_record'] )) ) {
            $found = esc_html( $domain['dmarc_record'] );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '  <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . $found . '</strong></td></tr>
';
        
        if ( $domain['dmarc_record'] and cptn_po_clean_dns_record( $domain['dmarc_record'] ) == cptn_po_clean_dns_record( $domain['dmarc_recommendation'] ) ) {
            $output .= '    <tr><td valign=top style="font-size:12px;" colspan=2><br><center><span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . esc_html__( "DMARC record is correct", "campation-postoffice" ) . '</u></span></center></td></tr>';
        } else {
            $output .= '	  <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Recommended", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" id="copy_dmarc_recommendation"><strong>' . esc_html( $domain['dmarc_recommendation'] ) . '</strong></td></tr>
				  <tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-dmarc-record" data-copy="copy_dmarc_recommendation" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>';
        }
    
    }
    
    $output .= ' </table>';
    if ( !isset( $_POST['id'] ) or !intval( $_POST['id'] ) ) {
        $output .= '<div style="font-size:12px;text-align:center;margin-top:10px;">' . esc_html__( "Data will be available 5-10min after background check", "campation-postoffice" ) . '</div>';
    }
    $output .= '		      
               </div>

      		   <div class="cptn-admin-box-header">
         	      ' . esc_html__( "DKIM policy", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The DKIM policy is a DNS TXT Record that can be published for a domain regarding the digital digital signature policy", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
               </div>
      		   <div class="cptn-admin-box-dotted-border">
			   	  <table width=100%>
';
    
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
        $output .= '		      
			      <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Host name", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>_domainkey.' . esc_html( $domain['domain'] ) . '</strong></td></tr>
';
        
        if ( !empty(esc_html( $domain['dkim_policy'] )) ) {
            $found = esc_html( $domain['dkim_policy'] );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '  <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . $found . '</strong></td></tr>
';
        
        if ( $domain['dkim_policy'] and cptn_po_clean_dns_record( $domain['dkim_policy'] ) == cptn_po_clean_dns_record( $domain['dkim_policy_recommendation'] ) ) {
            $output .= '    <tr><td valign=top style="font-size:12px;" colspan=2><br><center><span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . esc_html__( "DKIM policy is correct", "campation-postoffice" ) . '</u></span></center></td></tr>';
        } else {
            $output .= '	  <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Recommended", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" id="copy_dmarc_recommendation"><strong>' . esc_html( $domain['dkim_policy_recommendation'] ) . '</strong></td></tr>
				  <tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-dkim-policy" data-copy="copy_dkim_policy_recommendation" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>';
        }
    
    }
    
    $output .= ' </table>';
    if ( !isset( $_POST['id'] ) or !intval( $_POST['id'] ) ) {
        $output .= '<div style="font-size:12px;text-align:center;margin-top:10px;">' . esc_html__( "Data will be available 5-10min after background check", "campation-postoffice" ) . '</div>';
    }
    $output .= '		      
               </div>
            </div>                                         <!-- end 2nd column -->
';
    
    if ( intval( get_option( "cptn_po_opt_bimi" ) ) == 1 ) {
        $output .= '
   	        <div class="col-12 ' . esc_attr( $dnscolumns ) . '">          <!-- 3rd column -->
      		   <div class="cptn-admin-box-header">' . esc_html__( "BIMI record", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "'Brand Indicator Message Identification (BIMI)' records use brand logos as indicators to help email recipients recognize and avoid fraudulent messages. A DNS BIMI record is used to display a company logo inside the email inbox if the email is legitimate.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      		   <div class="cptn-admin-box-dotted-border">
';
        
        if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
            $output .= '    <table width=100%>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Host name", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>default._bimi.' . esc_html( $domain['domain'] ) . '</strong></td></tr>
';
            
            if ( !empty(esc_html( $domain['bimi_record'] )) ) {
                $found = esc_html( $domain['bimi_record'] );
            } else {
                $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
            }
            
            $output .= '  	 <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . $found . '</strong></td></tr>
';
            
            if ( $domain['bimi_record'] and strtolower( $domain['bimi_record'] ) == strtolower( $domain['bimi_recommendation'] ) ) {
                $output .= '		 <tr><td valign=top style="font-size:12px;" colspan=2><br><center><span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . esc_html__( "BIMI record is correct", "campation-postoffice" ) . '</u></span></center></td></tr>';
            } else {
                $output .= '		 <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Recommended", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" id="copy_bimi_recommendation"><strong>' . esc_html( $domain['bimi_recommendation'] ) . '</strong></td></tr>
				     <tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-bimi-record"  data-copy="copy_bimi_recommendation" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>';
            }
            
            $output .= '    </table>';
        }
        
        if ( !isset( $_POST['id'] ) or !intval( $_POST['id'] ) ) {
            $output .= '    <div style="font-size:12px;text-align:center;margin-top:10px;">' . esc_html__( "Data will be available 5-10min after background check", "campation-postoffice" ) . '</div>';
        }
        $output .= '		      
               </div>
            </div>               <!-- end 3rd column -->
';
    }
    
    $output .= '
         </div>   <!-- end row -->

		 <div class="row">
		    <div class="col-md-12">
			   <center><a href="' . CPTNPOPATH . 'bind-dns/BIND-DNS-' . $domain['domain'] . '.txt" download="BIND-DNS-' . $domain['domain'] . '.txt"><button type="button" class="button bind-zone-file-button" title="' . esc_attr__( "Download a BIND zone file for upload into your DNS", "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( "BIND zone file", "campation-postoffice" ) ) . '</button></a></center>
			</div>
		 </div>

      </div>      <!-- end tab-pane -->



      <div class="tab-pane fade" id="dmarc" role="tabpanel" aria-labelledby="dmarc-tab">
         <br>
	     <div class="row">
   	        <div class="col-12 col-md-12">
      		   <div class="cptn-admin-box-header">' . esc_html__( "DMARC reports", "campation-postoffice" ) . '<span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "DMARC reports analyze how your mail servers comply with DMARC configuration for this domain and how many messages pass SPF, DKIM and DMARC authentication.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      		   <div class="cptn-admin-box-dotted-border cptn_po_is_for_premium">
			   	  <br>
';
    $output .= '</div>
            </div>
		 </div>		 
      </div>      <!-- end tab-pane -->

      <div class="tab-pane fade" id="health" role="tabpanel" aria-labelledby="health-tab">
         <br>
      	 <div class="row">
   	        <div class="col-12 col-md-12">
      		   <div class="cptn-admin-box-header">
         	      ' . esc_html__( "Health report", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The health report shows all errors and recommendations - for optimal email delivery performance it should be empty!", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
               </div>
      		   <div class="cptn-admin-box-dotted-border">
			      <div>
';
    
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
        
        if ( empty($domain['last_checked']) ) {
            $output .= '<br><div style="text-align:center;">' . esc_html__( "Please wait for background check result or click button to re-check domain again", "campation-postoffice" ) . '</div>';
        } elseif ( empty($domain['last_check_result']) ) {
            $output .= '<br><div style="text-align:center;">' . esc_html__( "This domain is perfectly configured for high email delivery performance!", "campation-postoffice" ) . '</div>';
        } else {
            $output .= '<div id="cptn_po_last_check_result"><ul class="cptn-ul">' . wp_kses_post( $domain['last_check_result'] ) . '</ul></div>';
        }
    
    } else {
        $output .= '<div style="text-align:center;margin-top:10px;">' . esc_html__( "Data will be available 5-10min after background check", "campation-postoffice" ) . '</div>';
    }
    
    $output .= '   
			      </div>	  
               </div>
            </div>
         </div>   <!-- end row -->
      </div>      <!-- end tab-pane -->
   </div>         <!-- end tab-content -->
';
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_edit', 'cptn_po_domains_edit' );
add_action( 'wp_ajax_cptn_po_domains_edit', 'cptn_po_domains_edit' );
function cptn_po_domains_edit()
{
    global  $wpdb ;
    
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) ) {
        $query = "SELECT *\r\n   \t\t          FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t     WHERE id = " . intval( $_POST['id'] ) . "\r\n\t\t\t  \t ";
        $row = $wpdb->get_row( $query, ARRAY_A );
    } else {
        $row = [
            "id"                   => 0,
            "domain"               => "",
            "mailcategory"         => "",
            "status"               => 0,
            "envelope_address"     => "",
            "from_address"         => "",
            "replyto_address"      => "",
            "unsubscribe_address"  => "",
            "dmarc_address"        => "",
            "envelope_server"      => "",
            "envelope_port"        => "",
            "envelope_security"    => "",
            "envelope_account"     => "",
            "envelope_password"    => "",
            "spf_record"           => "",
            "spf_recommendation"   => "",
            "dmarc_server"         => "",
            "dmarc_port"           => "",
            "dmarc_security"       => "",
            "dmarc_account"        => "",
            "dmarc_password"       => "",
            "dmarc_policy"         => "",
            "dmarc_percent"        => "",
            "dmarc_aspf"           => "",
            "dmarc_adkim"          => "",
            "dmarc_record"         => "",
            "dmarc_recommendation" => "",
            "bimi_logo_url"        => "",
            "bimi_certificate_url" => "",
            "bimi_record"          => "",
            "bimi_recommendation"  => "",
            "mails_sent"           => 0,
            "mails_error"          => 0,
            "mails_opened"         => 0,
            "mails_clicked"        => 0,
        ];
    }
    
    $usedcategories = "";
    $query = "SELECT DISTINCT mailcategory\r\n               FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t  WHERE mailcategory>''\r\n\t\t\t    AND id != " . $row['id'];
    $categories = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $categories as $value ) {
        $usedcategories .= $value['mailcategory'] . " | ";
    }
    if ( isset( $_POST['id'] ) and intval( $_POST['id'] ) == 1 ) {
        // no mailcategory for main domain
        $usedcategories = "trans | marke | bulk | cold |";
    }
    $configcolumns = "col-md-3";
    if ( intval( get_option( "cptn_po_opt_bimi" ) ) != 1 ) {
        $configcolumns = "col-md-4";
    }
    $output = '
<form id="cptn_po_domain_form">
   <input type="hidden" name="id" value="' . intval( $row['id'] ) . '">
   <input type="hidden" name="status" value="' . esc_attr( $row['status'] ) . '">
   <input type="hidden" name="action" value="cptn_po_domain_modal_save" />
   <input type="hidden" id="cptn_po_usedcategories" value="' . esc_attr( $usedcategories ) . '">

      	 <div class="row">
   	        <div class="col-12 ' . esc_attr( $configcolumns ) . '">
			   <div class="row">
   	              <div class="col-12 col-md-12">
      	             <div class="cptn-admin-box-header">
         	            ' . esc_html__( "Name and category", "campation-postoffice" ) . ' <span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "Each mail category only can be set once - if a category is not selectable it is already in use by another (sub)domain.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
                     </div>		 
      		   	  	 <div class="cptn-admin-box-dotted-border">
	     	            <table width=100%>
		                   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "Domain name", "campation-postoffice" ) . '</td><td><input type="text" name="domainname" id="domainname" value="' . esc_attr( $row['domain'] ) . '"></td></tr>
		    	     	   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "Mail category", "campation-postoffice" ) . '</td><td><select name="mailcategory" id="mailcategory" data-selected="' . esc_attr( $row['mailcategory'] ) . '"><option value="">' . esc_html__( "Without", "campation-postoffice" ) . '</option><option value="trans">' . esc_html__( "transactional", "campation-postoffice" ) . '</option><option value="marke">' . esc_html__( "marketing", "campation-postoffice" ) . '</option><option value="bulk">' . esc_html__( "bulk mail", "campation-postoffice" ) . '</option><option value="cold">' . esc_html__( "cold mail", "campation-postoffice" ) . '</option></select></td></tr>
		                </table>
                     </div>
                  </div>
               </div>
			</div>

   	        <div class="col-12 ' . esc_attr( $configcolumns ) . '">
			   <div class="row">
   	              <div class="col-12 col-md-12">
      	             <div class="cptn-admin-box-header">
         	            ' . esc_html__( "Email addresses", "campation-postoffice" ) . ' <span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The 'envelope' (or 'bounce') and 'unsubscribe' address are required for all domains, are not shown to or used by the recipient and must be forwarded to the envelope imap account for automatic bounce and unsubscription management.\n\nThe 'DMARC' address is required for proper DNS setup and to receive so-called DMARC reports. It has to be forwarded to the DMARC or envelope IMAP account.\n\nThe 'From' address is shown to the recipient, the 'Reply-To' address receives all replies from recipients. Both are optional but have to be set for domains with a mail category (the original addresses will be overwritten with those by Campation DomainProtect&trade;).\n\nAll addresses MUST be in this sender domain and can be forwarded to any IMAP account.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
                     </div>		 
      		   	  	 <div class="cptn-admin-box-dotted-border">
	     	            <table width=100%>
		                   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "Envelope", "campation-postoffice" ) . '</td><td><input type="email" name="envelope_address" id="envelope_address" placeholder="postoffice@' . esc_attr( $row['domain'] ) . '" value="' . esc_attr( $row['envelope_address'] ) . '" required></td></tr>
		                   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "Unsubscribe", "campation-postoffice" ) . '</td><td><input type="email" name="unsubscribe_address" id="unsubscribe_address" placeholder="unsubscribe@' . esc_attr( $row['domain'] ) . '" value="' . esc_attr( $row['unsubscribe_address'] ) . '" required></td></tr>
		             	   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "DMARC", "campation-postoffice" ) . '</td><td><input type="email" name="dmarc_address" id="dmarc_address" placeholder="dmarc@' . esc_attr( $row['domain'] ) . '" value="' . esc_attr( $row['dmarc_address'] ) . '" required></td></tr>
		                   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "From", "campation-postoffice" ) . '</td><td><input type="email" name="from_address" id="from_address" placeholder="info@' . esc_attr( $row['domain'] ) . '" value="' . esc_attr( $row['from_address'] ) . '" required></td></tr>
		                   <tr><td valign=middle style="font-size:12px;">' . esc_html__( "Reply-To", "campation-postoffice" ) . '</td><td><input type="email" name="replyto_address" id="replyto_address" placeholder="reply@' . esc_attr( $row['domain'] ) . '" value="' . esc_attr( $row['replyto_address'] ) . '" required></td></tr>
		                </table>
                     </div>
                  </div>
			   </div>   
			</div>   

   	        <div class="col-12 ' . esc_attr( $configcolumns ) . '">
      		   <div class="cptn-admin-box-header">
         	      ' . esc_html__( "DMARC record", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "DMARC, which stands for Domain-based Message Authentication, Reporting, and Conformance, is a DNS TXT Record that can be published for a domain to control what happens if a message fails authentication (i.e. the recipient server can't verify that the message's sender is who they say they are).", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
               </div>
      		   <div class="cptn-admin-box-dotted-border">
			   	  <table width=100%>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Policy", "campation-postoffice" ) . '</td><td><select name="dmarc_policy" id="dmarc_policy" data-selected="' . esc_attr( $row['dmarc_policy'] ) . '"><option value="none">none</option><option value="quarantine">quarantine</option><option value="reject">reject</option></select></td></tr>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Percent", "campation-postoffice" ) . '</td><td><input type="text" name="dmarc_percent" id="dmarc_percent" placeholder="100" value="' . esc_attr( $row['dmarc_percent'] ) . '"></td></tr>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "SPF alignment", "campation-postoffice" ) . '</td><td><select name="dmarc_aspf" id="dmarc_aspf" data-selected="' . esc_attr( $row['dmarc_aspf'] ) . '"><option value="r">relaxed</option><option value="s">strict</option></select></td></tr>
			         <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "DKIM alignment", "campation-postoffice" ) . '</td><td><select name="dmarc_adkim" id="dmarc_adkim" data-selected="' . esc_attr( $row['dmarc_adkim'] ) . '"><option value="r">relaxed</option><option value="s">strict</option></select></td></tr>
                  </table>
               </div>
            </div>

';
    $output .= '
         </div>   <!-- end row -->
</form>
<div style="display:inline-block;float:right;text-align:right;"><button type="button" class="button" data-id="' . esc_attr( $_POST['id'] ) . '" id="cptn-po-recheck-domain">' . esc_html__( "RE-CHECK DOMAIN", "campation-postoffice" ) . '</button><br><small><i>' . esc_html__( "will save, close and open info window", "campation-postoffice" ) . '</i></small></div>

';
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_server', 'cptn_po_domains_server' );
add_action( 'wp_ajax_cptn_po_domains_server', 'cptn_po_domains_server' );
function cptn_po_domains_server()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $output = '
<div class="row">  <!-- complete container -->		 
   <div class="col-12 col-md-12">  <!-- left column -->
      <div class="cptn-admin-box-header">
         ' . esc_html__( "Connected mail server", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "Each domain is served by any number of mail servers. The mail servers are defined / configured in the 'mail servers' menu. Each mail server needs a proper configuration inside this domain which is done here. You may switch off mail servers for this domain using the start-stop button.", "campation-postoffice" ) . ' ' . esc_html__( "For the best protection of your domain (Campation DomainProtect&trade; activated) it is recommended to use only one dedicated mail server for each mail category and to stop all other mail servers on this domain ('trans' -> mail server 1, 'bulk' -> mail server 3 etc.).", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
      </div>
      <div class="cptn-admin-box-dotted-border">
   		 <table id="cptn-po-datatable-domains-mailserver" data-id="' . esc_attr( $id ) . '" data-tablehead="cptn_po_domains_mailserver" data-page-length="16" data-url="cptn_po_domains_mailserver" class="virelin-datatable table table-hover table-compact" cellspacing="0" width="100%" style="margin-bottom:20px !important;width:100% !important;">
	  	    <thead>
      		</thead>
	  		<tbody>
	  		</tbody>
         </table>
      </div>
   </div>                         <!-- end column -->
</div>                        <!-- end container -->
';
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_recheck_domain', 'cptn_po_recheck_domain' );
add_action( 'wp_ajax_cptn_po_recheck_domain', 'cptn_po_recheck_domain' );
function cptn_po_recheck_domain()
{
    global  $wpdb ;
    $domainid = 0;
    $serverid = 0;
    $recreatekeys = 0;
    if ( isset( $_POST['id'] ) ) {
        $domainid = intval( $_POST['id'] );
    }
    if ( isset( $_POST['serverid'] ) ) {
        $serverid = intval( $_POST['serverid'] );
    }
    if ( isset( $_POST['recreatekeys'] ) ) {
        $recreatekeys = sanitize_text_field( $_POST['recreatekeys'] );
    }
    
    if ( $domainid > 0 and $serverid > 0 and $recreatekeys > 0 ) {
        echo  wp_kses_post( cptn_po_sender_check( $domainid, $serverid, $recreatekeys ) ) ;
    } elseif ( $domainid > 0 ) {
        echo  wp_kses_post( cptn_po_sender_check( $domainid ) ) ;
    } else {
        echo  wp_kses_post( cptn_po_sender_check() ) ;
    }
    
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_mailserver', 'cptn_po_domains_mailserver' );
add_action( 'wp_ajax_cptn_po_domains_mailserver', 'cptn_po_domains_mailserver' );
function cptn_po_domains_mailserver()
{
    global  $wpdb ;
    $domain_id = intval( $_GET['id'] );
    // +++++++++++++++++++ CONFIGURE ++++++++++++++++++++++++++
    function actionbuttons( $id, $status )
    {
        // start/stop-button for domain_mailserver
        
        if ( $status == 0 ) {
            $startstopbutton = "fa-play-circle";
            $deletebuttonstatus = "";
            $startstopbuttonstatus = "";
            $startstopbuttoncolor = "btn-secondary";
            $startstopbuttontitle = __( "Start this mail server for domain", "campation-postoffice" );
        } else {
            $startstopbutton = "fa-pause";
            $deletebuttonstatus = " disabled";
            $startstopbuttoncolor = "btn-success";
            $startstopbuttontitle = __( "Stop this mail server for domain", "campation-postoffice" );
        }
        
        return '<button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-primary btn_edit_domain_mailserver" title="' . esc_attr__( "Edit / change this domain-mailserver combination", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-todo="edit" data-reload="cptn-po-datatable-domains"><i class="fas fa-edit"></i></button>
	          <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-info btn_info_domain_mailserver" title="' . esc_attr__( "Domain-mailserver details", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="cptn-po-datatable-domains"><i class="fas fa-info"></i></button>
		  	  <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-secondary btn_testmail_domain_mailserver" title="' . esc_attr__( "Send a test email from this domain through this server", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="cptn-po-datatable-domains"><i class="fas fa-envelope"></i></button>
		  	  <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs ' . esc_attr( $startstopbuttoncolor ) . ' btn_startstop_domain_mailserver" title="' . esc_attr( $startstopbuttontitle ) . '" data-id="' . esc_attr( $id ) . '" data-startstop="' . esc_attr( $status ) . '" data-reload="cptn-po-datatable-domains"><i class="fas ' . esc_attr( $startstopbutton ) . '"></i></button>
			  ';
    }
    
    $tables = $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm\r\n   \t\t\t\t  INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdm.mailserver_id\r\n\t\t\t\t   \t";
    // tablename in  database
    $primaryKey = 'sdm.id';
    $columns = array(
        "action",
        "sdm.id",
        "ms.status AS mailserver_status",
        "ms.shortname",
        "ms.address",
        "sdm.server_status",
        "sdm.spf",
        "sdm.dkim",
        "sdm.dkim_selector",
        "sdm.mails_sent",
        "sdm.mails_error",
        "CONCAT(sdm.mails_bounced,' <i>(',ROUND(sdm.mails_bounced/sdm.mails_sent*100,1),'%</i> ',IF(ROUND(sdm.mails_bounced/sdm.mails_sent*100,1)<=" . esc_html( get_option( "cptn_po_opt_max_bounce" ) ) . ",'&#10004;','&#10071;'),')') AS mails_bounced",
        "CONCAT(sdm.mails_opened,' <i>(',ROUND(sdm.mails_opened/(sdm.mails_sent-sdm.mails_bounced)*100,1),'%</i> ',IF(ROUND(sdm.mails_opened/(sdm.mails_sent-sdm.mails_bounced)*100,1)>=" . esc_html( get_option( "cptn_po_opt_min_open" ) ) . ",'&#10004;','&#10071;'),')') AS mails_opened",
        "CONCAT(sdm.mails_unsubscribed,' <i>(',ROUND(sdm.mails_unsubscribed/(sdm.mails_sent-sdm.mails_bounced)*100,1),'%</i> ',IF(ROUND(sdm.mails_unsubscribed/(sdm.mails_sent-sdm.mails_bounced)*100,1)<=" . esc_html( get_option( "cptn_po_opt_max_unsubscribe" ) ) . ",'&#10004;','&#10071;'),')') AS mails_unsubscribed",
        "CONCAT(sdm.mails_clicked,' <i>(',ROUND(sdm.mails_clicked/(sdm.mails_sent-sdm.mails_bounced)*100,1),'%</i> ',IF(ROUND(sdm.mails_clicked/(sdm.mails_sent-sdm.mails_bounced)*100,1)>=" . esc_html( get_option( "cptn_po_opt_min_click" ) ) . ",'&#10004;','&#10071;'),')') AS mails_clicked",
        "sdm.status"
    );
    $fields = implode( ", ", $columns );
    $fields = str_replace( "action,", "", $fields );
    // action is not a database field
    $additionalfields = "\r\n   \t\t\t\t\t    ";
    // z.B. ", (SELECT COUNT(distinct url) FROM clicks WHERE company_id = c.id) AS cnt ";
    // this query is added first to all queries - MUST NOT BE EMPTY, at least "true"
    $querycomplex = " true\r\n   \t\t\t\t     AND sdm.domain_id = " . $domain_id . "\r\n\t\t\t\t    ";
    // this query is added second to all queries
    $queryrelation = "  \r\n\t\t\t\t    ";
    // this query is added third to all queries
    $queryadditional = "  ";
    include CPTNPODIR . "common/ajax/db-generate-json.php";
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_mailserver_startstop', 'cptn_po_domains_mailserver_startstop' );
add_action( 'wp_ajax_cptn_po_domains_mailserver_startstop', 'cptn_po_domains_mailserver_startstop' );
function cptn_po_domains_mailserver_startstop()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    
    if ( intval( $_POST['status'] ) == 0 ) {
        $status = 1;
    } else {
        $status = 0;
    }
    
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n   \t\t        SET status = " . $status . "\r\n\t\t\t  WHERE id = " . $id;
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_mailserver_info', 'cptn_po_domains_mailserver_info' );
add_action( 'wp_ajax_cptn_po_domains_mailserver_info', 'cptn_po_domains_mailserver_info' );
function cptn_po_domains_mailserver_info()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $query = "SELECT sdm.*, sd.domain, ms.server_type \r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm\r\n   \t\t       INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain sd ON sd.id = sdm.domain_id\r\n   \t\t       INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdm.mailserver_id\r\n\t\t\t  WHERE sdm.id = " . $id . "\r\n\t\t\t  ";
    $row = $wpdb->get_row( $query, ARRAY_A );
    $output = "";
    
    if ( $row ) {
        $output .= '

	  
<div class="row">
   <div class="col-md-6">
      <ul class="nav nav-pills" id="myTab2" role="tablist">
  	     <li class="nav-item" role="presentation">
    	    <button class="nav-link active" id="dkim-tab" data-bs-toggle="tab" data-bs-target="#dkim" type="button" role="tab" aria-controls="dkim" aria-selected="false">' . esc_html__( "DKIM", "campation-postoffice" ) . '</a>
         </li>
  		 <li class="nav-item" role="presentation">
    	    <button class="nav-link" id="health2-tab" data-bs-toggle="tab" data-bs-target="#health2" type="button" role="tab" aria-controls="health2" aria-selected="false">' . esc_html__( "Health", "campation-postoffice" ) . '</a>
         </li>
      </ul>
   </div>

   <div class="col-md-6" style="text-align:right">
      <div style="display:inline-block;float:right;text-align:right;margin-top:0px;">
   	  <button type="button" class="button"  data-id="' . esc_attr( $row['domain_id'] ) . '" data-serverid="' . esc_attr( $id ) . '" id="cptn-po-recheck-domain-mailserver">' . esc_html__( "RE-CHECK DOMAIN", "campation-postoffice" ) . '</button>
   	  <br>
   	  <small><i>' . esc_html__( "will save, close and re-open window", "campation-postoffice" ) . '</i></small><br>
      ';
        if ( $row['server_type'] != "smtp" ) {
            $output .= '
      	 <div class="form-check form-check-inline" style="margin-top:-20px;"><label class="form-check-label" for="cptn_domain_recreate_keys"><small>' . esc_html__( "re-create keys and DKIM record, DNS update required", "campation-postoffice" ) . '</small></label>&nbsp;&nbsp;&nbsp;<input class="form-check-input" type="checkbox" id="cptn_domain_recreate_keys" name="cptn_domain_recreate_keys" value="1"></div>
      	 ';
        }
        $output .= '
      </div>
   </div>
</div>	  

<div class="tab-content" id="myTab2Content">

  <div class="tab-pane fade active show" id="dkim" role="tabpanel" aria-labelledby="dkim-tab">
     <br>
     <div class="row">
   	    <div class="col-12 col-md-4">
      	   <div class="cptn-admin-box-header">' . esc_html__( "DKIM record", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "DKIM (DomainKeys Identified Mail) is a protocol that allows an organization to take responsibility for transmitting a message by signing it in a way that mailbox providers can verify. DKIM record verification is made possible through cryptographic authentication.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      	   <div class="cptn-admin-box-dotted-border">
';
        if ( $row['server_type'] == 'smtp' ) {
            $output .= ' 	           	     <div class="cptn-admin-box-small-text">' . esc_html__( "Please take note: Campation PostOffice&trade; only can create DKIM recommendations and keys for its own mail servers - not for external SMTP server. For the latter please ask your SMTP provider to set up DKIM for the following host name:", "campation-postoffice" ) . '</div>
';
        }
        $output .= ' 	      <table width=100%>
			      	    <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Host name", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;"><strong>' . esc_html( $row['dkim_selector'] ) . '._domainkey.' . esc_html( $row['domain'] ) . '</strong></td></tr>
';
        
        if ( !empty(esc_html( $row['dkim_record'] )) ) {
            $found = esc_html( $row['dkim_record'] );
        } else {
            $found = '<span style="color:#aa0000;font-weight:bold;">' . esc_html__( "record not found", "campation-postoffice" ) . '</span>';
        }
        
        $output .= '  	 <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Current value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" class="cptn-admin-box-dns-record"><strong>' . $found . '</strong></td></tr>
';
        
        if ( $row['dkim_record'] and $row['dkim_recommendation'] and str_replace( " ", "", str_replace( '"', "", $row['dkim_record'] ) ) == str_replace( " ", "", str_replace( '"', "", $row['dkim_recommendation'] ) ) and $row['server_type'] != 'smtp' ) {
            $output .= '		      <tr><td valign=top style="font-size:12px;" colspan=2><br><center><span style="color:darkgreen;font-weight:bold;">&#10004; <u>' . esc_html__( "DKIM record is correct", "campation-postoffice" ) . '</u></span></center></td></tr>';
        } elseif ( $row['server_type'] != 'smtp' ) {
            $output .= '		    <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Recommended", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" class="cptn-admin-box-dns-record" id="copy_dkim_recommendation"><strong>' . esc_html( $row['dkim_recommendation'] ) . '</strong></td></tr>
				 		<tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-dkim-public-key" data-copy="copy_dkim_recommendation" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>
						';
        } else {
            $output .= '         <tr><td valign="top" style="font-size:12px;width:25%;">' . esc_html__( "Recommended", "campation-postoffice" ) . '</td><td valign="top" style="font-size:12px;" class="cptn-admin-box-dns-record"><i>' . htmlspecialchars_decode( esc_html__( "No recommendation for SMTP", "campation-postoffice" ) ) . '</i></td></tr>';
        }
        
        $output .= '          </table>
   	       </div>
   	    </div>
';
        if ( $row['server_type'] != 'smtp' ) {
            $output .= ' 
   	    <div class="col-12 col-md-4">
      	   <div class="cptn-admin-box-header">' . esc_html__( "DKIM public key", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The DKIM public key is the cryptographic key used for the DKIM record in DNS. Just use the recommended DKIM record!", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      	   <div class="cptn-admin-box-dotted-border">
			  <table width=100%>
	      	     <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" class="cptn-admin-box-dns-record" id="copy_dkim_public_key"><strong>' . esc_html( $row['dkim_public_key'] ) . '</strong></td></tr>
				 <tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-dkim-public-key" data-copy="copy_dkim_public_key" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>
			  </table>
           </div>
        </div>

   	    <div class="col-12 col-md-4">
      		<div class="cptn-admin-box-header">
         	   ' . esc_html__( "DKIM private key", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The DKIM private key is the cryptographic key used for signing outgoing emails. It is automatically applied by Campation PostOffice&trade;", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
            </div>
      		<div class="cptn-admin-box-dotted-border">
			   <table width=100%>
			      <tr><td valign=top style="font-size:12px;width:25%;">' . esc_html__( "Value", "campation-postoffice" ) . '</td><td valign=top style="font-size:12px;" class="cptn-admin-box-dns-record" id="copy_dkim_private_key"><strong>' . esc_html( $row['dkim_private_key'] ) . '</strong></td></tr>
				  <tr><td colspan=2 align=right><button type="button" class="button cptn-copy-button" id="cptn-po-copy-dkim-private-key" data-copy="copy_dkim_private_key" title="' . esc_attr__( "Copy the value to the clipboard", "campation-postoffice" ) . '">' . esc_html__( "COPY", "campation-postoffice" ) . '</button></td></tr>
			   </table>
            </div>
         </div>
';
        }
        $output .= '  

     </div>
  </div>

  <div class="tab-pane fade" id="health2" role="tabpanel" aria-labelledby="health2-tab">
     <br>
      <div class="row">
   	     <div class="col-12 col-md-12">
      		<div class="cptn-admin-box-header">
         	   ' . esc_html__( "Health report", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The health report shows all errors and recommendations - for optimal email delivery performance it should be empty!", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
            </div>
      		<div class="cptn-admin-box-dotted-border">
			   <div>
';
        
        if ( empty($row['last_error']) ) {
            $output .= '<div style="font-size:14px;text-align:center;margin-top:20px;">' . esc_html__( "This mail server is perfectly configured for high email delivery performance!", "campation-postoffice" ) . '</div>';
        } else {
            $output .= '<div id="cptn_po_last_error_domain_mailserver" style="font-size:12px;margin-top:20px;">' . wp_kses_post( $row['last_error'] ) . '</div>';
        }
        
        $output .= '   </div>	  
            </div>
         </div>
     </div>
  </div>
';
    } else {
        $output = "<br><br><center>" . esc_html__( "No data for this mail server", "campation-postoffice" ) . "</center><br><br>";
    }
    
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_mailserver_edit', 'cptn_po_domains_mailserver_edit' );
add_action( 'wp_ajax_cptn_po_domains_mailserver_edit', 'cptn_po_domains_mailserver_edit' );
function cptn_po_domains_mailserver_edit()
{
    global  $wpdb ;
    $query = "SELECT *\r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t\t  WHERE id = " . intval( $_POST['id'] ) . "\r\n\t\t\t  ";
    $row = $wpdb->get_row( $query, ARRAY_A );
    $output = '
      <form id="cptn_po_domain_server_form">
	     <input type="hidden" name="id" value="' . intval( $_POST['id'] ) . '">
		 <input type="hidden" name="action" value="cptn_po_domain_mailserver_modal_save" />
		 
		 <div class="row">  <!-- complete container -->		 
   		    <div class="col-12 col-md-12">
      		   <div class="cptn-admin-box-header">
         	      ' . esc_html__( "DKIM selector", "campation-postoffice" ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The DKIM selector is part of the hostname to which the DKIM record is set. Please do not change it - or you have to update your DKIM record in DNS. In case of external SMTP servers please set the selector used by your SMTP provider.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span>
               </div>
      		   <div class="cptn-admin-box-dotted-border">
	     		  <table width=100%>
		    	     <tr><td valign=middle style="font-size:12px;">' . esc_html__( "DKIM selector", "campation-postoffice" ) . '</td><td><input type="text" name="dkim_selector" id="dkim_selector" value="' . esc_attr( $row['dkim_selector'] ) . '"></td></tr>
		          </table>
               </div>
            </div>
         </div>                        <!-- end complete container -->
      </form>
';
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domain_mailserver_modal_save', 'cptn_po_domain_mailserver_modal_save' );
add_action( 'wp_ajax_cptn_po_domain_mailserver_modal_save', 'cptn_po_domain_mailserver_modal_save' );
function cptn_po_domain_mailserver_modal_save()
{
    global  $wpdb ;
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t\t    SET dkim_selector = '" . esc_sql( sanitize_text_field( $_POST['dkim_selector'] ) ) . "' \r\n\t\t      WHERE id = " . intval( $_POST['id'] );
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_mailserver_testmail', 'cptn_po_domains_mailserver_testmail' );
add_action( 'wp_ajax_cptn_po_domains_mailserver_testmail', 'cptn_po_domains_mailserver_testmail' );
function cptn_po_domains_mailserver_testmail()
{
    global  $wpdb ;
    $serverid = intval( $_POST['id'] );
    $query = "SELECT sdm.*, ms.address, ms.server_type, ms.plugin_url, d.envelope_address, d.from_address, d.replyto_address, d.unsubscribe_address, d.domain, d.mailcategory  \r\n               FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm\r\n              INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdm.mailserver_id \r\n              INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain d ON d.id = sdm.domain_id \r\n\t\t      WHERE sdm.id = " . $serverid;
    $server = $wpdb->get_row( $query, ARRAY_A );
    $headers = "From: Campation PostOffice (" . mb_encode_mimeheader( trim( esc_html( get_option( 'blogname' ) ) ) ) . ") <" . sanitize_email( $server['envelope_address'] ) . ">" . PHP_EOL;
    if ( $server['replyto_address'] ) {
        $headers .= "Reply-To: Campation PostOffice (" . mb_encode_mimeheader( trim( esc_html( get_option( 'blogname' ) ) ) ) . ") <" . sanitize_email( $server['replyto_address'] ) . ">" . PHP_EOL;
    }
    $headers .= "MIME-Version: 1.0" . PHP_EOL;
    $headers .= "Content-type: text/html; charset=utf-8" . PHP_EOL;
    $headers = explode( "\n", str_replace( "\r\n", "\n", $headers ) );
    $headers = array_filter( $headers );
    // delete empty elements
    // create queue record
    $to_email = esc_html( get_option( "cptn_po_opt_admin_alerts_to" ) );
    $query = "SELECT id \r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_recipient\r\n\t\t\t  WHERE recipient_email = '" . esc_sql( $to_email ) . "'";
    $recipient_id = $wpdb->get_var( $query );
    
    if ( empty($recipient_id) ) {
        $recipient_domain = substr( $to_email, strpos( $to_email, "@" ) + 1, 100 );
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_recipient\r\n\t\t\t          SET status = 1,\r\n\t\t\t\t\t      domain = '" . esc_sql( $recipient_domain ) . "',\r\n\t\t\t\t          recipient_email = '" . esc_sql( $to_email ) . "',\r\n\t\t\t\t       \t  created = NOW()\r\n\t\t\t\t\t";
        $wpdb->query( $query );
        $recipient_id = $wpdb->insert_id;
    }
    
    $subject = __( "Test mail (special characters", "campation-postoffice" ) . ': ÄÖÜäöüßáéíñúàèìòùÀÈÌÒÙÑ)';
    $content = __( "This is a test email from Campation PostOffice&trade;", "campation-postoffice" ) . ".<br><br>";
    $content .= "<table width=100%>";
    $content .= "<tr><td>" . esc_html__( "Website name", "campation-postoffice" ) . "</td><td align=right><strong>" . strtoupper( mb_encode_mimeheader( trim( esc_html( get_option( 'blogname' ) ) ) ) ) . "</strong></td></tr>";
    $content .= "<tr><td>" . esc_html__( "Sender domain", "campation-postoffice" ) . "</td><td align=right><strong>" . strtoupper( esc_html( $server['domain'] ) ) . "</strong></td></tr>";
    $content .= "<tr><td>" . esc_html__( "Mail server", "campation-postoffice" ) . "</td><td align=right><strong>" . strtoupper( esc_html( $server['address'] ) ) . "</strong></td></tr>";
    $content .= "<tr><td>" . esc_html__( "Recipient", "campation-postoffice" ) . "</td><td align=right><strong>" . sanitize_email( $to_email ) . "</strong></td></tr>";
    $content .= "<tr><td>" . esc_html__( "Special Characters", "campation-postoffice" ) . "</td><td align=right><strong>ÄÖÜäöüßáéíñúàèìòùÀÈÌÒÙÑ</strong></td></tr>";
    $content .= "</table> \r\n";
    $content = '<center><img src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/campation-postoffice-logo-mail.png"></center><br><br>' . wp_kses_post( $content );
    $content = '<body style="max-width:600px;margin:20px auto;">' . wp_kses_post( $content ) . "</body>";
    $content = wp_kses_post( $content );
    $recipient_domain = substr( $to_email, strpos( $to_email, "@" ) + 1, 100 );
    $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_queue\r\n   \t\t        SET priority = 1000,\r\n\t\t\t\t    source = 'po domain test',\r\n\t\t\t\t\tmailcategory = '" . esc_sql( $server['mailcategory'] ) . "',\r\n\t\t\t\t    mailserver = " . $server['mailserver_id'] . ",\r\n\t\t\t\t\tretry = 1,\r\n\t\t\t\t\tfrom_email = '" . esc_sql( $server['envelope_address'] ) . "',\r\n\t\t\t\t\tfrom_name = 'Campation PostOffice&trade;',\r\n\t\t\t\t\tsender_domain_id = " . $server['domain_id'] . ",\r\n\t\t\t\t\tto_email = '" . esc_sql( $to_email ) . "',\r\n\t\t\t\t\trecipient_domain = '" . esc_sql( $recipient_domain ) . "',\r\n\t\t\t\t\tto_name = 'Admin',\r\n\t\t\t\t\trecipient_id = '" . $recipient_id . "',\r\n\t\t\t\t\tmail_subject = '" . esc_sql( $subject ) . "',\r\n\t\t\t\t\tmail_content = '" . esc_sql( $content ) . "',\r\n\t\t\t\t\theaders = '" . esc_sql( json_encode( $headers ) ) . "',\r\n\t\t\t\t\tcreated = NOW()\r\n\t\t\t\t\t";
    $wpdb->query( $query );
    $queue_id = $wpdb->insert_id;
    // start slave url
    $output = [
        "domain"     => $server['domain'],
        "mailserver" => $server['address'],
        "to_email"   => $to_email,
        "queue_id"   => $queue_id,
    ];
    echo  cptn_json_output( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_mailserver_testmail_check', 'cptn_po_domains_mailserver_testmail_check' );
add_action( 'wp_ajax_cptn_po_domains_mailserver_testmail_check', 'cptn_po_domains_mailserver_testmail_check' );
function cptn_po_domains_mailserver_testmail_check()
{
    global  $wpdb ;
    $queue_id = intval( $_POST['queue_id'] );
    $count = intval( $_POST['count'] );
    $query = "SELECT id,executed, error_date, error_reason, error_full  \r\n               FROM " . $wpdb->prefix . "cptn_po_queue\r\n\t\t      WHERE id = " . $queue_id;
    $result = $wpdb->get_row( $query, ARRAY_A );
    
    if ( !empty($result['executed']) ) {
        echo  "<span style='color:green;font-weight:bold;'>" . esc_html__( "Email successfully sent - check your mailbox", "campation-postoffice" ) . "</span>" ;
    } elseif ( !empty($result['error_reason']) ) {
        echo  "<span style='color:#aa0000;font-weight:bold;'>" . esc_html__( "An error occurred", "campation-postoffice" ) . ": " . esc_html( $result['error_reason'] ) . " " . esc_html( $result['error_full'] ) . "</span>" ;
    } elseif ( !empty($result['id']) and $count > 8 ) {
        echo  "<span style='color:green;font-weight:bold;'>" . esc_html__( "Email successfully placed into outgoing queue", "campation-postoffice" ) . "</span>" ;
    } elseif ( $count > 8 ) {
        echo  "<span style='color:#aa0000;font-weight:bold;'>" . esc_html__( "An unknown error occurred", "campation-postoffice" ) . "</span>" ;
    }
    
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_domains_switch', 'cptn_po_domains_switch' );
add_action( 'wp_ajax_cptn_po_domains_switch', 'cptn_po_domains_switch' );
function cptn_po_domains_switch()
{
    global  $wpdb ;
    $switchname = sanitize_text_field( $_POST['name'] );
    $switchstatus = sanitize_text_field( $_POST['value'] );
    update_option( "cptn_po_domains_switch_" . $switchname, $switchstatus );
    wp_die();
}
