<?php
add_action('wp_ajax_nopriv_cptn_po_stop_all_email','cptn_po_stop_all_email');
add_action('wp_ajax_cptn_po_stop_all_email','cptn_po_stop_all_email');
function cptn_po_stop_all_email() {      
   global $wpdb;
   $query = "UPDATE ".$wpdb->prefix."cptn_po_slave 
                SET stop = NOW()
 				 ";
   $wpdb->query($query);
   cptn_po_update_option("cptn_po_opt_email_blocked","1");	  
   echo "OK";
   wp_die();
   }
   

add_action('wp_ajax_nopriv_cptn_po_start_all_email','cptn_po_start_all_email');
add_action('wp_ajax_cptn_po_start_all_email','cptn_po_start_all_email');
function cptn_po_start_all_email() {      
   global $wpdb;
   $query = "UPDATE ".$wpdb->prefix."cptn_po_slave 
                SET stop = NULL
 				 ";
   $wpdb->query($query);
   cptn_po_update_option("cptn_po_opt_email_blocked","0");	
   cptn_po_message_tasks();   // restart message slave
   echo "OK";
   wp_die();
   }
   

add_action('wp_ajax_nopriv_cptn_po_stat_block','cptn_po_stat_block');
add_action('wp_ajax_cptn_po_stat_block','cptn_po_stat_block');
function cptn_po_stat_block() 
   {      
   global $wpdb;
   $result = array();

   $query = "SELECT COUNT(id)
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE executed IS NULL
			    AND errors<9999 
				AND mailcategory != 'test'
 				 ";
   $result['waiting'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id)
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE executed IS NOT NULL
			    AND executed >= DATE_SUB(NOW(), INTERVAL 1 day)
				AND mailcategory != 'test'
 				 ";
   $result['sent'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id)
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE errors = 9999
			    AND error_date >= DATE_SUB(NOW(), INTERVAL 1 day)
				AND mailcategory != 'test'
 				 ";
   $result['bounced'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id)
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE unsubscribed = 1
			    AND executed >= DATE_SUB(NOW(), INTERVAL 1 day)
				AND mailcategory != 'test'
 				 ";
   $result['unsubscribed'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id)
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE opened IS NOT NULL
			    AND executed >= DATE_SUB(NOW(), INTERVAL 1 day)
				AND mailcategory != 'test'
 				 ";
   $result['opened'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id)
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE clicked IS NOT NULL
			    AND executed >= DATE_SUB(NOW(), INTERVAL 1 day)
				AND mailcategory != 'test'
 				 ";
   $result['clicked'] = $wpdb->get_var($query);

   $query = "SELECT AVG(executiontime) 
               FROM ".$wpdb->prefix."cptn_po_queue 
			  WHERE executed >= DATE_SUB(NOW(), INTERVAL 1 day)
 				 ";
   $result['executiontime'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id) 
               FROM ".$wpdb->prefix."cptn_po_recipient
			  WHERE recipient_status = 'INACT'
 				 ";
   $result['inactive'] = $wpdb->get_var($query);

   $query = "SELECT COUNT(id) 
               FROM ".$wpdb->prefix."cptn_po_recipient 
			  WHERE recipient_status = 'INACT' OR recipient_status = 'OK'
 				 ";
   $result['recipients'] = $wpdb->get_var($query);


   echo cptn_json_output($result);

   wp_die();
   }
   

add_action('wp_ajax_nopriv_cptn_po_test_imapaccount','cptn_po_test_imapaccount');
add_action('wp_ajax_cptn_po_test_imapaccount','cptn_po_test_imapaccount');
function cptn_po_test_imapaccount() {      
   global $wpdb;
   $imapaccount = cptn_recursive_sanitize_array(json_decode(stripslashes($_POST['imapaccount']),true));
   $connect_error = cptn_po_check_imap_server($imapaccount);
   echo wp_kses_post($connect_error);
   wp_die();
   }


add_action('wp_ajax_nopriv_cptn_po_test_smtpserver','cptn_po_test_smtpserver');
add_action('wp_ajax_cptn_po_test_smtpserver','cptn_po_test_smtpserver');
function cptn_po_test_smtpserver() {      
   global $wpdb;
   $mailserver = cptn_recursive_sanitize_array(json_decode(stripslashes($_POST['mailserver']),true));
   $connect_error = cptn_po_check_smtp_server($mailserver);
   echo wp_kses_post($connect_error);
   wp_die();
   }

   
   
   
   
   
?>