<?php

add_action( 'wp_ajax_nopriv_cptn_po_mailservers_add', 'cptn_po_mailservers_add' );
add_action( 'wp_ajax_cptn_po_mailservers_add', 'cptn_po_mailservers_add' );
function cptn_po_mailservers_add()
{
    global  $wpdb ;
    $output = "";
    $query = "SELECT count(*) FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t  WHERE server_type='smtp'";
    $count = $wpdb->get_var( $query );
    if ( $count ) {
        $output = "none";
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_mailserver_modal_save', 'cptn_po_mailserver_modal_save' );
add_action( 'wp_ajax_cptn_po_mailserver_modal_save', 'cptn_po_mailserver_modal_save' );
function cptn_po_mailserver_modal_save()
{
    global  $wpdb ;
    if ( !isset( $_POST['ms_contingent'] ) ) {
        $_POST['ms_contingent'] = 0;
    }
    if ( !isset( $_POST['ms_contingent_exceed'] ) ) {
        $_POST['ms_contingent_exceed'] = 0;
    }
    if ( !isset( $_POST['ms_contingent_period'] ) ) {
        $_POST['ms_contingent_period'] = "";
    }
    if ( !isset( $_POST['ms_processes'] ) ) {
        $_POST['ms_processes'] = "1";
    }
    if ( empty($_POST['ms_ip']) and !empty($_POST['ms_address']) ) {
        $_POST['ms_ip'] = esc_html( gethostbyname( sanitize_text_field( $_POST['ms_address'] ) ) );
    }
    $ip = esc_sql( sanitize_text_field( $_POST['ms_ip'] ) );
    $hostname = "";
    
    if ( $ip ) {
        update_option( "cptn_po_server_ip", $ip );
        $hostname = cptn_po_check_rdns( $ip );
        if ( $hostname ) {
            $_POST['ms_address'] = $hostname;
        }
    }
    
    
    if ( intval( $_POST['ms_id'] ) == 9999 ) {
        // we only can add SMTP-Servers - PHP-Servers always exist (#0) or are created by remote plugin
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t       SET shortname = '" . esc_sql( sanitize_text_field( $_POST['ms_shortname'] ) ) . "',\r\n\t\t\t\t   \t   server_type = 'smtp',\r\n\t\t\t\t\t   address = '" . esc_sql( sanitize_text_field( $_POST['ms_address'] ) ) . "',\r\n\t\t\t\t\t   ip = '" . esc_sql( sanitize_text_field( $_POST['ms_ip'] ) ) . "',\r\n\t\t\t\t\t   port = '" . esc_sql( sanitize_text_field( $_POST['ms_port'] ) ) . "',\r\n\t\t\t\t\t   encryption = '" . esc_sql( sanitize_text_field( $_POST['ms_encryption'] ) ) . "',\r\n\t\t\t\t\t   account = '" . esc_sql( sanitize_text_field( $_POST['ms_account'] ) ) . "',\r\n\t\t\t\t\t   password = '" . esc_sql( sanitize_text_field( $_POST['ms_password'] ) ) . "',\r\n\t\t\t\t\t   processes = '1',\r\n\t\t\t\t\t   contingent = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent'] ) ) . "',\r\n\t\t\t\t\t   contingent_exceed = " . intval( $_POST['ms_contingent_exceed'] ) . ",\r\n\t\t\t\t\t   contingent_period = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent_period'] ) ) . "',\r\n  \t\t\t\t\t   status = 1,\r\n\t\t\t\t \t   created = NOW(),\r\n\t\t\t\t\t   updated = NOW()\r\n\t\t\t\t\t   ";
        $wpdb->query( $query );
        $id = $wpdb->insert_id;
        // join with all domains
        $query = "SELECT id FROM " . $wpdb->prefix . "cptn_po_sender_domain";
        $domains = $wpdb->get_results( $query, ARRAY_A );
        foreach ( $domains as $domain ) {
            $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t \t\t    WHERE domain_id = " . $domain['id'] . " AND mailserver_id = " . $id;
            $domains_ms = $wpdb->get_results( $query, ARRAY_A );
            
            if ( !$domains_ms ) {
                $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t \t\t         SET domain_id = " . $domain['id'] . ",\r\n\t\t\t\t\t\t mailserver_id = " . $id . ",\r\n\t\t\t\t\t\t status = 1";
                $wpdb->query( $query );
            }
            
            cptn_po_sender_check( $domain['id'] );
        }
    } else {
        $id = intval( $_POST['ms_id'] );
        
        if ( sanitize_text_field( $_POST['ms_server_type'] ) !== "spmail" ) {
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t          SET shortname = '" . esc_sql( sanitize_text_field( $_POST['ms_shortname'] ) ) . "',\r\n\t\t\t\t\t   \t  address = '" . esc_sql( sanitize_text_field( $_POST['ms_address'] ) ) . "',\r\n\t\t\t\t\t   \t  ip = '" . esc_sql( sanitize_text_field( $_POST['ms_ip'] ) ) . "',\r\n\t\t\t\t\t   \t  port = '" . esc_sql( sanitize_text_field( $_POST['ms_port'] ) ) . "',\r\n\t\t\t\t\t   \t  encryption = '" . esc_sql( sanitize_text_field( $_POST['ms_encryption'] ) ) . "',\r\n\t\t\t\t\t   \t  account = '" . esc_sql( sanitize_text_field( $_POST['ms_account'] ) ) . "',\r\n\t\t\t\t\t   \t  password = '" . esc_sql( sanitize_text_field( $_POST['ms_password'] ) ) . "',\r\n\t\t\t\t\t\t  processes = '" . esc_sql( sanitize_text_field( $_POST['ms_processes'] ) ) . "',\r\n\t\t\t\t\t   \t  contingent = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent'] ) ) . "',\r\n\t\t\t\t\t   \t  contingent_exceed = " . intval( $_POST['ms_contingent_exceed'] ) . ",\r\n\t\t\t\t\t   \t  contingent_period = '" . esc_sql( sanitize_text_field( $_POST['ms_contingent_period'] ) ) . "',\r\n\t\t\t\t\t   \t  updated = NOW()\r\n\t\t\t        WHERE id = " . $id;
        } else {
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t          SET ip = '" . esc_sql( sanitize_text_field( $_POST['ms_ip'] ) ) . "',\r\n\t\t\t\t\t  \t  processes = '" . esc_sql( sanitize_text_field( $_POST['ms_processes'] ) ) . "',\r\n\t\t\t\t\t   \t  updated = NOW()\r\n\t\t\t        WHERE id = " . $id;
        }
        
        $wpdb->query( $query );
    }
    
    // check if relation mailserver-mxdomain is already known
    $query = "SELECT DISTINCT mx.mxdomain\r\n               FROM " . $wpdb->prefix . "cptn_po_mailserver_mxdomain mx\r\n              WHERE NOT EXISTS (SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver_mxdomain WHERE mailserver = " . $id . " AND mxdomain = mx.mxdomain)\r\n\t\t\t\t\t   ";
    $missing = $wpdb->get_results( $query, ARRAY_A );
    foreach ( $missing as $toadd ) {
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_mxdomain\r\n\t\t\t   \t\t    SET mailserver = " . $id . ",\r\n\t\t\t\t\t\t\tmxdomain = '" . $toadd['mxdomain'] . "',\r\n\t\t\t\t\t\t    minute_allowed = " . get_option( "cptn_po_opt_throttle_max_min" ) . ",\r\n\t\t\t\t\t\t\tcreated = NOW(),\r\n\t\t\t\t\t\t\tupdated = NOW()\r\n\t\t\t\t\t\t\t";
        $wpdb->query( $query );
    }
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_mailservers_startstop', 'cptn_po_mailservers_startstop' );
add_action( 'wp_ajax_cptn_po_mailservers_startstop', 'cptn_po_mailservers_startstop' );
function cptn_po_mailservers_startstop()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    
    if ( intval( $_POST['status'] ) == 0 ) {
        $status = 1;
    } else {
        $status = 0;
    }
    
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n   \t\t        SET status = " . $status . ",\r\n\t\t\t\t    errors = IF(" . $status . " = 1, 0, errors)\r\n\t\t\t  WHERE id = " . $id;
    $wpdb->query( $query );
    cptn_po_sender_check( 9999 );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_mailservers_delete', 'cptn_po_mailservers_delete' );
add_action( 'wp_ajax_cptn_po_mailservers_delete', 'cptn_po_mailservers_delete' );
function cptn_po_mailservers_delete()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t  WHERE id = " . $id;
    $wpdb->query( $query );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_mailserver_error\r\n\t\t\t  WHERE mailserver = " . $id;
    $wpdb->query( $query );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t\t  WHERE mailserver_id = " . $id;
    $wpdb->query( $query );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_mailserver_dnsbl\r\n\t\t\t  WHERE mailserver = " . $id;
    $wpdb->query( $query );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_queue\r\n\t\t\t  WHERE mailserver = " . $id . "\r\n\t\t\t    AND executed IS NOT NULL\r\n\t\t\t\t";
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_mailservers_info', 'cptn_po_mailservers_info' );
add_action( 'wp_ajax_cptn_po_mailservers_info', 'cptn_po_mailservers_info' );
function cptn_po_mailservers_info()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $output = '
<ul class="nav nav-pills" id="myTab" role="tablist">
  <li class="nav-item" role="presentation">
    <button class="nav-link active" id="error-tab" data-bs-toggle="tab" data-bs-target="#error" type="button" role="tab" aria-controls="error" aria-selected="true">' . htmlspecialchars_decode( esc_html__( "Errors", "campation-postoffice" ) ) . '</a>
  </li>
  <li class="nav-item" role="presentation">
    <button class="nav-link" id="blacklist-tab" data-bs-toggle="tab" data-bs-target="#blacklist" type="button" role="tab" aria-controls="blacklist" aria-selected="false">' . htmlspecialchars_decode( esc_html__( "Blacklists", "campation-postoffice" ) ) . '</a>
  </li>
</ul>

<div class="tab-content" id="myTabContent">
  <div class="tab-pane fade show active" id="error" role="tabpanel" aria-labelledby="error-tab">
     <br>
     <div class="row">
   	    <div class="col-12 col-md-12">
      	   <div class="cptn-admin-box-header">' . htmlspecialchars_decode( esc_html__( "Last mail server errors", "campation-postoffice" ) ) . '<span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "The error list shows the last 100 connection and similar errors related to this mail server.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      	   <div class="cptn-admin-box-dotted-border">
';
    $query = "SELECT *\r\n   \t           FROM " . $wpdb->prefix . "cptn_po_mailserver_error\r\n\t\t\t  WHERE mailserver = " . $id . "\r\n\t\t\t  ORDER BY error_date DESC\r\n\t\t\t  LIMIT 100\r\n\t\t\t       ";
    $rows = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $rows ) {
        $output .= "<table width=100% cellpadding=5 class='table table-sm table-striped table-hover table-compact'>";
        $output .= "<tr><th>" . htmlspecialchars_decode( esc_html__( "Date", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Reason", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Description", "campation-postoffice" ) ) . "</th></tr>";
        foreach ( $rows as $row ) {
            $output .= "<tr><td>" . cptn_date_format( $row['error_date'] ) . "</td><td>" . $row['error_reason'] . "</td><td>" . $row['error_full'] . "</td></tr>";
        }
        $output .= "</table>";
    } else {
        $output .= "<br><center>" . htmlspecialchars_decode( esc_html__( "No error data for this mail server", "campation-postoffice" ) ) . "</center><br>";
    }
    
    $output .= '
            </div>
         </div>
     </div>
  </div>
  
  <div class="tab-pane fade" id="blacklist" role="tabpanel" aria-labelledby="blacklist-tab">
     <br>
	    <div class="row">
   		   <div class="col-12 col-md-12">
      		  <div class="cptn-admin-box-header">' . htmlspecialchars_decode( esc_html__( "Blacklists", "campation-postoffice" ) ) . '<span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "Campation PostOffice&trade; checks every hour hundreds of DNS Blacklists for appeareance of your mail server. Black listing of your email server may have severe consequences. Most receiving mail servers will mark your emails as spam or directly delete them. To get de-listed from a black list: please search the black list's name on Google and find out how to be removed from that list.", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></div>
      		  <div class="cptn-admin-box-dotted-border cptn_po_is_for_starter">
';
    $query = "SELECT *\r\n   \t           FROM " . $wpdb->prefix . "cptn_po_mailserver_dnsbl\r\n\t\t\t  WHERE mailserver = " . $id . "\r\n\t\t\t  ORDER BY enddate ASC, startdate ASC\r\n\t\t\t       ";
    $rows = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $rows ) {
        $output .= '<table width=100% cellpadding=5>';
        $output .= "<tr><th>" . htmlspecialchars_decode( esc_html__( "Last check", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Appeared", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Disappeared", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Black list", "campation-postoffice" ) ) . "</th></tr>";
        $output .= "</table>";
    } else {
        $output .= "<br><center>" . htmlspecialchars_decode( esc_html__( "No black list matches for this mail server", "campation-postoffice" ) ) . "</center><br>";
    }
    
    $output .= '
           </div>
        </div>
     </div>
  </div>
</div>

';
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_mailservers_edit', 'cptn_po_mailservers_edit' );
add_action( 'wp_ajax_cptn_po_mailservers_edit', 'cptn_po_mailservers_edit' );
function cptn_po_mailservers_edit()
{
    global  $wpdb ;
    
    if ( isset( $_POST['id'] ) ) {
        $query = "SELECT ms.*\r\n   \t\t          FROM " . $wpdb->prefix . "cptn_po_mailserver ms\r\n\t\t\t     WHERE ms.id = " . intval( $_POST['id'] ) . "\r\n\t\t\t  \t ";
        $row = $wpdb->get_row( $query, ARRAY_A );
    } else {
        $row = array();
        $row['id'] = 9999;
        $row['status'] = 0;
        $row['server_type'] = "smtp";
        $row['processes'] = "1";
        $row['shortname'] = "";
        $row['address'] = "";
        $row['port'] = "";
        $row['ip'] = "";
        $row['encryption'] = "";
        $row['account'] = "";
        $row['password'] = "";
        $row['contingent'] = 0;
        $row['contingent_period'] = "";
        $row['contingent_exceed'] = 0;
        $row['connectable'] = 0;
    }
    
    $output = "";
    $output .= '
      <form id="cptn_po_mailserver_form">
	     <input type="hidden" name="ms_id" id="ms_id" value="' . intval( $row['id'] ) . '">
	     <input type="hidden" name="ms_status" id="ms_status" value="' . esc_attr( $row['status'] ) . '">
	     <input type="hidden" name="ms_server_type" id="ms_server_type" value="' . esc_attr( $row['server_type'] ) . '">
		 <input type="hidden" name="ms_connectable" id="ms_connectable" value="' . intval( $row['connectable'] ) . '">
		 <input type="hidden" name="action" value="cptn_po_mailserver_modal_save">
	     <table width=100%>';
    if ( $row['id'] > 0 and $row['id'] < 9999 ) {
        $output .= '
		    <tr><td>' . htmlspecialchars_decode( esc_html__( "Server ID", "campation-postoffice" ) ) . '</td><td><strong>' . esc_html( $row['id'] ) . '</strong></td></tr>
			';
    }
    $output .= '
		    <tr><td>' . htmlspecialchars_decode( esc_html__( "Server type", "campation-postoffice" ) ) . '</td><td id="server_type"><strong>' . strtoupper( $row['server_type'] ) . '</strong></td></tr>
			';
    
    if ( $row['server_type'] == "spmail" ) {
        $output .= '<tr><td>' . htmlspecialchars_decode( esc_html__( "Short name", "campation-postoffice" ) ) . '</td><td><strong>' . esc_html( $row['shortname'] ) . '</strong><input type="hidden" name="ms_shortname" id="ms_shortname" value="' . esc_attr( $row['shortname'] ) . '"></td></tr>';
    } else {
        $output .= '<tr><td>' . htmlspecialchars_decode( esc_html__( "Short name", "campation-postoffice" ) ) . '</td><td><input type="text" name="ms_shortname" id="ms_shortname" value="' . esc_attr( $row['shortname'] ) . '"></td></tr>';
    }
    
    
    if ( $row['server_type'] == "smtp" ) {
        $output .= '<tr><td>' . htmlspecialchars_decode( esc_html__( "Server address", "campation-postoffice" ) ) . '</td><td><input type="text" name="ms_address" id="ms_address" placeholder="mail.domain.com" value="' . esc_attr( $row['address'] ) . '"></td></tr>
	  		  	  <tr><td>' . htmlspecialchars_decode( esc_html__( "IP (optional)", "campation-postoffice" ) ) . '</td><td><input type="text" name="ms_ip" id="ms_ip" placeholder="123.456.789.012" value="' . esc_attr( $row['ip'] ) . '"></td></tr>';
    } else {
        $output .= '<tr><td>' . htmlspecialchars_decode( esc_html__( "Server address", "campation-postoffice" ) ) . '</td><td><strong>' . esc_html( $row['address'] ) . '</strong></td></tr>
	              <tr><td>' . htmlspecialchars_decode( esc_html__( "IP (MTA)", "campation-postoffice" ) ) . '</td><td><input type="text" style="width:80%;" name="ms_ip" id="ms_ip" placeholder="123.456.789.012" value="' . esc_attr( $row['ip'] ) . '"><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="' . esc_attr__( "If your server runs on multiple IPs please set the IP to your MTA's IP for best DNS results", "campation-postoffice" ) . '"><i class="fas fa-question-circle"></i></span></td></tr>
	  			  ';
    }
    
    $output .= '
		    <tr class="cptn-po-mailserver-smtp"><td>' . htmlspecialchars_decode( esc_html__( "Account", "campation-postoffice" ) ) . '</td><td><input type="text" name="ms_account" id="ms_account" placeholder="email@domain.com" value="' . esc_attr( $row['account'] ) . '"></td></tr>
		    <tr class="cptn-po-mailserver-smtp"><td>' . htmlspecialchars_decode( esc_html__( "Password", "campation-postoffice" ) ) . '</td><td><input type="password" name="ms_password" id="ms_password" placeholder="" value="' . esc_attr( $row['password'] ) . '" onmouseover="this.type=' . "'text'" . '" onmouseout="this.type=' . "'password'" . '"></td></tr>
		    <tr class="cptn-po-mailserver-smtp"><td>' . htmlspecialchars_decode( esc_html__( "Port", "campation-postoffice" ) ) . '</td><td><input type="text" name="ms_port" id="ms_port" placeholder="993" value="' . esc_attr( $row['port'] ) . '"></td></tr>
		    <tr class="cptn-po-mailserver-smtp"><td>' . htmlspecialchars_decode( esc_html__( "Security", "campation-postoffice" ) ) . '</td><td><select name="ms_encryption" id="ms_encryption" data-selected="' . esc_attr( $row['encryption'] ) . '"><option value="">' . htmlspecialchars_decode( esc_html__( "Without", "campation-postoffice" ) ) . '</option><option value="ssl">' . htmlspecialchars_decode( esc_html__( "SSL", "campation-postoffice" ) ) . '</option><option value="tls">' . htmlspecialchars_decode( esc_html__( "TLS", "campation-postoffice" ) ) . '</option></select></td></tr>
';
    $output .= '
			<tr class="cptn-po-mailserver-smtp"><td colspan=2 align=right><span id="cptn-po-test-smtpserver-result" style="float:left;font-size:12px;margin:5px;"></span><button type="button" class="button" id="cptn-po-test-smtpserver" data-id="' . esc_attr( $row['id'] ) . '">' . htmlspecialchars_decode( esc_html__( "TEST", "campation-postoffice" ) ) . '</button></td></tr>
         </table>
      </form>	
	  ';
    if ( $row['server_type'] !== "remote" ) {
        $output .= '<br><span class="cptn-po-icon-pro-business" style="top:0;margin-left:0;"></span><div style="font-size:11px;line-height:12px;">' . htmlspecialchars_decode( esc_html__( "With <strong>Campation RemoteMail&trade;</strong> you can equip many other WordPress installations as additional mail servers with <strong>Campation SpeedMail&trade;</strong> technology. To do this, install <strong>Campation RemoteMail&trade;</strong> in other WordPress installations and register it from there. The remote server then will be shown in the mail server list. It's easy!", "campation-postoffice" ) ) . "</div>";
    }
    echo  wp_kses_post( $output ) ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_mailservers', 'cptn_po_mailservers' );
add_action( 'wp_ajax_cptn_po_mailservers', 'cptn_po_mailservers' );
function cptn_po_mailservers()
{
    global  $wpdb ;
    // +++++++++++++++++++ CONFIGURE ++++++++++++++++++++++++++
    function actionbuttons( $id, $status )
    {
        // start/stop-button for mailserver
        
        if ( $status == 0 ) {
            $startstopbutton = "fa-play-circle";
            $deletebuttonstatus = "";
            $startstopbuttoncolor = "btn-secondary";
            $startstopbuttontitle = htmlspecialchars_decode( esc_html__( "Unblock this mail server", "campation-postoffice" ) );
        } else {
            $startstopbutton = "fa-pause";
            $deletebuttonstatus = " disabled";
            $startstopbuttoncolor = "btn-success";
            $startstopbuttontitle = htmlspecialchars_decode( esc_html__( "Block this mail server", "campation-postoffice" ) );
        }
        
        if ( $id == 0 ) {
            $deletebuttonstatus = " disabled";
        }
        return '<button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-primary btn_edit_mailserver" title="' . esc_attr__( "Edit / change this mail server", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-todo="edit" data-reload="cptn-po-datatable-mailservers"><i class="fas fa-edit"></i></button>
	          <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-info btn_info_mailserver" title="' . esc_attr__( "Mail server details", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="cptn-po-datatable-mailservers"><i class="fas fa-info"></i></button>
	  		  <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-danger  btn_delete_mailserver confirm-btn" title="' . esc_attr__( "Delete this mail server - block it before", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="virelin-datatable-person"' . esc_attr( $deletebuttonstatus ) . '><i class="fas fa-trash-alt"></i></button>
	  	      <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs ' . esc_attr( $startstopbuttoncolor ) . ' btn_startstop_mailserver" title="' . esc_attr( $startstopbuttontitle ) . '" data-id="' . esc_attr( $id ) . '" data-startstop="' . esc_attr( $status ) . '" data-reload="cptn-po-datatable-mailservers"><i class="fas ' . esc_attr( $startstopbutton ) . '"></i></button>
			  ';
    }
    
    $tables = $wpdb->prefix . "cptn_po_mailserver ms\r\n\t\t\t\t   \t";
    // tablename in  database
    $primaryKey = 'ms.id';
    // IF(ms.server_type != 'smtp' AND ms.test_mail_success IS NULL,0,ms.connectable) AS connectable
    $columns = array(
        "action",
        "ms.id",
        "ms.server_type",
        "ms.shortname",
        "ms.address",
        "ms.processes",
        "ms.connectable",
        "ms.rdns",
        "IF('" . CPTNPO_FS . "'='starter' OR '" . CPTNPO_FS . "'='premium' OR '" . CPTNPO_FS . "'='business',IF(ms.dnsbl>0,'<span style=\"color:#aa0000;font-weight:bold;\">&#10007;</span>','&#10004;'),'<span class=\"cptn-po-icon-pro-starter\"></span>') AS dnsbl",
        "IF('" . CPTNPO_FS . "'='business',ms.senderscore,'<span class=\"cptn-po-icon-pro-business\"></span>') AS senderscore",
        "IF('" . esc_html( get_option( "cptn_po_opt_warmup" ) ) . "'='1',CONCAT(warmup_day,'/','" . esc_html( get_option( "cptn_po_opt_warmup_days" ) ) . "'),'<span class=\"cptn-po-icon-pro-premium\"></span>') AS warmup",
        "ms.sent",
        "ms.errors",
        "CONCAT(ms.bounced,' <i>(',ROUND(ms.bounced/ms.sent*100,1),'%</i> ',IF(ROUND(ms.bounced/ms.sent*100,1)<=" . esc_html( get_option( "cptn_po_opt_max_bounce" ) ) . ",'&#10004;','&#10071;'),')') AS bounced",
        "CONCAT(ms.opened,' <i>(',ROUND(ms.opened/(ms.sent-ms.bounced)*100,1),'%</i> ',IF(ROUND(ms.opened/(ms.sent-ms.bounced)*100,1)>=" . esc_html( get_option( "cptn_po_opt_min_open" ) ) . ",'&#10004;','&#10071;'),')') AS opened",
        "CONCAT(ms.unsubscribed,' <i>(',ROUND(ms.unsubscribed/(ms.sent-ms.bounced)*100,1),'%</i> ',IF(ROUND(ms.unsubscribed/(ms.sent-ms.bounced)*100,1)<=" . esc_html( get_option( "cptn_po_opt_max_unsubscribe" ) ) . ",'&#10004;','&#10071;'),')') AS unsubscribed",
        "CONCAT(ms.clicked,' <i>(',ROUND(ms.clicked/(ms.sent-ms.bounced)*100,1),'%</i> ',IF(ROUND(ms.clicked/(ms.sent-ms.bounced)*100,1)>=" . esc_html( get_option( "cptn_po_opt_min_click" ) ) . ",'&#10004;','&#10071;'),')') AS clicked",
        "IF('" . CPTNPO_FS . "'='starter' OR '" . CPTNPO_FS . "'='premium' OR '" . CPTNPO_FS . "'='business',CONCAT(ms.contingent,' (',ms.contingent_period,')'),'<span class=\"cptn-po-icon-pro-starter\"></span>') AS contingent",
        "IF('" . CPTNPO_FS . "'='starter' OR '" . CPTNPO_FS . "'='premium' OR '" . CPTNPO_FS . "'='business',ms.contingent_used,'<span class=\"cptn-po-icon-pro-starter\"></span>') AS contingent_used",
        "ms.status"
    );
    $fields = implode( ", ", $columns );
    $fields = str_replace( "action,", "", $fields );
    // action is not a database field
    $additionalfields = "\r\n   \t\t\t\t\t    ";
    // z.B. ", (SELECT COUNT(distinct url) FROM clicks WHERE company_id = c.id) AS cnt ";
    // this query is added first to all queries - MUST NOT BE EMPTY, at least "true"
    $querycomplex = " true\r\n\t\t\t\t    ";
    // this query is added second to all queries
    $queryrelation = "  \r\n\t\t\t\t    ";
    // this query is added third to all queries
    $queryadditional = "  ";
    include CPTNPODIR . "common/ajax/db-generate-json.php";
    wp_die();
}
