<?php

add_action( 'wp_ajax_nopriv_cptn_po_outbox_info', 'cptn_po_outbox_info' );
add_action( 'wp_ajax_cptn_po_outbox_info', 'cptn_po_outbox_info' );
function cptn_po_outbox_info()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $query = "SELECT q.id, q.mailcategory, q.from_email, q.from_name, q.to_email, q.to_name, q.embargo, q.embargo_reason, q.executed, q.mail_subject, q.mail_content, q.attachments,\r\n   \t\t            q.opened, q.open_ip, q.open_ptr, q.clicked, q.click_ip, q.click_ptr,\r\n   \t\t  \t\t\tms.shortname,ms.address, \r\n   \t\t  \t        qe.error_date, qe.error_code, qe.error_type, qe.error_cat, qe.error_full \r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_queue q\r\n   \t\t       LEFT JOIN " . $wpdb->prefix . "cptn_po_queue_error qe ON qe.queue_id = q.id\r\n   \t\t       LEFT JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = q.mailserver\r\n\t\t\t  WHERE q.id = " . $id . "\r\n\t\t\t  ";
    $row = $wpdb->get_row( $query, ARRAY_A );
    $output = "";
    
    if ( $row ) {
        $output .= "<table width=100% cellpadding=5> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "ID", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['id'] ) . "</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Category", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . cptn_po_abbreviations( esc_html( $row['mailcategory'] ) ) . "</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Planned", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . cptn_date_format( esc_html( $row['embargo'] ) ) . "</strong> <strong>" . $row['embargo_reason'] . "</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Executed", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . cptn_date_format( esc_html( $row['executed'] ) ) . "</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Mail server", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['shortname'] ) . " (" . esc_html( $row['address'] ) . ")</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "From", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['from_name'] ) . " &#60;" . sanitize_email( $row['from_email'] ) . "&#62;</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "To", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['to_name'] ) . " &#60;" . sanitize_email( $row['to_email'] ) . "&#62;</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Subject", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['mail_subject'] ) . "</strong></td></tr> ";
        $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Content", "campation-postoffice" ) ) . "</td><td valign=top><div style='min-height:200px;overflow-y:auto;overflow-x:auto;border:1px #555 solid;border-radius:5px;padding:5px;background-color:#eee;'>" . $row['mail_content'] . "</div></td></tr> ";
        
        if ( json_decode( $row['attachments'], true ) ) {
            $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Attachments", "campation-postoffice" ) ) . "</td><td valign=top><strong>";
            foreach ( json_decode( $row['attachments'], true ) as $attachment ) {
                $output .= '<a href="' . home_url() . str_replace( $_SERVER['DOCUMENT_ROOT'], "", $attachment ) . '" target="_blank">' . basename( $attachment ) . '</a><br>';
            }
            $output .= "</strong></td></tr> ";
        }
        
        
        if ( $row['error_date'] ) {
            $query = "SELECT qe.error_date, qe.error_code, qe.error_type, qe.error_cat, qe.error_full \r\n   \t\t       \t     FROM " . $wpdb->prefix . "cptn_po_queue_error qe \r\n\t\t\t        WHERE qe.queue_id = " . $row['id'] . "\r\n\t\t\t\t\tORDER BY error_date DESC";
            $errors = $wpdb->get_results( $query, ARRAY_A );
            
            if ( $errors ) {
                $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Errors", "campation-postoffice" ) ) . "</td><td valign=top>";
                $output .= "<table width=100% cellpadding=4  class='table table-sm table-striped table-hover table-compact'> ";
                $output .= "<tr><th>" . htmlspecialchars_decode( esc_html__( "Date", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Code", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Type", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Category", "campation-postoffice" ) ) . "</th><th>" . htmlspecialchars_decode( esc_html__( "Message", "campation-postoffice" ) ) . "</th></tr> ";
                foreach ( $errors as $error ) {
                    $output .= "<tr><td style='font-size:12px;color:#aa0000;'>" . cptn_date_format( $error['error_date'] ) . "</td><td style='font-size:12px;color:#aa0000;'>" . esc_html( $error['error_code'] ) . "</td><td style='font-size:12px;color:#aa0000;' title='" . cptn_po_abbreviations( $error['error_type'] ) . "'>" . esc_html( $error['error_type'] ) . "</td><td style='font-size:12px;color:#aa0000;' title='" . cptn_po_abbreviations( $error['error_cat'] ) . "'>" . esc_html( $error['error_cat'] ) . "</td><td style='font-size:12px;color:#aa0000;'>" . esc_html( $error['error_full'] ) . "</td></tr> ";
                }
                $output .= "</table> ";
                $output .= "</td></tr>";
            }
        
        } else {
            
            if ( $row['opened'] ) {
                $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Opened", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . cptn_date_format( esc_html( $row['opened'] ) ) . "</strong></td></tr> ";
                $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Opened by", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['open_ptr'] ) . " (" . esc_html( $row['open_ip'] ) . ")</strong></td></tr> ";
            }
            
            
            if ( $row['clicked'] ) {
                $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Clicked", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . cptn_date_format( $row['clicked'] ) . "</strong></td></tr> ";
                $output .= "<tr><td valign=top>" . htmlspecialchars_decode( esc_html__( "Clicked by", "campation-postoffice" ) ) . "</td><td valign=top><strong>" . esc_html( $row['click_ptr'] ) . " (" . esc_html( $row['click_ip'] ) . ")</strong></td></tr> ";
            }
        
        }
        
        $output .= "</table> ";
    } else {
        $output = "<br><br><center>" . htmlspecialchars_decode( esc_html__( "No data for this message", "campation-postoffice" ) ) . "</center><br><br>";
    }
    
    echo  $output ;
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_outbox_delete', 'cptn_po_outbox_delete' );
add_action( 'wp_ajax_cptn_po_outbox_delete', 'cptn_po_outbox_delete' );
function cptn_po_outbox_delete()
{
    global  $wpdb ;
    $id = intval( $_POST['id'] );
    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_queue\r\n\t\t\t  WHERE id = " . $id;
    $wpdb->query( $query );
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_outbox', 'cptn_po_outbox' );
add_action( 'wp_ajax_cptn_po_outbox', 'cptn_po_outbox' );
function cptn_po_outbox()
{
    global  $wpdb ;
    // +++++++++++++++++++ CONFIGURE ++++++++++++++++++++++++++
    function actionbuttons( $id, $status )
    {
        $buttons = '<button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-info btn_info_outbox" title="' . esc_attr__( "Message details", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="cptn-po-datatable-outbox"><i class="fas fa-info"></i></button>
  		  	   	  <button type="button" class="mb-1 mt-1 mr-1 btn btn-xs btn-danger btn_delete_outbox confirm-btn" title="' . esc_attr__( "Delete this message", "campation-postoffice" ) . '" data-id="' . esc_attr( $id ) . '" data-reload="virelin-datatable-outbox"><i class="fas fa-trash-alt"></i></button>&nbsp;';
        return $buttons;
    }
    
    $tables = $wpdb->prefix . "cptn_po_queue q\r\n                  LEFT JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = q.mailserver\r\n\t\t\t\t   \t";
    // tablename in  database
    $primaryKey = 'q.id';
    $columns = array(
        "action",
        "q.id",
        "q.mailcategory",
        "q.domain_protect",
        "IF(q.executed IS NOT NULL, q.executed, q.error_date) AS executed",
        "IF(q.embargo IS NOT NULL,CONCAT(IF(DATE_ADD(q.embargo, INTERVAL 1 minute)-NOW()<0,'- ',''),LPAD(FLOOR(HOUR(TIMEDIFF(DATE_ADD(q.embargo, INTERVAL 1 minute),NOW())) / 24),2,'0'), 'd ',LPAD(MOD(HOUR(TIMEDIFF(DATE_ADD(q.embargo, INTERVAL 1 minute),NOW())), 24),2,'0'), 'h ',LPAD(MINUTE(TIMEDIFF(DATE_ADD(q.embargo, INTERVAL 1 minute),NOW())),2,'0'), 'm'),'') AS embargo",
        "q.errors",
        "IF(q.embargo_reason>'',q.embargo_reason,q.error_full) AS embargo_reason",
        "(SELECT \r\n\t\t\t\t\t       IF(q.executed IS NULL,\r\n\t\t\t\t\t         IF('" . intval( cptn_po_get_option( "cptn_po_opt_email_blocked" ) ) . "'='0',\r\n\t\t\t\t\t          IF (\r\n\t\t\t\t\t             (SELECT domain_status FROM " . $wpdb->prefix . "cptn_po_sender_domain sd WHERE sd.id=q.sender_domain_id AND sd.status=1)='OK',\r\n\t\t\t\t\t              IF (\r\n\t\t\t\t\t\t\t\t      (SELECT server_status FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm WHERE sdm.domain_id=q.sender_domain_id AND sdm.mailserver_id=ms.id AND sdm.status=1)='OK' OR q.mailserver IS NULL,\r\n\t\t\t\t\t              \t  IF (\r\n\t\t\t\t\t\t\t\t          (SELECT pms.id FROM " . $wpdb->prefix . "cptn_po_mailserver pms WHERE pms.id=ms.id AND pms.status=1)=ms.id OR q.mailserver IS NULL,\r\n\t\t\t\t\t\t\t\t\t\t  'OK',\r\n\t\t\t\t\t\t\t\t\t  \t  '" . htmlspecialchars_decode( esc_html__( "no server", "campation-postoffice" ) ) . "'\r\n\t\t\t\t\t\t\t\t\t\t  ),\r\n\t\t\t\t\t\t\t\t\t  '" . htmlspecialchars_decode( esc_html__( "no server for domain", "campation-postoffice" ) ) . "'\r\n\t\t\t\t\t\t\t\t\t ), \r\n\t\t\t\t\t\t\t\t  '" . htmlspecialchars_decode( esc_html__( "no sender domain", "campation-postoffice" ) ) . "' \r\n\t\t\t\t\t\t\t\t),\r\n                            '" . htmlspecialchars_decode( esc_html__( "general stop", "campation-postoffice" ) ) . "'\r\n\t\t\t\t\t\t\t),\r\n\t\t\t\t\t\t\t 'OK')\t\r\n\t\t\t\t\t) AS system_status",
        "(SELECT IF(q.slave IS NOT NULL,'WAIT',IF(q.errors='9999','ERROR',IF(q.executed IS NOT NULL,'OK','')))) AS error_reason",
        "q.from_email",
        "q.to_email",
        "q.mail_subject",
        "ms.shortname",
        "q.unsubscribed",
        "IF(q.opened>q.executed,CONCAT(FLOOR(HOUR(TIMEDIFF(q.opened,q.executed)) / 24), 'd ',MOD(HOUR(TIMEDIFF(q.opened,q.executed)), 24), 'h ',MINUTE(TIMEDIFF(q.opened,q.executed)), 'm'),'') AS opened",
        "IF(q.clicked>q.executed,CONCAT(FLOOR(HOUR(TIMEDIFF(q.clicked,q.executed)) / 24), 'd ',MOD(HOUR(TIMEDIFF(q.clicked,q.executed)), 24), 'h ',MINUTE(TIMEDIFF(q.clicked,q.executed)), 'm'),'') AS clicked",
        "q.sandbox",
        "q.source"
    );
    $fields = implode( ", ", $columns );
    $fields = str_replace( "action,", "", $fields );
    // action is not a database field
    $additionalfields = "\r\n   \t\t\t\t\t    ";
    // z.B. ", (SELECT COUNT(distinct url) FROM clicks WHERE company_id = c.id) AS cnt ";
    // this query is added first to all queries - MUST NOT BE EMPTY, at least "true"
    $querycomplex = " true\r\n\t\t\t\t    ";
    // this query is added second to all queries
    $queryrelation = "  \r\n\t\t\t\t    ";
    // this query is added third to all queries
    $queryadditional = " AND false ";
    
    if ( intval( get_option( "cptn_po_opt_outbox_switch_plan" ) ) or intval( get_option( "cptn_po_opt_outbox_switch_sent" ) ) or intval( get_option( "cptn_po_opt_outbox_switch_error" ) ) ) {
        $queryadditional = " AND (";
        
        if ( intval( get_option( "cptn_po_opt_outbox_switch_plan" ) ) == 1 and intval( get_option( "cptn_po_opt_outbox_switch_sent" ) ) != 1 ) {
            $queryadditional .= " q.executed IS NULL AND ";
        } elseif ( intval( get_option( "cptn_po_opt_outbox_switch_plan" ) ) != 1 and intval( get_option( "cptn_po_opt_outbox_switch_sent" ) ) == 1 ) {
            $queryadditional .= " q.executed IS NOT NULL AND ";
        } elseif ( intval( get_option( "cptn_po_opt_outbox_switch_plan" ) ) != 1 and intval( get_option( "cptn_po_opt_outbox_switch_sent" ) ) != 1 ) {
            $queryadditional .= " q.error_date IS NOT NULL AND ";
        }
        
        if ( intval( get_option( "cptn_po_opt_outbox_switch_error" ) ) != 1 ) {
            $queryadditional .= " q.error_date IS NULL AND ";
        }
        
        if ( $queryadditional != " AND (" ) {
            // we have arguments
            $queryadditional = substr( $queryadditional, 0, -4 );
            if ( intval( get_option( "cptn_po_opt_outbox_switch_error" ) ) == 1 ) {
                $queryadditional .= " OR q.error_date IS NOT NULL ";
            }
            $queryadditional .= ") ";
        } else {
            $queryadditional = "";
        }
    
    }
    
    include CPTNPODIR . "common/ajax/db-generate-json.php";
    wp_die();
}

add_action( 'wp_ajax_nopriv_cptn_po_outbox_switch', 'cptn_po_outbox_switch' );
add_action( 'wp_ajax_cptn_po_outbox_switch', 'cptn_po_outbox_switch' );
function cptn_po_outbox_switch()
{
    global  $wpdb ;
    $switchname = sanitize_text_field( $_POST['name'] );
    $switchstatus = sanitize_text_field( $_POST['value'] );
    update_option( "cptn_po_opt_outbox_switch_" . $switchname, $switchstatus );
    wp_die();
}
