<?php

// admin bar functions

if ( is_admin() ) {
    if ( !cptn_po_is_plugin_page( "assistant" ) ) {
        // show admin message "setup wizard not finished"
        
        if ( esc_html( get_option( "cptn_po_opt_assistant_status" ) ) != "OK" ) {
            add_action( 'admin_notices', 'cptn_po_admin_notice_continue_setup_error' );
            function cptn_po_admin_notice_continue_setup_error()
            {
                
                if ( esc_html( get_option( "cptn_po_opt_assistant_status" ) ) == "UPDATE" ) {
                    echo  '<div class="notice notice-error is-dismissible"><p>' . htmlspecialchars_decode( esc_html__( 'Campation PostOffice&trade; was updated - run the setup wizard again', "campation-postoffice" ) ) . ' - <a href="/wp-admin/admin.php?page=campation-postoffice-assistant">' . htmlspecialchars_decode( esc_html__( "please continue", "campation-postoffice" ) ) . '</a>!</p></div>' . PHP_EOL ;
                } elseif ( esc_html( get_option( "cptn_po_opt_assistant_status" ) ) != "OK" ) {
                    echo  '<div class="notice notice-error is-dismissible"><p>' . htmlspecialchars_decode( esc_html__( 'Setup wizard of Campation PostOffice&trade; was not finished successfully', "campation-postoffice" ) ) . ' - <a href="/wp-admin/admin.php?page=campation-postoffice-assistant">' . htmlspecialchars_decode( esc_html__( "please continue", "campation-postoffice" ) ) . '</a>!</p></div>' . PHP_EOL ;
                }
            
            }
        
        }
    
    }
    
    if ( cptn_cron_delay( "cptn_po_message_cron" ) and cptn_cron_delay( "cptn_po_message_cron" ) <= -240 ) {
        add_action( 'admin_notices', 'cptn_po_admin_notice_cron_not_running_error' );
        function cptn_po_admin_notice_cron_not_running_error()
        {
            echo  '<div class="notice notice-error is-dismissible"><p>' . htmlspecialchars_decode( esc_html__( 'The WordPress cron does not run continuously - Campation PostOffice&trade; cannot send email promptly - delay', "campation-postoffice" ) ) . ' ' . cptn_number_format( -cptn_cron_delay( "cptn_po_message_cron" ), 0, false ) . 's - <a href="admin.php?page=campation-postoffice-settings#utilities">' . htmlspecialchars_decode( esc_html__( 'please check instructions how to set up WP cron', "campation-postoffice" ) ) . '</a>!</p></div>' . PHP_EOL ;
        }
    
    }
    
    if ( cptn_po_is_plugin_page( "*" ) ) {
        // .htaccess missing or permalinks not set
        
        if ( !@file_get_contents( ABSPATH . '.htaccess' ) or !get_option( 'permalink_structure' ) ) {
            add_action( 'admin_notices', 'cptn_po_admin_notice_no_virtual_url' );
            function cptn_po_admin_notice_no_virtual_url()
            {
                echo  '<div class="notice notice-error is-dismissible"><p>' . htmlspecialchars_decode( esc_html__( 'Campation PostOffice&trade; cannot access its virtual URLs - may be <strong>.htaccess is missing</strong> or <a href="/wp-admin/options-permalink.php">permalinks need to be saved</a>! This link must work successfully:', "campation-postoffice" ) ) . ' <a href="/cptntestpage" target="_blank">' . htmlspecialchars_decode( esc_html__( 'Test virtual page', "campation-postoffice" ) ) . '</a></p></div>' . PHP_EOL ;
            }
        
        }
    
    }
}
