<?php
add_action('admin_footer', 'cptn_po_configuration_modal');
function cptn_po_configuration_modal()
   {
   global $wpdb;
   $mysql_timezone = $wpdb->get_var("SELECT @@system_time_zone;");
?>
<script>
var cptn_po_configuration_modal = `
<div id="cptn-po-config-general-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
   <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title"><?php echo htmlspecialchars_decode(esc_html__('General',"campation-postoffice")); ?></h5>
	    	<div style="float:right;">
               <button type="button" class="btn btn-secondary btn-sm cptn-close-modal" title="<?php echo esc_attr__('abort edit',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button>
		   	   <button type="button" class="btn btn-success btn-sm config_save_button" title="<?php echo esc_attr__('save this form',"campation-postoffice"); ?>"><i class="material-icons md-24">save</i></button>
		    </div>
         </div>
         <div class="modal-body">
	        <form id="cptn_po_config_general_form">
		 	   <input type="hidden" name="action" value="cptn_po_config_general_save">
     	       <div class="form-group cptn-form-group">
			      <label class="col-form-label-sm mb-0" for="cptn_opt_timezone_server"><?php echo htmlspecialchars_decode(esc_html__('Time zone of server',"campation-postoffice")); ?> (<?php echo htmlspecialchars_decode(esc_html__('found on server',"campation-postoffice")).": <strong>".$mysql_timezone; ?></strong>) <a href="https://en.wikipedia.org/wiki/Wikipedia:WikiProject_Time/Time_zone_table" target="_blank"><?php echo htmlspecialchars_decode(esc_html__('Time zone list',"campation-postoffice")); ?></a></label>
				  <div>
				     <select class="form-control form-control-sm" name="cptn_opt_timezone_server" id="cptn_opt_timezone_server">
					    <?php echo wp_timezone_choice(esc_html(get_option("cptn_opt_timezone_server"))); ?>
					 </select>
				  </div>
			   </div>

     	       <div class="form-group cptn-form-group">
			      <label class="col-form-label-sm mb-0" for="cptn_opt_timezone_staff"><?php echo htmlspecialchars_decode(esc_html__('Time zone of website',"campation-postoffice")); ?></label>
				  <div>
				     <select class="form-control form-control-sm" name="cptn_opt_timezone_staff" id="cptn_opt_timezone_staff">
					    <?php echo wp_timezone_choice(esc_html(get_option("cptn_opt_timezone_staff"))); ?>
					 </select>
				  </div>
			   </div>

			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_sandbox_mode" name="cptn_po_opt_sandbox_mode" value="1"><label class="form-check-label" for="cptn_po_opt_sandbox_mode"><?php echo htmlspecialchars_decode(esc_html__("Sandbox mode","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span></div>
	     	   <div class="form-group cptn-form-group cptn_po_opt_sandbox_container"><span class="cptn_po_is_for_business"><label class="col-form-label-sm mb-0" for="cptn_po_opt_sandbox_email"><?php echo htmlspecialchars_decode(esc_html__('Sandbox target (email address, leave empty for trash)',"campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span><div><span class="cptn_po_is_for_business"><input type="text" class="form-control form-control-sm" name="cptn_po_opt_sandbox_email" id="cptn_po_opt_sandbox_email" placeholder="email@domain.com"></span></div></div>

			   <div class="form-check"><input class="form-check-input" type="checkbox" id="cptn_po_opt_delete_data_uninstall" name="cptn_po_opt_delete_data_uninstall" value="1"><label class="form-check-label" for="cptn_po_opt_delete_data_uninstall"><?php echo htmlspecialchars_decode(esc_html__("Erase all data when uninstalling or upgrading this plugin","campation-postoffice")); ?></label></div>
		    </form>
         </div>
      </div>
   </div>
</div>

<div id="cptn-po-config-mail-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
   <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title"><?php echo htmlspecialchars_decode(esc_html__('Mail',"campation-postoffice")); ?></h5>
	    	<div style="float:right;">
               <button type="button" class="btn btn-secondary btn-sm cptn-close-modal" title="<?php echo esc_attr__('abort edit',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button>
		   	   <button type="button" class="btn btn-success btn-sm config_save_button" title="<?php echo esc_attr__('save this form',"campation-postoffice"); ?>"><i class="material-icons md-24">save</i></button>
		    </div>
         </div>
         <div class="modal-body">
	        <form id="cptn_po_config_mail_form">
		 	   <input type="hidden" name="action" value="cptn_po_config_mail_save">
	     	   <div class="form-group cptn-form-group mt-4"><label class="col-form-label-sm mb-0" for="cptn_opt_email_sendername"><?php echo htmlspecialchars_decode(esc_html__('Default sender name',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_opt_email_sendername" id="cptn_opt_email_sendername"></div></div>
	     	   <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_opt_email_sender"><?php echo htmlspecialchars_decode(esc_html__('Default sender email',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_opt_email_sender" id="cptn_opt_email_sender"></div></div>
	     	   <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_email_bcc"><?php echo htmlspecialchars_decode(esc_html__('Permanent blind copy (bcc) of transactional emails to',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_po_opt_email_bcc" id="cptn_po_opt_email_bcc"></div></div>
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_mailserver_off_errors"><?php echo htmlspecialchars_decode(esc_html__('Block mail server after error count of',"campation-postoffice")); ?></label><div><input type="number" class="form-control form-control-sm" name="cptn_po_opt_mailserver_off_errors" id="cptn_po_opt_mailserver_off_errors" placeholder="999"></div></div>
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_purge_queue_days"><?php echo htmlspecialchars_decode(esc_html__('Automatic cleanup of queue after days',"campation-postoffice")); ?></label><div><input type="number" class="form-control form-control-sm" name="cptn_po_opt_purge_queue_days" id="cptn_po_opt_purge_queue_days" placeholder="999"></div></div>

			   <br>
			   <div class="row">
   		    	  <div class="col-12 col-md-3"></div>
   		    	  <div class="col-12 col-md-6">
      	       		 <div class="cptn-admin-box-header"><?php echo htmlspecialchars_decode(esc_html__("Envelope IMAP account","campation-postoffice")); ?><span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("All bounced email go to the envelope address of any domain. All used envelope addresses should be forwarded to this IMAP account which serves for automatic processing of bounces and unsubscribes.","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
      		   		 <div class="cptn-admin-box-dotted-border">
      		      		<div class="row">
   	     	         	   <div class="col-12 col-md-12">
            	              <div class="table-responsive-sm mr-4">
      		   			   	     <table width="100%">
		    	  		   	 		<tr><td valign=middle style="font-size:12px;"><?php echo htmlspecialchars_decode(esc_html__("Email","campation-postoffice")); ?></td><td><input type="text" name="cptn_po_opt_envelope_account_email" id="cptn_po_opt_envelope_account_email" placeholder="postoffice@domain.com" value=""></td></tr>
		    	  		   	  		<tr><td valign=middle style="font-size:12px;"><?php echo htmlspecialchars_decode(esc_html__("Account","campation-postoffice")); ?></td><td><input type="text" name="cptn_po_opt_envelope_account_name" id="cptn_po_opt_envelope_account_name" placeholder="postoffice@domain.com" value=""></td></tr>
		    	  		   	  		<tr><td valign=middle style="font-size:12px;"><?php echo htmlspecialchars_decode(esc_html__("Password","campation-postoffice")); ?></td><td><input type="password" name="cptn_po_opt_envelope_account_password" id="cptn_po_opt_envelope_account_password" placeholder="" value="" onmouseover="this.type=<?php echo "'text'"; ?>" onmouseout="this.type=<?php echo "'password'"; ?>"></td></tr>
		    	  		      	    <tr><td valign=middle style="font-size:12px;"><?php echo htmlspecialchars_decode(esc_html__("Server","campation-postoffice")); ?></td><td><input type="text" name="cptn_po_opt_envelope_account_server" id="cptn_po_opt_envelope_account_server" placeholder="mail.domain.com" value=""></td></tr>
		    	  		   	  		<tr><td valign=middle style="font-size:12px;"><?php echo htmlspecialchars_decode(esc_html__("Port","campation-postoffice")); ?></td><td><input type="text" name="cptn_po_opt_envelope_account_port" id="cptn_po_opt_envelope_account_port" placeholder="993" value=""></td></tr>
		    	  		   	  		<tr><td valign=middle style="font-size:12px;"><?php echo htmlspecialchars_decode(esc_html__("Security","campation-postoffice")); ?></td><td><select name="cptn_po_opt_envelope_account_security" id="cptn_po_opt_envelope_account_security"><option value=""><?php echo htmlspecialchars_decode(esc_attr__("select","campation-postoffice")); ?></option><option value="notls"><?php echo htmlspecialchars_decode(esc_html_x("None","security","campation-postoffice")); ?></option><option value="ssl"><?php echo htmlspecialchars_decode(esc_html__("SSL","campation-postoffice")); ?></option><option value="ssl/novalidate-cert"><?php echo htmlspecialchars_decode(esc_html__("SSL (self signed certificate)","campation-postoffice")); ?></option><option value="tls"><?php echo htmlspecialchars_decode(esc_html__("TLS","campation-postoffice")); ?></option><option value="tls/novalidate-cert"><?php echo htmlspecialchars_decode(esc_html__("TLS (self signed certificate)","campation-postoffice")); ?></option></select></td></tr>
				  		   	  		<tr><td colspan=2 align=right><span style="float:left;font-size:12px;" id="cptn-po-test-imap-account-result-envelope"></span><button type="button" data-type="envelope" class="button cptn-po-test-imap-account"><?php echo htmlspecialchars_decode(esc_html__("TEST","campation-postoffice")); ?></button></td></tr>
	                             </table>
		                      </div> 
		                   </div> 
      		      		</div> 
                      </div>
   		           </div>
   		    	  <div class="col-12 col-md-3"></div>

               </div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_bounce_management" name="cptn_po_opt_bounce_management" value="1"><label class="form-check-label" for="cptn_po_opt_bounce_management"><?php echo htmlspecialchars_decode(esc_html__('Automatic bounce management',"campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("when activated, Campation PostOffice&trade; investigates the Envelope IMAP account for undeliverable emails every minute - the relevant recipients are automatically blocked.","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_business"><input class="form-check-input" type="checkbox" id="cptn_po_opt_bimi" name="cptn_po_opt_bimi" value="1"><label class="form-check-label" for="cptn_po_opt_bimi"><?php echo htmlspecialchars_decode(esc_html__("Use 'Brand Indicator Message Identification' (BIMI)","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-business"></span></div>

		    </form>
         </div>
      </div>
   </div>
</div>

<div id="cptn-po-config-headerfooter-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
   <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title"><?php echo htmlspecialchars_decode(esc_html__('Header / Footer',"campation-postoffice")); ?></h5>
	    	<div style="float:right;">
               <button type="button" class="btn btn-secondary btn-sm cptn-close-modal" title="<?php echo esc_attr__('abort edit',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button>
		   	   <button type="button" class="btn btn-success btn-sm config_save_button" title="<?php echo esc_attr__('save this form',"campation-postoffice"); ?>"><i class="material-icons md-24">save</i></button>
		    </div>
         </div>
         <div class="modal-body">
	        <form id="cptn_po_config_headerfooter_form">
		 	   <input type="hidden" name="action" value="cptn_po_config_headerfooter_save">

			   <div class="form-check"><input class="form-check-input" type="checkbox" id="cptn_po_opt_affiliate_footer" name="cptn_po_opt_affiliate_footer" value="1"><label class="form-check-label" for="cptn_po_opt_inaguard"><?php echo htmlspecialchars_decode(esc_html__("Add affiliate link footer to all emails","campation-postoffice")); ?> <small>(<a href="<?php echo CPTNPOAFFILIATEINFO; ?>" target="_blank" rel="noopener noreferrer"><?php echo htmlspecialchars_decode(esc_html__('Become an affiliate here',"campation-postoffice")); ?></a>)</small></label><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("If you are our affiliate and have an affiliate ID, you can enter it here and activate the affiliate link in outgoing emails. Then, at the bottom of each email will appear in small letters 'Sent with love by WP Campation PostOffice&trade;', linked to your affiliate ID.","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
			   <div class="cptn_po_opt_affiliate_container">
                  <table width=100% cellpadding=5>
	     	         <tr>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_po_opt_affiliate_id"><?php echo htmlspecialchars_decode(esc_html__('Affiliate ID',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_po_opt_affiliate_id" id="cptn_po_opt_affiliate_id"></div></td>
				     </tr>
				  </table>
			   </div>	  


			   <br>
			   <div class="row">
   		    	  <div class="col-12 col-md-12">
      	       		 <div class="cptn-admin-box-header"><?php echo htmlspecialchars_decode(esc_html__("General mail footer","campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("You may include HTML code that is shown centered at the bottom of all outgoing HTML emails. Please only use double quotes!","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
      		   		 <div class="cptn-admin-box-dotted-border  cptn_po_is_for_starter">
      		      		<div class="row">
   	     	         	   <div class="col-12 col-md-12">
						      <textarea style="width:100%;" name="cptn_po_opt_general_mail_footer" id="cptn_po_opt_general_mail_footer" placeholder='<div style="font-size:12px;background-color:green;">This is my footer html</div>'></textarea>
		                   </div> 
	                     </div> 
                      </div>
   		           </div>
               </div>

			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_email_read_online_header" name="cptn_po_opt_email_read_online_header" value="1"><label class="form-check-label" for="cptn_po_opt_email_read_online_header"><?php echo htmlspecialchars_decode(esc_html__('Add "read this mail in browser" link in header of all outgoing emails',"campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__('Sometimes the HTML code of your email may not be rendered well in the email client the recipient uses - clicking this link will display the email in the web browser. This requires a valid <body> tag in the email.',"campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_email_unsubscribe_header" name="cptn_po_opt_email_unsubscribe_header" value="1"><label class="form-check-label" for="cptn_po_opt_email_unsubscribe_header"><?php echo htmlspecialchars_decode(esc_html__('Add unsubscribe header ("one click") to all non-transactional emails',"campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("'one-click unsubscribe' helps your recipients not to receive any further emails - instead of marking your email as spam. This function is indispensable for Gmail, Yahoo and other recipient domains for a good sender reputation!","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_email_unsubscribe_footer" name="cptn_po_opt_email_unsubscribe_footer" value="1"><label class="form-check-label" for="cptn_po_opt_email_unsubscribe_footer"><?php echo htmlspecialchars_decode(esc_html__("Add unsubscribe footer to all non-transactional emails","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("Not all email clients already support the 'one-click-unsubscribe' feature. You should therefore also display a corresponding unsubscribe link in the footer of each email.","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
	           <div class="form-group cptn-form-group"><span class="cptn_po_is_for_starter"><label class="col-form-label-sm mb-0" for="cptn_po_opt_unsubscribe_page"><?php echo htmlspecialchars_decode(esc_html__('Page after unsubscribe',"campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span><div>
			      <span class="cptn_po_is_for_starter"><select id="cptn_po_opt_unsubscribe_page" name="cptn_po_opt_unsubscribe_page">
				     <option value=""><?php echo htmlspecialchars_decode(esc_html__('without',"campation-postoffice")); ?></option>
<?php
$pages = get_pages(); 
foreach($pages AS $page) 
   {
   $option = '<option value="' . esc_url_raw(get_page_link($page->ID)) . '">';
   $option .= $page->post_title;
   $option .= '</option>';
   echo esc_html($option.PHP_EOL);
   }
?>
				  </select></span>
			   </div></div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_unsubscribe_management" name="cptn_po_opt_unsubscribe_management" value="1"><label class="form-check-label" for="cptn_po_opt_unsubscribe_management"><?php echo htmlspecialchars_decode(esc_html__("Automatic unsubscribe management","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("when activated, Campation PostOffice&trade; investigates the Envelope IMAP account for unsubscribes every minute - the corresponding recipients are automatically blocked.","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
			   <br>
			   <div class="row">
   		    	  <div class="col-12 col-md-12">
      	       		 <div class="cptn-admin-box-header"><?php echo htmlspecialchars_decode(esc_html__('Pixels',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("Please note that pixels are not taken into account by all email clients and are therefore not triggered by every recipient","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
      		   		 <div class="cptn-admin-box-dotted-border cptn_po_is_for_premium">
      		      		<div class="row">
   	     	         	   <div class="col-12 col-md-12">
	           			      <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_analytics_pixel"><?php echo htmlspecialchars_decode(esc_html__('Google Analytics Tracking ID',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_po_opt_analytics_pixel" id="cptn_po_opt_analytics_pixel" placeholder="<?php echo htmlspecialchars_decode(esc_html__("Your Google Analytics Tracking ID (UA-XXXX-Y / G- ...)","campation-postoffice")); ?>"></div></div>
	           				  <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_adwords_pixel"><?php echo htmlspecialchars_decode(esc_html__('Google Adwords Tracking ID',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_po_opt_adwords_pixel" id="cptn_po_opt_adwords_pixel" placeholder="<?php echo htmlspecialchars_decode(esc_html__("Your Google Adwords ID (AW-......)","campation-postoffice")); ?>"></div></div>
	           				  <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_facebook_pixel"><?php echo htmlspecialchars_decode(esc_html__('Facebook pixel',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_po_opt_facebook_pixel" id="cptn_po_opt_facebook_pixel" placeholder="<?php echo htmlspecialchars_decode(esc_html__("Your Facebook pixel ID","campation-postoffice")); ?>"></div></div>
		                   </div> 
	                     </div> 
                      </div>
   		           </div>
               </div>

		    </form>
         </div>
      </div>
   </div>
</div>

<div id="cptn-po-config-optimization-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
   <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title"><?php echo htmlspecialchars_decode(esc_html__('Optimization (AI)',"campation-postoffice")); ?></h5>
	    	<div style="float:right;">
               <button type="button" class="btn btn-secondary btn-sm cptn-close-modal" title="<?php echo esc_attr__('abort edit',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button>
		   	   <button type="button" class="btn btn-success btn-sm config_save_button" title="<?php echo esc_attr__('save this form',"campation-postoffice"); ?>"><i class="material-icons md-24">save</i></button>
		    </div>
         </div>
         <div class="modal-body">
	        <form id="cptn_po_config_optimization_form">
		 	   <input type="hidden" name="action" value="cptn_po_config_optimization_save">

			   <div class="form-check"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_schedule" name="cptn_po_opt_schedule" value="1"><label class="form-check-label" for="cptn_po_opt_schedule"><?php echo htmlspecialchars_decode(esc_html__("Campation MailSchedule&trade; (recommended on productive sites)","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("Non-transactional emails will be sent only at hours permitted here - e.g. your business hours","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
			   <div class="cptn_po_opt_schedule_container cptn_po_is_for_starter">
                  <table width=100% cellpadding=5>
	     	         <tr>
				  	    <td valign=top><label class="col-form-label-sm mb-0" for="cptn_opt_automation_days"><?php echo htmlspecialchars_decode(esc_html__('Send non-transactional email only',"campation-postoffice")); ?></label><div><select size="7" class="form-control form-control-sm" name="cptn_opt_automation_days[]" id="cptn_opt_automation_days" multiple><option value="0"><?php echo htmlspecialchars_decode(esc_html__('Sunday',"campation-postoffice")); ?></option><option value="1"><?php echo htmlspecialchars_decode(esc_html__('Monday',"campation-postoffice")); ?></option><option value="2"><?php echo htmlspecialchars_decode(esc_html__('Tuesday',"campation-postoffice")); ?></option><option value="3"><?php echo htmlspecialchars_decode(esc_html__('Wednesday',"campation-postoffice")); ?></option><option value="4"><?php echo htmlspecialchars_decode(esc_html__('Thursday',"campation-postoffice")); ?></option><option value="5"><?php echo htmlspecialchars_decode(esc_html__('Friday',"campation-postoffice")); ?></option><option value="6"><?php echo htmlspecialchars_decode(esc_html__('Saturday',"campation-postoffice")); ?></option></select><small><i>(<?php echo htmlspecialchars_decode(esc_html__('multiple select with ctrl + left mouse key',"campation-postoffice")); ?>)</i></small></div></td>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_opt_automation_time_start"><?php echo htmlspecialchars_decode(esc_html__('from hour',"campation-postoffice")); ?></label><div><input type="time" min="06:00" max="23:00" class="form-control form-control-sm" name="cptn_opt_automation_time_start" id="cptn_opt_automation_time_start" placeholder="08:00"><small><i>(<?php echo htmlspecialchars_decode(esc_html__('24h format',"campation-postoffice")); ?>)</i></small></div></td>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_opt_automation_time_end"><?php echo htmlspecialchars_decode(esc_html__('until hour',"campation-postoffice")); ?></label><div><input type="time" min="06:00" max="23:00" class="form-control form-control-sm" name="cptn_opt_automation_time_end" id="cptn_opt_automation_time_end" placeholder="20:00"><small><i>(<?php echo htmlspecialchars_decode(esc_html__('24h format',"campation-postoffice")); ?>)</i></small></div></td>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_opt_automation_send_gap_min"><?php echo htmlspecialchars_decode(esc_html__('minimum time gap',"campation-postoffice")); ?></label><div><input type="number" class="form-control form-control-sm" name="cptn_opt_automation_send_gap_min" id="cptn_opt_automation_send_gap_min" placeholder="60"><small><i>(<?php echo htmlspecialchars_decode(esc_html__('min',"campation-postoffice")); ?>)</i></small></div></td>
				     </tr>
				  </table>
			   </div>	  
			   <div class="form-check cptn_po_opt_schedule_container"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_intellimail" name="cptn_po_opt_intellimail" value="1"><label class="form-check-label" for="cptn_po_opt_intellimail"><?php echo htmlspecialchars_decode(esc_html__('Campation IntelliMail&trade; (machine learning, "send @ best time")',"campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("Non-transactional emails are sent at the time of day the recipient is most likely to open them - requires some time for the learning process per recipient","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>

			   <div class="form-check"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_domain_protect" name="cptn_po_opt_domain_protect" value="1"><label class="form-check-label" for="cptn_po_opt_domain_protect"><?php echo htmlspecialchars_decode(esc_html__("Campation DomainProtect&trade;","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("All emails will be sent through the sub-domain that fits to the category of an email - requires some one-time configuration and protects your sender reputation perfectly","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>

			   <div class="form-check"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_inaguard" name="cptn_po_opt_inaguard" value="1"><label class="form-check-label" for="cptn_po_opt_inaguard"><?php echo htmlspecialchars_decode(esc_html__("Campation InaGuard&trade; (do not mail inactive subscribers)","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("Non-transactional emails for recipients who have not opened / clicked any of the last XX messages <b><u>or</u></b> any messages in the last XX days will be ignored and not added to the outbound queue. This recipient status is reset as soon as the recipient receives a transactional email (e.g. an invoice). All click events are reliably measured but please note that not all email clients provide exact feedback on opening events of emails and you can lose subscribers who open your messages (but do not click). The activity status of all recipients is updated in the background on a hourly basis. If you change the configuration values it will be recalculated. Switching off this function will set all recipients into active state.","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
			   <div class="cptn_po_opt_inaguard_container cptn_po_is_for_premium">
                  <table width=100% cellpadding=5>
	     	         <tr>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_po_opt_inaguard_days"><?php echo htmlspecialchars_decode(esc_html__('no open / click in the last days',"campation-postoffice")); ?></label><div><input type="number" min="0" class="form-control form-control-sm" name="cptn_po_opt_inaguard_days" id="cptn_po_opt_inaguard_days"></div></td>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_po_opt_inaguard_messages"><?php echo htmlspecialchars_decode(esc_html__('no open / click in the last messages',"campation-postoffice")); ?></label><div><input type="number" min="0" class="form-control form-control-sm" name="cptn_po_opt_inaguard_messages" id="cptn_po_opt_inaguard_messages"></div></td>
				     </tr>
				  </table>
			   </div>	  
			   <br>

			   <div class="form-check"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_warmup" name="cptn_po_opt_warmup" value="1"><label class="form-check-label" for="cptn_po_opt_warmup"><?php echo htmlspecialchars_decode(esc_html__("Campation WarmUp&trade; (increase sending volume for each mailserver slowly)","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("For best sender reputation, a new mail server / sender domain must be warmed up - the daily sending volume is increased from XX e-mails daily to unlimited over XX days - transactional emails are always sent immediately","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
			   <div class="cptn_po_opt_warmup_container cptn_po_is_for_premium">
                  <table width=100% cellpadding=5>
	     	         <tr>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_po_opt_warmup_days"><?php echo htmlspecialchars_decode(esc_html__('warm up period in days',"campation-postoffice")); ?></label><div><input type="number" min="0" class="form-control form-control-sm" name="cptn_po_opt_warmup_days" id="cptn_po_opt_warmup_days"></div></td>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_po_opt_warmup_volume"><?php echo htmlspecialchars_decode(esc_html__('planned monthly total email volume after warm up',"campation-postoffice")); ?></label><div><input type="number" min="0" class="form-control form-control-sm" name="cptn_po_opt_warmup_volume" id="cptn_po_opt_warmup_volume"></div></td>
				     </tr>
				  </table>
			   </div>	  
			   <br>
			   
			   <div class="form-check"><span class="cptn_po_is_for_business"><input class="form-check-input" type="checkbox" id="cptn_po_opt_throttle" name="cptn_po_opt_throttle" value="1"><label class="form-check-label" for="cptn_po_opt_throttle"><?php echo htmlspecialchars_decode(esc_html__("Campation MailThrottle&trade; (throttle sending volume per recipient domain)","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-business"></span><span class="cptn-question-circle-blue" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("To avoid 'attacks' on receiving mail servers you may limit the number of emails per minute send to a particular recipient domain - transactional emails are always sent immediately","campation-postoffice"); ?>."><i class="fas fa-question-circle"></i></span></div>
			   <div class="cptn_po_opt_throttle_container cptn_po_is_for_business">
                  <table width=100% cellpadding=5>
	     	         <tr>
	           	  		<td valign=top><label class="col-form-label-sm mb-0" for="cptn_po_opt_throttle_max_min"><?php echo htmlspecialchars_decode(esc_html__('max. emails per minute per recipient domain',"campation-postoffice")); ?></label><div><input type="number" min="0" class="form-control form-control-sm" name="cptn_po_opt_throttle_max_min" id="cptn_po_opt_throttle_max_min"></div></td>
				     </tr>
				  </table>
			   </div>	  
			   <br>

			   <div class="row">
   		    	  <div class="col-12 col-md-12">
      	       		 <div class="cptn-admin-box-header"><?php echo htmlspecialchars_decode(esc_html__('Mail categories',"campation-postoffice")); ?><span class="cptn-question-circle" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo esc_attr__("Campation PostOffice&trade; controls various functions (e.g. delayed sending of emails or selection of sender domain) via the mail category. Please set the mail category for each installed plugin that sends email.","campation-postoffice"); ?>"><i class="fas fa-question-circle"></i></span></div>
      		   		 <div class="cptn-admin-box-dotted-border">
      		      		<div class="row">
   	     	         	   <div class="col-12 col-md-12">
	  		   	  		      <div class="table-responsive-sm">
                     		     <table width=100% cellpadding=2 class="table table-sm table-hover table-compact">
   				        		    <tr><th><?php echo htmlspecialchars_decode(esc_html__("Plugin","campation-postoffice")); ?></th><th style="text-align:right;"><?php echo htmlspecialchars_decode(esc_html__("Mail category","campation-postoffice")); ?></th></tr>

<?php
global $wpdb;
$query = "SELECT pluginname, pluginslug, fullpluginslug, mailcategory, mailcatfull FROM ".$wpdb->prefix."cptn_po_plugin_mailcategory ORDER BY pluginname ASC";
$plugins = $wpdb->get_results($query, ARRAY_A);
$active_plugins = get_option("active_plugins");
foreach($plugins AS $key => $plugin)
   {
   if(substr($plugin['pluginname'],0,20) != "Campation PostOffice" AND substr($plugin['pluginname'],0,20) != "Campation RemoteMail")
      {
      $plugin_is_active = false;
	  foreach($active_plugins AS $active_plugin)
	     {
		 if($active_plugin === $plugin['fullpluginslug'])
		    {
		    $plugin_is_active = true;
	        break;
            } 		 
		 }
      if($plugin_is_active)
         echo '<tr style="font-size:12px;">';
	  else
         echo '<tr style="font-size:12px;color:#aaaaaa !important;">';

      echo '<td valign="middle">'.esc_html($plugin['pluginname']).'</td><td align="right">
	       <input type="hidden" name="pluginname['.esc_html($plugin['pluginslug']).']" value="'.esc_attr($plugin['pluginname']).'">
		      <div class="form-check form-check-inline">
  			     <input class="form-check-input" type="radio" name="mailcategory['.esc_attr($plugin['pluginslug']).']" id="none_'.esc_attr($plugin['pluginslug']).'" value="">
				 <label class="form-check-label" for="none-'.esc_attr($plugin['pluginslug']).'">'.htmlspecialchars_decode(esc_html__("Without","campation-postoffice")).'</label>
              </div>
		      <div class="form-check form-check-inline">
  			     <input class="form-check-input" type="radio" name="mailcategory['.esc_attr($plugin['pluginslug']).']" id="trans_'.esc_attr($plugin['pluginslug']).'" value="trans">
				 <label class="form-check-label" for="trans-'.esc_attr($plugin['pluginslug']).'">'.htmlspecialchars_decode(esc_html__("Transaction","campation-postoffice")).'</label>
              </div>
		      <div class="form-check form-check-inline">
  			     <input class="form-check-input" type="radio" name="mailcategory['.esc_attr($plugin['pluginslug']).']" id="marke_'.esc_attr($plugin['pluginslug']).'" value="marke">
				 <label class="form-check-label" for="marke-'.esc_attr($plugin['pluginslug']).'">'.htmlspecialchars_decode(esc_html__("Marketing","campation-postoffice")).'</label>
              </div>
		      <div class="form-check form-check-inline">
  			     <input class="form-check-input" type="radio" name="mailcategory['.esc_attr($plugin['pluginslug']).']" id="bulk_'.esc_attr($plugin['pluginslug']).'" value="bulk">
				 <label class="form-check-label" for="bulk-'.esc_attr($plugin['pluginslug']).'">'.htmlspecialchars_decode(esc_html__("Bulk","campation-postoffice")).'</label>
              </div>
		      <div class="form-check form-check-inline">
  			     <input class="form-check-input" type="radio" name="mailcategory['.esc_attr($plugin['pluginslug']).']" id="cold_'.esc_attr($plugin['pluginslug']).'" value="cold">
				 <label class="form-check-label" for="cold-'.esc_attr($plugin['pluginslug']).'">'.htmlspecialchars_decode(esc_html__("Cold","campation-postoffice")).'</label>
              </div>
         </td></tr>';
      }
   }
?>
                     		     </table>
                              </div>
		                   </div> 
	                     </div> 
                      </div>
   		           </div>
               </div>

		    </form>
         </div>
      </div>
   </div>
</div>

<div id="cptn-po-config-report-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
   <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title"><?php echo htmlspecialchars_decode(esc_html__('Reporting',"campation-postoffice")); ?></h5>
	    	<div style="float:right;">
               <button type="button" class="btn btn-secondary btn-sm cptn-close-modal" title="<?php echo esc_attr__('abort edit',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button>
		   	   <button type="button" class="btn btn-success btn-sm config_save_button" title="<?php echo esc_attr__('save this form',"campation-postoffice"); ?>"><i class="material-icons md-24">save</i></button>
		    </div>
         </div>
         <div class="modal-body">
	        <form id="cptn_po_config_report_form">
		 	   <input type="hidden" name="action" value="cptn_po_config_report_save">

	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_admin_alerts_to"><?php echo htmlspecialchars_decode(esc_html__('Send all system messages to',"campation-postoffice")); ?></label><div><input type="text" class="form-control form-control-sm" name="cptn_po_opt_admin_alerts_to" id="cptn_po_opt_admin_alerts_to" placeholder="info@domain.com"></div></div>
			   <div class="form-check"><input class="form-check-input" type="checkbox" id="cptn_po_opt_admin_alerts" name="cptn_po_opt_admin_alerts" value="1"><label class="form-check-label" for="cptn_po_opt_admin_alerts"><?php echo htmlspecialchars_decode(esc_html__("Send alert emails in case of problems","campation-postoffice")); ?></label></div>
			   <div class="form-check"><input class="form-check-input" type="checkbox" id="cptn_po_opt_info_developer" name="cptn_po_opt_info_developer" value="1"><label class="form-check-label" for="cptn_po_opt_info_developer"><?php echo htmlspecialchars_decode(esc_html__("Submit technical information and statistics to developers anonymously","campation-postoffice")); ?></label></div>

			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_mail_error_report" name="cptn_po_opt_mail_error_report" value="1"><label class="form-check-label" for="cptn_po_opt_mail_error_report"><?php echo htmlspecialchars_decode(esc_html__("Daily mail error report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_health_report" name="cptn_po_opt_health_report" value="1"><label class="form-check-label" for="cptn_po_opt_health_report"><?php echo htmlspecialchars_decode(esc_html__("Campation DNSGuard&trade; - Health change report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_unsub_bounce_report" name="cptn_po_opt_unsub_bounce_report" value="1"><label class="form-check-label" for="cptn_po_opt_unsub_bounce_report"><?php echo htmlspecialchars_decode(esc_html__("Daily unsubscribe / bounce report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_starter"><input class="form-check-input" type="checkbox" id="cptn_po_opt_blacklist_report" name="cptn_po_opt_blacklist_report" value="1"><label class="form-check-label" for="cptn_po_opt_blacklist_report"><?php echo htmlspecialchars_decode(esc_html__("Black list change report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-starter"></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_daily_dmarc_report" name="cptn_po_opt_daily_dmarc_report" value="1"><label class="form-check-label" for="cptn_po_opt_daily_dmarc_report"><?php echo htmlspecialchars_decode(esc_html__("Daily DMARC report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_premium"><input class="form-check-input" type="checkbox" id="cptn_po_opt_inaguard_report" name="cptn_po_opt_inaguard_report" value="1"><label class="form-check-label" for="cptn_po_opt_inaguard_report"><?php echo htmlspecialchars_decode(esc_html__("Daily Campation InaGuard&trade; report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-premium"></span></div>
			   <div class="form-check"><span class="cptn_po_is_for_business"><input class="form-check-input" type="checkbox" id="cptn_po_opt_senderscore_report" name="cptn_po_opt_senderscore_report" value="1"><label class="form-check-label" for="cptn_po_opt_senderscore_report"><?php echo htmlspecialchars_decode(esc_html__("SenderScore change report email to admin","campation-postoffice")); ?></label></span><span class="cptn-po-icon-pro-business"></span></div>
		    </form>
         </div>
      </div>
   </div>
</div>

<div id="cptn-po-config-statistics-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
   <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
      <div class="modal-content">
         <div class="modal-header">
            <h5 class="modal-title"><?php echo htmlspecialchars_decode(esc_html__('Statistics',"campation-postoffice")); ?></h5>
	    	<div style="float:right;">
               <button type="button" class="btn btn-secondary btn-sm cptn-close-modal" title="<?php echo esc_attr__('abort edit',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button>
		   	   <button type="button" class="btn btn-success btn-sm config_save_button" title="<?php echo esc_attr__('save this form',"campation-postoffice"); ?>"><i class="material-icons md-24">save</i></button>
		    </div>
         </div>
      	 <div class="modal-body">
	        <form id="config_statistics_form">
		       <input type="hidden" name="action" value="cptn_po_config_statistics_save">
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_max_bounce"><?php echo htmlspecialchars_decode(esc_html__('Maximum allowed bounce rate',"campation-postoffice")); ?> (%)</label><div><input type="number" min="0" max="100" step="0.1" id="cptn_po_opt_max_bounce" name="cptn_po_opt_max_bounce" placeholder="1.5"></div></div>
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_min_open"><?php echo htmlspecialchars_decode(esc_html__('Minimum expected open rate',"campation-postoffice")); ?> (%)</label><div><input type="number" min="0" max="100" step="0.1" id="cptn_po_opt_min_open" name="cptn_po_opt_min_open" placeholder="25.0"></div></div>
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_max_unsubscribe"><?php echo htmlspecialchars_decode(esc_html__('Maximum allowed unsubscribe rate',"campation-postoffice")); ?> (%)</label><div><input type="number" min="0" max="100" step="0.1" id="cptn_po_opt_max_unsubscribe" name="cptn_po_opt_max_unsubscribe" placeholder="0.1"></div></div>
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_min_click"><?php echo htmlspecialchars_decode(esc_html__('Minimum expected click rate',"campation-postoffice")); ?> (%)</label><div><input type="number" min="0" max="100" step="0.1" id="cptn_po_opt_min_click" name="cptn_po_opt_min_click" placeholder="1.2"></div></div>
	           <div class="form-group cptn-form-group"><label class="col-form-label-sm mb-0" for="cptn_po_opt_statistics_days"><?php echo htmlspecialchars_decode(esc_html__('Calculate statistical values (domains, mail server) over days',"campation-postoffice")); ?></label><div><input type="number" min="30" max="365" step="1" id="cptn_po_opt_statistics_days" name="cptn_po_opt_statistics_days" placeholder="30"></div></div>
		    </form>
         </div>
      </div>
   </div>
</div>
`;
</script>
<?php
   };
?>