<?php

//add_action('wp_loaded', 'cptn_po_db_install');       // run database check
function cptn_po_db_install()
{
    global  $wpdb ;
    $tableprefix = $wpdb->prefix . 'cptn_po_';
    require_once ABSPATH . 'wp-admin/includes/upgrade.php';
    if ( !isset( $cptn_po_db_tables ) ) {
        $cptn_po_db_tables = array();
    }
    // all tables in array for API
    // *********************************************
    //                 DATABASE TABLES
    // *********************************************
    // Create table for mailserver
    $packagetable = $tableprefix . 'mailserver';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n            \tshortname varchar(50) NULL, \n            \tserver_type varchar(10) NULL, \n            \taddress varchar(200) NULL, \n\t\t\t\tip varchar(50) NULL,\n\t\t\t\tplugin_url varchar(150) NULL,\n\t\t\t\trdns INT(11) NULL,\n\t\t\t\trdns_record VARCHAR(200) NULL,\n\t\t\t\tconnectable INT(11) NOT NULL,\n\t\t\t\ttest_mail_success DATETIME NULL,\n            \tport varchar(4) NULL, \n            \taccount varchar(200) NULL, \n\t\t\t\tpassword varchar(200) NULL,\n\t\t\t\tencryption varchar(10) NULL,\n\t\t\t\tprocesses INT(11) NULL,\n\t\t\t\tcontingent INT(11) NOT NULL,\n\t\t\t\tcontingent_exceed INT(11) NOT NULL,\n\t\t\t\tcontingent_period VARCHAR(1) NULL,\n\t\t\t\tcontingent_used INT(11) NOT NULL,\n\t\t\t\tdnsbl INT(11) NULL,\n\t\t\t\tsenderscore INT(11) NOT NULL,\n\t\t\t\tsenderscoredate DATETIME NULL,\n\t\t\t\tsenderscoretrend varchar(1) NULL,\n\t\t\t\tstatus INT(11) NOT NULL,\n\t\t\t\twarmup_day INT(11) NOT NULL,\n\t\t\t\twarmup_allowed INT(11) NOT NULL,\n\t\t\t\twarmup_sent INT(11) NOT NULL,\n\t\t\t\tsent INT(11) NOT NULL,\n\t\t\t\tbounced INT(11) NOT NULL,\n\t\t\t\terrors INT(11) NOT NULL,\n\t\t\t\tlasterror TEXT NULL,\n\t\t\t\topened INT(11) NOT NULL,\n\t\t\t\tunsubscribed INT NOT NULL,\n\t\t\t\tclicked INT(11) NOT NULL,\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY server_type (server_type),\n\t\t\t\tKEY shortname (shortname)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // add spmail
    $query = "SELECT * FROM " . $packagetable;
    $result = $wpdb->get_results( $query, ARRAY_A );
    
    if ( !$result ) {
        $ip_addr = CPTNPOIP;
        // get hostname from external server to avoid local name resolution
        $hostname = cptn_po_check_rdns( $ip_addr );
        $query = "INSERT INTO " . $packagetable . " SET id=0, shortname = 'SpeedMail', server_type = 'spmail', address = '" . esc_sql( $hostname ) . "', ip = '" . esc_sql( $ip_addr ) . "', connectable = 1, processes = 1, status = 1, dnsbl = 0, created = NOW(), updated = NOW()";
        if ( $hostname ) {
            $query .= " , rdns = 1, rdns_record = '" . esc_sql( $hostname ) . "'";
        }
        $result = $wpdb->query( $query );
        $query = "UPDATE " . $packagetable . " SET id=0 WHERE shortname = 'SpeedMail'";
        $result = $wpdb->query( $query );
    }
    
    // Create table for mailserver errors
    $packagetable = $tableprefix . 'mailserver_error';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n            \tmailserver INT NULL, \n\t\t\t\terror_date DATETIME NULL,\n\t\t\t\terror_reason VARCHAR(30) NULL,\n\t\t\t\terror_full TEXT NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY mailserver (mailserver),\n\t\t\t\tKEY error_date (error_date),\n\t\t\t\tKEY error_reason (error_reason)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for mailserver mxhost
    $packagetable = $tableprefix . 'mailserver_mxdomain';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tmailserver INT NOT NULL,\n\t\t\t\tmxdomain VARCHAR(100) NULL,\n\t\t\t\ttotal_sent INT NOT NULL,\n\t\t\t\tminute_allowed INT NOT NULL,\n\t\t\t\tminute_sent INT NOT NULL,\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY mailserver (mailserver),\n\t\t\t\tKEY mxdomain (mxdomain)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for message slaves
    $packagetable = $tableprefix . 'slave';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tmailserver_id INT NULL,\n            \tserver_type varchar(10) NULL, \n\t\t\t\tdomain_id INT NULL,\n            \tmails INT NOT NULL, \n\t\t\t\tstart DATETIME NULL,\n            \tsent INT NOT NULL, \n            \tseconds INT NOT NULL, \n\t\t\t\tmailspersec DECIMAL(12,2) NOT NULL, \n\t\t\t\tstop DATETIME NULL,\n\t\t\t\texecuted DATETIME NULL,\n\t\t\t\tcreated DATETIME NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY start (start),\n\t\t\t\tKEY stop (stop),\n\t\t\t\tKEY executed (executed),\n\t\t\t\tKEY created (created),\n\t\t\t\tKEY mailserver_id (mailserver_id)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for message queue
    $packagetable = $tableprefix . 'queue';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tembargo DATETIME NULL,\n            \tembargo_reason varchar(30) NULL, \n\t\t\t\texecuted DATETIME NULL,\n\t\t\t\tdomain_protect INT NULL,\n\t\t\t\tslave INT NULL,\n\t\t\t\tsource varchar(50) NULL,\n\t\t\t\tmailcategory varchar(20) NULL,\n\t\t\t\tpriority INT NULL,\n\t\t\t\tmailserver INT NULL,\n            \tsandbox varchar(1) NULL, \n            \tfrom_email varchar(100) NULL, \n\t\t\t\tfrom_name varchar(100) NULL,\n            \tsender_domain_id INT NULL,\n\t\t\t\tto_email varchar(100) NULL,\n\t\t\t\tto_name varchar(100) NULL,\n            \trecipient_id INT NULL,\n            \trecipient_domain varchar(100) NULL,\n            \tuser_id INT NULL,\n\t\t\t\tmail_subject varchar(100) NULL,\n\t\t\t\tmail_content TEXT NULL,\n\t\t\t\tmail_content_sent TEXT NULL,\n\t\t\t\theaders TEXT NULL,\n\t\t\t\tattachments TEXT NULL,\n\t\t\t\tmessage_id INT NULL,\n\t\t\t\terrors INT NOT NULL,\n\t\t\t\terror_date DATETIME NULL,\n            \terror_reason varchar(30) NULL, \n\t\t\t\terror_full TEXT NULL,\n\t\t\t\tretry INT NOT NULL,\n\t\t\t\texecutiontime INT NULL,\n\t\t\t\topened DATETIME NULL,\n            \topen_ip varchar(50) NULL, \n            \topen_ptr varchar(100) NULL, \n\t\t\t\tclicked DATETIME NULL,\n            \tclick_ip varchar(50) NULL, \n            \tclick_ptr varchar(100) NULL, \n\t\t\t\tunsubscribed INT NOT NULL,\n\t\t\t\tunsubscribe_date DATETIME NULL,\n\t\t\t\tcreated DATETIME NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY embargo (embargo),\n\t\t\t\tKEY mailcategory (mailcategory),\n\t\t\t\tKEY error_date (error_date),\n\t\t\t\tKEY slave (slave),\n\t\t\t\tKEY priority (priority),\n\t\t\t\tKEY user_id (user_id),\n\t\t\t\tKEY open_ptr (open_ptr),\n\t\t\t\tKEY click_ptr (click_ptr),\n\t\t\t\tKEY executed (executed),\n\t\t\t\tKEY opened (opened),\n\t\t\t\tKEY clicked (clicked),\n\t\t\t\tKEY errors (errors),\n\t\t\t\tKEY unsubscribed (unsubscribed),\n\t\t\t\tKEY unsubscribe_date (unsubscribe_date),\n\t\t\t\tKEY to_email (to_email)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // set autoincrement to 9 digits
    $query = "SELECT MAX(id) FROM " . $packagetable;
    $maxid = $wpdb->get_var( $query );
    
    if ( $maxid <= 99999999 ) {
        $query = "ALTER TABLE " . $packagetable . " AUTO_INCREMENT=" . RAND( 111111111, 900000000 );
        $wpdb->query( $query );
    }
    
    // Create table for bounced emails
    $packagetable = $tableprefix . 'queue_error';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n            \tqueue_id INT NULL,\n            \trecipient_id INT NULL,\n            \tmailserver INT NULL,\n\t\t\t\tsender_domain_id INT NULL,\n\t\t\t\trecipient_status varchar(6) NULL,\n\t\t\t\trecipient_email varchar(100) NULL,\n\t\t\t\tmail_date DATETIME NULL,\n\t\t\t\tmail_category varchar(5) NULL,\n\t\t\t\tmail_subject VARCHAR(100) NULL,\n\t\t\t\terror_date DATETIME NULL,\n            \terror_reason varchar(30) NULL, \n\t\t\t\terror_code varchar(30) NULL,\n\t\t\t\terror_type varchar(30) NULL,\n\t\t\t\terror_cat varchar(30) NULL,\n\t\t\t\terror_full TEXT NULL,\n\t\t\t\taction_taken varchar(100) NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY queue_id (queue_id),\n\t\t\t\tKEY recipient_id (recipient_id),\n\t\t\t\tKEY mailserver (mailserver),\n\t\t\t\tKEY sender_domain_id (sender_domain_id),\n\t\t\t\tKEY recipient_status (recipient_status),\n\t\t\t\tKEY recipient_email (recipient_email)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for recipients
    $packagetable = $tableprefix . 'recipient';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tstatus INT NOT NULL,\n            \tuser_id INT NULL,\n\t\t\t\trecipient_status varchar(6) NULL,\n\t\t\t\trecipient_email varchar(100) NULL,\n            \tdomain varchar(100) NULL, \n\t\t\t\tmails_sent INT NOT NULL,\n\t\t\t\tmails_error INT NOT NULL,\n\t\t\t\tmails_error_last DATETIME NULL,\n\t\t\t\tmails_opened INT NOT NULL,\n\t\t\t\tlast_opened DATETIME NULL,\n\t\t\t\tmails_clicked INT NOT NULL,\n\t\t\t\tlast_clicked DATETIME NULL,\n\t\t\t\topen_delay INT NULL,\n\t\t\t\tclick_delay INT NULL,\n\t\t\t\tbest_time_open INT NULL,\n\t\t\t\tbest_time_click INT NULL,\n\t\t\t\tembargo DATETIME NULL,\n\t\t\t\tembargo_reason varchar(30) NULL,\n\t\t\t\tunsubscribe_date DATETIME NULL,\n\t\t\t\tinactive_date DATETIME NULL,\n\t\t\t\tbounce_date DATETIME NULL,\n\t\t\t\tcreated DATETIME NULL,\n\t\t\t\tupdated DATETIME NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY unsubscribe_date (unsubscribe_date),\n\t\t\t\tKEY bounce_date (bounce_date),\n\t\t\t\tKEY embargo (embargo),\n\t\t\t\tKEY user_id (user_id),\n\t\t\t\tKEY recipient_status (recipient_status),\n\t\t\t\tKEY recipient_email (recipient_email)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for sender domain
    $packagetable = $tableprefix . 'sender_domain';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tstatus INT NOT NULL,\n            \tdomain varchar(100) NULL, \n            \tmailcategory varchar(5) NULL, \n\t\t\t\tdomain_status varchar(4) NULL,\n\t\t\t\tlast_checked DATETIME NULL,\n\t\t\t\tlast_check_result TEXT NULL,\n\t\t\t\tlast_error TEXT NULL,\n\t\t\t\tenvelope_address varchar(50) NULL,\n\t\t\t\tunsubscribe_address varchar(50) NULL,\n\t\t\t\tfrom_address varchar(50) NULL,\n\t\t\t\treplyto_address varchar(50) NULL,\n\t\t\t\tdmarc_address varchar(50) NULL,\n\t\t\t\tdmarc_policy varchar(20) NULL,\n\t\t\t\tdmarc_percent int(11) NULL,\n\t\t\t\tdmarc_aspf varchar(1) NULL,\n\t\t\t\tdmarc_adkim varchar(1) NULL,\n\t\t\t\tdmarc_record TEXT NULL,\t\t\t\t\n\t\t\t\tdmarc_recommendation TEXT NULL,\t\t\t\t\n\t\t\t\tbimi_logo_url varchar(254) NULL,\n\t\t\t\tbimi_certificate_url varchar(254) NULL,\n\t\t\t\tbimi_record TEXT NULL,\t\t\t\t\n\t\t\t\tbimi_recommendation TEXT NULL,\t\t\t\t\n\t\t\t\tdkim_policy TEXT NULL,\t\t\t\t\n\t\t\t\tdkim_policy_recommendation TEXT NULL,\t\t\t\t\n\t\t\t\tmx_record TEXT NULL,\t\t\t\t\n\t\t\t\tspf_record TEXT NULL,\t\t\t\t\n\t\t\t\tspf_recommendation TEXT NULL,\t\t\t\t\n\t\t\t\tspf_missing_ips TEXT NULL,\t\t\t\t\n\t\t\t\tmails_sent INT NOT NULL,\n\t\t\t\tmails_error INT NOT NULL,\n\t\t\t\tmails_opened INT NOT NULL,\n\t\t\t\tmails_unsubscribed INT NOT NULL,\n\t\t\t\tmails_clicked INT NOT NULL,\n\t\t\t\tmails_bounced INT(11) NOT NULL,\n\t\t\t\topen_delay INT NULL,\n\t\t\t\tclick_delay INT NULL,\n\t\t\t\tbest_time_open INT NULL,\n\t\t\t\tbest_time_click INT NULL,\n\t\t\t\tbest_dow INT NULL,\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY last_checked (last_checked),\n\t\t\t\tKEY domain_status (domain_status)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // insert main domain if empty
    $result = $wpdb->get_results( "SELECT * FROM " . $packagetable );
    
    if ( count( $result ) == 0 ) {
        $url = parse_url( esc_url_raw( home_url() ) );
        $domain = str_replace( "www.", "", strtolower( $url['host'] ) );
        $query = "INSERT INTO " . $packagetable . " \n\t                    SET status = 1,\n            \t\t\t    domain = '" . esc_sql( $domain ) . "', \n\t\t\t\t\t\t\tdomain_status = 'OK',\n\t\t\t\t\t\t\tenvelope_address = 'postoffice@" . $domain . "',\n\t\t\t\t\t\t\tunsubscribe_address = 'unsubscribe@" . $domain . "',\n\t\t\t\t\t\t\tfrom_address = 'info@" . $domain . "',\n\t\t\t\t\t\t\treplyto_address = 'reply@" . $domain . "',\n\t\t\t\t\t\t\tdmarc_address = 'dmarc@" . $domain . "',\n\t\t\t\t\t\t\tdmarc_policy = 'none',\n\t\t\t\t\t\t\tdmarc_percent = '0',\n\t\t\t\t\t\t\tdmarc_aspf = 'r',\n\t\t\t\t\t\t\tdmarc_adkim = 'r',\n\t\t\t\t\t\t\tcreated = NOW(),\n\t\t\t\t\t\t\tupdated = NOW()\n\t\t\t\t\t\t";
        $wpdb->query( $query );
    }
    
    // Create table for domain mailserver
    $packagetable = $tableprefix . 'sender_domain_mailserver';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tmailserver_id INT NOT NULL,\n\t\t\t\tdomain_id INT NOT NULL,\n\t\t\t\tstatus INT(11) NOT NULL,\n\t\t\t\tserver_status VARCHAR(5) NULL,\n\t\t\t\tlast_error TEXT NULL,\n\t\t\t\tspf INT(11) NOT NULL,\n\t\t\t\tdkim INT(11) NOT NULL,\n\t\t\t\tdkim_selector varchar(50) NULL,\n\t\t\t\tdkim_record TEXT NULL,\n\t\t\t\tdkim_recommendation TEXT NULL,\n\t\t\t\tdkim_public_key TEXT NULL,\n\t\t\t\tdkim_private_key TEXT NULL,\n\t\t\t\tmails_sent INT NOT NULL,\n\t\t\t\tmails_error INT NOT NULL,\n\t\t\t\tmails_opened INT NOT NULL,\n\t\t\t\tmails_unsubscribed INT NOT NULL,\n\t\t\t\tmails_clicked INT NOT NULL,\n\t\t\t\tmails_bounced INT(11) NOT NULL,\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY domain_id (domain_id),\n\t\t\t\tKEY mailserver_id (mailserver_id)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // insert main domain - SpeedMail if empty
    $result = $wpdb->get_results( "SELECT * FROM " . $packagetable );
    
    if ( count( $result ) == 0 ) {
        $domain = str_replace( "http://", "", str_replace( "https://", "", str_replace( "www.", "", home_url() ) ) );
        $query = "INSERT INTO " . $packagetable . " \n\t                    SET status = 1,\n            \t\t\t    domain_id = 1,\n\t\t\t\t\t\t\tmailserver_id = 0, \n\t\t\t\t\t\t\tdkim_selector = 'po',\n\t\t\t\t\t\t\tserver_status = 'OK'\n\t\t\t\t\t\t";
        $wpdb->query( $query );
    }
    
    // Create table for plugins mailcategory
    $packagetable = $tableprefix . 'plugin_mailcategory';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\tpluginname VARCHAR(100) NULL,\n\t\t\t\tpluginslug VARCHAR(100) NULL,\n\t\t\t\tfullpluginslug  VARCHAR(200) NULL,\n\t\t\t\tmailcategory VARCHAR(5) NULL,\n\t\t\t\tmailcatfull VARCHAR(20) NULL,\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY pluginslug (pluginslug)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for mailserver DNSBL
    $packagetable = $tableprefix . 'mailserver_dnsbl';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n            \tmailserver INT NULL, \n\t\t\t\tcheckdate DATETIME NULL,\n\t\t\t\tstartdate DATETIME NULL,\n\t\t\t\tenddate DATETIME NULL,\n\t\t\t\tdnsbl VARCHAR(100) NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY mailserver (mailserver),\n\t\t\t\tKEY dnsbl (dnsbl)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for dmarc_report
    $packagetable = $tableprefix . 'dmarc_report';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . "\n                (\n  \t\t\t\tid int(10) unsigned NOT NULL AUTO_INCREMENT,\n  \t\t\t\tdate_begin timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',\n  \t\t\t\tdate_end timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',\n  \t\t\t\torg varchar(255) NOT NULL,\n  \t\t\t\tserial varchar(255) NOT NULL,\n  \t\t\t\tsender_domain varchar(255) NOT NULL,\n\t\t\t\tsender_domain_id INT NULL,\n  \t\t\t\tadkim varchar(5) NULL,\n  \t\t\t\taspf varchar(5) NULL,\n  \t\t\t\tpolicy varchar(5) NULL,\n  \t\t\t\tsubdomain_policy varchar(5) NULL,\n  \t\t\t\tpercent varchar(5) NULL,\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n  \t\t\t\tPRIMARY KEY (id),\n  \t\t\t\tUNIQUE KEY sender_domain (sender_domain,org,serial),\n  \t\t\t\tKEY sender_domain_id (sender_domain_id)\t\t\t\t\n\t\t\t\t)\n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for dmarc_record
    $packagetable = $tableprefix . 'dmarc_record';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . "\n                (\n            \tid INT NOT NULL AUTO_INCREMENT, \n\t\t\t\treport_id int(10) unsigned NOT NULL,\n  \t\t\t\tmailserver_ip varchar(39) NOT NULL,\n  \t\t\t\tmailserver_ptr varchar(255) NULL,\n  \t\t\t\tmailserver_id int NULL,\n  \t\t\t\tmailcount int(10) unsigned NOT NULL,\n  \t\t\t\tdisposition enum('none','quarantine','reject'),\n  \t\t\t\treason varchar(255),\n  \t\t\t\tdkim_result enum('none','pass','fail','neutral','policy','temperror','permerror'),\n  \t\t\t\tspf_result enum('none','neutral','pass','fail','softfail','temperror','permerror'),\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n  \t\t\t\tPRIMARY KEY (id),\n  \t\t\t\tKEY serial (report_id,mailserver_ip)\t\t\t\t\n\t\t\t\t)\n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for dmarc_result
    $packagetable = $tableprefix . 'dmarc_result';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . "\n                (\n            \tid INT NOT NULL AUTO_INCREMENT, \n  \t\t\t\treport_id int(10) unsigned NOT NULL,\n  \t\t\t\tmailserver_ip varchar(39) NOT NULL,\n  \t\t\t\ttype enum('dkim','spf'),\n  \t\t\t\tseq int(10) unsigned NOT NULL,\n  \t\t\t\tdomain varchar(255),\n  \t\t\t\tresult enum('none','pass','fail','softfail','neutral','policy','temperror','permerror'),\n\t\t\t\tcreated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n\t\t\t\tupdated DATETIME NULL DEFAULT CURRENT_TIMESTAMP,\n  \t\t\t\tPRIMARY KEY (id),\n  \t\t\t\tKEY serial (report_id,mailserver_ip,type,seq)\n\t\t\t\t)\n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    // Create table for options
    $packagetable = $tableprefix . 'option';
    $cptn_po_db_tables[] = $packagetable;
    $sql = "CREATE TABLE " . $packagetable . " \n\t\t        (\n            \tid INT NOT NULL AUTO_INCREMENT, \n            \toption_name varchar(191) NOT NULL, \n            \toption_value longtext NOT NULL,\n            \tPRIMARY KEY  (id),\n\t\t\t\tKEY option_name (option_name)\n        \t\t) \n\t\t\t\tCHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n\t\t\t\t";
    dbDelta( $sql );
    update_option( 'cptn_po_db_tables', $cptn_po_db_tables );
    // all tables in array for UNINSTALL
    // *********************************************
    //                    OPTIONS
    // *********************************************
    if ( !cptn_exist_option( "cptn_po_opt_email_blocked" ) ) {
        update_option( "cptn_po_opt_email_blocked", "0" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_switch_general" ) ) {
        update_option( "cptn_po_opt_cockpit_switch_general", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_mailserver_off_errors" ) ) {
        update_option( "cptn_po_opt_mailserver_off_errors", "100" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_assistant_step" ) ) {
        update_option( "cptn_po_opt_assistant_step", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_assistant_status" ) ) {
        update_option( "cptn_po_opt_assistant_status", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_info_developer" ) ) {
        update_option( "cptn_po_opt_info_developer", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_admin_alerts" ) ) {
        update_option( "cptn_po_opt_admin_alerts", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_admin_alerts_to" ) ) {
        update_option( "cptn_po_opt_admin_alerts_to", esc_html( get_option( "admin_email" ) ) );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_switch_without" ) ) {
        update_option( "cptn_po_opt_cockpit_switch_without", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_switch_trans" ) ) {
        update_option( "cptn_po_opt_cockpit_switch_trans", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_switch_marke" ) ) {
        update_option( "cptn_po_opt_cockpit_switch_marke", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_switch_bulk" ) ) {
        update_option( "cptn_po_opt_cockpit_switch_bulk", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_switch_cold" ) ) {
        update_option( "cptn_po_opt_cockpit_switch_cold", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_date_from" ) ) {
        update_option( "cptn_po_opt_cockpit_date_from", date( "Y-m-d", strtotime( date( "Y-m-d" ) . " -1 month" ) ) );
    }
    if ( !cptn_exist_option( "cptn_po_opt_cockpit_date_to" ) ) {
        update_option( "cptn_po_opt_cockpit_date_to", date( "Y-m-d" ) );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_ok" ) ) {
        update_option( "cptn_po_opt_recipient_switch_ok", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_malf" ) ) {
        update_option( "cptn_po_opt_recipient_switch_malf", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_nomx" ) ) {
        update_option( "cptn_po_opt_recipient_switch_nomx", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_bounce" ) ) {
        update_option( "cptn_po_opt_recipient_switch_bounce", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_inactive" ) ) {
        update_option( "cptn_po_opt_recipient_switch_inactive", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_unsub" ) ) {
        update_option( "cptn_po_opt_recipient_switch_unsub", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_recipient_switch_block" ) ) {
        update_option( "cptn_po_opt_recipient_switch_block", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_outbox_switch_plan" ) ) {
        update_option( "cptn_po_opt_outbox_switch_plan", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_outbox_switch_sent" ) ) {
        update_option( "cptn_po_opt_outbox_switch_sent", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_outbox_switch_error" ) ) {
        update_option( "cptn_po_opt_outbox_switch_error", "1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_max_bounce" ) ) {
        update_option( "cptn_po_opt_max_bounce", "1.5" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_min_open" ) ) {
        update_option( "cptn_po_opt_min_open", "25.0" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_max_unsubscribe" ) ) {
        update_option( "cptn_po_opt_max_unsubscribe", "0.1" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_min_click" ) ) {
        update_option( "cptn_po_opt_min_click", "1.2" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_statistics_days" ) ) {
        update_option( "cptn_po_opt_statistics_days", "30" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_email_bcc" ) ) {
        update_option( "cptn_po_opt_email_bcc", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_purge_queue_days" ) ) {
        update_option( "cptn_po_opt_purge_queue_days", "180" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_affiliate_footer" ) ) {
        update_option( "cptn_po_opt_affiliate_footer", "0" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_affiliate_id" ) ) {
        update_option( "cptn_po_opt_affiliate_id", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_envelope_account_email" ) ) {
        update_option( "cptn_po_opt_envelope_account_email", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_envelope_account_name" ) ) {
        update_option( "cptn_po_opt_envelope_account_name", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_envelope_account_password" ) ) {
        update_option( "cptn_po_opt_envelope_account_password", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_envelope_account_server" ) ) {
        update_option( "cptn_po_opt_envelope_account_server", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_envelope_account_port" ) ) {
        update_option( "cptn_po_opt_envelope_account_port", "" );
    }
    if ( !cptn_exist_option( "cptn_po_opt_envelope_account_security" ) ) {
        update_option( "cptn_po_opt_envelope_account_security", "" );
    }
    if ( !cptn_exist_option( "cptn_po_scret_key" ) ) {
        update_option( "cptn_po_scret_key", wp_create_nonce( "cptn_po_scret_key" ) );
    }
    if ( !cptn_exist_option( "cptn_po_opt_delete_data_uninstall" ) ) {
        update_option( "cptn_po_opt_delete_data_uninstall", 0 );
    }
    if ( !cptn_exist_option( "cptn_po_opt_first_activation" ) ) {
        update_option( "cptn_po_opt_first_activation", date( "Y-m-d H:i:s" ) );
    }
    if ( !cptn_exist_option( "cptn_po_opt_first_version" ) ) {
        update_option( "cptn_po_opt_first_version", CPTNPOVERSION );
    }
    if ( !cptn_exist_option( "cptn_po_opt_delete_data_uninstall" ) ) {
        update_option( "cptn_po_opt_delete_data_uninstall", 0 );
    }
    if ( !cptn_exist_option( "cptn_po_opt_email_read_online_header" ) ) {
        update_option( "cptn_po_opt_email_read_online_header", 0 );
    }
    error_log( "Campation PostOffice data tables created / updated" );
}
