<?php

// ************* all includes have to be changed to CPTNPODIR *******************
// DO NOT REMOVE THIS IF, IT IS ESSENTIAL FOR THE `function_exists` CALL ABOVE TO PROPERLY WORK.

if ( !function_exists( 'cptn_po_fs' ) ) {
    // Create a helper function for easy SDK access.
    function cptn_po_fs()
    {
        global  $cptn_po_fs ;
        
        if ( !isset( $cptn_po_fs ) ) {
            // Include Freemius SDK.
            require_once CPTNPODIR . 'freemius/start.php';
            $cptn_po_fs = fs_dynamic_init( array(
                'id'              => '9582',
                'slug'            => 'campation-postoffice',
                'premium_slug'    => 'campation-postoffice-pro',
                'type'            => 'plugin',
                'public_key'      => 'pk_025e0ba0e864be59561342289e25e',
                'is_premium'      => false,
                'premium_suffix'  => '(Pro)',
                'has_addons'      => false,
                'has_paid_plans'  => true,
                'trial'           => array(
                'days'               => 14,
                'is_require_payment' => true,
            ),
                'has_affiliation' => 'all',
                'menu'            => array(
                'slug'       => 'campation-postoffice',
                'first-path' => 'admin.php?page=campation-postoffice-assistant',
                'contact'    => false,
                'support'    => false,
            ),
                'is_live'         => true,
            ) );
        }
        
        return $cptn_po_fs;
    }
    
    // Init Freemius and set the custom pricing JS path.
    cptn_po_fs()->add_filter( 'freemius_pricing_js_path', 'cptn_po_custom_pricing_js_path' );
    function cptn_po_custom_pricing_js_path( $default_pricing_js_path )
    {
        return CPTNPODIR . 'freemius-pricing/freemius-pricing.js';
    }
    
    cptn_po_fs()->add_filter( 'plugin_icon', 'cptn_po_fs_custom_icon' );
    function cptn_po_fs_custom_icon()
    {
        return CPTNPODIR . 'img/cptn-spinner.svg';
    }
    
    cptn_po_fs();
    do_action( 'cptn_po_fs_loaded' );
    // Signal that SDK was initiated.
}

// END FREEMIUS BLOCK