<?php

add_action( 'admin_footer', 'cptn_po_cockpit_js' );
function cptn_po_cockpit_js()
{
    ?>
   <script type="text/javascript">

   // START check every 30ms until jQuery is available
   (function() {
      var nTimer = setInterval(function() {
        if (window.jQuery) {
	  	   clearInterval(nTimer);

	    // jQuery is loaded
		jQuery(document).ready(function($) {

		   $('.loadingSpinnerContainer').show(); 

           jQuery.switcher('input[type=checkbox]');


		   // filter switches				
           $(document).on("click", '.cptn-po-cockpit-filter', function(event) {
			  $('.loadingSpinnerContainer').show();	  
			  if($(this).is(':checked'))
				 switchstate = 1;
		      else
				 switchstate = 0;
			  switchname = $(this).attr('data-switch');

			  if(switchname == 'general')
			     {
				 if(switchstate == 1)
				    $('#cptn-po-cockpit-general-container').css('background-color','rgba(0,0,0,0.03)').css('color','black');
				 else
				    $('#cptn-po-cockpit-general-container').css('background-color','#aa0000').css('color','white');
				 }
		      $.ajax({
		 		 method: 'POST',
		 		 cache: false,
				 headers: {'cache-control':'no-cache'},
		 		 context: this,
		 		 url: adminajaxurl,
		 		 data: {action:'cptn_po_cockpit_switch', name:switchname, value:switchstate},
         		 success: function(data) {
					cptn_po_cockpit_outbox_chart();
            		},
               	 complete: function() {},
   		       	 error: function(xhr, textStatus, errorThrown) {
     	            console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			    return false;
   			        }
                 });
			  }); 

		   // filter date				
           $('.cptn-po-cockpit-date').on("change", function(event) {
			  $('.loadingSpinnerContainer').show();	  
			  var datename = $(this).attr('data-date');
			  var datevalue = $(this).val();
		      $.ajax({
		 		 method: 'POST',
		 		 cache: false,
				 headers: {'cache-control':'no-cache'},
		 		 context: this,
		 		 url: adminajaxurl,
		 		 data: {action:'cptn_po_cockpit_date', name:datename, value:datevalue},
         		 success: function(data) {
					cptn_po_cockpit_outbox_chart();
            		},
               	 complete: function() {},
   		       	 error: function(xhr, textStatus, errorThrown) {
     	            console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			    return false;
   			        }
                 });
			  }); 


	  	   // create outbox chart
		   cptn_po_cockpit_outbox_chart();
		   function cptn_po_cockpit_outbox_chart()
		      {
			  if($('#cptn_po_cockpit_outbox').length)
			     {
		         $.ajax({
		 			method: 'POST',
		 			cache: false,
					headers: {'cache-control':'no-cache'},
		 			context: this,
		 			url: adminajaxurl,
		 			data: {action:'cptn_po_cockpit_outbox'},
					dataType: 'json'
					})
         			.done(function(data) {
				   	      var ctx = document.getElementById('cptn_po_cockpit_outbox').getContext('2d');
            		   	  var config = {
                		  	 data: {
                    	        datasets: data.datasets,
                    		    labels: data.labels
                			 	},
                             options:  {
                    	        responsive: true,
								maintainAspectRatio: false,
                    	  	 	title: {
                                   display: true,
                        	 	   text: data.title
                             	   },
    							scales: {
      							   y: {
        						      type: 'linear',
        							  display: true,
        							  position: 'left',
      								  }
                                   }
                                }
                             };
						  if(window.cptn_po_cockpit_outbox_chart)
						     window.cptn_po_cockpit_outbox_chart.destroy();	 
						  $('#cptn_po_cockpit_outbox').css('height','600px');
                          window.cptn_po_cockpit_outbox_chart = new Chart(ctx, config);
					   })
   		       		.fail(function(xhr, textStatus, errorThrown) {
     	          		   console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			 		   return false;
                    });
                 }
              };

	  	   // get general health 
		   $.ajax({
		 			method: 'POST',
		 			cache: false,
					headers: {'cache-control':'no-cache'},
		 			context: this,
		 			url: adminajaxurl,
		 			data: {action:'cptn_po_cockpit_system_health'}
					})
         			.done(function(data) {
					   $('#cptn_po_cockpit_system_health').html(data);
					   })
   		       		.fail(function(xhr, textStatus, errorThrown) {
     	          		   console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			 		   return false;
                    });
					

	  	   // get health of all sender domains
		   $.ajax({
		 			method: 'POST',
		 			cache: false,
					headers: {'cache-control':'no-cache'},
		 			context: this,
		 			url: adminajaxurl,
		 			data: {action:'cptn_po_cockpit_sender_health'}
					})
         			.done(function(data) {
					   $('#cptn_po_cockpit_sender_health').html(data);
					   })
   		       		.fail(function(xhr, textStatus, errorThrown) {
     	          		   console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			 		   return false;
                    });
					

	  	   // get last bounces
		   $.ajax({
		 			method: 'POST',
		 			cache: false,
					headers: {'cache-control':'no-cache'},
		 			context: this,
		 			url: adminajaxurl,
		 			data: {action:'cptn_po_cockpit_last_bounces'}
					})
         			.done(function(data) {
					   $('#cptn_po_cockpit_last_bounces').html(data);
					   })
   		       		.fail(function(xhr, textStatus, errorThrown) {
     	          		   console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			 		   return false;
                    });
					

	  	   // get last server errors
		   $.ajax({
		 			method: 'POST',
		 			cache: false,
					headers: {'cache-control':'no-cache'},
		 			context: this,
		 			url: adminajaxurl,
		 			data: {action:'cptn_po_cockpit_last_server_errors'}
					})
         			.done(function(data) {
					   $('#cptn_po_cockpit_last_server_errors').html(data);
					   })
   		       		.fail(function(xhr, textStatus, errorThrown) {
     	          		   console.log('ajax loading error... '+xhr+' '+textStatus+' '+errorThrown);
     			 		   return false;
                    });
					
<?php 
    ?>

			 
		   });   // End of document ready
         
	     }    // END check every 30ms until jQuery is available
      }, 30);
   })();

   </script>
<?php 
}
