<?php
add_action('admin_footer', 'cptn_po_datatables_js',0);
function cptn_po_datatables_js()
   {
?>
<script>
        var datatablehead_cptn_po_recipients   = [{mData:"action",title: "<?php echo esc_html__("Action","campation-postoffice"); ?>", sortable:false},
		                                         {mData:"id",title: "ID",name: "id",visible:true,sortable:true,className: "text-right"},
												 {mData:"recipient_email",title: "<?php echo esc_html__("Email","campation-postoffice"); ?>",name:"recipient_email",visible:true,sortable:true},
			                                     {mData:"recipient_status",name:"recipient_status",title: "<?php echo esc_html__("State","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d!='OK') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span> '+d; else return '&#10004;';}},
												 {mData:"embargo",name:"embargo", title: "<?php echo esc_html__("Embargo","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d=='') return d; else return cptn_date_format(d,'T');}},
			                                     {mData:"embargo_reason",name:"embargo_reason",title: "<?php echo esc_html__("Embargo reason","campation-postoffice"); ?>",visible:true,sortable:true},
		                                         {mData:"mails_sent",name: "mails_sent",title: "<?php echo esc_html__("Emails","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"mails_error",name: "mails_error",title: "<?php echo esc_html__("Errors","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-right"},
												 {mData:"mails_error_last",name:"mails_error_last", title: "<?php echo esc_html__("Last error","campation-postoffice"); ?>", visible:true,sortable:true,render:function(d) {if(d=='') return d; else return cptn_date_format(d,'D');},className: "text-right"},
		                                         {mData:"mails_opened",name: "mails_opened",title: "<i title='<?php echo esc_attr__("Opened emails","campation-postoffice"); ?>' class='far fa-envelope-open'></i>",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"open_delay",name: "open_delay",title: "<i class='far fa-envelope-open'></i><i title='<?php echo esc_attr__("Open delay","campation-postoffice"); ?>' class='fas fa-history'></i>",visible:true,sortable:true,className: "text-center"},
		                                         {mData:"mails_clicked",name: "mails_clicked",title: "<i title='<?php echo esc_attr__("Clicked emails","campation-postoffice"); ?>' class='fas fa-external-link-alt'></i>",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"click_delay",name: "click_delay",title: "<i class='fas fa-external-link-alt'></i><i title='<?php echo esc_attr__("Click delay","campation-postoffice"); ?>' class='fas fa-history'></i>",visible:true,sortable:true,className: "text-center"},
		                                         {mData:"best_time_open",name: "best_time_open",title: "<?php echo esc_attr__("Opens at","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center"},
		                                         {mData:"best_time_click",name: "best_time_click",title: "<?php echo esc_attr__("Clicks at","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center"},
												 {mData:"created",name:"created", title: "<i title='<?php echo esc_attr__("Subscribed","campation-postoffice"); ?>' class='fas fa-play'></i>",visible:true,sortable:true,render:function(d) {if(d=='') return d; else return cptn_date_format(d,'D');},className: "text-center"},
		                                         {mData:"unsubscribe_date",name: "unsubscribe_date",title: "<i title='<?php echo esc_attr__("Unsubscribed / bounced","campation-postoffice"); ?>' class='fas fa-power-off'></i>",visible:true,sortable:true,render:function(d) {if(d=='') return d; else return cptn_date_format(d,'D');},className: "text-center"}
												 ];
		
        var datatablehead_cptn_po_outbox       = [{mData:"action",title: "<?php echo esc_html__("Action","campation-postoffice"); ?>", sortable:false},
		                                         {mData:"id",title: "ID",name: "id",visible:true,sortable:true,className: "text-right"},
												 {mData:"mailcategory",title: "<?php echo esc_html__("Categ","campation-postoffice"); ?>",name:"mailcategory",visible:true,sortable:true, className: "text-center",render:function(d, type, row, meta) {if(row.source =='po domain test') return '&#9881;'; else return d;}},
		                                         {mData:"domain_protect",name: "domain_protect",title: "<span title='<?php echo esc_attr__("Email has been sent with Campation DomainProtect&trade;","campation-postoffice"); ?>'><i class='fas fa-umbrella'></i></span>",visible:true,sortable:true,className: "text-center",render:function(d) {if(d!=1) return ''; else return '&#10004;';}},
												 {mData:"executed",title: "<?php echo esc_html__("Executed","campation-postoffice"); ?>",name:"executed",visible:true,sortable:true,render:function(d) {if(d=='') return d; else return cptn_date_format(d,'T');}, className: "text-center"},
												 {mData:"embargo",title: "<?php echo esc_html__("Schedule","campation-postoffice"); ?>",name:"embargo",visible:true,sortable:true, className: "text-center"},
												 {mData:"errors",title: "<?php echo esc_html__("Errors","campation-postoffice"); ?>",name:"errors",visible:true,sortable:true,className: "text-center", render:function(d) {if(d==0) return ''; else if(d==9999) return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span> <?php echo cptn_po_abbreviations("bounce"); ?>'; else return d;}},
												 {mData:"embargo_reason",title: "<?php echo esc_html__("Reason","campation-postoffice"); ?>",name:"embargo_reason",visible:true,sortable:false,render:function(d, type, row, meta) {if(d) dd=d; else if(row.system_status !='OK') dd=row.system_status; else dd='';return cptn_dt_shorten(dd,20);}},
		                                         {mData:"system_status",name: "system_status",title: "<?php echo esc_html__("System","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center",render:function(d) {if(d!='OK') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';}},
		                                         {mData:"error_reason",name: "error_reason",title: "<?php echo esc_html__("Delivery","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center",render:function(d) {if(d=='') return d; else if(d=='WAIT') return '<img src="<?php echo esc_url_raw(CPTNPOPATH,wp_allowed_protocols()); ?>img/cptn-spinner.svg" width=20>'; else if(d=='OK') return '&#10004;'; else return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>';}},
			                                     {mData:"from_email",name:"from_email",title: "<?php echo esc_html__("Sender","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {return cptn_dt_shorten(d,15);}},
			                                     {mData:"to_email",name:"to_email",title: "<?php echo esc_html__("Recipient","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {return cptn_dt_shorten(d,15);}},
		                                         {mData:"mail_subject",name: "mail_subject",title: "<?php echo esc_html__("Subject","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {return cptn_dt_shorten(d,15);}},
		                                         {mData:"shortname",name: "shortname",title: "<?php echo esc_html__("Mail server","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center",render:function(data, type, row) {if(row.sandbox==1) return '<span style="color:#aa0000;" title="<?php echo esc_attr__("Email was not sent to recipient due to active sandbox","campation-postoffice"); ?>"><i class="fas fa-trash-alt"></i></span>'; else return data;}},
		                                         {mData:"unsubscribed",name: "unsubscribed",title: "<i title='<?php echo esc_attr__("Unsubscribed","campation-postoffice"); ?>' class='fas fa-power-off'></i>",visible:true,sortable:true,className: "text-center",render:function(d) {if(d==0) return ''; else return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>';}},
												 {mData:"opened",name:"opened", title: "<i title='<?php echo esc_attr__("Open delay","campation-postoffice"); ?>' class='far fa-envelope-open'></i>",visible:true,sortable:true,className: "text-center"},
												 {mData:"clicked",name:"clicked", title: "<i title='<?php echo esc_attr__("Click delay","campation-postoffice"); ?>' class='fas fa-external-link-alt'>",visible:true,sortable:true,className: "text-center"}
												 ];
												 
        var datatablehead_cptn_po_domains      = [{mData:"action",title: "<?php echo esc_html__("Action","campation-postoffice"); ?>", sortable:false},
		                                         {mData:"id",title: "ID",name: "id",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"domain",name:"domain",title: "<?php echo esc_html__("Domain","campation-postoffice"); ?>",visible:true,sortable:true},
			                                     {mData:"mailcategory",name:"mailcategory",title: "<?php echo esc_html__("Categ","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d) return d.toUpperCase(); else return '';}},
			                                     {mData:"count",name:"count",title: "<?php echo esc_html__("Servers","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center"},
			                                     {mData:"domain_status",name:"domain_status",title: "<i title='<?php echo esc_attr__("Health","campation-postoffice"); ?>' class='fas fa-heartbeat'></i>",visible:true,sortable:true,render:function(d) {if(d!='OK') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
			                                     {mData:"spf_record",name:"spf_status",title: "<?php echo esc_html__("SPF","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d=='') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
			                                     {mData:"dmarc_record",name:"dmarc_status",title: "<?php echo esc_html__("DMARC","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d=='') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
			                                     {mData:"dkim_policy",name:"dkim_status",title: "<?php echo esc_html__("DKIM","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d=='') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
												 {mData:"mails_sent",name:"mails_sent", title: "<i title='<?php echo esc_attr__("Sent","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-paper-plane'></i>",visible:true,sortable:true,className: "text-right"},
												 {mData:"mails_error",name:"mails_error", title: "<i title='<?php echo esc_attr__("Sending errors","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-exclamation-triangle'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"mails_bounced",name:"mails_bounced",title: "<i title='<?php echo esc_attr__("Bounced emails","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").") <".esc_html(get_option("cptn_po_opt_max_bounce"))."%"; ?>' class='fas fa-undo-alt'></i>",visible:true,sortable:true,className: "text-right"},
												 {mData:"mails_opened",name:"mails_opened", title: "<i title='<?php echo esc_attr__("Opened emails","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").") >".esc_html(get_option("cptn_po_opt_min_open"))."%"; ?>' class='far fa-envelope-open'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"open_delay",name:"open_delay",title: "<i class='far fa-envelope-open'></i><i title='<?php echo esc_attr__("Open delay","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-history'></i>",visible:true,sortable:true,className: "text-center"},
			                                     {mData:"mails_unsubscribed",name:"mails_unsubscribed",title: "<i title='<?php echo esc_attr__("Unsubscribed","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").") <".esc_html(get_option("cptn_po_opt_max_unsubscribe"))."%"; ?>' class='fas fa-power-off'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"mails_clicked",name:"mails_clicked",title: "<i title='<?php echo esc_attr__("Clicked emails","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").") >".esc_html(get_option("cptn_po_opt_min_click"))."%"; ?>' class='fas fa-external-link-alt'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"click_delay",name:"click_delay",title: "<i class='far fa-envelope-open'></i><i title='<?php echo esc_attr__("Click delay","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-history'></i>",visible:true,sortable:true,className: "text-center"},
		                                         {mData:"best_time_open",name: "best_time_open",title: "<?php echo esc_html__("Opens at","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"best_time_click",name: "best_time_click",title: "<?php echo esc_html__("Clicks at","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-right"}
												 ];
												 
        var datatablehead_cptn_po_mailservers  = [{mData:"action",title: "<?php echo esc_html__("Action","campation-postoffice"); ?>", sortable:false},
		                                         {mData:"id",title: "ID",name: "id",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"server_type",name:"server_type",title: "<?php echo esc_html__("Type","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d) return d.toUpperCase(); else return '';}},
			                                     {mData:"shortname",name:"shortname",title: "<?php echo esc_html__("Short name","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {return cptn_dt_shorten(d,27);}},
			                                     {mData:"address",name:"address",title: "<?php echo esc_html__("Address","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {return cptn_dt_shorten(d,20);}},
												 {mData:"processes",name:"processes", title: "<i title='<?php echo esc_attr__("Processes","campation-postoffice"); ?>' class='fas fa-microchip'></i>",visible:true,sortable:true,className: "text-right"},
												 {mData:"connectable",name:"connectable", title: "<i title='<?php echo esc_attr__("Connectable","campation-postoffice"); ?>' class='fas fa-link'></i>",visible:true,sortable:true,render:function(d) {if(d==0) return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
												 {mData:"rdns",name:"rdns", title: "<?php echo esc_attr__("rDNS","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d!='1') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
												 {mData:"dnsbl",name:"dnsbl", title: "<?php echo esc_attr__("DNSBL","campation-postoffice"); ?>",visible:true,sortable:true,className: "text-center"},
												 {mData:"senderscore",name:"senderscore", title: "<?php echo esc_attr__("SScore","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d=='0') return '&#63;'; else return d;},className: "text-center"},
												 {mData:"warmup",name:"warmup", title: "<i title='<?php echo esc_attr__("Warm-up remaining days","campation-postoffice"); ?>' class='fas fa-fire'></i>",visible:true,sortable:true,className: "text-center"},
		                                         {mData:"sent",title: "<i title='<?php echo esc_attr__("Sent","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-paper-plane'></i>",name: "sent",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"errors",title: "<i title='<?php echo esc_attr__("Sending errors","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-exclamation-triangle'></i>",name: "errors",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"bounced",title: "<i title='<?php echo esc_attr__("Bounced emails","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-undo-alt'></i>",name: "bounced",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"opened",title: "<i title='<?php echo esc_attr__("Opened emails","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='far fa-envelope-open'></i>",name: "opened",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"unsubscribed",name:"unsubscribed",title: "<i title='<?php echo esc_attr__("Unsubscribed","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-power-off'></i>",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"clicked",title: "<i title='<?php echo esc_attr__("Clicked emails","campation-postoffice")." (".esc_html(get_option("cptn_po_opt_statistics_days"))." ".esc_html__("days","campation-postoffice").")"; ?>' class='fas fa-external-link-alt'>",name: "clicked",visible:true,sortable:true,className: "text-right"},
		                                         {mData:"contingent",title: "<?php echo esc_html__("Contingent","campation-postoffice"); ?>",name: "contingent",visible:true, sortable:true,className: "text-right", render:function(d) {if(d>'0') return d; else return '';}},
		                                         {mData:"contingent_used",title: "<?php echo esc_html__("Used","campation-postoffice"); ?>",name: "contingent_used",visible:true,sortable:true,className: "text-center", render:function(data, type, row) {if(row.contingent>'0') return data; else return '';}}
												 ];
												 
        var datatablehead_cptn_po_domains_mailserver = [{mData:"action",title: "<?php echo esc_html__("Action","campation-postoffice"); ?>", sortable:false},
		                                         {mData:"id",title: "ID",name: "id",visible:true,sortable:true,className: "text-right"},
												 {mData:"mailserver_status",name:"mailserver_status", title: "<?php echo esc_html__("Status","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d!='1') return '<i class="fas fa-toggle-off"></i>'; else return '<i class="fas fa-toggle-on"></i>';},className: "text-center"},
			                                     {mData:"shortname",name:"shortname",title: "<?php echo esc_html__("Short name","campation-postoffice"); ?>",visible:true,sortable:true},
			                                     {mData:"address",name:"address",title: "<?php echo esc_html__("Mail server","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {return cptn_dt_shorten(d,20);}},
			                                     {mData:"server_status",name:"server_status",title: "<i title='<?php echo esc_attr__("Health","campation-postoffice"); ?>' class='fas fa-heartbeat'></i>",visible:true,sortable:true,render:function(d) {if(d!='OK') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
			                                     {mData:"spf",name:"spf",title: "<?php echo esc_html__("SPF","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d!='1') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
												 {mData:"dkim",name:"dkim", title: "<?php echo esc_html__("DKIM","campation-postoffice"); ?>",visible:true,sortable:true,render:function(d) {if(d!='1') return '<span style="color:#aa0000;font-weight:bold;">&#10007;</span>'; else return '&#10004;';},className: "text-center"},
												 {mData:"dkim_selector",name:"dkim_selector", title: "<?php echo esc_html__("DKIM selector","campation-postoffice"); ?>",visible:true,sortable:true},
												 {mData:"mails_sent",name:"mails_sent", title: "<i title='<?php echo esc_attr__("Sent","campation-postoffice"); ?>' class='fas fa-paper-plane'></i>",visible:true,sortable:true,className: "text-right"},
												 {mData:"mails_error",name:"mails_error", title: "<i title='<?php echo esc_attr__("Sending errors","campation-postoffice"); ?>' class='fas fa-exclamation-triangle'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"mails_bounced",name:"mails_bounced",title: "<i title='<?php echo esc_attr__("Bounced emails","campation-postoffice")." <".esc_html(get_option("cptn_po_opt_max_bounce"))."%"; ?>' class='fas fa-undo-alt'></i>",visible:true,sortable:true,className: "text-right"},
												 {mData:"mails_opened",name:"mails_opened", title: "<i title='<?php echo esc_attr__("Opened emails","campation-postoffice")." >".esc_html(get_option("cptn_po_opt_min_open"))."%"; ?>' class='far fa-envelope-open'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"mails_unsubscribed",name:"mails_unsubscribed",title: "<i title='<?php echo esc_attr__("Unsubscribed","campation-postoffice")." <".esc_html(get_option("cptn_po_opt_max_unsubscribe"))."%"; ?>' class='fas fa-power-off'></i>",visible:true,sortable:true,className: "text-right"},
			                                     {mData:"mails_clicked",name:"mails_clicked",title: "<i title='<?php echo esc_attr__("Clicked emails","campation-postoffice")." >".esc_html(get_option("cptn_po_opt_min_click"))."%"; ?>' class='fas fa-external-link-alt'></i>",visible:true,sortable:true,className: "text-right"},
												 ];
</script>   
<?php
   }
?>