<?php

// exit if accessed directly
if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( cptn_po_is_plugin_page( "assistant" ) ) {
    include_once "assets/includes/cptn-po-general-modal.php";
    include_once "assets/css/cptn-po-css.php";
    include_once "assets/js/cptn-po-general-js.php";
    include_once CPTNPODIR . "common/js/cptn-modal-js.php";
    include_once "assets/js/assistant-js.php";
}

function cptn_po_admin_assistant()
{
    global  $wpdb ;
    echo  '<div class="wrap">
   
   <div class="loadingSpinnerContainer"><img class="loadingSpinnerImage" src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/cptn-spinner.svg"></div>

   <h1 class="mt-2"><img height=40 src="' . esc_url_raw( CPTNPOPATH, wp_allowed_protocols() ) . 'img/h1-icon.png"> Campation PostOffice&trade; > ' . esc_html__( 'Setup wizard', "campation-postoffice" ) . '</h1>' ;
    ?>
   <p><?php 
    echo  esc_html__( 'Set up Campation PostOffice&trade;', "campation-postoffice" ) ;
    ?></p>

   <br>
         <div style="height:45px;text-align:center;">    <!-- progress bar -->
            <span id="cptn-po-assistant-progress-1" data-id="1" class="cptn-po-assistant-progress"><?php 
    echo  esc_html__( 'Welcome', "campation-postoffice" ) ;
    ?></span>
			<span id="cptn-po-assistant-progress-2" data-id="2" class="cptn-po-assistant-progress"><?php 
    echo  esc_html__( 'Server', "campation-postoffice" ) ;
    ?></span>
			<span id="cptn-po-assistant-progress-3" data-id="3" class="cptn-po-assistant-progress"><?php 
    echo  esc_html__( 'Domain & Email', "campation-postoffice" ) ;
    ?></span>
<?php 
    ?>			
			<span id="cptn-po-assistant-progress-6" data-id="6" class="cptn-po-assistant-progress"><?php 
    echo  esc_html__( 'SmartDNS&trade;', "campation-postoffice" ) ;
    ?></span>
			<span id="cptn-po-assistant-progress-7" data-id="7" class="cptn-po-assistant-progress"><?php 
    echo  esc_html__( 'Check', "campation-postoffice" ) ;
    ?></span>
			<span id="cptn-po-assistant-progress-8" data-id="8" class="cptn-po-assistant-progress"><?php 
    echo  esc_html__( 'End', "campation-postoffice" ) ;
    ?></span>   
		 </div>

	    <button style="position:fixed;bottom:25px;right:20px;width:120px;display:none;" type="button" class="btn btn-cptn-next cptn-po-assistant-next-button" title="<?php 
    echo  esc_attr__( 'Next step', "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( 'Next', "campation-postoffice" ) ) ;
    ?>&nbsp;&nbsp;<i class="fas fa-arrow-circle-right"></i></button>
		<button id="cptn-po-assistant-previous-button" style="position:fixed;bottom:25px;left:182px;width:120px;display:none;" type="button" class="btn btn-outline-secondary" title="<?php 
    echo  esc_attr__( 'Previous step', "campation-postoffice" ) . '"><i class="fas fa-arrow-circle-left"></i>&nbsp;&nbsp;' . htmlspecialchars_decode( esc_html__( 'Back', "campation-postoffice" ) ) ;
    ?></button>
		<button id="cptn-po-assistant-finish-button" style="position:fixed;bottom:25px;right:28px;width:120px;display:none;" type="button" class="btn btn-cptn-next" title="<?php 
    echo  esc_attr__( 'Finish the assistant', "campation-postoffice" ) . '">' . htmlspecialchars_decode( esc_html__( 'Finish', "campation-postoffice" ) ) ;
    ?>&nbsp;&nbsp;<i class="fas fa-arrow-circle-right"></i></button>

		<div class="cptn-po-assistant-orange-sign"></div>
		<div class="cptn-po-assistant-green-sign"></div>





		 <div class="container-fluid" id="cptn-po-assistant-container" style="border:1px solid #999;border-radius:10px;height:690px;overflow:auto;">    <!-- container -->


		    <!-- step 1 -->
			<div class="row mr-0 pt-2 pb-2" id="cptn-po-assistant-step-1" style="min-height:630px;padding:5px;display:none;">
			   <div class="col-12 col-md-9" style="padding:15px;">
			      <h1 style="background-color:#999;color:white;"><center><strong><?php 
    echo  htmlspecialchars_decode( esc_html__( 'The ALL-IN-ONE solution for high-end email - 10 x faster than SMTP!', "campation-postoffice" ) ) ;
    ?></strong></center></h1>
				  <br>
				  <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "As you probably know, WordPress contains only marginal functions for sending emails. Without an extension, many emails simply end up in the recipient's spam folder. <strong>What distinguishes</strong> Campation PostOffice&trade; from other widely used email plugins?", "campation-postoffice" ) ) ;
    ?></p>
				  <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Campation PostOffice&trade; has (in addition to the connection of SMTP servers) a proprietary <strong>sending technology</strong> (SpeedMail&trade;), which is <strong>10 times faster</strong> than SMTP and thanks to AsyncMail&trade; can also <strong>send in parallel</strong>! Your data will <strong>not be sent to external servers</strong>, and all <strong>costs for external SMTP service providers will not apply</strong>!", "campation-postoffice" ) ) ;
    ?></p>
				  <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "All emails from WordPress are <strong>stored in a queue and sent in the background</strong> - your website won't falter anymore! All <strong>recipient addresses are checked before use</strong> and permanently blocked in the event of errors. Thanks to our <strong>SmartDNS&trade;</strong> technology, you can configure your domain's DNS perfectly in no time at all - just like the big ones!", "campation-postoffice" ) ) ;
    ?></p>
				  <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "In addition, Campation PostOffice&trade; contains a wealth of other functions for the <strong>secure and professional delivery</strong> of emails from WordPress - be it to optimize the <strong>reputation of your sender domain</strong> or to increase the economic <strong>success of your emails</strong>!", "campation-postoffice" ) ) ;
    ?></p>


				  <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "The setup wizard first checks <strong>which servers can be used</strong> and then asks you to specify your <strong>email domain and some email addresses</strong>.", "campation-postoffice" ) ) ;
    ?></p>
				  <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "After that, the <strong>DNS of your domain</strong> will be checked if it is configured perfectly. This step is <strong>not necessary for Campation PostOffice&trade;</strong>, but in general to ensure that your emails <strong>do not end up in spam!</strong>", "campation-postoffice" ) ) ;
    ?></p>

			      <br>
			   	  <center><div id="cptn-po-assistant-start-button" style="cursor:pointer;display:inline-block;background-color:green;font-size:18px;text-align:center;padding:10px;font-weight:bold;color:white;border-radius:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Start the wizard", "campation-postoffice" ) ) ;
    ?></div></center>
				  <br><br>
			      <div class="form-check"><input class="form-check-input" type="checkbox" id="cptn_po_opt_info_developer" name="cptn_po_opt_info_developer" value="1"<?php 
    if ( intval( get_option( "cptn_po_opt_info_developer" ) ) == 1 ) {
        echo  ' checked=checked' ;
    }
    ?>><label class="form-check-label" for="cptn_po_opt_domain_protect"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Submit technical information and statistics to developers anonymously", "campation-postoffice" ) ) ;
    ?></label></span></div>
			      <div class="form-check"><input class="form-check-input" type="checkbox" id="cptn_po_opt_delete_data_uninstall" name="cptn_po_opt_delete_data_uninstall" value="1"<?php 
    if ( intval( get_option( "cptn_po_opt_delete_data_uninstall" ) ) == 1 ) {
        echo  ' checked=checked' ;
    }
    ?>><label class="form-check-label" for="cptn_po_opt_delete_data_uninstall"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Erase all data when uninstalling or upgrading this plugin", "campation-postoffice" ) ) ;
    ?></label></div>
               </div>
			   <div class="col-12 col-md-3">
	     		  <div class="cptn-sidebar-text">
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Please use the "Next" and "Back" buttons to navigate between the individual steps. Your entries are saved as soon as you switch to another step.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Please open the necessary external configurations (email accounts, DNS) in a new window and return here after you have completed the external steps.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'You can interrupt this wizard at any time and call it up again later in the menu; the wizard remembers your last step.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'In the penultimate step, all configurations made are checked so that you can be sure that everything is configured perfectly!', "campation-postoffice" ) ) ;
    ?></p>
				  </div>
               </div>
			</div>


		    <!-- step 2 -->
			<div class="row mr-0 pt-2 pb-2" id="cptn-po-assistant-step-2" style="min-height:630px;padding:5px;display:none;">
			   <div class="col-12 col-md-9" style="padding:15px;">

				  <p class="cptn-po-assistant-subtitle"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Is your server environment suitable for Campation PostOffice&trade;? If so, you don't need an SMTP server!", "campation-postoffice" ) ) ;
    ?></p>
	  		   	  <div class="border-top mb-3 mr-4"></div>
      	          <div class="cptn-admin-box-header"><?php 
    echo  htmlspecialchars_decode( esc_html__( "SpeedMail server", "campation-postoffice" ) ) ;
    ?></div>
      		   	  <div class="cptn-admin-box-dotted-border">
   	     	       	 <div class="col-12 col-md-12">

<?php 
    $check_mta = cptn_po_check_mta();
    $speedmail_ready = true;
    
    if ( $check_mta['mta'] == "OK" ) {
        $query = "SELECT ip, address, test_mail_success FROM " . $wpdb->prefix . "cptn_po_mailserver\n\t          WHERE server_type = 'spmail'\n\t\t   ";
        $address = $wpdb->get_row( $query, ARRAY_A );
        //   if(empty($address['ip']))
        $address['ip'] = CPTNPOIP;
        //   if(empty($address['address']))
        $address['address'] = cptn_po_check_rdns( $address['ip'] );
        $rdns = 0;
        if ( $address['address'] and $address['address'] != $address['ip'] ) {
            $rdns = 1;
        }
        $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                SET address = '" . esc_sql( $address['address'] ) . "',\n\t\t\t\t\tip = '" . esc_sql( $address['ip'] ) . "',\n\t\t\t\t\trdns = " . $rdns . " \n\t          WHERE server_type = 'spmail'\n\t\t   ";
        $wpdb->query( $query );
        // log errors
        
        if ( empty($address['ip']) ) {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\n\t  \t\t       SET mailserver = 0,\n\t\t\t\t   \t   error_date = NOW(),\n\t\t\t\t\t   error_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\n\t\t\t\t\t   error_full = '" . esc_html__( "IP unknown", "campation-postoffice" ) . "'\n\t\t\t\t\t   ";
            $wpdb->query( $query );
        }
        
        
        if ( $rdns == 0 ) {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\n\t  \t\t       SET mailserver = 0,\n\t\t\t\t   \t   error_date = NOW(),\n\t\t\t\t\t   error_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\n\t\t\t\t\t   error_full = '" . esc_html__( "no FQDN / rDNS for server", "campation-postoffice" ) . "'\n\t\t\t\t\t   ";
            $wpdb->query( $query );
        }
        
        // send test email via PHPMailer once a day
        $cptn_po_mail_check_result = array();
        $cptn_po_mail_check_result['result'] = "OK";
        
        if ( empty($address['test_mail_success']) or $address['test_mail_success'] < date( "Y-m-d" ) ) {
            global  $phpmailer ;
            // define the global variable
            
            if ( !$phpmailer instanceof PHPMailer ) {
                global  $wp_version ;
                
                if ( version_compare( $wp_version, '5.5', '<' ) ) {
                    require_once ABSPATH . WPINC . '/class-phpmailer.php';
                    require_once ABSPATH . WPINC . '/class-smtp.php';
                    $phpmailer = new PHPMailer( true );
                } else {
                    require_once ABSPATH . WPINC . '/PHPMailer/PHPMailer.php';
                    require_once ABSPATH . WPINC . '/PHPMailer/SMTP.php';
                    require_once ABSPATH . WPINC . '/PHPMailer/Exception.php';
                    $phpmailer = new PHPMailer\PHPMailer\PHPMailer();
                }
            
            }
            
            $phpmailer->clearAllRecipients();
            $phpmailer->clearAttachments();
            $phpmailer->clearCustomHeaders();
            $phpmailer->clearReplyTos();
            $phpmailer->CharSet = "UTF-8";
            $phpmailer->setFrom( get_bloginfo( 'admin_email' ), get_bloginfo( 'name' ) );
            $phpmailer->addAddress( 'support@campation.com' );
            $phpmailer->Subject = 'Test mail from assistant';
            $phpmailer->Body = 'just a test email from ' . get_home_url();
            try {
                
                if ( $phpmailer->send() ) {
                    $cptn_po_mail_check_result = array(
                        "result" => "OK",
                    );
                    $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                         SET test_mail_success = NOW() \n\t                   WHERE server_type = 'spmail'\n\t\t   \t\t \t   ";
                    $wpdb->query( $query );
                } else {
                    $cptn_po_mail_check_result = array(
                        "result"       => "error",
                        "error_reason" => htmlspecialchars_decode( esc_html__( "Server failure", "campation-postoffice" ) ),
                        "error_full"   => str_replace( "https://github.com/PHPMailer/PHPMailer/wiki/Troubleshooting", "", $phpmailer->ErrorInfo ),
                    );
                }
            
            } catch ( phpmailerException $e ) {
                $mail_error_data = compact(
                    'to',
                    'subject',
                    'message',
                    'headers',
                    'attachments'
                );
                $mail_error_data['phpmailer_exception_code'] = $e->getCode();
                $cptn_po_mail_check_result = array(
                    "result"       => "error",
                    "error_reason" => htmlspecialchars_decode( esc_html__( "Server failure", "campation-postoffice" ) ),
                    "error_full"   => $e->getMessage() . "\r\n" . $mail_error_data,
                );
            }
        }
        
        
        if ( $rdns == 1 and $cptn_po_mail_check_result['result'] == "OK" ) {
            echo  '<table width=100%><tr>
	  	                          <td valign="middle" align="center" width="10%"><span style="color:green;font-size:36px;font-weight:bold;">&#10004;</span></td>
								  <td>' . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade;, the proprietary sending technology of Campation PostOffice&trade;, <strong>is operational</strong> and there is <strong>no need for an SMTP server</strong>!", "campation-postoffice" ) ) . '!
								  <br><br>								  
								  ' . htmlspecialchars_decode( esc_html__( "However, please <strong>continue with the wizard to the last page</strong> ('End') and finally <strong>send a test e-mail</strong> from there - this is the only way to check whether problems with your server's firewall remained", "campation-postoffice" ) ) . '
								  
								  </td>
							 </tr>
						  </table>' ;
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                   SET connectable = 1,\n\t\t\t\t   \t   rdns = 1 \n\t             WHERE server_type = 'spmail'\n\t\t   \t\t \t";
            $wpdb->query( $query );
        } elseif ( $rdns == 0 and $cptn_po_mail_check_result['result'] == "OK" ) {
            $speedmail_ready = false;
            echo  '<table width=100%><tr><td valign="middle" align="center" width="10%"><span style="color:#aa0000;font-size:36px;font-weight:bold;">&#x3f;</span></td><td>
	           <div>
   				   ' . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade; is connectable but <strong><u>should not be used</u></strong>, all emails probably <strong><u>will end up in spam folders</u></strong>! Your WordPress server <strong>does not have a FQDN (fully qualified domain name) / rDNS entry (reverse DNS PTR)</strong> - please check with your server administrator! IP: ", "campation-postoffice" ) ) . esc_html( $address['ip'] ) . '. 
				   <br><br>
				   ' . htmlspecialchars_decode( esc_html__( "This is <strong>not an error of Campation PostOffice&trade;</strong> but a <strong>basic configuration problem of your WordPress hosting</strong>.", "campation-postoffice" ) ) . '				   
				   <br><br>
               	   ' . htmlspecialchars_decode( esc_html__( "That's <strong>really a pity but no tragedy</strong>! Nevertheless you can use and enjoy Campation PostOffice&trade; and its <strong>many useful features</strong> with <strong>any SMTP server</strong>!", "campation-postoffice" ) ) . '
               	   <button style="float:right;margin:2px;" data-bs-toggle="modal" data-bs-target="#cptn-po-smtp-modal" class="button button-primary">' . htmlspecialchars_decode( esc_html__( "Read more ...", "campation-postoffice" ) ) . '</button>
               </div>
			</td></tr></table>' ;
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                   SET connectable = 1,\n\t\t\t\t   \t   rdns = 0 \n\t             WHERE server_type = 'spmail'\n\t\t   \t\t ";
            $wpdb->query( $query );
        } else {
            // error on test mail send
            $speedmail_ready = false;
            echo  '<table width=100%><tr><td valign="middle" align="center" width="10%"><span style="color:#aa0000;font-size:24px;font-weight:bold;">&#10007;</span></td><td>
	           <div>
   				   ' . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade;-Server tried to <strong>send a test email</strong> but <strong>is not able to send emails</strong> in your WordPress environment.", "campation-postoffice" ) ) . '
				   <br><br>
				   ' . htmlspecialchars_decode( esc_html__( "Error message", "campation-postoffice" ) ) . ': 
				   <span style="background-color:#ccc;padding:3px;">
				   <strong>' . esc_html( $cptn_po_mail_check_result['error_reason'] ) . '</strong> <i>' . esc_html( $cptn_po_mail_check_result['error_full'] ) . '</i>
				   </span>
				   <br><br>
				   ' . htmlspecialchars_decode( esc_html__( "This is <strong>not an error of Campation PostOffice&trade;</strong> but a <strong>basic configuration problem of your WordPress hosting</strong>.", "campation-postoffice" ) ) . '				   
				   <br><br>
               	   ' . htmlspecialchars_decode( esc_html__( "That's <strong>really a pity but no tragedy</strong>! Nevertheless you can use and enjoy Campation PostOffice&trade; and its <strong>many useful features</strong> with <strong>any SMTP server</strong>!", "campation-postoffice" ) ) . '
               	   <button style="float:right;margin:2px;" data-bs-toggle="modal" data-bs-target="#cptn-po-smtp-modal" class="button button-primary">' . htmlspecialchars_decode( esc_html__( "Read more ...", "campation-postoffice" ) ) . '</button>
               </div>
			</td></tr></table>' ;
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                   SET test_mail_success = NULL,\n\t\t\t\t   \t   rdns = 1,\n\t\t\t\t       connectable = 0\n\t             WHERE server_type = 'spmail'\n\t\t   \t\t ";
            $wpdb->query( $query );
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\n\t\t           SET mailserver = 0,\n\t\t\t\t   \t   error_date = NOW(),\n\t\t\t\t\t   error_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\n\t\t\t\t\t   error_full = '" . esc_html__( "error on sending test email", "campation-postoffice" ) . "'\n\t\t\t\t\t   ";
            $wpdb->query( $query );
        }
    
    } elseif ( $check_mta['mta'] == "NOPORT" ) {
        $speedmail_ready = false;
        echo  '<table width=100%><tr>
	  	                   <td valign="middle" align="center" width="10%"><span style="color:#aa0000;font-size:24px;font-weight:bold;">&#10007;</span></td>
						   <td>' . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade; has passed all tests successfully, but obviously <strong>cannot connect to other mail servers</strong>. The cause is probably <strong>your server's firewall</strong>, which shields your WordPress from the outside world. Please check with your server administrator!", "campation-postoffice" ) ) . '
				   		      <br><br>
				   		   	  ' . htmlspecialchars_decode( esc_html__( "This is <strong>not an error of Campation PostOffice&trade;</strong> but a <strong>basic configuration problem of your WordPress hosting</strong>.", "campation-postoffice" ) ) . '				   
				   			  <br><br>
               	   			  ' . htmlspecialchars_decode( esc_html__( "That's <strong>really a pity but no tragedy</strong>! Nevertheless you can use and enjoy Campation PostOffice&trade; and its <strong>many useful features</strong> with <strong>any SMTP server</strong>!", "campation-postoffice" ) ) . '
               	   			  <button style="float:right;margin:2px;" data-bs-toggle="modal" data-bs-target="#cptn-po-smtp-modal" class="button button-primary">' . htmlspecialchars_decode( esc_html__( "Read more ...", "campation-postoffice" ) ) . '</button>
						   </td>
						</tr>
					 </table>' ;
        $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                SET connectable = 0,\n\t\t\t\t    test_mail_success = NULL \n\t          WHERE server_type = 'spmail'\n\t\t   ";
        $wpdb->query( $query );
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\n\t\t        SET mailserver = 0,\n\t\t\t\t   \terror_date = NOW(),\n\t\t\t\t\terror_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\n\t\t\t\t\terror_full = '" . esc_html__( "Firewall seems to block outgoing port 25", "campation-postoffice" ) . "'\n\t\t\t\t\t";
        $wpdb->query( $query );
    } elseif ( $check_mta['mta'] == "NOMAIL" ) {
        $speedmail_ready = false;
        echo  '<table width=100%><tr><td valign="middle" align="center" width="10%"><span style="color:#aa0000;font-size:24px;font-weight:bold;">&#10007;</span></td><td>
	           <div>
   				   ' . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade;-Server <u>cannot be used</u> in your WordPress environment - <strong>PHP function mail() is disabled</strong> - please check with your server administrator!", "campation-postoffice" ) ) . '
				   <br><br>
				   ' . htmlspecialchars_decode( esc_html__( "This is <strong>not an error of Campation PostOffice&trade;</strong> but a <strong>basic configuration problem of your WordPress hosting</strong>.", "campation-postoffice" ) ) . '				   
				   ' . htmlspecialchars_decode( esc_html__( "It happens that web hosts generally do not allow WordPress to send emails without an SMTP server.", "campation-postoffice" ) ) . '				   
				   <br><br>
               	   ' . htmlspecialchars_decode( esc_html__( "That's <strong>really a pity but no tragedy</strong>! Nevertheless you can use and enjoy Campation PostOffice&trade; and its <strong>many useful features</strong> with <strong>any SMTP server</strong>!", "campation-postoffice" ) ) . '
               	   <button style="float:right;margin:2px;" data-bs-toggle="modal" data-bs-target="#cptn-po-smtp-modal" class="button button-primary">' . htmlspecialchars_decode( esc_html__( "Read more ...", "campation-postoffice" ) ) . '</button>
               </div>
			</td></tr></table>' ;
        $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                SET connectable = 0,\n\t\t\t\t    test_mail_success = NULL \n\t       WHERE server_type = 'spmail'\n\t\t   ";
        $wpdb->query( $query );
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\n\t\t        SET mailserver = 0,\n\t\t\t\t   \terror_date = NOW(),\n\t\t\t\t\terror_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\n\t\t\t\t\terror_full = '" . esc_html__( "PHP function mail() disabled", "campation-postoffice" ) . "'\n\t\t\t\t\t";
        $wpdb->query( $query );
    } else {
        $speedmail_ready = false;
        echo  '<table width=100%><tr><td valign="middle" align="center" width="10%"><span style="color:#aa0000;font-size:24px;font-weight:bold;">&#10007;</span></td><td>
	           <div>
   				   ' . htmlspecialchars_decode( esc_html__( "Campation SpeedMail&trade;-Server <u>cannot be used</u> in your WordPress environment - <strong>no connection to MTA / sendmail</strong> - please check with your server administrator!", "campation-postoffice" ) ) . '
				   <br><br>
				   ' . htmlspecialchars_decode( esc_html__( "This is <strong>not an error of Campation PostOffice&trade;</strong> but a <strong>basic configuration problem of your WordPress hosting</strong>.", "campation-postoffice" ) ) . '				   
				   ' . htmlspecialchars_decode( esc_html__( "It happens that web hosts generally do not allow WordPress to send emails without an SMTP server.", "campation-postoffice" ) ) . '				   
				   <br><br>
               	   ' . htmlspecialchars_decode( esc_html__( "That's <strong>really a pity but no tragedy</strong>! Nevertheless you can use and enjoy Campation PostOffice&trade; and its <strong>many useful features</strong> with <strong>any SMTP server</strong>!", "campation-postoffice" ) ) . '
               	   <button style="float:right;margin:2px;" data-bs-toggle="modal" data-bs-target="#cptn-po-smtp-modal" class="button button-primary">' . htmlspecialchars_decode( esc_html__( "Read more ...", "campation-postoffice" ) ) . '</button>
               </div>
			</td></tr></table>' ;
        $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\n                SET connectable = 0,\n\t\t\t\t    test_mail_success = NULL \n\t       WHERE server_type = 'spmail'\n\t\t   ";
        $wpdb->query( $query );
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\n\t\t        SET mailserver = 0,\n\t\t\t\t   \terror_date = NOW(),\n\t\t\t\t\terror_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\n\t\t\t\t\terror_full = '" . esc_html__( "no connection to MTA / sendmail", "campation-postoffice" ) . "'\n\t\t\t\t\t";
        $wpdb->query( $query );
    }
    
    update_option( "cptn_po_check_mta", $check_mta );
    update_option( "cptn_po_mail_check_result", $cptn_po_mail_check_result );
    update_option( "cptn_po_speedmail_ready", $speedmail_ready );
    ?>
                     </div>
			      </div>	




<?php 
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver\n\t       WHERE server_type = 'smtp'\n\t\t   ORDER BY id ASC\n\t\t   LIMIT 1\n\t\t   ";
    $mailserver = $wpdb->get_row( $query, ARRAY_A );
    
    if ( !$mailserver ) {
        $mailserver = array();
        $mailserver['id'] = 9999;
        $mailserver['status'] = 0;
        $mailserver['server_type'] = "smtp";
        $mailserver['processes'] = "1";
        $mailserver['shortname'] = "";
        $mailserver['address'] = "";
        $mailserver['port'] = "";
        $mailserver['ip'] = "";
        $mailserver['encryption'] = "";
        $mailserver['account'] = "";
        $mailserver['password'] = "";
        $mailserver['contingent'] = 0;
        $mailserver['contingent_period'] = "";
        $mailserver['contingent_exceed'] = 0;
        $mailserver['connectable'] = 0;
    }
    
    if ( !$speedmail_ready ) {
        $mailserver['status'] = 1;
    }
    ?>

      		      <form id="cptn_po_assistant_mailserver_form">
	     		     <input type="hidden" name="ms_id" id="ms_id" value="<?php 
    echo  esc_attr( $mailserver['id'] ) ;
    ?>">
	     			 <input type="hidden" name="ms_server_type" id="ms_server_type" value="smtp">
	     			 <input type="hidden" name="ms_processes" id="ms_processes" value="1">
				     <input type="hidden" name="ms_connectable" id="ms_connectable" value="<?php 
    echo  intval( $mailserver['connectable'] ) ;
    ?>">
		 			 <input type="hidden" name="action" value="cptn_po_assistant_mailserver_save">
      	       		 <div class="cptn-admin-box-header"><?php 
    echo  htmlspecialchars_decode( esc_html__( "SMTP server", "campation-postoffice" ) ) ;
    ?></div>
      		   		 <div class="cptn-admin-box-dotted-border">
   	     	         	<div class="col-12 col-md-12">
		                   <div class="form-check">
						      <input class="form-check-input" type="checkbox" name="ms_status" id="ms_status" value="1"<?php 
    if ( intval( $mailserver['status'] ) == 1 ) {
        echo  ' checked=checked' ;
    }
    ?>>
							  <label class="form-check-label" for="ms_status">
						   	  <?php 
    
    if ( $speedmail_ready ) {
        echo  htmlspecialchars_decode( esc_html__( "Use SMTP server (<i>optional</i>)", "campation-postoffice" ) ) ;
    } else {
        echo  htmlspecialchars_decode( esc_html__( "Use SMTP server (<strong>mandatory as long as SpeedMail does not work</strong>)", "campation-postoffice" ) ) ;
    }
    
    ?>
								 </label>
						   </div>
					 	   <br>
            	           <div id="cptn_po_assistant_mailserver_form_container" class="table-responsive-sm mr-4">
	     			 	      <table width=80% align=center>
		    		    	     <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Server type", "campation-postoffice" ) ) ;
    ?></td><td width=50%><strong>SMTP</strong></td><td width=25%>&nbsp;</td></tr>
      							 <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Short name", "campation-postoffice" ) ) ;
    ?></td><td width=50%><input type="text" class="form-control form-control-sm" name="ms_shortname" id="ms_shortname" placeholder="<?php 
    echo  htmlspecialchars_decode( esc_html__( "My mail server", "campation-postoffice" ) ) ;
    ?>" value="<?php 
    echo  esc_attr( $mailserver['shortname'] ) ;
    ?>"></td><td width=25%>&nbsp;</td></tr>
		    					 <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Address", "campation-postoffice" ) ) ;
    ?></td><td width=50%><input type="text" class="form-control form-control-sm" name="ms_address" id="ms_address" placeholder="mail.domain.com" value="<?php 
    echo  esc_attr( $mailserver['address'] ) ;
    ?>"></td><td width=25%>&nbsp;</td></tr>
		    					 <tr><td width=25%>IP <?php 
    echo  htmlspecialchars_decode( esc_html__( "(optional)", "campation-postoffice" ) ) ;
    ?></td><td width=50%><input type="text" class="form-control form-control-sm" name="ms_ip" id="ms_ip" placeholder="111.111.111.111 <?php 
    echo  htmlspecialchars_decode( esc_html__( "(optional)", "campation-postoffice" ) ) ;
    ?>" value="<?php 
    echo  esc_attr( $mailserver['ip'] ) ;
    ?>"></td><td width=25%>&nbsp;</td></tr>
		    					 <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Account", "campation-postoffice" ) ) ;
    ?></td><td width=50%><input type="text" class="form-control form-control-sm" name="ms_account" id="ms_account" placeholder="email@domain.com" value="<?php 
    echo  esc_attr( $mailserver['account'] ) ;
    ?>"></td><td width=25%>&nbsp;</td></tr>
		    					 <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Password", "campation-postoffice" ) ) ;
    ?></td><td width=50%><input type="password" class="form-control form-control-sm" name="ms_password" id="ms_password" placeholder="" value="<?php 
    echo  esc_attr( $mailserver['password'] ) ;
    ?>" onmouseover="this.type='text'" onmouseout="this.type='password'"></td><td width=25%>&nbsp;</td></tr>
		    					 <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Port", "campation-postoffice" ) ) ;
    ?> 
								 <small><strong>
<?php 
    
    if ( $check_mta['smtp'] ) {
        echo  '<span style="color:green;">25 &#10004;</span>' ;
    } else {
        echo  '<span style="color:#aa0000;text-decoration: line-through;">25</span>' ;
    }
    
    echo  " | " ;
    
    if ( $check_mta['ssl'] ) {
        echo  '<span style="color:green;">465(SSL) &#10004;</span>' ;
    } else {
        echo  '<span style="color:#aa0000;text-decoration: line-through;">465(SSL)</span>' ;
    }
    
    echo  " | " ;
    
    if ( $check_mta['tls'] ) {
        echo  '<span style="color:green;">587(TLS) &#10004;</span>' ;
    } else {
        echo  '<span style="color:#aa0000;text-decoration: line-through;">587(TLS)</span>' ;
    }
    
    ?>
								 </strong></small>
								 </td><td width=50%><input type="text" class="form-control form-control-sm" name="ms_port" id="ms_port" placeholder="465" value="<?php 
    echo  esc_attr( $mailserver['port'] ) ;
    ?>"></td><td width=25%>&nbsp;</td></tr>
		    					 <tr><td width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Security", "campation-postoffice" ) ) ;
    ?></td><td width=50%><select class="form-control form-control-sm" name="ms_encryption" id="ms_encryption" data-selected="<?php 
    echo  esc_attr( $mailserver['encryption'] ) ;
    ?>"><option value=""><?php 
    echo  htmlspecialchars_decode( esc_html__( "Without", "campation-postoffice" ) ) ;
    ?></option><option value="ssl"><?php 
    echo  htmlspecialchars_decode( esc_html__( "SSL", "campation-postoffice" ) ) ;
    ?></option><option value="tls"><?php 
    echo  htmlspecialchars_decode( esc_html__( "TLS", "campation-postoffice" ) ) ;
    ?></option></select></td><td width=25%>&nbsp;</td></tr>
<?php 
    $mysql_timezone = $wpdb->get_var( "SELECT @@system_time_zone;" );
    ?>
			                     <tr class="cptn-po-mailserver-smtp"><td width=25%>&nbsp;</td><td align=center><button type="button" class="button button-primary" id="cptn-po-test-smtpserver" data-id="'.esc_attr($row['id']).'"><?php 
    echo  htmlspecialchars_decode( esc_html__( "TEST", "campation-postoffice" ) ) ;
    ?></button></td><td width="25%" style="text-align:center;"><span style="font-size:12px;margin:5px;" id="cptn-po-test-smtpserver-result"></span></td></tr>
                    		  </table>
		                   </div> 
	                    </div> 
                     </div>

      	       		 <div class="cptn-admin-box-header"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Time zones", "campation-postoffice" ) ) ;
    ?></div>
      		   		 <div class="cptn-admin-box-dotted-border">
   	     	         	<div class="col-12 col-md-12">
						   <table width=80% align=center>
						      <tr>
							     <td>
			      				    <label class="col-form-label-sm mb-0" for="cptn_opt_timezone_server"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Time zone of server', "campation-postoffice" ) ) ;
    ?> (<?php 
    echo  htmlspecialchars_decode( esc_html__( 'found on server', "campation-postoffice" ) ) . ": <strong>" . $mysql_timezone ;
    ?></strong>) <a href="https://en.wikipedia.org/wiki/Wikipedia:WikiProject_Time/Time_zone_table" target="_blank"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Time zone list', "campation-postoffice" ) ) ;
    ?></a></label>
				  					<div>
				     				   <select class="form-control form-control-sm" name="cptn_opt_timezone_server" id="cptn_opt_timezone_server">
					    			      <?php 
    echo  wp_timezone_choice( esc_html( get_option( "cptn_opt_timezone_server" ) ) ) ;
    ?>
					                   </select>
				                    </div>
				                 </td>
				  				 <td>
			      				    <label class="col-form-label-sm mb-0" for="cptn_opt_timezone_staff"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Time zone of website', "campation-postoffice" ) ) ;
    ?></label>
				  				    <div>
				     			       <select class="form-control form-control-sm" name="cptn_opt_timezone_staff" id="cptn_opt_timezone_staff">
					    			      <?php 
    echo  wp_timezone_choice( esc_html( get_option( "cptn_opt_timezone_staff" ) ) ) ;
    ?>
					                   </select>
				                    </div>
                                 </td>
                              </tr>
						   </table>
						</div>
				     </div>		
                  </form>	
			   	  <center><div class="cptn-po-assistant-next-button" style="cursor:pointer;display:inline-block;background-color:green;font-size:18px;text-align:center;padding:10px;font-weight:bold;color:white;border-radius:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Next", "campation-postoffice" ) ) ;
    ?>&nbsp;&nbsp;<i class="fas fa-arrow-circle-right"></i></div></center>
				  <br><br>
               </div>
			   <div class="col-12 col-md-3">
	     		  <div class="cptn-sidebar-text">
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Campation PostOffice&trade; has its own internal sending technology called <strong>Campation SpeedMail&trade;</strong> which is <strong>10 times faster</strong> than SMTP and active by default.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'In addition, the <strong>PRO license</strong> can connect to the add-on plugin <strong>Campation RemoteMail&trade;</strong>. It allows you to install this technology on other remote servers and to set up a farm of mail servers that are operated by Campation PostOffice&trade; main plugin.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'The <strong>amount of emails sent via SpeedMail is unlimited and free of charge</strong>.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Campation PostOffice&trade; can send emails (via SpeedMail as well as SMTP) <strong>with parallel processing</strong> in the background - <strong>1,000 and more emails <u>per second</u></strong> easily can be sent! The number of possible parallel processes only depends on your license type and server hardware. The free license allows 1 process.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( '<strong>External SMTP servers</strong>, which can often result in considerable costs, are <strong>not necessary</strong> for Campation PostOffice&trade;. However, on this page you can configure a first SMTP server that will only be used if Campation SpeedMail&trade; has either been disabled or is busy. You can add additional SMTP servers in the "Mail server" menu item, provided your license type allows this.', "campation-postoffice" ) ) ;
    ?> <?php 
    if ( cptn_po_fs()->is_plan( 'starter' ) ) {
        echo  htmlspecialchars_decode( esc_html__( 'The definition of a <strong>contingent</strong> (e.g. free packages) limits the use of the SMTP server to a maximum of this number of emails.', "campation-postoffice" ) ) ;
    }
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'However, an external SMTP server is not necessary, so you can <strong><u>skip this step</u></strong>!', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Please check whether the <strong>time zones of your server and website</strong> have been determined correctly and change them if necessary. They are required for the correct timing of processes.', "campation-postoffice" ) ) ;
    ?></p>
				  </div>	 
               </div>

			</div>


		    <!-- step 3 -->
			<div class="row mr-0 pt-2 pb-2" id="cptn-po-assistant-step-3" style="min-height:630px;padding:5px;display:none;">
			   <div class="col-12 col-md-9" style="padding:15px;">
				  <p class="cptn-po-assistant-subtitle""><?php 
    echo  htmlspecialchars_decode( esc_html__( "For sending emails, Campation PostOffice&trade; needs some information about your domain and email.", "campation-postoffice" ) ) ;
    ?></p>
	  		   	  <div class="border-top mb-3 mr-4"></div>
<?php 
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain\n\t       WHERE id = 1";
    $domaindata = $wpdb->get_row( $query, ARRAY_A );
    ?>
			      <form id="cptn_po_assistant_domain_form">
   				     <input type="hidden" name="id" value="1">
   					 <input type="hidden" name="action" value="cptn_po_assistant_domain_save" />
      	             <div class="cptn-admin-box-header">
         	            <?php 
    echo  htmlspecialchars_decode( esc_html__( "Email sender domain", "campation-postoffice" ) ) ;
    ?>
                     </div>		 
      		   	  	 <div class="cptn-admin-box-dotted-border">
	     	            <table width=100%>
		                   <tr><td valign=middle width=25% style="font-size:12px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Email sender domain", "campation-postoffice" ) ) ;
    ?></td><td width=40%><input type="text" class="form-control form-control-sm" name="cptn_sender_domain" id="cptn_sender_domain" value="<?php 
    echo  esc_attr( $domaindata['domain'] ) ;
    ?>" placeholder="domain.com" required></td><td width=35%>&nbsp;</td></tr>
		                </table>
                     </div>
					 <br>

      	             <div class="cptn-admin-box-header">
         	            <?php 
    echo  htmlspecialchars_decode( esc_html__( "Default sender", "campation-postoffice" ) ) ;
    ?>
                     </div>		 
      		   	  	 <div class="cptn-admin-box-dotted-border">
	     	            <table width=100%>
		                   <tr><td valign=middle width=25% style="font-size:12px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Default sender name", "campation-postoffice" ) ) ;
    ?></td><td width=40%><input type="text" class="form-control form-control-sm" name="cptn_opt_email_sendername" id="cptn_opt_email_sendername" value="<?php 
    echo  esc_attr( get_option( "cptn_opt_email_sendername" ) ) ;
    ?>" placeholder="John Doe" required></td><td width=35%>&nbsp;</td></tr>
		                   <tr><td valign=middle width=25% style="font-size:12px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Default sender email", "campation-postoffice" ) ) ;
    ?></td><td width=40%><input type="email" class="form-control form-control-sm" name="cptn_opt_email_sender" id="cptn_opt_email_sender" value="<?php 
    echo  esc_attr( get_option( "cptn_opt_email_sender" ) ) ;
    ?>" placeholder="info@domain.com" required></td><td width=35% align="center"><span style="font-size:12px;font-weight:bold;color:#aa0000;" id="cptn_opt_email_sender_error"></span></td></tr>
		                </table>
                     </div>
					 <br>
<?php 
    ?>			

					 
      	       		 <div class="cptn-admin-box-header"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Email addresses of sender domain", "campation-postoffice" ) ) ;
    ?></div>		 
      		   	  	 <div class="cptn-admin-box-dotted-border">
	     	            <table width=100%>
	                       <tr><td valign=middle width=25% style="font-size:12px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Envelope", "campation-postoffice" ) ) ;
    ?></td><td width=40%><input type="email" class="form-control form-control-sm cptn-po-email-address" name="envelope_address" id="envelope_address" placeholder="postoffice@<?php 
    echo  esc_attr( $domaindata['domain'] ) ;
    ?>" value="<?php 
    echo  esc_attr( $domaindata['envelope_address'] ) ;
    ?>" required></td><td width=35% style="font-size:12px;"><span class="cptn_po_only_pro"><span class="material-icons">arrow_forward</span> <span class="envelope-imap-account"></span> (<?php 
    echo  htmlspecialchars_decode( esc_html__( "Envelope IMAP account", "campation-postoffice" ) ) ;
    ?>)</span></td></tr>
<?php 
    ?>			
		                   <tr><td valign=middle width=25% style="font-size:12px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "From", "campation-postoffice" ) ) ;
    ?></td><td width=40%><input type="email" class="form-control form-control-sm cptn-po-email-address" name="from_address" id="from_address" placeholder="info@<?php 
    echo  esc_attr( $domaindata['domain'] ) ;
    ?>" value="<?php 
    echo  esc_attr( $domaindata['from_address'] ) ;
    ?>" required></td><td width=35% style="font-size:12px;"><span class="cptn_po_only_pro"><span class="material-icons">arrow_forward</span> <?php 
    echo  htmlspecialchars_decode( esc_html__( "Business IMAP account", "campation-postoffice" ) ) ;
    ?></span></td></tr>
		                   <tr><td valign=middle width=25% style="font-size:12px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Reply-To", "campation-postoffice" ) ) ;
    ?></td><td width=40%><input type="email" class="form-control form-control-sm cptn-po-email-address" name="replyto_address" id="replyto_address" placeholder="reply@<?php 
    echo  esc_attr( $domaindata['domain'] ) ;
    ?>" value="<?php 
    echo  esc_attr( $domaindata['replyto_address'] ) ;
    ?>" required></td><td width=35% style="font-size:12px;"><span class="cptn_po_only_pro"><span class="material-icons">arrow_forward</span> <?php 
    echo  htmlspecialchars_decode( esc_html__( "Business IMAP account", "campation-postoffice" ) ) ;
    ?></span></td></tr>
		                </table>
                     </div>
                  </form>

			      <br>
			   	  <center><div class="cptn-po-assistant-next-button" style="cursor:pointer;display:inline-block;background-color:green;font-size:18px;text-align:center;padding:10px;font-weight:bold;color:white;border-radius:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Next", "campation-postoffice" ) ) ;
    ?>&nbsp;&nbsp;<i class="fas fa-arrow-circle-right"></i></div></center>
				  <br><br>
				  
			   </div>   
			   <div class="col-12 col-md-3">
	     		  <div class="cptn-sidebar-text">
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Campation PostOffice&trade; requires your <strong>main sender domain</strong> for emails (domain of your website, never the domain of an email service like GMail, Yahoo etc.).', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'The <strong>default sender</strong> is used when WordPress does not receive any other information from a plugin and would normally use the name of the website and the email address of the administrator. The default sender email address MUST be in the sender domain.', "campation-postoffice" ) . " " . esc_html__( 'The default sender normally is not used but replaced by the below edited email addresses of the domain.', "campation-postoffice" ) ) ;
    ?></p>
<?php 
    ?>			
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'In addition, <strong>several email addresses</strong> are required for various purposes, which you can name as you like, but must be <strong>in the sender domain</strong> (not @gmail, @ yahoom.com!).', "campation-postoffice" ) ) ;
    ?></p>
				  	 <ul class="cptn-ul" style="font-size:12px;margin-top:-30px;">
				        <li><?php 
    echo  htmlspecialchars_decode( esc_html__( '<strong>Envelope</strong>: technical sender address, it is not visible to the recipient and receives all bounced email', "campation-postoffice" ) ) ;
    ?></li>
<?php 
    ?>			
                     </ul>
				  	 <p style="margin-top:-30px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'If no from / reply-to addresses are specified by the sending plugin the following default addresses will be used for this domain', "campation-postoffice" ) ) ;
    ?>:</p>
				  	 <ul class="cptn-ul" style="font-size:12px;margin-top:-30px;">
				  	 	<li><?php 
    echo  htmlspecialchars_decode( esc_html__( '<strong>From</strong>: the sender address visible to the recipient', "campation-postoffice" ) ) ;
    ?></li>
				  	 	<li><?php 
    echo  htmlspecialchars_decode( esc_html__( '<strong>Reply to</strong>: the reply address visible to the recipient', "campation-postoffice" ) ) ;
    ?></li>
                     </ul>
				  	 <p style="margin-top:-30px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( '<strong><u>Important</u></strong>: If the from / reply-to addresses are set by the sending plugin those addresses have to be in the sender domain and be directed to the business IMAP account!', "campation-postoffice" ) ) ;
    ?></p>
				  </div>
               </div>
			</div>




<?php 
    ?>			
		    <!-- step 6 -->
			<div class="row mr-0 pt-2 pb-2" id="cptn-po-assistant-step-6" style="min-height:630px;padding:5px;display:none;">
			   <div class="col-12 col-md-9" style="padding:15px;">
				  <p class="cptn-po-assistant-subtitle">
				     <?php 
    echo  htmlspecialchars_decode( esc_html__( "The correct and complete configuration of your DNS is crucial to ensure that your emails do not end up in the spam folder.", "campation-postoffice" ) ) ;
    ?> 
				  	 <?php 
    echo  htmlspecialchars_decode( esc_html__( "This is a basic requirement <strong>for your domain</strong> (not for Campation PostOffice&trade;), it's independant of the email client or plugin you are using. See it as our service to check and help you with the correct and optimal DNS settings for your domain so that your emails <strong>arrive in inboxes and not spam folders</strong>!", "campation-postoffice" ) ) ;
    ?>
				     <br><br>
				  	 <?php 
    echo  htmlspecialchars_decode( esc_html__( "If this page shows errors and you are inexperienced in setting DNS values, contact your administrator or search for \"<strong>DNS settings [name of your domain provider]</strong>\"!", "campation-postoffice" ) ) ;
    ?>
					 
				  </p>
	  		   	  <div class="border-top mb-3 mr-4"></div>
      	          <div class="cptn-admin-box-header">
         	         <?php 
    echo  htmlspecialchars_decode( esc_html__( "rDNS / FQDN", "campation-postoffice" ) ) ;
    ?>
                  </div>		 
      		   	  <div class="cptn-admin-box-dotted-border">
  		   	     	 <div class="table-responsive-sm">
                        <table id="cptn_po_assistant_rdns_table" style="table-layout:fixed;width:100%;" align=center cellpadding=2 class="table table-sm table-striped table-hover table-compact">
   				           <thead>
						   	     <tr><th width=16%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Mail server", "campation-postoffice" ) ) ;
    ?></th>
						       	     <th style="text-align:center;" width=5%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Type", "campation-postoffice" ) ) ;
    ?></th>
						       		 <th style="text-align:center;" width=10%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Status", "campation-postoffice" ) ) ;
    ?></th>
						       		 <th width=69%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Result", "campation-postoffice" ) ) ;
    ?></th>
						         </tr>
						   </thead>
						   <tbody>
						   </tbody>
						</table>
					 </div>
                  </div>

	  		   	  <div class="border-top mb-3 mr-4"></div>
      	          <div class="cptn-admin-box-header">
         	         <?php 
    echo  htmlspecialchars_decode( esc_html__( "DNS records", "campation-postoffice" ) ) ;
    ?>
                  </div>		 
      		   	  <div class="cptn-admin-box-dotted-border">
  		   	     	 <div class="table-responsive-sm">
                        <table id="cptn_po_assistant_dns_table" style="table-layout:fixed;width:100%;" align=center cellpadding=2 class="table table-sm table-striped table-hover table-compact">
   				           <thead>
						   <tr><th style="width:16%;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Domain", "campation-postoffice" ) ) ;
    ?></th>
						       <th style="width:21%;text-align:center;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "MX", "campation-postoffice" ) ) ;
    ?><div style="font-size:12px;color:#999;margin-bottom:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "incoming mail servers", "campation-postoffice" ) ) ;
    ?></div></th>
							   <th style="width:21%;text-align:center;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "TXT SPF", "campation-postoffice" ) ) ;
    ?><div style="font-size:12px;color:#999;margin-bottom:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "outgoing mail servers", "campation-postoffice" ) ) ;
    ?></div></th>
							   <th style="width:21%;text-align:center;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "TXT DMARC", "campation-postoffice" ) ) ;
    ?><div style="font-size:12px;color:#999;margin-bottom:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "domain abuse rules", "campation-postoffice" ) ) ;
    ?></div></th>
							   <th style="width:21%;text-align:center;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "TXT DKIM", "campation-postoffice" ) ) ;
    ?><div style="font-size:12px;color:#999;margin-bottom:10px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "digital email signature", "campation-postoffice" ) ) ;
    ?></div></th>
						   </tr>
						   </thead>
						   <tbody>
						   </tbody>
						</table>
					 </div>
                  </div>
               </div>
			   <div class="col-12 col-md-3">
	     		  <div class="cptn-sidebar-text">
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'The configuration of main and subdomains in the DNS is of great importance for the successful delivery of emails.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'For this purpose, the following DNS records must be set for each domain in the domain administration:', "campation-postoffice" ) ) ;
    ?></p>
				  	 <ul class="cptn-ul" style="font-size:12px;margin-top:-30px;">
   				        <li><strong>MX</strong> <?php 
    echo  htmlspecialchars_decode( esc_html__( 'which mail server is authorized to receive incoming mail', "campation-postoffice" ) ) ;
    ?></li>
   					 	<li><strong>SPF</strong> <?php 
    echo  htmlspecialchars_decode( esc_html__( 'which mail servers are authorized to send emails', "campation-postoffice" ) ) ;
    ?></li>
   					 	<li><strong>DMARC</strong> <?php 
    echo  htmlspecialchars_decode( esc_html__( 'What should happen if the authentication of a mail server fails (if the domain is misused by a third party)', "campation-postoffice" ) ) ;
    ?></li>
   					 	<li><strong>DKIM</strong> <?php 
    echo  htmlspecialchars_decode( esc_html__( 'digital signature of a combination of mail server and domain', "campation-postoffice" ) ) ;
    ?></li>
                     </ul>
				  	 <p style="margin-top:-30px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'The values for the individual records can be found on the right. Click on "Copy" and add the value in the DNS. You can view and refine these later in the "Domains" menu item.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( '<b><u>Please note</u></b>: Campation PostOffice&trade; can only generate DKIM recommendations and keys for its own mail servers - not for external SMTP servers. For the latter, ask your SMTP provider to set up DKIM.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'In the first column you find a <strong>BIND zone file</strong> for each domain to upload into your DNS.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'It may take up to 48 hours for your DNS records to propagate across the Internet.', "campation-postoffice" ) ) ;
    ?> <?php 
    echo  htmlspecialchars_decode( esc_html__( 'Therefore, please do not despair if your changes do not appear here immediately when you test again!', "campation-postoffice" ) ) ;
    ?></p>
				     <div style="text-align:center;"><button type="button" class="button" id="cptn-po-assistant-recheck-dns"><?php 
    echo  htmlspecialchars_decode( esc_html__( "RE-CHECK DNS", "campation-postoffice" ) ) ;
    ?></button></div>
				  </div>	 
               </div>
			</div>

			
		    <!-- step 7 -->
			<div class="row mr-0 pt-2 pb-2" id="cptn-po-assistant-step-7" style="min-height:630px;padding:5px;display:none;">
			   <div class="col-12 col-md-9" style="padding:15px;">
				  <p class="cptn-po-assistant-subtitle"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Please check now your overall configuration and click the button", "campation-postoffice" ) ) ;
    ?> 
				  <span id="cptn-po-assistant-check" style="float:right;">
<?php 
    ?>			
				     <button type="button" class="button button-primary" id="cptn-po-assistant-check-everything"><?php 
    echo  htmlspecialchars_decode( esc_html__( "CHECK EVERYTHING", "campation-postoffice" ) ) ;
    ?></button>
				  </span>
                  </p>
	  		   	  <div class="border-top mb-3 mr-4"></div>
			      <div id="cptn-po-assistant-check-printThis">
      	             <div class="cptn-admin-box-header">
         	            <?php 
    echo  htmlspecialchars_decode( esc_html__( "Server", "campation-postoffice" ) ) ;
    ?>
                     </div>		 
      		   	  	 <div class="cptn-admin-box-dotted-border">
  		   	     	    <div class="table-responsive-sm">
                           <table id="cptn_po_assistant_check_mailserver_table" style="table-layout:fixed;width:100%;" align=center cellpadding=2 class="table table-sm table-striped table-hover table-compact">
   				              <thead>
						   	     <tr><th width=20%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Mail server", "campation-postoffice" ) ) ;
    ?></th>
						       	     <th style="text-align:center;" width=5%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Type", "campation-postoffice" ) ) ;
    ?></th>
						       		 <th style="text-align:center;" width=10%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Status", "campation-postoffice" ) ) ;
    ?></th>
						       		 <th width=65%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Result", "campation-postoffice" ) ) ;
    ?></th>
						         </tr>
						      </thead>
						   	  <tbody>
						   	  </tbody>
						   </table>
					    </div>
                     </div>




<?php 
    ?>			

      	             <div class="cptn-admin-box-header">
         	            <?php 
    echo  htmlspecialchars_decode( esc_html__( "Domains", "campation-postoffice" ) ) ;
    ?>
                     </div>		 
      		   	     <div class="cptn-admin-box-dotted-border">
  		   	     	    <div class="table-responsive-sm">
                           <table id="cptn_po_assistant_check_domain_table" style="table-layout:fixed;width:100%;" align=center cellpadding=2 class="table table-sm table-striped table-hover table-compact">
   				              <thead>
						         <tr><th width=25%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Domain", "campation-postoffice" ) ) ;
    ?></th>
						             <th style="text-align:center;" width=10%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Status", "campation-postoffice" ) ) ;
    ?></th>
						             <th width=65%><?php 
    echo  htmlspecialchars_decode( esc_html__( "Result", "campation-postoffice" ) ) ;
    ?></th>
						         </tr>
						      </thead>
						   	  <tbody>
						   	  </tbody>
						   </table>
					    </div>
                     </div>
                  </div>
               </div>
			   <div class="col-12 col-md-3">
	     		  <div class="cptn-sidebar-text">
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'For the optimal functionality of Campation PostOffice&trade; an <strong>error-free configuration</strong> is very important!', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Finally, the overall configuration is examined and remaining errors are determined.', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'If errors are still found, <strong>please go back</strong> to the corresponding page of this wizard and make the necessary changes. Then please return to this page!', "campation-postoffice" ) ) ;
    ?></p>
				  	 <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'If all test results are perfect, please click on the "Finish" button at the bottom right!', "campation-postoffice" ) ) ;
    ?></p>
<?php 
    ?>			
				     <div style="text-align:center;margin-top:40px;"><button type="button" class="button" id="cptn-po-assistant-recheck-print"><?php 
    echo  htmlspecialchars_decode( esc_html__( "PRINT THIS PAGE", "campation-postoffice" ) ) ;
    ?></button></div>
				  </div>	 
               </div>
			</div>

			
			
		    <!-- step 8 -->
			<div class="row mr-0 pt-2 pb-2" id="cptn-po-assistant-step-8" style="min-height:630px;padding:5px;display:none;">

			   <div class="col-12 col-md-9" style="padding:15px;">
	     	      <h1 style="background-color:#999;color:white;"><center><strong><?php 
    echo  htmlspecialchars_decode( esc_html__( "Congratulations - you're done with a perfect setup!", "campation-postoffice" ) ) ;
    ?></strong></center></h1>
				  <p style="font-size:var(--bs-body-font-size);margin-top:20px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Thank you for your cooperation - Campation PostOffice&trade; is now <strong>optimally configured</strong> for sending emails quickly and professionally!", "campation-postoffice" ) ) ;
    ?></p>

				  <div style="border:1px solid #999;border-radius:10px;padding:10px;">				  
	     	         <table cellspacing=20 width=100%>
<?php 
    
    if ( CPTNPO_FS == "free" ) {
        ?>
				        <tr>
					       <td width="5%"><i style="color:#2C5478;font-size:90px;" class="fas fa-caret-right"></i></td>
					       <td width="75%"><p style="font-size:var(--bs-body-font-size);"><?php 
        echo  htmlspecialchars_decode( esc_html__( "Why not try the <strong>PRO version for 14 days free of charge and without obligation</strong>? This gives you a lot of additional functions that further expand the email functionality of your website!<strong>", "campation-postoffice" ) ) ;
        ?> <?php 
        echo  htmlspecialchars_decode( esc_html__( "Start your free 14 days trial of any PRO version!", "campation-postoffice" ) ) ;
        ?></strong></p></td>
						   <td width="20%" align="right" valign="top"><a href = "/wp-admin/admin.php?page=campation-postoffice-whypro" target="_blank"><button class="button" style="font-size:14px;"><?php 
        echo  htmlspecialchars_decode( esc_html__( 'Open in new window', "campation-postoffice" ) ) ;
        ?></button></a></td>
					    </tr>	
<?php 
        // ******************************** END CPTNPRO
    }
    
    ?>			
				     	<tr>
					       <td width="5%"><i style="color:#2C5478;font-size:90px;" class="fas fa-caret-right"></i></td>
					       <td><p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "<strong>As an affiliate</strong> of Campation PostOffice&trade; you can ensure its further distribution without any effort and <strong>make some money 'in your sleep'</strong>!", "campation-postoffice" ) ) ;
    ?></p></td>
						   <td width="20%" align="right"><a href = "/wp-admin/admin.php?page=campation-postoffice-affiliation" target="_blank"><button class="button" style="font-size:14px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Open in new window', "campation-postoffice" ) ) ;
    ?></button></a></td>
					    </tr>	
				        <tr>
					       <td width="5%"><i style="color:#2C5478;font-size:90px;" class="fas fa-caret-right"></i></td>
					       <td><p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "It is recommended to look through the <strong>configuration</strong> menu - there are <strong>more features to configure</strong>!", "campation-postoffice" ) ) ;
    ?></p></td>
						   <td width="20%" align="right"><a href = "/wp-admin/admin.php?page=campation-postoffice-settings" target="_blank"><button class="button" style="font-size:14px;"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Open in new window', "campation-postoffice" ) ) ;
    ?></button></a></td>
					    </tr>	
				     </table>
                  </div>
				  <br>
                  <center>
				     <p style="font-size:var(--bs-body-font-size);"><?php 
    echo  htmlspecialchars_decode( esc_html__( "Finally, send a test email to an external email account (outside your mail server / sender domain, e.g. GMail)", "campation-postoffice" ) ) ;
    ?>:</p>
				     <div style="max-width:400px;text-align:center;">
				        <form id="cptn-po-assistant-final-test-emails" role="form">
		      		       <input type="hidden" name="action" value="cptn_po_assistant_final_test_mails">
                    	   <input type="email" name="externalemail" class="form-control" placeholder="name@gmail.com" required="required">
                	       <input style="text-align:center;margin-top:20px;margin-bottom:20px;background-color:#208C41;color:white;" type="submit" id="cptn-po-assistant-final-test-emails-button" class="button" value="<?php 
    echo  htmlspecialchars_decode( esc_html__( 'Send message', "campation-postoffice" ) ) ;
    ?>">
					    </form>
				     </div>
            		 <div id="cptn-po-assistant-final-test-emails-result" class="col-md-12" style="margin-top:20px;text-align:center;padding:5px;background-color:#208C41;color:white;border-radius:5px;display:none;">
					    <?php 
    echo  htmlspecialchars_decode( esc_html__( 'Your message was sent successfully - please watch your inbox', "campation-postoffice" ) ) ;
    ?>
                     </div>
            		 <div id="cptn-po-assistant-final-test-emails-hint" class="col-md-12" style="margin-top:20px;text-align:center;display:none;">
					    <?php 
    echo  htmlspecialchars_decode( esc_html__( "Please also check out the menu items '<strong>Outbox</strong>' and '<strong>Recipients</strong>'", "campation-postoffice" ) ) ;
    ?>
                     </div>
            		 <div id="cptn-po-assistant-final-test-emails-error" class="col-md-12" style="margin-top:20px;text-align:center;padding:5px;background-color:#aa0000;color:white;border-radius:5px;display:none;">
					    <?php 
    echo  htmlspecialchars_decode( esc_html__( 'There was an error sending the message', "campation-postoffice" ) ) ;
    ?>
                     </div>
                  <center>
               </div>

			   <div class="col-12 col-md-3">
	     		  <div class="cptn-sidebar-text">
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'You have now <strong>successfully configured</strong> Campation PostOffice!', "campation-postoffice" ) ) ;
    ?></p>
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'You can also call up this wizard again later to make changes or to <strong>check the overall configuration</strong> after you have made changes elsewhere.', "campation-postoffice" ) ) ;
    ?></p>
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'From now on, an automatic monitoring of the system health will run <strong>in the background</strong> - if errors occur, you will receive an email.', "campation-postoffice" ) ) ;
    ?><span class="cptn-po-icon-pro-starter"></span></p>
				     <p><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Check out <strong>all other menu items</strong> of Campation PostOffice&trade;!', "campation-postoffice" ) ) ;
    ?></p>
				  </div>	 
               </div>

			</div>


		 </div>   <!-- end container -->

   </div>

   
	<div id="cptn-po-smtp-modal" class="modal fade modal-fullscreen cptn-main-modal" data-bs-backdrop="static" tabindex="-1" role="dialog">
	   <div class="modal-dialog modal-dialog-centered modal-md" id="cptn-po-medium-modal-window" role="document">
	      <div class="modal-content">
     	     <div class="modal-header">
			    <table style="width:100%;">
				   <tr>
				      <td align="left" valign="middle">
					     <h5 class="modal-title"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'Server info', "campation-postoffice" ) ) ;
    ?></h5>
					  </td>
					  <td align="right" valign="middle">
						 <table><tr>
						    <td valign="middle"><button type="button" class="btn btn-secondary btn-sm cptn-po-close-modal" data-bs-dismiss="modal" title="<?php 
    echo  esc_attr__( 'abort edit', "campation-postoffice" ) ;
    ?>"><i class="material-icons md-24">clear</i></button></td>
						 </tr></table>
				      </td>
				   </tr>
			    </table>
             </div>
			 <div class="modal-body" style="font-size:13px;">
			 <?php 
    echo  htmlspecialchars_decode( esc_html__( 'One of the strengths of Campation PostOffice&trade; is its sending technology SpeedMail - unfortunately you cannot use this in your WordPress environment.
<br><br>
But (<i>like with other WP Mail Plugins</i>) you can use <strong>any SMTP server</strong> and use <strong>all other advantages of PostOffice that are not usual</strong>:
<br><br>
<ul class="list-group  list-group-numbered">
<li class="list-group-item list-group-item-success"><strong>Outgoing mail queue</strong> - All outgoing emails are queued and processed in the background without slowing down your website - and you see the delivery/opening/click status of each email</li>
<li class="list-group-item list-group-item-warning"><strong>Check recipient addresses</strong> - All recipient addresses are checked for correct spelling and MX entry before they are used for the first time</li>
<li class="list-group-item list-group-item-success"><strong>Recipient database</strong> - All contacted email addresses are stored in recipient database</li>
<li class="list-group-item list-group-item-warning"><strong>URL Shortening</strong> - All linked URLs in an email are shortened</li>
<li class="list-group-item list-group-item-success"><strong>Open/Click Measurement</strong> - Open and click events in an email and the time elapsed since it was sent are measured</li>
<li class="list-group-item list-group-item-warning"><strong>24h Statistical Data</strong> - total sent, opened, clicked e-mails compared with min/max target values set by you</li>
<li class="list-group-item list-group-item-success"><strong>Permanent blind carbon copy (BCC)</strong> - send blind carbon copy (BCC) of all transactional emails (e.g. invoices) to the admin</li>
<li class="list-group-item list-group-item-warning"><strong>Automatic queue cleanup</strong> - removes all sent emails from the outgoing queue after a defined number of days to keep your database small</li>
<li class="list-group-item list-group-item-primary"><strong>and much more in Campation PostOffice&trade; PRO!<br><br><center><a href="/wp-admin/admin.php?page=campation-postoffice-whypro" target="_blank">Find out about all features here!</a></center></strong></li>
</ul>
<br>
So don\'t worry! <strong>Proceed with the setup wizard</strong> and fill in your SMTP server in the form below!', "campation-postoffice" ) ) ;
    ?>
			 </div>
			 <div class="modal-footer">
			    <button type="button" class="btn btn-primary" data-url="" data-id="" data-bs-dismiss="modal"><?php 
    echo  htmlspecialchars_decode( esc_html__( 'OK', "campation-postoffice" ) ) ;
    ?></button>
             </div>
          </div>
       </div>
    </div>
   
   
   
<?php 
}
