<?php
// exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {	exit(); }

if(cptn_po_is_plugin_page("settings"))
   {
   include_once("assets/includes/cptn-po-general-modal.php");
   include_once("assets/includes/cptn-po-configuration-modal.php");
   include_once("assets/css/cptn-po-css.php");
   include_once("assets/js/cptn-po-general-js.php");
   include_once(CPTNPODIR."common/js/cptn-modal-js.php");
   include_once("assets/js/configuration-js.php");
   }

   
function cptn_po_admin_configuration(){
   echo '<div class="wrap">
   <div class="loadingSpinnerContainer"><img class="loadingSpinnerImage" src="'.esc_url_raw(CPTNPOPATH,wp_allowed_protocols()).'img/cptn-spinner.svg"></div>
   <h1 class="mt-2"><img height=40 src="'.esc_url_raw(CPTNPOPATH,wp_allowed_protocols()).'img/h1-icon.png"> Campation PostOffice&trade; > '.htmlspecialchars_decode(esc_html__('Settings',"campation-postoffice")).'</h1>';
?>
   <p><?php echo htmlspecialchars_decode(esc_html__('Configure Campation PostOffice&trade; and determine how it behaves',"campation-postoffice")); ?></p>
   
   <table id="cptn_po_stat" title="<?php echo esc_attr__("Data from the last 24 hours - updated every 15 seconds - except 'inactive'","campation-postoffice"); ?>">
      <tr><th><?php echo htmlspecialchars_decode(esc_html__('waiting',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html_x('sent','stats circle',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html__('opened',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html__('clicked',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html__('unsubscribed',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html__('bounced',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html__('inactive',"campation-postoffice")); ?></th><th><?php echo htmlspecialchars_decode(esc_html__('Execution',"campation-postoffice")); ?></th></tr>    
	  <tr><td id="cptn_po_stat_waiting"><span id="cptn_po_stat_waiting_val"></span></td><td id="cptn_po_stat_sent"><span id="cptn_po_stat_sent_val"></span></td><td id="cptn_po_stat_opened"><span id="cptn_po_stat_opened_val"></span></td><td id="cptn_po_stat_clicked"><span id="cptn_po_stat_clicked_val"></span></td><td id="cptn_po_stat_unsubscribed"><span id="cptn_po_stat_unsubscribed_val"></span></td><td id="cptn_po_stat_bounced"><span id="cptn_po_stat_bounced_val"></span></td><td id="cptn_po_stat_inactive"><span id="cptn_po_stat_inactive_val"></span></td><td id="cptn_po_stat_executiontime"><span id="cptn_po_stat_executiontime_val"></span></td></tr>
   </table>

   <ul class="nav nav-pills" id="myTab" role="tablist">
      <li class="nav-item" role="presentation"><button class="nav-link active" id="general-tab" data-bs-toggle="tab" data-bs-target="#general" type="button" role="tab" aria-controls="general" aria-selected="true"><?php echo htmlspecialchars_decode(esc_html__("General","campation-postoffice")); ?></a></li>
  	  <li class="nav-item" role="presentation"><button class="nav-link" id="mail-tab" data-bs-toggle="tab" data-bs-target="#mail" type="button" role="tab" aria-controls="mail" aria-selected="false"><?php echo htmlspecialchars_decode(esc_html__("Mail","campation-postoffice")); ?></a></li>
  	  <li class="nav-item" role="presentation"><button class="nav-link" id="headerfooter-tab" data-bs-toggle="tab" data-bs-target="#headerfooter" type="button" role="tab" aria-controls="headerfooter" aria-selected="false"><?php echo htmlspecialchars_decode(esc_html_x("Header / Footer","config","campation-postoffice")); ?></a></li>
 	  <li class="nav-item" role="presentation"><button class="nav-link" id="optimization-tab" data-bs-toggle="tab" data-bs-target="#optimization" type="button" role="tab" aria-controls="optimization" aria-selected="false"><?php echo htmlspecialchars_decode(esc_html__("Optimization (AI)","campation-postoffice")); ?></a></li>
  	  <li class="nav-item" role="presentation"><button class="nav-link" id="report-tab" data-bs-toggle="tab" data-bs-target="#report" type="button" role="tab" aria-controls="report" aria-selected="false"><?php echo htmlspecialchars_decode(esc_html__("Reporting","campation-postoffice")); ?></a></li>
  	  <li class="nav-item" role="presentation"><button class="nav-link" id="statistics-tab" data-bs-toggle="tab" data-bs-target="#statistics" type="button" role="tab" aria-controls="statistics" aria-selected="false"><?php echo htmlspecialchars_decode(esc_html__("Statistics","campation-postoffice")); ?></a></li>
  	  <li class="nav-item" role="presentation"><button class="nav-link" id="utilities-tab" data-bs-toggle="tab" data-bs-target="#utilities" type="button" role="tab" aria-controls="utilities" aria-selected="false"><?php echo htmlspecialchars_decode(esc_html__("Utilities","campation-postoffice")); ?></a></li>
   </ul>



   <div class="tab-content" id="myTabContent" style="border:1px solid #999;border-radius:10px;min-height:700px;overflow:auto;padding-left:10px;">

      <div class="tab-pane fade show active" id="general" role="tabpanel" aria-labelledby="general-tab">
         <div class="row">
            <div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Configure basic settings like time zones and sandbox mode","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
       	       <div class="row">
	              <div class="col">
	  	             <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#cptn-po-config-general-modal"><?php echo htmlspecialchars_decode(esc_html__('Edit',"campation-postoffice")); ?></button>&nbsp;&nbsp;
	              </div>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
	  		   <div class="table-responsive-sm mr-4">
         	      <table width="100%" class="table table-sm table-striped table-hover table-compact">
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Time zone of server',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_opt_timezone_server_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Time zone of website',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_opt_timezone_staff_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Sandbox mode',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_sandbox_mode_show"></span></strong></td></tr>
	     		  	 <tr class="cptn_po_opt_sandbox_container_show"><td><?php echo htmlspecialchars_decode(esc_html__('Sandbox target',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_sandbox_email_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Erase all data when uninstalling or upgrading this plugin',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_delete_data_uninstall_show"></span></strong></td></tr>
	              </table>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
            </div>
   	        <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__("All times are calculated based on the time zones. Servers usually run under UTC. Your website's time zone should match the average time zone of your visitors.","campation-postoffice")); ?></p>
			      <p><?php echo htmlspecialchars_decode(esc_html__("In 'Sandbox' mode, all emails are not sent to the actual recipient, but are redirected either to trash or to a test email address specified by you.","campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span><span class="cptn-po-icon-pro-premium"></span></p>
			   </div>
            </div>
         </div>
	  </div>
  
      <div class="tab-pane fade" id="mail" role="tabpanel" aria-labelledby="mail-tab">
         <div class="row">
            <div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Configure your email system in the most important basic parameters","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
      	       <div class="row">
	              <div class="col">
	  	             <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#cptn-po-config-mail-modal"><?php echo htmlspecialchars_decode(esc_html__('Edit',"campation-postoffice")); ?></button>&nbsp;&nbsp;
	              </div>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
	  		   <div class="table-responsive-sm mr-4">
         	      <table width="100%" class="table table-sm table-striped table-hover table-compact">
     	             <tr><td><?php echo htmlspecialchars_decode(esc_html__('Default sender name',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_opt_email_sendername_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Default sender email',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_opt_email_sender_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Permanent blind copy (bcc) of transactional emails to',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_email_bcc_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Automatic cleanup of queue after days',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_purge_queue_days_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Block mail server after error count of',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_mailserver_off_errors_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Envelope IMAP account',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_envelope_account_email_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Automatic bounce management',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_bounce_management_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__("Use 'Brand Indicator Message Identification' (BIMI)","campation-postoffice")); ?><span class="cptn-po-icon-pro-business"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_bimi_show"></span></strong></td></tr>
	              </table>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
            </div>
   	        <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__('The default sender is used if no other sender information is available.',"campation-postoffice")); ?></p>
			      <p><?php echo htmlspecialchars_decode(esc_html__('Correct specification of the envelope IMAP account is of great importance. All undeliverable emails are returned to this account.',"campation-postoffice")); ?></p>
			   </div>
            </div>
         </div>
      </div>

      <div class="tab-pane fade" id="headerfooter" role="tabpanel" aria-labelledby="headerfooter-tab">
         <div class="row">
            <div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Design the header and footer of your emails with content and functionality","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
      	       <div class="row">
	              <div class="col">
	  	             <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#cptn-po-config-headerfooter-modal"><?php echo htmlspecialchars_decode(esc_html__('Edit',"campation-postoffice")); ?></button>&nbsp;&nbsp;
	              </div>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
	  		   <div class="table-responsive-sm mr-4">
         	      <table width="100%" class="table table-sm table-striped table-hover table-compact">
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Add affiliate link footer to all emails',"campation-postoffice")); ?> <small>(<a href="<?php echo CPTNPOAFFILIATEINFO; ?>" target="_blank" rel="noreferrer"><?php echo htmlspecialchars_decode(esc_html__('Spread the word and become an affiliate here',"campation-postoffice")); ?></a>)</small></td><td align="right" valign="top"><strong><span id="cptn_po_opt_affiliate_footer_show"></span></strong></td></tr>
	     	      	 <tr class="cptn_po_opt_affiliate_container_show"><td>-&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('Affiliate ID',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_affiliate_id_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('General mail footer',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_general_mail_footer_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Add "read this mail in browser" link in header of all outgoing emails',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_email_read_online_header_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Add unsubscribe header ("one click") to all non-transactional emails',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_email_unsubscribe_header_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Add unsubscribe footer to all non-transactional emails',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span> <small>(<?php echo htmlspecialchars_decode(esc_html__('Recommended, not all email clients support "one-click"',"campation-postoffice")); ?>)</small></td><td align="right" valign="top"><strong><span id="cptn_po_opt_email_unsubscribe_footer_show"></span></strong></td></tr>
   		  	       	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Page after unsubscribe',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_unsubscribe_page_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Automatic unsubscribe management',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_unsubscribe_management_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Google Analytics Tracking ID',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_analytics_pixel_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Google Adwords Tracking ID',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_adwords_pixel_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Facebook pixel',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_facebook_pixel_show"></span></strong></td></tr>
	              </table>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
            </div>
   	        <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__('Define the content of the header and footer of your emails.',"campation-postoffice")); ?></p>
			      <p><?php echo htmlspecialchars_decode(esc_html__('Also configure which options your recipients should have to unsubscribe.',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></p>
			      <p><?php echo htmlspecialchars_decode(esc_html__('Tracking/Marketing pixels are integrated into every email invisibly for your recipients.',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></p>
			   </div>
            </div>
         </div>
      </div>

      <div class="tab-pane fade" id="optimization" role="tabpanel" aria-labelledby="optimization-tab">
	     <div class="row">
   			<div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Use professional functions with AI to completely professionalize the sending of your emails","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
      		   <div class="row">
	     	      <div class="col"><button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#cptn-po-config-optimization-modal"><?php echo htmlspecialchars_decode(esc_html__('Edit',"campation-postoffice")); ?></button>&nbsp;&nbsp;</div>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
	  		   <div class="table-responsive-sm mr-4">
         	      <table width="100%" class="table table-sm table-striped table-hover table-compact">
				     <tr><td valign=top><?php echo htmlspecialchars_decode(esc_html__('Campation MailSchedule&trade;',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_schedule_show"></span></strong></td></tr>
                     <tr class="cptn_po_opt_schedule_container"><td valign=top>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('Send non-transactional email only',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_opt_automation_days_show"></span> <span id="cptn_opt_automation_time_start_show"></span> - <span id="cptn_opt_automation_time_end_show"></span>h</strong></td></tr>
	     		  	 <tr class="cptn_po_opt_schedule_container"><td valign=top>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('Minimum time gap between non-transactional emails',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_opt_automation_send_gap_min_show"></span> <?php echo htmlspecialchars_decode(esc_html__('min',"campation-postoffice")); ?></strong></td></tr>
				     <tr class="cptn_po_opt_schedule_container"><td valign=top>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('Campation IntelliMail&trade; (machine learning, "send @ best time")',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_intellimail_show"></span></strong></td></tr>
				     <tr><td valign=top><?php echo htmlspecialchars_decode(esc_html__("Campation DomainProtect&trade; (mail category -> (sub)domain)","campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_domain_protect_show"></span></strong></td></tr>
				     <tr><td valign=top><?php echo htmlspecialchars_decode(esc_html__('Campation InaGuard&trade; (do not mail inactive subscribers)',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_inaguard_show"></span></strong></td></tr>
                     <tr class="cptn_po_opt_inaguard_container"><td valign=top>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('no open / click in the last days',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_inaguard_days_show"></span></strong></td></tr>
	     		  	 <tr class="cptn_po_opt_inaguard_container"><td valign=top>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('no open / click in the last messages',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_inaguard_messages_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation WarmUp&trade; (increase sending volume for each mailserver slowly)',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_warmup_show"></span></strong></td></tr>
	     	      	 <tr class="cptn_po_opt_warmup_container"><td>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('warm up period in days',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_warmup_days_show"></span></strong></td></tr>
	     	      	 <tr class="cptn_po_opt_warmup_container"><td>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('planned monthly total email volume after warm up',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_warmup_volume_show"></span></strong></td></tr>
	     	      	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation MailThrottle&trade; (throttle sending volume per recipient domain)',"campation-postoffice")); ?><span class="cptn-po-icon-pro-business"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_throttle_show"></span></strong></td></tr>
	     	      	 <tr class="cptn_po_opt_throttle_container"><td>-&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo htmlspecialchars_decode(esc_html__('max. emails per minute per recipient domain',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_throttle_max_min_show"></span></strong></td></tr>
	              </table>
	           </div> 
			   <div>
			      <br>
	           	  <h5><?php echo htmlspecialchars_decode(esc_html__("Mail categories","campation-postoffice")); ?></h5>
			   	  <div><small><?php echo htmlspecialchars_decode(esc_html__("Campation MailPriority&trade; controls the urgency of emails via their mail category. Transactional emails (e.g. an invoice) are always sent immediately, even if 10,000 newsletters are waiting to be sent.","campation-postoffice")); ?> <?php echo htmlspecialchars_decode(esc_html__("If you have activated <strong>Campation MailSchedule&trade;</strong> or <strong>Campation DomainProtect&trade;</strong>, Campation PostOffice&trade; differentiates between email categories for mail scheduling and sending emails via the sender (sub) domain that corresponds to a category. Assign the correct category to every installed plugin that sends emails:","campation-postoffice")); ?></small></div>
	  		   	  <div class="border-top my-1 mr-4"></div>
	  		   	  <div class="table-responsive-sm mr-4">
			         <table id="cptn_po_config_plugis" class="table table-sm table-hover table-compact" width="100%">
   				        <tr><th><?php echo htmlspecialchars_decode(esc_html__("Plugin","campation-postoffice")); ?></th><th style="text-align:right;"><?php echo htmlspecialchars_decode(esc_html__("Mail category","campation-postoffice")); ?></th></tr>
<?php
   global $wpdb;

   // update plugin list on any call of configuration menu
   $plugins = get_plugins();
   foreach($plugins AS $key => $plugin)
      {
   	  $pluginslug = substr($key,0,strpos($key,"/"));
	  if(strpos($pluginslug,".")!==false)
   	     $pluginslug = substr($pluginslug,0,strpos($pluginslug,"."));
	  
      if(substr($plugin['Name'],0,9)!="Campation")
         {
	  	 $query = "SELECT * FROM ".$wpdb->prefix."cptn_po_plugin_mailcategory
	                WHERE pluginslug = '".esc_sql($pluginslug)."'";
         $row = $wpdb->get_row($query, ARRAY_A);
	  	 if(!$row)
	        {
			$mailcategory = "";
			$mailcatfull = "";
			if(strpos($pluginslug,"woocommerce")!==false)
			   {
			   $mailcategory = "trans";
			   $mailcatfull = "Transaction";
			   }			
	  	 	$query = "INSERT INTO ".$wpdb->prefix."cptn_po_plugin_mailcategory
		                 SET pluginslug = '".esc_sql($pluginslug)."',
						     fullpluginslug = '".esc_sql($key)."',
					      	 pluginname = '".esc_sql($plugin['Name'])."',
						  	 mailcategory = '".esc_sql($mailcategory)."',
							 mailcatfull = '".esc_sql($mailcatfull)."'
	                	  	 ";
            $wpdb->query($query);
		    }				 
	     }
      }

   // select all plugins for page
   $query = "SELECT pluginname, pluginslug, fullpluginslug, mailcategory, mailcatfull FROM ".$wpdb->prefix."cptn_po_plugin_mailcategory";
   $plugins = $wpdb->get_results($query, ARRAY_A);
   $active_plugins = get_option("active_plugins");
   foreach($plugins AS $key => $plugin)
      {

   	  if(substr($plugin['pluginname'],0,20) != "Campation PostOffice" AND substr($plugin['pluginname'],0,20) != "Campation RemoteMail")
         {
      	 $plugin_is_active = false;
	  	 foreach($active_plugins AS $active_plugin)
	        {
		 	if($active_plugin === $plugin['fullpluginslug'])
		       {
		       $plugin_is_active = true;
	           break;
               } 		 
		    }
         if($plugin_is_active)
            echo '<tr><td>'.esc_html($plugin['pluginname']).'</td><td align=right id="plugin_'.esc_html($plugin['pluginslug']).'_show"></td></tr>';
	     else
            echo '<tr style="color:#aaa;"><td>'.esc_html($plugin['pluginname']).'</td><td align=right id="plugin_'.esc_html($plugin['pluginslug']).'_show"></td></tr>';
	     }		
		 		
      }
?>
			         </table>
	              </div>
			   </div>	  
	  		   <div class="border-top my-1 mr-4"></div>
            </div>
   		    <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__('Configure integrated technologies that increase your reputation as an email sender and the response of your recipients!',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span><span class="cptn-po-icon-pro-premium"></span><span class="cptn-po-icon-pro-business"></span></p>
			   </div>
            </div>
         </div>
      </div>

      <div class="tab-pane fade" id="report" role="tabpanel" aria-labelledby="report-tab">
         <div class="row">
            <div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Turn on and off the desired email reports to the administrator","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
      	       <div class="row">
	              <div class="col">
	  	             <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#cptn-po-config-report-modal"><?php echo htmlspecialchars_decode(esc_html__('Edit',"campation-postoffice")); ?></button>&nbsp;&nbsp;
	              </div>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
	  		   <div class="table-responsive-sm mr-4">
         	      <table width="100%" class="table table-sm table-striped table-hover table-compact">
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Send all system messages to',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_admin_alerts_to_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Send alert emails in case of problems',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_admin_alerts_show"></span></strong></td></tr>
	     		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Submit technical information and statistics to developers anonymously',"campation-postoffice")); ?></td><td align="right" valign="top"><strong><span id="cptn_po_opt_info_developer_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Daily mail error report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_mail_error_report_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation DNSGuard&trade; - Health change report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_health_report_show"></span></strong></td></tr>
					 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Daily unsubscribe / bounce report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_unsub_bounce_report_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Black list change report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span></td><td align="right" valign="top"><strong><span id="cptn_po_opt_blacklist_report_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Daily DMARC report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_daily_dmarc_report_show"></span></strong></td></tr>
					 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Daily Campation InaGuard&trade; report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-premium"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_inaguard_report_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('SenderScore change report email to admin',"campation-postoffice")); ?><span class="cptn-po-icon-pro-business"></span></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_senderscore_report_show"></span></strong></td></tr>
	              </table>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
            </div>
   	        <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; sends you reports by email on request - you can manage them here.',"campation-postoffice")); ?><span class="cptn-po-icon-pro-starter"></span><span class="cptn-po-icon-pro-premium"></span></p>
			   </div>
            </div>
         </div>
      </div>

      <div class="tab-pane fade" id="statistics" role="tabpanel" aria-labelledby="statistics-tab">
         <div class="row">
   		 	<div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Specify minimum and maximum values for statistical calculations","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
      	       <div class="row">
	              <div class="col">
	  	             <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#cptn-po-config-statistics-modal"><?php echo htmlspecialchars_decode(esc_html__('Edit',"campation-postoffice")); ?></button>&nbsp;&nbsp;
	              </div>
	           </div>
	  		   <div class="border-top my-1 mr-4"></div>
      	       <div class="table-responsive-sm mr-4">
        	   	  <table width="100%" class="table table-sm table-striped table-hover table-compact">
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Maximum allowed bounce rate',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_max_bounce_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Minimum expected open rate',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_min_open_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Maximum allowed unsubscribe rate',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_max_unsubscribe_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Minimum expected click rate',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_min_click_show"></span></strong></td></tr>
	     	   	  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Calculate statistical values (domains, mail server) over days',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_opt_statistics_days_show"></span></strong></td></tr>
                  </table>
	  		   	  <div class="border-top my-1 mr-4"></div>
				  <br><br>
	           	  <h5><?php echo htmlspecialchars_decode(esc_html__("Database statistics","campation-postoffice")); ?></h5>
	  		   	  <div class="border-top my-1 mr-4"></div>
        	   	  <table width="100%" class="table table-sm table-striped table-hover table-compact">
           	         <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; database size on your web server',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_db_size"></span></strong></td></tr>
           		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; recipients',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_recipients"></span></strong></td></tr>
           		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; mail server',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_mailserver"></span></strong></td></tr>
           		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; sender domains',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_domains"></span></strong></td></tr>
          		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; emails waiting',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_queue_wait"></span></strong></td></tr>
           		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; emails sent',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_queue_sent"></span></strong></td></tr>
           		  	 <tr><td><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; emails with error',"campation-postoffice")); ?></td><td align="right"  valign="top"><strong><span id="cptn_po_config_statistics_queue_error"></span></strong></td></tr>
                  </table>
              	  <div class="border-top my-1 mr-4"></div>
	           </div>
            </div>
   	        <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__('Set statistical targets for key email marketing parameters - and monitor overall statistics from Campation PostOffice&trade;.',"campation-postoffice")); ?></p>
			   </div>
			</div>
         </div>
      </div>

      <div class="tab-pane fade" id="utilities" role="tabpanel" aria-labelledby="utilities-tab">
	     <div class="row">
   			<div class="col-12 col-md-9 my-3">
			   <p class="cptn-po-configuration-subtitle"><?php echo htmlspecialchars_decode(esc_html__("Other important information for using Campation PostOffice&trade;","campation-postoffice")); ?></p>
	  		   <div class="border-top mb-3 mr-4"></div>
	  		   <strong><?php echo htmlspecialchars_decode(esc_html__('1 Minute cron job',"campation-postoffice")); ?></strong>
	  		   <div class="border-top my-1 mr-4"></div>
	  		   <p><?php echo htmlspecialchars_decode(esc_html__("Campation PostOffice&trade; does not work reliably with WordPress's internal background processing ('cron'). It needs a properly configured system (or external) cron job running every minute. Please follow these steps or ask your hosting provider to help you:","campation-postoffice")); ?></p>
      		   <div class="table-responsive-sm mr-4">
         		  <table width="100%" class="table table-sm table-striped table-hover table-compact">
<?php if(!defined("DISABLE_WP_CRON") OR !DISABLE_WP_CRON) { ?> 
	                 <tr><td width="40%"><?php echo htmlspecialchars_decode(esc_html__('add this line to',"campation-postoffice")); ?> wp-config.php</td><td align="right" valign="middle"><small><strong><span id="cptn_cronjob_config_show"><span class="cptn-background-lightgrey">define('DISABLE_WP_CRON', true);</span></span></strong></small></td></tr>
<?php } ?>
	                 <tr><td width="40%"><?php echo htmlspecialchars_decode(esc_html__('add one of the both lines to Linux crontab',"campation-postoffice")); ?></td><td align="right" valign="middle"><small><strong><span id="cptn_cronjob_crontab_show"><span class="cptn-background-lightgrey"><?php echo "* * * * * root php -q ".ABSPATH."wp-cron.php > /dev/null";?></span><br><br><?php echo htmlspecialchars_decode(esc_html__('OR',"campation-postoffice")); ?>: <span class="cptn-background-lightgrey">* * * * *             root curl --silent --show-error <?php echo esc_url_raw(get_option('siteurl')); ?>/wp-cron.php?doing_wp_cron > /dev/null</span></strong></small></td></tr>
	     			 <tr><td width="40%"><?php echo htmlspecialchars_decode(esc_html__('or call this URL every minute by an external cron service',"campation-postoffice")); ?> <i><small>(<a href="https://cron-job.org/" target="_blank" rel="noopener noreferrer">cron-job.org</a> <?php echo htmlspecialchars_decode(esc_html__('offers such a free external cron service',"campation-postoffice")); ?>)</small></i></td><td align="right" valign="middle"><small><strong><span id="cptn_cronjob_url_show"><span class="cptn-background-lightgrey"><?php echo get_site_url()."/wp-cron.php";?></span></span></strong></small></td></tr>
	              </table>
               </div>
	  		   <div class="border-top my-1 mr-4"></div>
            </div>
   		    <div class="col-12 col-md-3 my-3 px-4">
	     	   <div class="cptn-sidebar-text">
			      <p><?php echo htmlspecialchars_decode(esc_html__('Campation PostOffice&trade; handles many tasks in the background without affecting the performance of your website. The correct setup of a one-minute cron job is essential for this.',"campation-postoffice")); ?></p>
			   </div>
			</div>
         </div>
      </div>

   </div>

<?php

   }
?>
