<?php
// =========================================================================
//    adjust textdomain after copying!  "wp-campation" / "campation-postoffice"
// =========================================================================
if(!function_exists("cptn_support_form_technical_attachment"))
   {
   add_action('wp_ajax_nopriv_cptn_support_form_technical_attachment','cptn_support_form_technical_attachment');
   add_action('wp_ajax_cptn_support_form_technical_attachment','cptn_support_form_technical_attachment');
   function cptn_support_form_technical_attachment() 
      {      
      global $wpdb,$locale;

      $output = array();
	  
      // mail server errors last 50
	  $output['mailservererrors'] = ""; 
   	  if(cptn_get_textdomain(plugin_basename(__FILE__))=="campation-postoffice")
	     {
		 $mailerrors = "";
   		 // mail server errors
   		 $query = "SELECT ms.shortname, ms.address, mse.error_date, mse.error_reason, mse.error_full 
   		             FROM ".$wpdb->prefix."cptn_po_mailserver_error mse
   		            INNER JOIN ".$wpdb->prefix."cptn_po_mailserver ms ON ms.id = mse.mailserver
			        ORDER BY mse.error_date DESC
					LIMIT 50
   		     		";
         $errors = $wpdb->get_results($query, ARRAY_A);
   		 if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
   
   	  	 $mailerrors .= '<tr><td valign="top">'.esc_html__("Mail server errors","campation-postoffice").'</td> ';
   		 if($errors)
      	    {
   	  	 	$mailerrors .= '<td valign="top"><table width=100%> '.PHP_EOL;
	  		$mailerrors .= '<tr style="background-color:#555;color:white;"><th align=left>'.htmlspecialchars_decode(esc_html__("Mail server","campation-postoffice")).'</th><th align=left>'.htmlspecialchars_decode(esc_html__("Date / time","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Error reason","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Error full","campation-postoffice")).'</th></tr> '.PHP_EOL;
      		foreach($errors AS $error)
         	   {
		 	   $mailerrors .= '<tr><td valign="top">'.esc_html($error['shortname']).' ('.esc_html($error['address']).')</td><td valign="top">'.esc_html($error['error_date']).'</td><td valign="top">'.wp_kses_post($error['error_reason']).'</td><td valign="top">'.wp_kses_post($error['error_full']).'</td></tr> '.PHP_EOL;
		 	   }
            $mailerrors .= '</table></td></tr>'.PHP_EOL;
      		}
		 else
      	 	$mailerrors .= '<td valign="top">'.esc_html__("No mail server errors at all","campation-postoffice").'</td></tr>'.PHP_EOL;
         $output['mailservererrors'] = base64_encode(wp_kses_post($mailerrors));
	     }

	  
      // mail queue errors last 50
	  $output['mailqueueerrors'] = ""; 
   	  if(cptn_get_textdomain(plugin_basename(__FILE__))=="campation-postoffice")
	     {
		 $mailerrors = "";
   		 // mail server errors
   		 $query = "SELECT mse.error_date, mse.error_reason, mse.error_code, mse.error_type, mse.error_cat, mse.error_full, mse.recipient_status, mse.recipient_email 
   		             FROM ".$wpdb->prefix."cptn_po_queue_error mse
			        ORDER BY mse.error_date DESC
					LIMIT 50
   		     		";
         $errors = $wpdb->get_results($query, ARRAY_A);
   		 if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
   
   	  	 $mailerrors .= '<tr><td valign="top">'.esc_html__("Mail queue errors","campation-postoffice").'</td> ';
   		 if($errors)
      	    {
   	  	 	$mailerrors .= '<td valign="top"><table width=100%> '.PHP_EOL;
	  		$mailerrors .= '<tr style="background-color:#555;color:white;"><th align=left>'.htmlspecialchars_decode(esc_html__("Date / time","campation-postoffice")).'</th><th align=left>'.htmlspecialchars_decode(esc_html__("Recipient status","campation-postoffice")).'</th><th align=left>'.htmlspecialchars_decode(esc_html__("Recipient email","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Error reason","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Code","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Type","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Category","campation-postoffice")).'</th><th align="left">'.htmlspecialchars_decode(esc_html__("Error full","campation-postoffice")).'</th></tr> '.PHP_EOL;
      		foreach($errors AS $error)
         	   {
		 	   $mailerrors .= '<tr><td valign="top">'.esc_html($error['error_date']).'</td><td valign="top">'.esc_html($error['recipient_status']).'</td><td valign="top">'.esc_html(substr($error['recipient_email'],0,-5)).'...</td><td valign="top">'.wp_kses_post($error['error_reason']).'</td><td valign="top">'.wp_kses_post($error['error_code']).'</td><td valign="top">'.wp_kses_post($error['error_type']).'</td><td valign="top">'.wp_kses_post($error['error_cat']).'</td><td valign="top">'.wp_kses_post($error['error_full']).'</td></tr> '.PHP_EOL;
		 	   }
            $mailerrors .= '</table></td></tr>'.PHP_EOL;
      		}
		 else
      	 	$mailerrors .= '<td valign="top">'.esc_html__("No mail queue errors at all","campation-postoffice").'</td></tr>'.PHP_EOL;
         $output['mailqueueerrors'] = base64_encode(wp_kses_post($mailerrors));
	     }

	  
      //debug.log last 100 lines
	  $output['debuglog'] = ""; 
	  $debuglog = '<tr><td valign="top">debug.log</td>'.PHP_EOL;
	  $debugfile = WP_CONTENT_DIR."/debug.log";
 	  if(file_exists($debugfile)) 
	     {
	   	 $all_lines = file($debugfile);
		 foreach($all_lines AS $key => $line)
		    {
			$all_lines[$key] = htmlentities($line);
			}
		 $count_lines = count($all_lines);
		 if($count_lines > 0)
		    {
		    if($count_lines > 100)
			   $count_lines = 100;
		    $last_lines = array_slice($all_lines , -$count_lines);
			$last_lines = "<ul>".PHP_EOL."<li>".implode("</li>".PHP_EOL."<li>",$last_lines)."</li>".PHP_EOL."</ul>";
			$debuglog .= '<td valign=top style="font-size:11px;">'.wp_kses_post($last_lines).'</td></tr>'.PHP_EOL;
			}
		 else
      	    $debuglog .= "<td>".esc_html__("Debug.log is empty","campation-postoffice")."</td></tr>".PHP_EOL;
         }
	  else
         $debuglog .= "<td>".esc_html__("Debug.log - file not found","campation-postoffice")."</td></tr>".PHP_EOL;
      $output['debuglog'] = base64_encode(wp_kses_post($debuglog));


   	  // plugins
  	  $pluginlist = '<tr><td valign="top">'.esc_html__("Plugins","campation-postoffice").'</td><td valign="top"> ';
   	  $pluginlist .= '<table width="100%"> '.PHP_EOL;

   	  $plugins = get_plugins();
   	  foreach($plugins AS $key => $plugin)
         {
  	   	 if(is_plugin_active($key))
            $pluginlist .=  '<tr>';
	     else
            $pluginlist .=  '<tr style="color:#aaa;">';
	     $pluginslug = substr($key,0,strpos($key,"/"));
	  	 $query = "SELECT mailcatfull FROM ".$wpdb->prefix."cptn_po_plugin_mailcategory WHERE pluginslug = '".$pluginslug."'";
      	 $mailcatfull = $wpdb->get_var($query);
         $pluginlist .= '<td valign="top">'.esc_html($plugin['Name']).'</td><td valign="top">'.esc_html($mailcatfull).'</td><td valign="top">'.esc_html($pluginslug).'</td></tr> '.PHP_EOL;
         }
      $pluginlist .= '</table> '.PHP_EOL;
      $pluginlist .= '</td></tr>'.PHP_EOL;
      $output['pluginlist'] = base64_encode(wp_kses_post($pluginlist));


   	  // options
  	  $optionlist = '<tr><td valign="top">'.esc_html__("Options","campation-postoffice").'</td><td valign="top"> ';
   	  $optionlist .= '<table width="100%"> '.PHP_EOL;
	  $query = "SELECT * FROM ".$wpdb->prefix."options WHERE option_name LIKE 'cptn_po_%' AND option_name NOT LIKE '%password%' AND option_name != 'cptn_po_db_tables' ORDER BY option_name ASC";
	  $options = $wpdb->get_results($query,ARRAY_A);
   	  foreach($options AS $option)
         {
  	   	 if($option['option_value'])
            $optionlist .=  '<tr>';
	     else
            $optionlist .=  '<tr style="color:#aaa;">';
         $optionlist .= '<td valign="top">'.esc_html($option['option_name']).'</td><td valign="top">'.str_replace("<","&gt;",str_replace("<","&lt;",$option['option_value']))."</td></tr> ".PHP_EOL;
         }
      $optionlist .= '</table> '.PHP_EOL;
      $optionlist .= '</td></tr>'.PHP_EOL;
      $output['optionlist'] = base64_encode(wp_kses_post($optionlist));
	  

      // tables
      $output['tablelist'] = "";
  	  $plugin_tables = get_option('cptn_po_db_tables');
   	  if (is_array($plugin_tables) && !empty($plugin_tables)) 
         {
		 $tables = "";
      	 foreach ($plugin_tables as $plugin_table) 
			{
			$size = $wpdb->get_var("SELECT count(*) FROM ".$plugin_table);
			$tables .= '<tr><td>'.esc_html($plugin_table).'</td><td>'.cptn_number_format($size,0,false).' records</td></tr> '.PHP_EOL;
         	}
   	  	 $tablelist  = '<tr><td valign="top">'.esc_html__("Tables","campation-postoffice").'</td><td valign="top"> ';
   	  	 $tablelist .= '<table width="100%"> '.PHP_EOL;
   	  	 $tablelist .= $tables.PHP_EOL;
         $tablelist .= '</table> '.PHP_EOL;
      	 $tablelist .= '</td></tr>'.PHP_EOL;
      	 $output['tablelist'] = base64_encode(wp_kses_post($tablelist));
		 }

      // language
   	  $output['language'] = get_locale();

      // first activation
   	  $output['activation'] = sanitize_text_field(get_option("cptn_po_opt_first_activation"));

   	  // first plugin_version
   	  $output['firstversion'] = sanitize_text_field(get_option("cptn_po_opt_first_version"));

   	  // assistant step
   	  $output['assistant_step'] = sanitize_text_field(get_option("cptn_po_opt_assistant_step"));

   	  // assistant status
   	  $output['assistant_status'] = sanitize_text_field(get_option("cptn_po_opt_assistant_status"));

      // cron status
   	  $cron_delay = cptn_cron_delay("cptn_po_message_cron");
   	  if($cron_delay > -120)
         $output['cron'] = "OK";
      else	  
         $output['cron'] = "DELAYED ".$cron_delay." sec";

      // MTA / rDNS status
   	  $query = "SELECT connectable, rdns FROM ".$wpdb->prefix."cptn_po_mailserver
	             WHERE server_type = 'spmail'
		      	 ";
      $server = $wpdb->get_row($query, ARRAY_A);

      if($server['connectable']==1)  
         $output['connectable'] = "OK";
      else	     
         $output['connectable'] = "ERROR";

      if($server['rdns']==1)  
         $output['rdns'] = "OK";
      else	     
         $output['rdns'] = "ERROR";

      $output['tz_server']       = get_option("cptn_opt_timezone_server");
      $output['tz_website'] 	 = get_option("cptn_opt_timezone_staff");
      $output['speedmail_ready'] = get_option("cptn_po_speedmail_ready");
      $output['check_mta'] 		 = get_option("cptn_po_check_mta")['mta'];
      $output['port_smtp'] 		 = get_option("cptn_po_check_mta")['smtp'];
      $output['port_ssl'] 		 = get_option("cptn_po_check_mta")['ssl'];
      $output['port_tls'] 		 = get_option("cptn_po_check_mta")['tls'];
      $output['mail_check'] 	 = get_option("cptn_po_mail_check_result")['result'];
      $output['mail_error'] 	 = "";
	  if(isset(get_option("cptn_po_mail_check_result")['error_reason']))
         $output['mail_error'] = get_option("cptn_po_mail_check_result")['error_reason'];
      $output['mail_error_full'] = "";
	  if(isset(get_option("cptn_po_mail_check_result")['error_full']))
         $output['mail_error_full'] = get_option("cptn_po_mail_check_result")['error_full'];

      // users
   	  $query = "SELECT COUNT(*) 
   		          FROM ".$wpdb->prefix."users
   		     	  ";
      $output['users'] = intval($wpdb->get_var($query));

      // recipients
   	  $query = "SELECT COUNT(*) 
   		          FROM ".$wpdb->prefix."cptn_po_recipient
   		     	  ";
      $output['recipients'] = intval($wpdb->get_var($query));


      // queue
   	  $query = "SELECT COUNT(*) 
   		          FROM ".$wpdb->prefix."cptn_po_queue
			     WHERE executed IS NOT NULL
   		     	 ";
      $output['queue'] = number_format($wpdb->get_var($query),0,".",",");
   
      $query = "SELECT COUNT(*) 
   		          FROM ".$wpdb->prefix."cptn_po_queue
   		     	  ";
      $output['queue'] .= " / ".number_format($wpdb->get_var($query),0,".",",");
   
   
      // mailserver
   	  $mailserverlist = '<tr><td valign="top">'.esc_html__("Mail server","campation-postoffice").'</td> ';
   	  $query = "SELECT id, server_type, address, status 
   		          FROM ".$wpdb->prefix."cptn_po_mailserver
   		     	  ";
      $mailservers = $wpdb->get_results($query, ARRAY_A);
   	  $mailserverlist .= "<td><table>".PHP_EOL;;
   	  $mailserverlist .= "<tr style='background-color:#555;color:white;'><th align='left'>ID</th><th align='left'>".htmlspecialchars_decode(esc_html__("Status","campation-postoffice"))."</th><th align='left'>".htmlspecialchars_decode(esc_html__("Type","campation-postoffice"))."</th><th align='left'>".htmlspecialchars_decode(esc_html__("Address","campation-postoffice"))."</th></tr>".PHP_EOL;
   	  foreach($mailservers AS $mailserver)
         {
   	  	 $mailserverlist .= "<tr><td>".esc_html($mailserver['id'])."</td><td>".esc_html($mailserver['status'])."</td><td>".esc_html($mailserver['server_type'])."</td><td>".esc_html($mailserver['address'])."</td></tr>".PHP_EOL;;
	  	 }
      $mailserverlist .= "</table></td></tr>".PHP_EOL;;
      $output['mailserver'] = base64_encode(wp_kses_post($mailserverlist));
     
	  
      // DNS
   	  $output['dns'] = "";
	  $dns_result    = "";
   	  $query = "SELECT * 
   		          FROM ".$wpdb->prefix."cptn_po_sender_domain
			     WHERE status = 1 
   		     	 ";
      $domains = $wpdb->get_results($query, ARRAY_A);
   	  foreach($domains AS $domain)
         {
	  	 $domain_output = "";
	     if($domain['domain_status'] != "OK")	  
	        $domain_output .= "domain_status: ".$domain['domain_status']."<br>".PHP_EOL;
	     if(empty($domain['mx_record']))	  
	        $domain_output .= "mx_record: empty<br>".PHP_EOL;
	     if(empty($domain['spf_record']))	  
	        $domain_output .= "spf_record: empty<br>".PHP_EOL;
	     if(empty($domain['dmarc_record']))	  
	        $domain_output .= "dmarc_record: empty<br>".PHP_EOL;
	     if(empty($domain['dkim_policy']))	  
	        $domain_output .= "dkim_policy: empty<br>".PHP_EOL;

         $query = "SELECT sdm.*, ms.id, ms.address 
   		             FROM ".$wpdb->prefix."cptn_po_sender_domain_mailserver sdm
				    INNER JOIN ".$wpdb->prefix."cptn_po_mailserver ms ON ms.id = sdm.mailserver_id AND ms.status=1   
			        WHERE domain_id = ".$domain['id']."
				     AND sdm.status = 1 
   		     	 	  ";
         $servers = $wpdb->get_results($query, ARRAY_A);

	  	 foreach($servers AS $server)
	        {
	  	    if($server['server_status'] != "OK")	  
	           $domain_output .= "MX ".$server['id']." ".$server['address'].": server_status ".$server['server_status']."<br>".PHP_EOL;
	  	    if(empty($server['dkim_selector']))	  
	           $domain_output .= "MX ".$server['id']." ".$server['address'].": no DKIM selector<br>".PHP_EOL;
	  	    if(empty($server['dkim_record']))	  
	           $domain_output .= "MX ".$server['id']." ".$server['address'].": no DKIM record<br>".PHP_EOL;
		    }

         if($domain_output)
	        {
   	  	 	$dns_result .= '<tr>'.PHP_EOL;
			$dns_result .= '<td valign="top">'.$domain['domain'].'</td>'.PHP_EOL;
			$dns_result .= '<td valign="top">'.$domain_output.'</td>'.PHP_EOL;
   	  	 	$dns_result .= '</tr>'.PHP_EOL;
		 	}
	     else	 	  
   	  	    $dns_result .= '<tr><td valign="top">'.$domain['domain'].'</td><td valign="top">OK</td></tr>'.PHP_EOL;
	     }

      if($dns_result)
	     {		 
   	     $output['dns'] = '<tr><td valign="top">DNS / Domains</td>'.PHP_EOL;
   	     $output['dns'] .= '<td valign=top style="font-size:11px;">'.PHP_EOL;
   	     $output['dns'] .= '<table>'.PHP_EOL;
   	     $output['dns'] .= '<tr style="background-color:#555;color:white;"><th align=left>'.htmlspecialchars_decode(esc_html__("Domain","campation-postoffice")).'</th><th align=left>'.htmlspecialchars_decode(esc_html__("Status","campation-postoffice")).'</th></tr> '.PHP_EOL;
   	     $output['dns'] .= $dns_result.PHP_EOL;
   	     $output['dns'] .= '</table>'.PHP_EOL;
      	 $output['dns'] .= '</td></tr>'.PHP_EOL;

      	 $output['dns'] = base64_encode(wp_kses_post($output['dns']));
		 }
		 
		 
	  echo cptn_json_output($output);

	  wp_die();
      }
   }

?>