<?php
if(!function_exists('cptn_db_install'))
   {
   function cptn_db_install() {
   global $wpdb;
   $tableprefix = $wpdb->prefix . 'cptn_';
   require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

      if(!isset($cptn_db_tables))
         $cptn_db_tables = array();            // all tables in array for API
      if(!isset($cptn_db_exclude_fields))
         $cptn_db_exclude_fields = array();    // fields not to be included in API data exchange

		 
		 
      // Create table for shortened url 
      $packagetable = $tableprefix . 'url';
	  $cptn_db_tables[] = $packagetable; 
      $sql = "CREATE TABLE " . $packagetable . " 
		        (
            	id INT NOT NULL AUTO_INCREMENT, 
            	code varchar(20) NOT NULL, 
            	url varchar(255) NOT NULL, 
            	clicks int(11) NOT NULL, 
				created DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
            	PRIMARY KEY  (id),
				KEY code (code),
				KEY url (url)
        		) 
				CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
				";
      dbDelta($sql);
		 

      $packagetable = $tableprefix . 'country';
	  $cptn_db_tables[] = $packagetable; 
      $sql = "CREATE TABLE " . $packagetable . " 
		        (
  				id int(11) NOT NULL,
  				name varchar(64) NOT NULL,
  				iso_code_2 char(2) NOT NULL,
  				iso_code_3 char(3) NOT NULL,
  				address_format_id int(11) NOT NULL,
  				status int(1) DEFAULT 1,
  				PRIMARY KEY  (id),
  				KEY name (name),
  				KEY iso_code_2 (iso_code_2)
        		) 
				CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
				";
      dbDelta($sql);

	  $result = $wpdb->get_results("SELECT * FROM ".$packagetable);
	  if(count($result)==0)  
	     {
	     $query = "INSERT INTO " . $packagetable . " (id,name,iso_code_2,iso_code_3, address_format_id, status) 
				   VALUES
				   (0, '', '', '', 1, 1),
				   (1, 'Afghanistan', 'AF', 'AFG', 1, 1),
				   (2, 'Albania', 'AL', 'ALB', 1, 1),
				   (3, 'Algeria', 'DZ', 'DZA', 1, 1),
				   (4, 'American Samoa', 'AS', 'ASM', 1, 1),
				   (5, 'Andorra', 'AD', 'AND', 1, 1),
				   (6, 'Angola', 'AO', 'AGO', 1, 1),
				   (7, 'Anguilla', 'AI', 'AIA', 1, 1),
				   (8, 'Antarctica', 'AQ', 'ATA', 1, 1),
				   (9, 'Antigua and Barbuda', 'AG', 'ATG', 1, 1),
				   (10, 'Argentina', 'AR', 'ARG', 1, 1),
				   (11, 'Armenia', 'AM', 'ARM', 1, 1),
				   (12, 'Aruba', 'AW', 'ABW', 1, 1),
				   (13, 'Australia', 'AU', 'AUS', 1, 1),
				   (14, 'Austria', 'AT', 'AUT', 5, 1),
				   (15, 'Azerbaijan', 'AZ', 'AZE', 1, 1),
				   (16, 'Bahamas', 'BS', 'BHS', 1, 1),
				   (17, 'Bahrain', 'BH', 'BHR', 1, 1),
				   (18, 'Bangladesh', 'BD', 'BGD', 1, 1),
				   (19, 'Barbados', 'BB', 'BRB', 1, 1),
				   (20, 'Belarus', 'BY', 'BLR', 1, 1),
				   (21, 'Belgium', 'BE', 'BEL', 1, 1),
				   (22, 'Belize', 'BZ', 'BLZ', 1, 1),
				   (23, 'Benin', 'BJ', 'BEN', 1, 1),
				   (24, 'Bermuda', 'BM', 'BMU', 1, 1),
				   (25, 'Bhutan', 'BT', 'BTN', 1, 1),
				   (26, 'Bolivia', 'BO', 'BOL', 1, 1),
				   (27, 'Bosnia and Herzegowina', 'BA', 'BIH', 1, 1),
				   (28, 'Botswana', 'BW', 'BWA', 1, 1),
				   (29, 'Bouvet Island', 'BV', 'BVT', 1, 1),
				   (30, 'Brazil', 'BR', 'BRA', 1, 1),
				   (31, 'British Indian Ocean Territory', 'IO', 'IOT', 1, 1),
				   (32, 'Brunei Darussalam', 'BN', 'BRN', 1, 1),
				   (33, 'Bulgaria', 'BG', 'BGR', 1, 1),
				   (34, 'Burkina Faso', 'BF', 'BFA', 1, 1),
				   (35, 'Burundi', 'BI', 'BDI', 1, 1),
				   (36, 'Cambodia', 'KH', 'KHM', 1, 1),
				   (37, 'Cameroon', 'CM', 'CMR', 1, 1),
				   (38, 'Canada', 'CA', 'CAN', 1, 1),
				   (39, 'Cape Verde', 'CV', 'CPV', 1, 1),
				   (40, 'Cayman Islands', 'KY', 'CYM', 1, 1),
				   (41, 'Central African Republic', 'CF', 'CAF', 1, 1),
				   (42, 'Chad', 'TD', 'TCD', 1, 1),
				   (43, 'Chile', 'CL', 'CHL', 1, 1),
				   (44, 'China', 'CN', 'CHN', 1, 1),
				   (45, 'Christmas Island', 'CX', 'CXR', 1, 1),
				   (46, 'Cocos (Keeling) Islands', 'CC', 'CCK', 1, 1),
				   (47, 'Colombia', 'CO', 'COL', 1, 1),
				   (48, 'Comoros', 'KM', 'COM', 1, 1),
				   (49, 'Congo', 'CG', 'COG', 1, 1),
				   (50, 'Cook Islands', 'CK', 'COK', 1, 1),
				   (51, 'Costa Rica', 'CR', 'CRI', 1, 1),
				   (52, 'Cote D\'Ivoire', 'CI', 'CIV', 1, 1),
				   (53, 'Croatia', 'HR', 'HRV', 1, 1),
				   (54, 'Cuba', 'CU', 'CUB', 1, 1),
				   (55, 'Cyprus', 'CY', 'CYP', 1, 1),
				   (56, 'Czech Republic', 'CZ', 'CZE', 1, 1),
				   (57, 'Denmark', 'DK', 'DNK', 1, 1),
				   (58, 'Djibouti', 'DJ', 'DJI', 1, 1),
				   (59, 'Dominica', 'DM', 'DMA', 1, 1),
				   (60, 'Dominican Republic', 'DO', 'DOM', 1, 1),
				   (61, 'East Timor', 'TP', 'TMP', 1, 1),
				   (62, 'Ecuador', 'EC', 'ECU', 1, 1),
				   (63, 'Egypt', 'EG', 'EGY', 1, 1),
				   (64, 'El Salvador', 'SV', 'SLV', 1, 1),
				   (65, 'Equatorial Guinea', 'GQ', 'GNQ', 1, 1),
				   (66, 'Eritrea', 'ER', 'ERI', 1, 1),
				   (67, 'Estonia', 'EE', 'EST', 1, 1),
				   (68, 'Ethiopia', 'ET', 'ETH', 1, 1),
				   (69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', 1, 1),
				   (70, 'Faroe Islands', 'FO', 'FRO', 1, 1),
				   (71, 'Fiji', 'FJ', 'FJI', 1, 1),
				   (72, 'Finland', 'FI', 'FIN', 1, 1),
				   (73, 'France', 'FR', 'FRA', 1, 1),
				   (74, 'France, Metropolitan', 'FX', 'FXX', 1, 1),
				   (75, 'French Guiana', 'GF', 'GUF', 1, 1),
				   (76, 'French Polynesia', 'PF', 'PYF', 1, 1),
				   (77, 'French Southern Territories', 'TF', 'ATF', 1, 1),
				   (78, 'Gabon', 'GA', 'GAB', 1, 1),
				   (79, 'Gambia', 'GM', 'GMB', 1, 1),
				   (80, 'Georgia', 'GE', 'GEO', 1, 1),
				   (81, 'Germany', 'DE', 'DEU', 5, 1),
				   (82, 'Ghana', 'GH', 'GHA', 1, 1),
				   (83, 'Gibraltar', 'GI', 'GIB', 1, 1),
				   (84, 'Greece', 'GR', 'GRC', 1, 1),
				   (85, 'Greenland', 'GL', 'GRL', 1, 1),
				   (86, 'Grenada', 'GD', 'GRD', 1, 1),
				   (87, 'Guadeloupe', 'GP', 'GLP', 1, 1),
				   (88, 'Guam', 'GU', 'GUM', 1, 1),
				   (89, 'Guatemala', 'GT', 'GTM', 1, 1),
				   (90, 'Guinea', 'GN', 'GIN', 1, 1),
				   (91, 'Guinea-Bissau', 'GW', 'GNB', 1, 1),
				   (92, 'Guyana', 'GY', 'GUY', 1, 1),
				   (93, 'Haiti', 'HT', 'HTI', 1, 1),
				   (94, 'Heard and Mc Donald Islands', 'HM', 'HMD', 1, 1),
				   (95, 'Honduras', 'HN', 'HND', 1, 1),
				   (96, 'Hong Kong', 'HK', 'HKG', 1, 1),
				   (97, 'Hungary', 'HU', 'HUN', 1, 1),
				   (98, 'Iceland', 'IS', 'ISL', 1, 1),
				   (99, 'India', 'IN', 'IND', 1, 1),
				   (100, 'Indonesia', 'ID', 'IDN', 1, 1),
				   (101, 'Iran (Islamic Republic of)', 'IR', 'IRN', 1, 1),
				   (102, 'Iraq', 'IQ', 'IRQ', 1, 1),
				   (103, 'Ireland', 'IE', 'IRL', 1, 1),
				   (104, 'Israel', 'IL', 'ISR', 1, 1),
				   (105, 'Italy', 'IT', 'ITA', 1, 1),
				   (106, 'Jamaica', 'JM', 'JAM', 1, 1),
				   (107, 'Japan', 'JP', 'JPN', 1, 1),
				   (108, 'Jordan', 'JO', 'JOR', 1, 1),
				   (109, 'Kazakhstan', 'KZ', 'KAZ', 1, 1),
				   (110, 'Kenya', 'KE', 'KEN', 1, 1),
				   (111, 'Kiribati', 'KI', 'KIR', 1, 1),
				   (112, 'Korea, Democratic People\'s Republic of', 'KP', 'PRK', 1, 1),
				   (113, 'Korea, Republic of', 'KR', 'KOR', 1, 1),
				   (114, 'Kuwait', 'KW', 'KWT', 1, 1),
				   (115, 'Kyrgyzstan', 'KG', 'KGZ', 1, 1),
				   (116, 'Lao People\'s Democratic Republic', 'LA', 'LAO', 1, 1),
				   (117, 'Latvia', 'LV', 'LVA', 1, 1),
				   (118, 'Lebanon', 'LB', 'LBN', 1, 1),
				   (119, 'Lesotho', 'LS', 'LSO', 1, 1),
				   (120, 'Liberia', 'LR', 'LBR', 1, 1),
				   (121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', 1, 1),
				   (122, 'Liechtenstein', 'LI', 'LIE', 1, 1),
				   (123, 'Lithuania', 'LT', 'LTU', 1, 1),
				   (124, 'Luxembourg', 'LU', 'LUX', 1, 1),
				   (125, 'Macau', 'MO', 'MAC', 1, 1),
				   (126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', 1, 1),
				   (127, 'Madagascar', 'MG', 'MDG', 1, 1),
				   (128, 'Malawi', 'MW', 'MWI', 1, 1),
				   (129, 'Malaysia', 'MY', 'MYS', 1, 1),
				   (130, 'Maldives', 'MV', 'MDV', 1, 1),
				   (131, 'Mali', 'ML', 'MLI', 1, 1),
				   (132, 'Malta', 'MT', 'MLT', 1, 1),
				   (133, 'Marshall Islands', 'MH', 'MHL', 1, 1),
				   (134, 'Martinique', 'MQ', 'MTQ', 1, 1),
				   (135, 'Mauritania', 'MR', 'MRT', 1, 1),
				   (136, 'Mauritius', 'MU', 'MUS', 1, 1),
				   (137, 'Mayotte', 'YT', 'MYT', 1, 1),
				   (138, 'Mexico', 'MX', 'MEX', 1, 1),
				   (139, 'Micronesia, Federated States of', 'FM', 'FSM', 1, 1),
				   (140, 'Moldova, Republic of', 'MD', 'MDA', 1, 1),
				   (141, 'Monaco', 'MC', 'MCO', 1, 1),
				   (142, 'Mongolia', 'MN', 'MNG', 1, 1),
				   (143, 'Montserrat', 'MS', 'MSR', 1, 1),
				   (144, 'Morocco', 'MA', 'MAR', 1, 1),
				   (145, 'Mozambique', 'MZ', 'MOZ', 1, 1),
				   (146, 'Myanmar', 'MM', 'MMR', 1, 1),
				   (147, 'Namibia', 'NA', 'NAM', 1, 1),
				   (148, 'Nauru', 'NR', 'NRU', 1, 1),
				   (149, 'Nepal', 'NP', 'NPL', 1, 1),
				   (150, 'Netherlands', 'NL', 'NLD', 1, 1),
				   (151, 'Netherlands Antilles', 'AN', 'ANT', 1, 1),
				   (152, 'New Caledonia', 'NC', 'NCL', 1, 1),
				   (153, 'New Zealand', 'NZ', 'NZL', 1, 1),
				   (154, 'Nicaragua', 'NI', 'NIC', 1, 1),
				   (155, 'Niger', 'NE', 'NER', 1, 1),
				   (156, 'Nigeria', 'NG', 'NGA', 1, 1),
				   (157, 'Niue', 'NU', 'NIU', 1, 1),
				   (158, 'Norfolk Island', 'NF', 'NFK', 1, 1),
				   (159, 'Northern Mariana Islands', 'MP', 'MNP', 1, 1),
				   (160, 'Norway', 'NO', 'NOR', 1, 1),
				   (161, 'Oman', 'OM', 'OMN', 1, 1),
				   (162, 'Pakistan', 'PK', 'PAK', 1, 1),
				   (163, 'Palau', 'PW', 'PLW', 1, 1),
				   (164, 'Panama', 'PA', 'PAN', 1, 1),
				   (165, 'Papua New Guinea', 'PG', 'PNG', 1, 1),
				   (166, 'Paraguay', 'PY', 'PRY', 1, 1),
				   (167, 'Peru', 'PE', 'PER', 1, 1),
				   (168, 'Philippines', 'PH', 'PHL', 1, 1),
				   (169, 'Pitcairn', 'PN', 'PCN', 1, 1),
				   (170, 'Poland', 'PL', 'POL', 1, 1),
				   (171, 'Portugal', 'PT', 'PRT', 1, 1),
				   (172, 'Puerto Rico', 'PR', 'PRI', 1, 1),
				   (173, 'Qatar', 'QA', 'QAT', 1, 1),
				   (174, 'Reunion', 'RE', 'REU', 1, 1),
				   (175, 'Romania', 'RO', 'ROM', 1, 1),
				   (176, 'Russian Federation', 'RU', 'RUS', 1, 1),
				   (177, 'Rwanda', 'RW', 'RWA', 1, 1),
				   (178, 'Saint Kitts and Nevis', 'KN', 'KNA', 1, 1),
				   (179, 'Saint Lucia', 'LC', 'LCA', 1, 1),
				   (180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', 1, 1),
				   (181, 'Samoa', 'WS', 'WSM', 1, 1),
				   (182, 'San Marino', 'SM', 'SMR', 1, 1),
				   (183, 'Sao Tome and Principe', 'ST', 'STP', 1, 1),
				   (184, 'Saudi Arabia', 'SA', 'SAU', 1, 1),
				   (185, 'Senegal', 'SN', 'SEN', 1, 1),
				   (186, 'Seychelles', 'SC', 'SYC', 1, 1),
				   (187, 'Sierra Leone', 'SL', 'SLE', 1, 1),
				   (188, 'Singapore', 'SG', 'SGP', 4, 1),
				   (189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', 1, 1),
				   (190, 'Slovenia', 'SI', 'SVN', 1, 1),
				   (191, 'Solomon Islands', 'SB', 'SLB', 1, 1),
				   (192, 'Somalia', 'SO', 'SOM', 1, 1),
				   (193, 'South Africa', 'ZA', 'ZAF', 1, 1),
				   (194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', 1, 1),
				   (195, 'Spain', 'ES', 'ESP', 5, 1),
				   (196, 'Sri Lanka', 'LK', 'LKA', 1, 1),
				   (197, 'St. Helena', 'SH', 'SHN', 1, 1),
				   (198, 'St. Pierre and Miquelon', 'PM', 'SPM', 1, 1),
				   (199, 'Sudan', 'SD', 'SDN', 1, 1),
				   (200, 'Suriname', 'SR', 'SUR', 1, 1),
				   (201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', 1, 1),
				   (202, 'Swaziland', 'SZ', 'SWZ', 1, 1),
				   (203, 'Sweden', 'SE', 'SWE', 1, 1),
				   (204, 'Switzerland', 'CH', 'CHE', 1, 1),
				   (205, 'Syrian Arab Republic', 'SY', 'SYR', 1, 1),
				   (206, 'Taiwan', 'TW', 'TWN', 1, 1),
				   (207, 'Tajikistan', 'TJ', 'TJK', 1, 1),
				   (208, 'Tanzania, United Republic of', 'TZ', 'TZA', 1, 1),
				   (209, 'Thailand', 'TH', 'THA', 1, 1),
				   (210, 'Togo', 'TG', 'TGO', 1, 1),
				   (211, 'Tokelau', 'TK', 'TKL', 1, 1),
				   (212, 'Tonga', 'TO', 'TON', 1, 1),
				   (213, 'Trinidad and Tobago', 'TT', 'TTO', 1, 1),
				   (214, 'Tunisia', 'TN', 'TUN', 1, 1),
				   (215, 'Turkey', 'TR', 'TUR', 1, 1),
				   (216, 'Turkmenistan', 'TM', 'TKM', 1, 1),
				   (217, 'Turks and Caicos Islands', 'TC', 'TCA', 1, 1),
				   (218, 'Tuvalu', 'TV', 'TUV', 1, 1),
				   (219, 'Uganda', 'UG', 'UGA', 1, 1),
				   (220, 'Ukraine', 'UA', 'UKR', 1, 1),
				   (221, 'United Arab Emirates', 'AE', 'ARE', 1, 1),
				   (222, 'United Kingdom', 'GB', 'GBR', 1, 1),
				   (223, 'United States', 'US', 'USA', 2, 1),
				   (224, 'United States Minor Outlying Islands', 'UM', 'UMI', 1, 1),
				   (225, 'Uruguay', 'UY', 'URY', 1, 1),
				   (226, 'Uzbekistan', 'UZ', 'UZB', 1, 1),
				   (227, 'Vanuatu', 'VU', 'VUT', 1, 1),
				   (228, 'Vatican City State (Holy See)', 'VA', 'VAT', 1, 1),
				   (229, 'Venezuela', 'VE', 'VEN', 1, 1),
				   (230, 'Viet Nam', 'VN', 'VNM', 1, 1),
				   (231, 'Virgin Islands (British)', 'VG', 'VGB', 1, 1),
				   (232, 'Virgin Islands (U.S.)', 'VI', 'VIR', 1, 1),
				   (233, 'Wallis and Futuna Islands', 'WF', 'WLF', 1, 1),
				   (234, 'Western Sahara', 'EH', 'ESH', 1, 1),
				   (235, 'Yemen', 'YE', 'YEM', 1, 1),
				   (236, 'Yugoslavia', 'YU', 'YUG', 1, 1),
				   (237, 'Zaire', 'ZR', 'ZAR', 1, 1),
				   (238, 'Zambia', 'ZM', 'ZMB', 1, 1),
				   (239, 'Zimbabwe', 'ZW', 'ZWE', 1, 1),
				   (240, 'Serbia', 'RS', 'SRB', 1, 1);
		 ";
	     $wpdb->get_results($query);	  
	  	 }
	  

      update_option('cptn_db_tables',$cptn_db_tables);                               // all tables in array for UNINSTALL
      update_option('cptn_db_exclude_fields',$cptn_db_exclude_fields);


		 
      // check / set important parameters initialization
   	  if(!cptn_exist_option("cptn_opt_automation_days"))              update_option("cptn_opt_automation_days", "|1|2|3|4|5|6|7|");   
   	  if(!cptn_exist_option("cptn_opt_automation_time_start"))     	  update_option("cptn_opt_automation_time_start", "00:00");   
   	  if(!cptn_exist_option("cptn_opt_automation_time_end"))  	   	  update_option("cptn_opt_automation_time_end", "23:59");   
   	  if(!cptn_exist_option("cptn_opt_automation_send_gap_min"))   	  update_option("cptn_opt_automation_send_gap_min", "30");   

	  if(!cptn_exist_option("cptn_opt_timezone_server")) 		   	  
	     {
	     if(date_default_timezone_get())
	        update_option("cptn_opt_timezone_server", date_default_timezone_get());   
		 else
	        update_option("cptn_opt_timezone_server", "UTC");   
		 }
      if(!cptn_exist_option("cptn_opt_timezone_staff"))
	     { 		   	  
	  	 if(esc_html(get_option('timezone_string')))
	        update_option("cptn_opt_timezone_staff", esc_html(get_option('timezone_string')));
	     else
	        update_option("cptn_opt_timezone_staff", "UTC");
		 }
		 
	  if(!cptn_exist_option("cptn_opt_currencyiso"))	   		   	  update_option("cptn_opt_currencyiso", "EUR");   
	  if(!cptn_exist_option("cptn_opt_currencysign"))	   		      update_option("cptn_opt_currencysign", "€");   
	  if(empty(esc_html(get_option("cptn_opt_email_sender"))))  	  update_option("cptn_opt_email_sender", esc_html(get_option('admin_email')));   
	  if(empty(esc_html(get_option("cptn_opt_email_sendername"))))	  update_option("cptn_opt_email_sendername", esc_html(get_bloginfo('name')));   
		
      }
   }


if(!function_exists('cptn_exist_option'))
   {
   function cptn_exist_option( $arg ) {
      global $wpdb;
      $prefix = $wpdb->prefix;
      $db_options = $prefix.'options';
      $sql_query = 'SELECT * FROM ' . $db_options . ' WHERE option_name LIKE "' . $arg . '"';
      $results = $wpdb->get_results( $sql_query, OBJECT );
      if ( count( $results ) === 0 )
         return false;
      else
        return true;
      }
   }

?>