<?php

if(!function_exists("cptn_disable_emojis"))
   {
   add_action( 'init', 'cptn_disable_emojis' );
   function cptn_disable_emojis() {
      remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
 	  remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
 	  remove_action( 'wp_print_styles', 'print_emoji_styles' );
 	  remove_action( 'admin_print_styles', 'print_emoji_styles' ); 
 	  remove_filter( 'the_content_feed', 'wp_staticize_emoji' );
 	  remove_filter( 'comment_text_rss', 'wp_staticize_emoji' ); 
 	  remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );
 	  add_filter( 'tiny_mce_plugins', 'cptn_disable_emojis_tinymce' );
 	  add_filter( 'wp_resource_hints', 'cptn_disable_emojis_remove_dns_prefetch', 10, 2 );
	  }
   function cptn_disable_emojis_tinymce( $plugins ) {
      if ( is_array( $plugins ) ) 
 	     return array_diff( $plugins, array( 'wpemoji' ) );
      else
         return array();
      }
   function cptn_disable_emojis_remove_dns_prefetch( $urls, $relation_type ) {
      if ( 'dns-prefetch' == $relation_type ) {
 	     $emoji_svg_url = apply_filters( 'emoji_svg_url', 'https://s.w.org/images/core/emoji/2/svg/' );
 		 $urls = array_diff( $urls, array( $emoji_svg_url ) );
 		 }
      return $urls;
	  }
   }
   
   

if(!function_exists("cptn_number_format"))
   {
   function cptn_number_format ($number,$decimals=0,$currency = true)
      {
	  $output = "";
	  if($currency)
	     {
  	  	 setlocale(LC_MONETARY, substr(get_user_locale(wp_get_current_user()),0,5).".UTF-8");	
	  	 $locale = localeconv();
	  	 $decimal_point = $locale['mon_decimal_point'];
	  	 $thousands_sep = $locale['mon_thousands_sep'];
	  	 if(empty($thousands_sep) AND $decimal_point==",") $thousands_sep = "."; ;
	  	 if(empty($thousands_sep) AND $decimal_point==".") $thousands_sep = ","; ;
	  	 $output = number_format($number,$decimals,$decimal_point,$thousands_sep);
		 $spacesign = "";

		 if($number >= 0)
		    {	
		    if($locale['p_sep_by_space'])
		       $spacesign = " ";
		 	if($locale['p_cs_precedes'])
		       $output = esc_html(get_option("cptn_opt_currencysign")).$spacesign.$output;
		    else	
		       $output = $output.$spacesign.esc_html(get_option("cptn_opt_currencysign"));
			}
	     else		   
		    {	
		    if($locale['n_sep_by_space'])
		       $spacesign = " ";
		 	if($locale['n_cs_precedes'])
		       $output = esc_html(get_option("cptn_opt_currencysign")).$spacesign.$output;
		    else	
		       $output = $output.$spacesign.esc_html(get_option("cptn_opt_currencysign"));
			}
		 }
      else
	     {
  	  	 setlocale(LC_NUMERIC, substr(get_user_locale(wp_get_current_user()),0,5).".UTF-8");	
	  	 $locale = localeconv();
	  	 $decimal_point = $locale['decimal_point'];
	  	 $thousands_sep = $locale['thousands_sep'];
	  	 if(empty($thousands_sep) AND $decimal_point==",") $thousands_sep = "."; ;
	  	 if(empty($thousands_sep) AND $decimal_point==".") $thousands_sep = ","; ;
	  	 $output = number_format($number,$decimals,$decimal_point,$thousands_sep);
		 }

   	  return($output);
   	  }
   }


if(!function_exists("cptn_date_format"))
   {
   function cptn_date_format ($datestring, $format="T")
      {
	  $output = "";
	  if($datestring)
	     {
         $serverTimezone = new DateTimeZone(get_option("cptn_opt_timezone_server"));
		 $userTimezone = new DateTimeZone(get_option("cptn_opt_timezone_staff"));
		 $date = new DateTime($datestring, $serverTimezone );
		 $date->setTimeZone($userTimezone);
		 if(strtoupper($format)=="D") 
            $output = date_i18n(get_option('date_format'), strtotime($date->format('Y-m-d H:i:s')));
         else
            $output = date_i18n(get_option('date_format').' '.get_option('time_format').':s', strtotime($date->format('Y-m-d H:i:s')));
		 }
   	  return($output);
   	  }
   }
   

// offset between 2 timezones in hours   
if(!function_exists("cptn_timezone_offset"))
   {
   function cptn_timezone_offset ($timezone1="UTC", $timezone2="UTC")
      {
	  $dateTimeZone1 = new DateTimeZone($timezone1);
	  $dateTimeZone2 = new DateTimeZone($timezone2);
	  $dateTime1 = new DateTime("now", $dateTimeZone1);
	  $dateTime2 = new DateTime("now", $dateTimeZone2);
	  $timeOffset = $dateTimeZone1->getOffset($dateTime2);
	  if(!$timeOffset) $timeOffset = 0;
   	  return((int) ($timeOffset/3600));
   	  }
   }



if(!function_exists("cptn_admin_meta_head"))
   {
   if(is_admin())
      add_action( 'admin_head', 'cptn_admin_meta_head' );
   function cptn_admin_meta_head() 
      {
      // to avoid slow datatables with Skype
	  echo '<meta name="SKYPE_TOOLBAR" content="SKYPE_TOOLBAR_PARSER_COMPATIBLE" />'.PHP_EOL;
      }
   }	  




if(!function_exists("cptn_crypt"))
   {
   function cptn_crypt($str)
      {
	  $ciphering = "AES-128-CTR";
	  $iv_length = openssl_cipher_iv_length($ciphering);
	  $options = 0;
	  $encryption_iv = '1234567891011121';
	  $encryption_key = "WPCampationSuite";
	  $encryption = openssl_encrypt($str, $ciphering, $encryption_key, $options, $encryption_iv);
  	  return($encryption);
	  }
   }
   
   
if(!function_exists("cptn_decrypt"))
   {
   function cptn_decrypt($str)
      {
	  $ciphering = "AES-128-CTR";
	  $iv_length = openssl_cipher_iv_length($ciphering);
	  $options = 0;
	  $decryption_iv = '1234567891011121';
	  $decryption_key = "WPCampationSuite";
	  $decryption = openssl_decrypt ($str, $ciphering, $decryption_key, $options, $decryption_iv);
  	  return($decryption);
	  }
   }

   
if(!function_exists("cptn_short_url"))
   {   
   function cptn_short_url ($url)
      {
   	  global $wpdb;
   	  $url = urldecode($url);
   	  $query = "SELECT code FROM ".$wpdb->prefix."cptn_url WHERE url = '".esc_sql($url)."'";
   	  $result = $wpdb->get_row($query,ARRAY_A);
   	  if($result AND $result['code']>'')
         return (get_home_url()."/".$result['code']);
      else
         {
   	  	 while(true)
            {
	  	 	// does this random code already exist?
   	  	 	$code = cptn_generateRandomString(7);
	  	 	$query = "SELECT * FROM ".$wpdb->prefix."cptn_url WHERE code = '".esc_sql($code)."'";
	  	 	$result = $wpdb->get_row($query,ARRAY_A);
	  	 	if(!$result)
               {
   		 	   $query = "INSERT INTO ".$wpdb->prefix."cptn_url SET url = '".esc_sql($url)."', code = '".$code."'";
   		 	   $result = $wpdb->query($query);
   		 	   return (get_home_url()."/".$code);
		 	   break;
		 	   }
	        }	    
         }    
      }
   }
   
   
if(!function_exists("cptn_generateRandomString"))
   {   
   function cptn_generateRandomString($length = 7) 
      {
   	  $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';   // 62 characters ^ 7 = 3.500 Mrd
   	  $charactersLength = strlen($characters);
   	  $randomString = '';
   	  for ($i = 0; $i < $length; $i++) {
         $randomString .= $characters[rand(0, $charactersLength - 1)];
      	 }
      return $randomString;
      }
   }



// catch shortened URL
if(!function_exists("cptn_catch_shortened_url"))
   {   
   add_action('template_redirect', 'cptn_catch_shortened_url',-99);
   function cptn_catch_shortened_url()
      {
	  global $wpdb, $wp_query;
      if ($wp_query->is_404())  
         {
		 if(isset($_GET['cptnpoi']))
		    $queue_id = intval($_GET['cptnpoi']);
	     else		
		    $queue_id = 0;
			 		 
	  	 // shortened URL
	  	 $code = substr(parse_url(esc_url($_SERVER["REQUEST_URI"]), PHP_URL_PATH),1,1000);   // leading slash
	  	 if(substr($code,strlen($code)-1,1)=="/")   // trailing slash
	        $code = substr($code,0,-1);            

	     $query = "SELECT * 
			         FROM ".$wpdb->prefix."cptn_url 
				    WHERE code = '".esc_sql($code)."'
				";
         $forward = $wpdb->get_row($query,ARRAY_A);
	     if($forward AND $forward['url']>'')
	        {
	  	 	// count usage of shortened URL
	  	 	$query = "UPDATE ".$wpdb->prefix."cptn_url SET clicks = clicks+1 WHERE id = ".$forward['id'];
		 	$result = $wpdb->query($query);

			// mark PostOffice tables as clicked
			if($queue_id AND defined("CPTNPOVERSION"))
			   {
			   if (!empty($_SERVER['HTTP_CLIENT_IP'])) 
    		      $ip = $_SERVER['HTTP_CLIENT_IP'];
               elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) 
    		      $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
               else 
			      $ip = $_SERVER['REMOTE_ADDR'];
               $host = gethostbyaddr($ip);

			   // mark queue as clicked - and opened if tracking image was not downloaded (outlook)
			   $query = "UPDATE ".$wpdb->prefix."cptn_po_queue
                            SET clicked = NOW(),
								opened = IF(opened IS NULL, NOW(), opened),
			     				click_ip = '".esc_sql($ip)."',
				 				click_ptr = '".esc_sql($host)."'
		                  WHERE id = ".$queue_id."
		                    AND clicked IS NULL";	  		 
               $count = $wpdb->query($query);

			   if($count)
   			      {

			      // get queue data
			      $query = "SELECT * FROM ".$wpdb->prefix."cptn_po_queue
		                     WHERE id = ".$queue_id;	  		 
                  $queue = $wpdb->get_row($query, ARRAY_A);
			   

			      // mark mailserver as clicked 
			      $query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
                               SET clicked = clicked+1
		                     WHERE id = ".$queue['mailserver'];	  		 
                  $wpdb->query($query);


			      // mark recipient as clicked 
			      $query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
                               SET mails_clicked = mails_clicked+1,
							       last_clicked = NOW()
		                     WHERE id = ".$queue['recipient_id'];	  		 
                  $wpdb->query($query);

			      // mark domain as clicked  
			      $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
                               SET mails_clicked = mails_clicked+1
		                     WHERE id = ".$queue['sender_domain_id'];	  		 
                  $wpdb->query($query);

   				  // Domain - Mailserver
     			  $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain_mailserver
	                           SET mails_clicked = mails_clicked+1
			                 WHERE domain_id = ".$queue['sender_domain_id']."
			                   AND mailserver_id = ".$queue['mailserver'];	  		 
                  $wpdb->query($query);

				  }

			   }
			
		 	// forward to target url
		 	header("Location: ".$forward['url']);
		 	exit;
	        }
         }

      }   
   }

// get the textdomain of current plugin for translation in /common files   
if(!function_exists("cptn_get_textdomain"))
   {
   function cptn_get_textdomain($plugin) 
      {
	  $slug = get_plugins('/'.explode('/', $plugin)[0]);
	  foreach($slug AS $key => $value)
   	     {
   		 return($value['TextDomain']);
   		 }
	  }
   }


// checks next cron run in seconds, if negative = delayed   
if(!function_exists("cptn_cron_delay"))
   {
   function cptn_cron_delay($cron_name)
      {
   	  foreach( _get_cron_array() as $timestamp => $crons )
         {
      	 if( in_array( $cron_name, array_keys( $crons ) ) )
            return $timestamp - time();
         }
      return false;
      }
   }


// convert phone number to international format
if(!function_exists("cptn_intl_phone_format"))
   {
   function cptn_intl_phone_format($number,$country)
      {
   	  $newnumber = $number;
   
   	  // +49 (0) .......
   	  if(substr($newnumber,0,1) == "+" AND strpos($newnumber,"(0)")!==false)
         $newnumber = str_replace("(0)","",$newnumber);

      $newnumber = str_replace(" ","",$newnumber);
   	  $newnumber = str_replace("(","",$newnumber);
   	  $newnumber = str_replace(")","",$newnumber);
   	  $newnumber = str_replace("/","",$newnumber);
   	  $newnumber = str_replace("-","",$newnumber);
   	  $newnumber = trim($newnumber);
   
   	  // 0049
   	  if(substr($newnumber,0,2) == "00")
         $newnumber = "+".substr($newnumber,2,100);
   
      // 02151 without country code
   	  if(substr($newnumber,0,1) == "0")
         {
      	 if($country=="DE")
            $newnumber = "+49".substr($newnumber,1,100);
         if($country=="AT")
            $newnumber = "+43".substr($newnumber,1,100);
         if($country=="CH")
            $newnumber = "+41".substr($newnumber,1,100);
         if($country=="PL")
            $newnumber = "+48".substr($newnumber,1,100);
         if($country=="BE")
            $newnumber = "+32".substr($newnumber,1,100);
         if($country=="IT")
            $newnumber = "+39".substr($newnumber,1,100);
         if($country=="DK")
            $newnumber = "+45".substr($newnumber,1,100);
         if($country=="NL")
            $newnumber = "+31".substr($newnumber,1,100);
         if($country=="FR")
            $newnumber = "+33".substr($newnumber,1,100);
         if($country=="ES")
            $newnumber = "+34".substr($newnumber,1,100);
         if($country=="LU")
            $newnumber = "+352".substr($newnumber,1,100);
         if($country=="BG")
            $newnumber = "+359".substr($newnumber,1,100);
         if($country=="RO")
            $newnumber = "+40".substr($newnumber,1,100);
         if($country=="HU")
            $newnumber = "+36".substr($newnumber,1,100);
         if($country=="AL")
            $newnumber = "+355".substr($newnumber,1,100);
         if($country=="AD")
            $newnumber = "+376".substr($newnumber,1,100);
         if($country=="AM")
            $newnumber = "+374".substr($newnumber,1,100);
         if($country=="BY")
            $newnumber = "+375".substr($newnumber,1,100);
         if($country=="BA")
            $newnumber = "+387".substr($newnumber,1,100);
         if($country=="CY")
            $newnumber = "+357".substr($newnumber,1,100);
         if($country=="CZ")
            $newnumber = "+420".substr($newnumber,1,100);
         if($country=="EE")
            $newnumber = "+372".substr($newnumber,1,100);
         if($country=="FO")
            $newnumber = "+298".substr($newnumber,1,100);
         if($country=="GB")
            $newnumber = "+44".substr($newnumber,1,100);
         if($country=="GE")
            $newnumber = "+995".substr($newnumber,1,100);
         if($country=="GI")
            $newnumber = "+350".substr($newnumber,1,100);
         if($country=="GR")
            $newnumber = "+30".substr($newnumber,1,100);
         if($country=="HR")
            $newnumber = "+385".substr($newnumber,1,100);
         if($country=="IE")
            $newnumber = "+353".substr($newnumber,1,100);
         if($country=="LT")
            $newnumber = "+370".substr($newnumber,1,100);
         if($country=="LV")
            $newnumber = "+371".substr($newnumber,1,100);
         if($country=="MK")
            $newnumber = "+389".substr($newnumber,1,100);
         if($country=="MT")
            $newnumber = "+356".substr($newnumber,1,100);
         if($country=="NO")
            $newnumber = "+47".substr($newnumber,1,100);
         if($country=="PO")
            $newnumber = "+48".substr($newnumber,1,100);
         if($country=="PT")
            $newnumber = "+351".substr($newnumber,1,100);
         if($country=="RU")
            $newnumber = "+7".substr($newnumber,1,100);
         if($country=="SE")
            $newnumber = "+46".substr($newnumber,1,100);
         if($country=="SI")
            $newnumber = "+386".substr($newnumber,1,100);
         if($country=="SK")
            $newnumber = "+421".substr($newnumber,1,100);
         if($country=="TR")
            $newnumber = "+90".substr($newnumber,1,100);
         if($country=="UA")
            $newnumber = "+380".substr($newnumber,1,100);
	     }	 

      if(preg_match('/^\\+?[1-9][0-9]{7,16}$/', $newnumber))	              
         return($newnumber);
      else
         return($number);
      }      	     
   }   



if(!function_exists("cptn_country_select_options"))
   {
   function cptn_country_select_options($preselected="")
      {
   	  global $wpdb;
   
      $query = "SELECT name, iso_code_2
	              FROM ".$wpdb->prefix."cptn_country
			     WHERE name > '' 
			       AND iso_code_2 NOT IN ('DE','AT','CH')
		         ORDER BY name 
              	 "; 
      $result = $wpdb->get_results($query, ARRAY_A);
   	  $country_options = '<option value="">Land auswählen</option> ';
   	  $selected = "";
   	  if('DE'==$preselected) $selected = " selected";
   	  $country_options .= '<option value="DE"'.$selected.'>'.__('Germany', 'campation-postoffice').'</option> ';
   	  $selected = "";
   	  if('AT'==$preselected) $selected = " selected";
   	  $country_options .= '<option value="AT"'.$selected.'>'.__('Austria', 'campation-postoffice').'</option> ';
   	  $selected = "";
   	  if('CH'==$preselected) $selected = " selected";
   	  $country_options .= '<option value="CH"'.$selected.'>'.__('Switzerland', 'campation-postoffice').'</option> ';
   	  $country_options .= '<option value="">- - - - -</option> ';
   	  foreach($result AS $row)
         {
	  	 $selected = "";
      	 if($row['iso_code_2']==$preselected) $selected = " selected";
	  	 $country_options .= '<option value="'.$row['iso_code_2'].'"'.$selected.'>'.addslashes($row['name']).'</option> '; 
	     }
      return ($country_options);
	  } 	  
   }


if(!function_exists("cptn_country_select_options_ajax"))
   {
   add_action('wp_ajax_nopriv_cptn_country_select_options_ajax','cptn_country_select_options_ajax');
   add_action('wp_ajax_cptn_country_select_options_ajax','cptn_country_select_options_ajax');
   function cptn_country_select_options_ajax ()
      {
   	  echo cptn_country_select_options($_POST['preselected']);   
   	  }   
   }

if(!function_exists("cptn_country_from_iso2"))
   {
   function cptn_country_from_iso2($iso2)
      {
      global $wpdb;
      $query = "SELECT name
	              FROM ".$wpdb->prefix."cptn_country
			     WHERE iso_code_2 = '".$iso2."' 
              	 "; 
      return($wpdb->get_var($query));
	  }
   }


?>