<?php
// exit if accessed directly
// =========================================================================
//    adjust textdomain after copying!  "wp-campation" / "campation-postoffice"
// =========================================================================

if ( ! defined( 'ABSPATH' ) ) {	exit(); }

if(!function_exists("cptn_admin_support"))
   {
   function cptn_admin_support()
      {
	  global $wpdb;
   	  include_once("js/support-js.php");

   	  if(sanitize_text_field($_GET['page'])=="campation-faq-support") 
	     {
		 $cptnpath = esc_url_raw(CPTNPATH,wp_allowed_protocols());
		 $cptnlogo = esc_url_raw(CPTNPATH,wp_allowed_protocols()).'img/campation-logo-mail.png';
		 $pluginname = "Campation Journey&trade;";
		 $plugin = "campation";
		 }
   	  elseif(sanitize_text_field($_GET['page'])=="campation-postoffice-faq-support")
	     {
		 $cptnpath = esc_url_raw(CPTNPOPATH,wp_allowed_protocols());
		 $cptnlogo = esc_url_raw(CPTNPOPATH,wp_allowed_protocols()).'img/campation-postoffice-logo-mail.png';
		 $pluginname = "Campation PostOffice&trade;";
		 $plugin = "campation-postoffice";
		 }
   	  elseif(sanitize_text_field($_GET['page'])=="campation-master-faq" ) 
	     {
		 $cptnpath = esc_url_raw(CPTNMASTERURL,wp_allowed_protocols());
		 $cptnlogo = esc_url_raw(CPTNMASTERURL,wp_allowed_protocols()).'img/campation-postoffice-logo-mail.png';
		 $pluginname = "Campation Master&trade;";
		 $plugin = "campation-master";
		 }

?>

   <div class="wrap">
      <div class="loadingSpinnerContainer"><img class="loadingSpinnerImage" src="<?php echo esc_url_raw($cptnpath); ?>img/cptn-spinner.svg"></div>
      <h1 class="mt-2"><img height=40 src="<?php echo esc_url_raw($cptnpath); ?>img/h1-icon.png"> <?php echo esc_html($pluginname); ?> > <?php echo htmlspecialchars_decode(esc_html__('FAQ / Support',"campation-postoffice")); ?></h1>

   <p><?php echo htmlspecialchars_decode(esc_html__('In case you need help or like to contact our support',"campation-postoffice")); ?></p>

   <div class="row" style="margin:0px;border:1px solid #999;border-radius:10px;min-height:700px;overflow:auto;">
   
	  <div class="col-12 col-md-10 my-2">
		 <h1>FAQ</h1>
		 <p style="font-size:var(--bs-body-font-size);"><?php echo htmlspecialchars_decode(esc_html__('Use the most frequently asked questions and the answers to them.',"campation-postoffice")); ?></p>
		 <br>
		 <div style="border:1px solid #999;padding:10px;border-radius:10px;">
            <div class="form-group" style="padding:0px 30%;margin-top:20px;margin-bottom:20px;">
			   <div class="input-group">
  			      <span class="input-group-text" style="background-color:#208C41;color:white;font-size:20px;border:5px solid #208C41;"><i class="fas fa-search"></i></span>
				  <input id="cptn-faq-search" type="search" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('enter a keyword with at least 3 characters',"campation-postoffice")); ?>">
               </div>
            </div>
		    <div id="cptn-faq-main-content" data-plugin="<?php echo esc_attr($plugin); ?>">
		       <div id="cptn-faq-error">
			      <?php echo htmlspecialchars_decode(esc_html__('An error occurred while loading the FAQ content. Please try later again',"campation-postoffice")); ?>	        
			   </div>		
	        </div>		
   		 	<div style="font-size:12px;text-align:center;"><i><?php echo htmlspecialchars_decode(esc_html__("All FAQs are loaded from the central Campation server to keep them up-to-date.<br>Your clicks and ratings are sent anonymously to the same server to improve quality.","campation-postoffice")); ?></i></div>';
         </div>		 
	  </div>
      <div class="col-12 col-md-2 my-3">
	      <div class="cptn-sidebar-text">
   	  	    <p><?php echo htmlspecialchars_decode(esc_html__('If you have any questions or problems, please do the following:',"campation-postoffice")); ?></p>	  
			<ul class="cptn-ul" style="font-size:12px;margin-top:-30px;">
			   <li><?php echo htmlspecialchars_decode(esc_html__('Please take a look at our <strong>FAQ first</strong> - this is the <strong>fastest way</strong> for you to get an answer!',"campation-postoffice")); ?></li>
			   <li><?php echo htmlspecialchars_decode(esc_html__("If you don't find what you're looking for, please send a <strong>request to our support</strong> using the button at the right.","campation-postoffice")); ?></li>
            </ul>
   	  	    <p style="margin-top:-20px;"><?php echo htmlspecialchars_decode(esc_html__("If you find a software error, we will do our best to provide you with an update within 24 hours. We usually implement suggestions for improvement within 1 week.","campation-postoffice")); ?></p>
			<br>
			<center><button class="button" style="font-size:14px;" data-bs-toggle="modal" data-bs-target="#cptn-support-modal"><?php echo htmlspecialchars_decode(esc_html__('Support request',"campation-postoffice")); ?></button></center>
		 </div>		  
	  </div>

   </div>


	<div id="cptn-support-modal" class="modal fade modal-fullscreen" data-bs-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="cptn-support-modal-title" aria-hidden="true">
	   <div class="modal-dialog modal-dialog-centered modal-lg">
	      <div class="modal-content">
     	     <div class="modal-header">
			    <table style="width:100%;">
				   <tr>
				      <td align="left" valign="middle">
					     <h5 class="modal-title" id="cptn-support-modal-title"><?php echo htmlspecialchars_decode(esc_html__('Support request',"campation-postoffice")); ?></h5>
					  </td>
					  <td align="right" valign="middle">
						 <table><tr>
						    <td valign="middle"><button type="button" class="btn btn-secondary btn-sm" data-bs-dismiss="modal" title="<?php echo esc_attr__('close window',"campation-postoffice"); ?>"><i class="material-icons md-24">clear</i></button></td>
						 </tr></table>
				      </td>
				   </tr>
			    </table>
             </div>
			 <div class="modal-body">

   		        <p style="font-size:var(--bs-body-font-size);"><?php echo esc_html__('You have a question or found a bug? Contact our support!',"campation-postoffice"); ?></p>

   		   		<form id="cptn_support_form" role="form" class="my-6" style="margin-top:30px;" data-url="<?php echo esc_url_raw(CPTNSUPPORTURL); ?>cptnsupportrequest">
		      	   <input type="hidden" name="plugin" value="<?php echo esc_attr($plugin); ?>">
		      	   <input type="hidden" name="pluginname" value="<?php echo esc_attr($pluginname); ?>">
		      	   <input type="hidden" name="language" value="<?php echo substr(get_bloginfo("language"),0,2); ?>">
		      	   <input type="hidden" name="wpversion" value="<?php echo get_bloginfo('version'); ?>">
		      	   <input type="hidden" name="phpversion" value="<?php echo PHP_VERSION; ?>">
		      	   <input type="hidden" name="secretkey" value="<?php echo get_option("cptn_po_scret_key"); ?>">
<?php
   	  	 $query = 'SHOW VARIABLES LIKE "version";';
   	  	 $versionresult = $wpdb->get_row($query,ARRAY_A);
   	  	 $mysqlVersion = $versionresult['Value']; 

   	     $query = 'SHOW VARIABLES LIKE "version_comment";';
   	  	 $vendorresult = $wpdb->get_row($query,ARRAY_A);
   	  	 $mysqlVendor = $vendorresult['Value']; 

   		 $license_type = "";
   		 if(cptn_po_fs()->is_trial())  
      	    $license_type = "trial";
   		 elseif(cptn_po_fs()->is_plan('business'))  
      	    $license_type = "business";
         elseif(cptn_po_fs()->is_plan('premium'))  
      	    $license_type = "premium";
         elseif(cptn_po_fs()->is_plan('starter'))  
      	    $license_type = "starter";
         else  
      	    $license_type = "free";

   	     // plugin referrer
   		 $referrer_keyword  = ""; 
   		 $referrer_page 	= ""; 
   		 $referrer_source   = ""; 
   		 $referrer = get_option("cptn_po_referrer");
   		 if($referrer)
      	    {
	  		if(isset($referrer['s']))
   	           $referrer_keyword = $referrer['s']; 
	        if(isset($referrer['paged']))
   	           $referrer_page    = $referrer['paged'];
	        if(isset($referrer['type']))
   	     	   $referrer_source  = $referrer['type'];
   	        }




?>
		      	   <input type="hidden" name="sqlversion" value="<?php echo esc_attr($mysqlVendor." ".$mysqlVersion); ?>">

<?php if(cptn_get_textdomain(plugin_basename(__FILE__))=="wp-campation") { ?>
		      	   <input type="hidden" name="pluginurl" value="<?php echo CPTNPATH; ?>">
		      	   <input type="hidden" name="pluginversion" value="<?php echo CPTNVERSION; ?>">
<?php } elseif(cptn_get_textdomain(plugin_basename(__FILE__))=="campation-postoffice") { ?>
		      	   <input type="hidden" name="pluginurl" value="<?php echo esc_url_raw(CPTNPOPATH,wp_allowed_protocols()); ?>">
		      	   <input type="hidden" name="pluginversion" value="<?php echo CPTNPOVERSION; ?>">
		      	   <input type="hidden" name="license_type" value="<?php echo $license_type; ?>">
		      	   <input type="hidden" name="referrer_keyword" value="<?php echo $referrer_keyword; ?>">
		      	   <input type="hidden" name="referrer_page" value="<?php echo $referrer_page; ?>">
		      	   <input type="hidden" name="referrer_source" value="<?php echo $referrer_source; ?>">
		      	   <input type="hidden" name="domainprotect" value="<?php echo sanitize_text_field(get_option("cptn_po_opt_domain_protect")); ?>">
<?php } else { ?>
		      	   <input type="hidden" name="pluginurl" value="">
		      	   <input type="hidden" name="pluginversion" value="">
<?php } ?>

        		   <div class="row">
            	      <div class="col-md-6">
                	     <div class="form-group">
                            <label for="cptn_support_form_name"><?php echo htmlspecialchars_decode(esc_html__('Firstname',"campation-postoffice")); ?> *</label>
                    	  	<input id="cptn_support_form_name" type="text" name="firstname" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('Firstname',"campation-postoffice")); ?> *" required="required">
                    	  	<div class="help-block with-errors"></div>
                         </div>
                      </div>
            		  <div class="col-md-6">
                	     <div class="form-group">
                            <label for="cptn_support_form_lastname"><?php echo htmlspecialchars_decode(esc_html__('Lastname',"campation-postoffice")); ?> *</label>
                    	  	<input id="cptn_support_form_lastname" type="text" name="lastname" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('Lastname',"campation-postoffice")); ?> *" required="required">
                    	  	<div class="help-block with-errors"></div>
                         </div>
                      </div>
                   </div>

         		   <div class="row">
            		  <div class="col-md-6">
                	     <div class="form-group">
                            <label for="cptn_support_form_email"><?php echo htmlspecialchars_decode(esc_html__('Email',"campation-postoffice")); ?> *</label>
                    	  	<input id="cptn_support_form_email" type="email" name="email" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('Email address',"campation-postoffice")); ?> *" required="required" value="<?php echo esc_attr(get_option('admin_email')); ?>">
                    	  	<div class="help-block with-errors"></div>
                         </div>
                      </div>
            		  <div class="col-md-6">
                	     <div class="form-group">
                            <label for="cptn_support_form_website"><?php echo htmlspecialchars_decode(esc_html__('Website',"campation-postoffice")); ?> *</label>
                    	    <input id="cptn_support_form_website" type="text" name="website" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('Website url',"campation-postoffice")); ?> *" required="required" value="<?php echo esc_url_raw(home_url()); ?>" readonly>
                    	    <div class="help-block with-errors"></div>
                         </div>
                      </div>
                   </div>

        	       <div class="row">
            		  <div class="col-md-3">
                	     <div class="form-group">
                            <label for="cptn_support_form_area"><?php echo htmlspecialchars_decode(esc_html__('Area',"campation-postoffice")); ?> *</label>
                    	    <select id="cptn_support_form_area" name="area" class="form-control" required="required">
                        	    <option value=""><?php echo htmlspecialchars_decode(esc_html__('please select',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html__('Configuration',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html__('Configuration',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html_x('Operation','support area',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html_x('Operation','support area',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html__('Software bug',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html__('Software bug',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html__('Suggestion for improvement',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html__('Suggestion for improvement',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html_x('Pre-sale','support area',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html_x('Pre-sale','support area',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html__('License',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html__('License',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html__('Affiliation',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html__('Affiliation',"campation-postoffice")); ?></option>
                        		<option value="<?php echo htmlspecialchars_decode(esc_html__('Other',"campation-postoffice")); ?>"><?php echo htmlspecialchars_decode(esc_html__('Other',"campation-postoffice")); ?></option>
                            </select>
                            <div class="help-block with-errors"></div>
                         </div>
                      </div>
            		  <div class="col-md-9">
                	     <div class="form-group">
                            <label for="cptn_support_form_subject"><?php echo htmlspecialchars_decode(esc_html__('Subject',"campation-postoffice")); ?> *</label>
                    	    <input id="cptn_support_form_subject" type="text" name="subject" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('Subject',"campation-postoffice")); ?> *" required="required">
                    	    <div class="help-block with-errors"></div>
                         </div>
                      </div>
			       </div>		

        	       <div class="row">
            		  <div class="col-md-12">
                	     <div class="form-group">
                            <label for="cptn_support_form_message"><?php echo htmlspecialchars_decode(esc_html__('Message',"campation-postoffice")); ?> *</label>
                          	<textarea id="cptn_support_form_message" name="message" class="form-control" placeholder="<?php echo htmlspecialchars_decode(esc_html__('Message',"campation-postoffice")); ?> *" rows="5" required="required"></textarea>
                    	  	<div class="help-block with-errors"></div>
                         </div>
                      </div>
                   </div>

				   <div class="row">
            		  <div class="col-md-12">
                	     <div class="form-group">
                            <label for="cptn_support_form_attachment"><?php echo htmlspecialchars_decode(esc_html__('Attachments (screenshot etc.) - multiple select enabled',"campation-postoffice")); ?></label>
                          	<input class="form-control" type="file" id="cptn_support_form_attachment" name="attachments[]" multiple>
                    	  	<div class="help-block with-errors"></div>
                         </div>
                      </div>
                   </div>

        	       <div class="row">
            		  <div class="col-md-12">
                	     <div class="form-group">
                            <div class="form-check">
						       <input style="margin:3px 15px 0px 2px;" class="form-check-input" type="checkbox" id="cptn_support_form_technical" name="technical" value="1">
						       <label class="form-check-label" for="cptn_support_form_technical"><?php echo htmlspecialchars_decode(esc_html__('Attach technical data for support (installed plugins, error log etc.)',"campation-postoffice")); ?></label>
                            </div>
                         </div>
                    	 <div class="help-block with-errors"></div>
                      </div>
                   </div>

        	       <div class="row">
                	  <p class="text-muted"><strong>*</strong> <?php echo htmlspecialchars_decode(esc_html__('These fields are required',"campation-postoffice")); ?>.</p>
            		  <div class="col-md-12" style="text-align:center;margin-top:20px;">
            	         <div id="cptn_support_form_action" class="col-md-12" style="text-align:center;">
                	        <input style="text-align:center;" type="submit" id="cptn_support_form_save" class="button" value="<?php echo htmlspecialchars_decode(esc_html__('Send message',"campation-postoffice")); ?>">
                	        <p style="margin-top:20px;" class="text-muted"><i></strong> <?php echo htmlspecialchars_decode(esc_html__('Your input will be sent encrypted to the Campation support server',"campation-postoffice")); ?></i></p>

                         </div>
                      </div>
        	       </div>

		        </form>

	    		<div id="cptn_support_form_result" class="col-md-12" style="text-align:center;padding:5px;background-color:#208C41;color:white;border-radius:5px;display:none;">
		   		   <?php echo htmlspecialchars_decode(esc_html__('Your message was sent successfully - please watch your inbox',"campation-postoffice")); ?>
                </div>
        		<div id="cptn_support_form_error" class="col-md-12" style="text-align:center;padding:5px;background-color:#aa0000;color:white;border-radius:5px;display:none;"></div>
			 </div>
          </div>
       </div>
    </div>

<?php
      }
   }
?>