<?php
function cptn_po_cron_developer_report($dev_action="cron") 
   {      
   global $wpdb;
   $output = array();
   
   // plugin slug
   $output['slug'] = "campation-postoffice";

   // developer action
   $output['dev_action'] = $dev_action;

   // plugin referrer
   $output['referrer_keyword'] = ""; 
   $output['referrer_page'] = ""; 
   $output['referrer_source'] = ""; 
   $referrer = get_option("cptn_po_referrer");
   if($referrer)
      {
	  if(isset($referrer['s']))
   	     $output['referrer_keyword'] = $referrer['s']; 
	  if(isset($referrer['paged']))
   	     $output['referrer_page'] 	 = $referrer['paged'];
	  if(isset($referrer['type']))
   	     $output['referrer_source']  = $referrer['type'];
   	  }
   
   // Plugin Version
   $output['pluginversion'] = CPTNPOVERSION;

   // license type
   $output['license_type'] = "";
   if(cptn_po_fs()->is_trial())  
      $output['license_type'] = "trial";
   elseif(cptn_po_fs()->is_plan('business'))  
      $output['license_type'] = "business";
   elseif(cptn_po_fs()->is_plan('premium'))  
      $output['license_type'] = "premium";
   elseif(cptn_po_fs()->is_plan('starter'))  
      $output['license_type'] = "starter";
   else  
      $output['license_type'] = "free";

   // WP Version
   $output['wpversion'] = get_bloginfo('version');

   // PHP Version
   $output['phpversion'] = PHP_VERSION;

   // SQL Version
   $query = 'SHOW VARIABLES LIKE "version";';
   $versionresult = $wpdb->get_row($query,ARRAY_A);
   $mysqlVersion = $versionresult['Value']; 

   $query = 'SHOW VARIABLES LIKE "version_comment";';
   $vendorresult = $wpdb->get_row($query,ARRAY_A);
   $mysqlVendor = $vendorresult['Value']; 
   $output['sqlversion'] = $mysqlVendor." ".$mysqlVersion;

   // language
   $output['language'] = substr(get_bloginfo("language"),0,2);
   
   // first activation
   $output['activation'] = sanitize_text_field(get_option("cptn_po_opt_first_activation"));

   // first plugin_version
   $output['firstversion'] = sanitize_text_field(get_option("cptn_po_opt_first_version"));

   // assistant step
   $output['assistant_step'] = sanitize_text_field(get_option("cptn_po_opt_assistant_step"));

   // assistant status
   $output['assistant_status'] = sanitize_text_field(get_option("cptn_po_opt_assistant_status"));

   // domainprotect
   $output['domainprotect'] = sanitize_text_field(get_option("cptn_po_opt_domain_protect"));

   // throttle
   $output['throttle'] = sanitize_text_field(get_option("cptn_po_opt_throttle"));

   // throttle max
   $output['throttle_max'] = sanitize_text_field(get_option("cptn_po_opt_throttle_max_min"));

   // warmup
   $output['warmup'] = sanitize_text_field(get_option("cptn_po_opt_warmup"));

   // warmup days
   $output['warmup_days'] = sanitize_text_field(get_option("cptn_po_opt_warmup_days"));

   // warmupvolume
   $output['warmup_volume'] = sanitize_text_field(get_option("cptn_po_opt_warmup_volume"));
   
   // cron status
   $cron_delay = cptn_cron_delay("cptn_po_message_cron");
   if($cron_delay > -120)
      $output['cron'] = "OK (".$cron_delay." sec)";
   elseif($cron_delay >= -120)	  
      $output['cron'] = "DELAY (".$cron_delay." sec)";
   else	  
      $output['cron'] = "OFF";

   // MTA / rDNS status
   $query = "SELECT connectable, rdns FROM ".$wpdb->prefix."cptn_po_mailserver
	          WHERE server_type = 'spmail'
		      ";
   $server = $wpdb->get_row($query, ARRAY_A);

   if($server['connectable']==1)  
      $output['connectable'] = "OK";
   else	     
      $output['connectable'] = "ERROR";

   if($server['rdns']==1)  
      $output['rdns'] = "OK";
   else	     
      $output['rdns'] = "ERROR";


   $output['tz_server'] 	     = get_option("cptn_opt_timezone_server");
   $output['tz_website'] 	 	 = get_option("cptn_opt_timezone_staff");
   $output['speedmail_ready'] 	 = get_option("cptn_po_speedmail_ready");
   $output['check_mta'] 		 = get_option("cptn_po_check_mta")['mta'];
   $output['port_smtp'] 		 = get_option("cptn_po_check_mta")['smtp'];
   $output['port_ssl'] 		 	 = get_option("cptn_po_check_mta")['ssl'];
   $output['port_tls'] 		 	 = get_option("cptn_po_check_mta")['tls'];
   $output['mail_check'] 	 	 = get_option("cptn_po_mail_check_result")['result'];
   $output['mail_error'] 	 	 = "";
   if(isset(get_option("cptn_po_mail_check_result")['error_reason']))
      $output['mail_error'] = get_option("cptn_po_mail_check_result")['error_reason'];
   $output['mail_error_full']    = "";
   if(isset(get_option("cptn_po_mail_check_result")['error_full']))
      $output['mail_error_full'] = get_option("cptn_po_mail_check_result")['error_full'];
	  
	  
   // users
   $query = "SELECT COUNT(*) 
   		       FROM ".$wpdb->prefix."users
   		     ";
   $output['users'] = intval($wpdb->get_var($query));

   // recipients
   $query = "SELECT COUNT(*) 
   		       FROM ".$wpdb->prefix."cptn_po_recipient
   		     ";
   $output['recipients'] = intval($wpdb->get_var($query));

   // queue
   $query = "SELECT COUNT(*) 
   		       FROM ".$wpdb->prefix."cptn_po_queue
			  WHERE executed IS NOT NULL
   		     ";
   $output['queue'] = number_format($wpdb->get_var($query),0,".",",");
   
   $query = "SELECT COUNT(*) 
   		       FROM ".$wpdb->prefix."cptn_po_queue
   		     ";
   $output['queue'] .= " / ".number_format($wpdb->get_var($query),0,".",",");
   
   // mailserver
   $query = "SELECT id, server_type, address, status 
   		       FROM ".$wpdb->prefix."cptn_po_mailserver
   		     ";
   $mailservers = $wpdb->get_results($query, ARRAY_A);
   $output['mailserver'] = "<table>".PHP_EOL;;
   $output['mailserver'] .= "<tr style='background-color:#555;color:white;'><th align='left'>ID</th><th align='left'>".htmlspecialchars_decode(esc_html__("Status","campation-postoffice"))."</th><th align='left'>".htmlspecialchars_decode(esc_html__("Type","campation-postoffice"))."</th><th align='left'>".htmlspecialchars_decode(esc_html__("Address","campation-postoffice"))."</th></tr>".PHP_EOL;
   foreach($mailservers AS $mailserver)
      {
   	  $output['mailserver'] .= "<tr><td>".esc_html($mailserver['id'])."</td><td>".esc_html($mailserver['status'])."</td><td>".esc_html($mailserver['server_type'])."</td><td>".esc_html($mailserver['address'])."</td></tr>".PHP_EOL;;
	  }
   $output['mailserver'] .= "</table>".PHP_EOL;;
   
   // debug log last 100 lines with "campation"
   $output['debuglog'] = ""; 
   if(file_exists(ABSPATH."wp-content/debug.log"))
      {
	  $debuglog = fopen(ABSPATH."wp-content/debug.log", "r");
	  $i = 0;
	  while (!feof($debuglog) AND $i<100) 
	     {
   		 $line = fgets($debuglog);
		 if(strpos(strtolower($line),"campation")!==false OR strpos(strtolower($line),"cptn_")!==false)
		    {
   		    $output['debuglog'] .= sanitize_text_field($line).PHP_EOL;
	     	$i++;
			} 
		 }
      fclose($debuglog);
	  }


   // DNS
   $output['dns'] = "";
   $dns_result    = "";
   $query = "SELECT * 
   		       FROM ".$wpdb->prefix."cptn_po_sender_domain
			  WHERE status = 1 
   		     	 ";
   $domains = $wpdb->get_results($query, ARRAY_A);
   foreach($domains AS $domain)
      {
	  $domain_output = "";
	  if($domain['domain_status'] != "OK")	  
	     $domain_output .= "domain_status: ".$domain['domain_status']."<br>".PHP_EOL;
	  if(empty($domain['mx_record']))	  
	     $domain_output .= "mx_record: empty<br>".PHP_EOL;
	  if(empty($domain['spf_record']))	  
	     $domain_output .= "spf_record: empty<br>".PHP_EOL;
	  if(empty($domain['dmarc_record']))	  
	     $domain_output .= "dmarc_record: empty<br>".PHP_EOL;
	  if(empty($domain['dkim_policy']))	  
	     $domain_output .= "dkim_policy: empty<br>".PHP_EOL;

      $query = "SELECT sdm.*, ms.id, ms.address 
   		          FROM ".$wpdb->prefix."cptn_po_sender_domain_mailserver sdm
				 INNER JOIN ".$wpdb->prefix."cptn_po_mailserver ms ON ms.id = sdm.mailserver_id AND ms.status=1   
			     WHERE domain_id = ".$domain['id']."
				  AND sdm.status = 1 
   		     	 	  ";
      $servers = $wpdb->get_results($query, ARRAY_A);
	  foreach($servers AS $server)
	     {
	  	 if($server['server_status'] != "OK")	  
	        $domain_output .= "MX ".$server['id']." ".$server['address'].": server_status ".$server['server_status']."<br>".PHP_EOL;
	  	 if(empty($server['dkim_selector']))	  
	        $domain_output .= "MX ".$server['id']." ".$server['address'].": no DKIM selector<br>".PHP_EOL;
	  	 if(empty($server['dkim_record']))	  
	        $domain_output .= "MX ".$server['id']." ".$server['address'].": no DKIM record<br>".PHP_EOL;
		 }

      if($domain_output)
	     {
   	   	 $dns_result .= '<tr>'.PHP_EOL;
		 $dns_result .= '<td valign="top">'.$domain['domain'].'</td>'.PHP_EOL;
		 $dns_result .= '<td>'.$domain_output.'</td>'.PHP_EOL;
   	  	 $dns_result .= '</tr>'.PHP_EOL;
		 }
	  else	 	  
   	  	 $dns_result .= '<tr><td valign="top">'.$domain['domain']."</td><td>OK</td></tr>".PHP_EOL;
	  }

   if($dns_result)
	  {		 
   	  $output['dns'] = '<tr><td valign="top">DNS / Domains</td>'.PHP_EOL;
   	  $output['dns'] .= '<td valign=top style="font-size:11px;">'.PHP_EOL;
   	  $output['dns'] .= '<table>'.PHP_EOL;
   	  $output['dns'] .= '<tr style="background-color:#555;color:white;"><th align=left>'.htmlspecialchars_decode(esc_html__("Domain","campation-postoffice")).'</th><th align=left>'.htmlspecialchars_decode(esc_html__("Status","campation-postoffice")).'</th></tr> '.PHP_EOL;
   	  $output['dns'] .= $dns_result;
   	  $output['dns'] .= '</table>'.PHP_EOL;
      $output['dns'] .= '</td></tr>'.PHP_EOL;
	  }

   $query = "SELECT domain 
   		       FROM ".$wpdb->prefix."cptn_po_sender_domain
			  WHERE id = 1";
   $output['domain'] = $wpdb->get_var($query);

   $output['domain_site'] = site_url();

   
   // send to Campation support
   $result = wp_remote_post(CPTNSUPPORTURL."cptndeveloperdata", array(
            'method'      => 'POST',
			'sslverify'   => false,
    	 	'timeout'     => 45,
    	 	'redirection' => 5,
    	 	'httpversion' => '1.0',
    	 	'blocking'    => true,
			'referer'     => 'remote.site.com/login',
    	 	'body'        => wp_json_encode(cptn_recursive_sanitize_array($output)),
    	 	'cookies'     => array(),
			'headers' 	  => array('Content-Type' => 'application/json')			
    	 	)
         );
   if(is_wp_error($result)) error_log("Campation PostOffice developer report result: ".$result->get_error_message());
   }
?>