<?php

// minute cron to send messages
// IMPORTANT:
// all smtp servers are called via slaves of spmail - also if spmail is not activated for a domain
// The "processes" value in table ".$wpdb->prefix."cptn_po_mailserver needs to be low enough to be able to serve the processes of smtp servers, too
// e.g.: the "spmail" mailserver could run 20 processes but we have 5 "smtp" mailserver with 1 process each
// -> value "processes" for mailserver "spmail" should be set to 15 (+5x1 process smtp server)
//
// smtp server is used last - after all spmail/remote server capacity is used
function cptn_po_cron_message_send()
{
    global  $wpdb ;
    if ( $wpdb->get_var( "SHOW TABLES LIKE '" . $wpdb->prefix . "cptn_po_sender_domain'" ) != $wpdb->prefix . "cptn_po_sender_domain" ) {
        wp_die();
    }
    if ( $wpdb->get_var( "SHOW TABLES LIKE '" . $wpdb->prefix . "cptn_po_mailserver'" ) != $wpdb->prefix . "cptn_po_mailserver" ) {
        wp_die();
    }
    if ( $wpdb->get_var( "SHOW TABLES LIKE '" . $wpdb->prefix . "cptn_po_sender_domain_mailserver'" ) != $wpdb->prefix . "cptn_po_sender_domain_mailserver" ) {
        wp_die();
    }
    if ( $wpdb->get_var( "SHOW TABLES LIKE '" . $wpdb->prefix . "cptn_po_queue'" ) != $wpdb->prefix . "cptn_po_queue" ) {
        wp_die();
    }
    $slavemaxmails = 100;
    // max mails per slave job
    $slaveminmails = 10;
    // min mails per slave job before starting a new slave
    $startscript = intval( microtime( true ) );
    cptn_po_update_option( "cptn_po_message_cron", $startscript );
    while ( $startscript >= intval( cptn_po_get_option( "cptn_po_message_cron" ) ) and intval( cptn_po_get_option( "cptn_po_cron_running" ) ) == 1 ) {
        // was email blocked by Admin?
        if ( intval( cptn_po_get_option( "cptn_po_opt_email_blocked" ) ) == 1 ) {
            break;
        }
        // error_log(cptn_cron_delay("cptn_po_message_cron")." ".(-cptn_cron_delay("cptn_po_message_cron") % 300)." ".cptn_po_get_option("cptn_po_message_cron"));
        // wp-cron has not been executed for 5 minutes - restart wp-cron.php
        
        if ( -cptn_cron_delay( "cptn_po_message_cron" ) % 300 > 296 ) {
            add_filter( 'use_curl_transport', '__return_false' );
            add_filter( 'use_streams_transport', '__return_false' );
            $cron_url = esc_url( site_url( "/", "https" ) . 'wp-cron.php?doing_wp_cron' );
            wp_remote_post( $cron_url, array(
                'timeout'  => 0.01,
                'blocking' => false,
            ) );
            break;
            // and finish this one
        }
        
        // set all emails to embargo where we find too many mails for recipient domain e.g. gmail.com #################################
        // alternativ: in Query je domain/server Summe freier Mails abfragen bei Limit
        // select all domains to loop through with domain related mailservers
        $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t         WHERE domain_status = 'OK' \r\n\t\t\t\t   AND status=1\r\n\t\t\t    ";
        $domains = $wpdb->get_results( $query, ARRAY_A );
        if ( $wpdb->last_error ) {
            error_log( $wpdb->last_error );
        }
        
        if ( $domains ) {
            foreach ( $domains as $domain ) {
                // loop through all sender domains
                if ( intval( cptn_po_get_option( "cptn_po_opt_email_blocked" ) ) == 1 or intval( cptn_po_get_option( "cptn_po_cron_running" ) ) != 1 ) {
                    wp_die();
                }
                // select all messages that are to be sent for this domain and do not have a "slave"
                $query = "SELECT cpq.*, cpsd.envelope_address  \r\n               \t        FROM " . $wpdb->prefix . "cptn_po_queue cpq\r\n                  INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain cpsd  ON cpsd.id = cpq.sender_domain_id\r\n\t\t               WHERE (UNIX_TIMESTAMP(cpq.embargo) <= UNIX_TIMESTAMP(NOW()) OR cpq.embargo IS NULL)\r\n\t\t\t             AND cpq.slave IS NULL \r\n\t\t\t        \t AND cpq.executed IS NULL\r\n\t\t\t\t    \t AND cpq.sender_domain_id = " . $domain['id'] . "\r\n\t\t\t\t\t     AND EXISTS (SELECT id FROM " . $wpdb->prefix . "cptn_po_recipient cpr WHERE cpr.id = cpq.recipient_id AND cpr.status = 1 AND cpr.recipient_status = 'OK' AND (cpr.embargo IS NULL OR UNIX_TIMESTAMP(cpr.embargo) <= UNIX_TIMESTAMP(NOW())))\r\n\t\t\t\t\t     AND EXISTS (SELECT id FROM " . $wpdb->prefix . "cptn_po_sender_domain cpsd WHERE cpsd.id = cpq.sender_domain_id AND cpsd.domain_status = 'OK' AND cpsd.status=1)\r\n\t\t\t\t\t\t AND cpq.errors <= " . CPTN_PO_MAXRETRIES . "\r\n\t\t\t\t\t   ORDER BY priority DESC\r\n\t\t\t\t\t\t ";
                $mailstosend = $wpdb->get_results( $query, ARRAY_A );
                if ( $wpdb->last_error ) {
                    error_log( $wpdb->last_error );
                }
                if ( !$mailstosend ) {
                    continue;
                }
                // next domain
                $total_mails = count( $mailstosend );
                // select allowed processes for the sender domain on all servers
                $query = "SELECT ms.*, cpsd.id AS domain_id, cpsd.domain, cpsd.mailcategory, cpsd.envelope_address, sdms.dkim_selector, sdms.dkim_private_key, sdms.dkim_public_key,\r\n\t\t\t                 (SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_slave WHERE mailserver_id = sdms.id AND start IS NOT NULL AND executed IS NULL) AS slaves_used,\r\n\t\t\t\t\t\t\t ms.processes - (SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_slave WHERE mailserver_id = sdms.id AND start IS NOT NULL AND executed IS NULL) AS free_processes   \r\n                        FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdms\r\n                       INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdms.mailserver_id\r\n\t\t\t  \t\t   INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain cpsd ON cpsd.id = sdms.domain_id \t \r\n\t\t               WHERE sdms.domain_id = " . $domain['id'] . "\r\n\t\t\t\t\t     AND sdms.status = 1\r\n\t\t\t\t         AND sdms.server_status = 'OK'\r\n\t\t\t\t   \t\t AND ms.status = 1\r\n\t\t\t\t   \t\t AND ms.connectable = 1\r\n\t\t\t\t\t\t AND ms.processes > 0\r\n\t\t\t\t\t\t AND IF(ms.contingent>0,IF(ms.contingent>ms.contingent_used OR ms.contingent_exceed=1,true,false),true)\r\n\t\t\t\t\t   ORDER BY IF(server_type='smtp',99,IF(server_type='remote',50,0)) ASC\r\n\t\t\t\t\t   ";
                $allservers = $wpdb->get_results( $query, ARRAY_A );
                if ( $wpdb->last_error ) {
                    error_log( $wpdb->last_error );
                }
                // how many possible processes do we have total ?
                $free_processes = 0;
                foreach ( $allservers as $server ) {
                    $free_processes += $server['free_processes'];
                }
                // we now have the available processes on local, smtp and remote servers
                
                if ( $free_processes > 0 ) {
                    // we have domain, emails to send and available mailserver capacity  - distribute all mails!
                    // how many mails do we put into every process?
                    
                    if ( $total_mails <= $slaveminmails ) {
                        // few mails, only 1 new slave
                        $slavenew = 1;
                    } else {
                        // n new slaves with at least $slaveminmails
                        $slavenew = intval( $total_mails / $slaveminmails ) + 1;
                        if ( $slavenew > $free_processes ) {
                            // more slaves than allowed
                            $slavenew = $free_processes;
                        }
                    }
                    
                    // calculate how many messages to send by each slave
                    $mailsperjob = intval( $total_mails / $slavenew ) + 1;
                    if ( $mailsperjob > $slavemaxmails ) {
                        $mailsperjob = $slavemaxmails;
                    }
                    if ( $mailsperjob < $slaveminmails ) {
                        $mailsperjob = $slaveminmails;
                    }
                    if ( $mailsperjob < 1 ) {
                        $mailsperjob = 1;
                    }
                    // distribute all mails on slaves
                    $newslaves = 0;
                    $messages_sent = 0;
                    foreach ( $allservers as $server ) {
                        for ( $i = 1 ;  $i <= $server['free_processes'] ;  $i++ ) {
                            // create new slave type spmail or remote
                            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_slave\r\n\t\t\t\t                  SET mailserver_id = " . $server['id'] . ",\r\n\t\t\t\t\t\t\t          server_type = '" . esc_sql( $server['server_type'] ) . "',\r\n\t\t\t\t\t\t\t\t\t  created = NOW()\r\n\t\t\t\t\t\t\t\t\t  ";
                            $wpdb->query( $query );
                            $slave_id = $wpdb->insert_id;
                            // limit jobs to left contingent of SMTP server
                            
                            if ( $server['server_type'] == "smtp" and $server['contingent'] > 0 and $server['contingent'] - $server['contingent_used'] < $mailsperjob ) {
                                $jobcount = $server['contingent'] - $server['contingent_used'];
                            } elseif ( $server['server_type'] == "smtp" and $server['contingent'] > 0 and $server['contingent'] - $server['contingent_used'] <= 0 ) {
                                $jobcount = 0;
                            } else {
                                $jobcount = $mailsperjob;
                            }
                            
                            // mark mails as task for this slave		- if message is one of the few retries the same mailserver as before has to be used, we ignore contingent
                            $createdjobs = 0;
                            // for-loop needed for mailthrottle to run query for each mail
                            for ( $queuecount = 1 ;  $queuecount <= $jobcount ;  $queuecount++ ) {
                                $query = "UPDATE " . $wpdb->prefix . "cptn_po_queue cpq\r\n\t\t\t\t\t\t\t       INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver cpms ON cpms.id = IF(cpq.retry = 0," . $server['id'] . ", cpq.mailserver)  \t\t\t\t\t\t\t\t\t  \r\n\t\t\t\t\t\t\t       INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver_mxdomain cpmx ON cpmx.mailserver = IF(cpq.retry = 0," . $server['id'] . ", cpq.mailserver) AND cpmx.mxdomain = cpq.recipient_domain \t\t  \t\t\t\t\t\t\t\t\t  \r\n\t\t\t\t         \t         SET cpq.slave = " . $slave_id . ",\r\n\t\t\t\t\t\t\t\t      \t cpq.mailserver = IF(cpq.retry = 0," . $server['id'] . ", cpq.mailserver),\r\n\t\t\t\t\t\t\t\t\t  \t cpms.warmup_sent = cpms.warmup_sent+1,\r\n\t\t\t\t\t\t\t\t\t  \t cpms.contingent_used = IF(cpms.contingent>0,cpms.contingent_used+1,cpms.contingent_used),\r\n\t\t\t\t\t\t\t\t\t  \t cpmx.minute_sent = cpmx.minute_sent+1,\r\n\t\t\t\t\t\t\t\t\t  \t cpmx.total_sent = cpmx.total_sent+1 \r\n\t\t               \t\t       WHERE (UNIX_TIMESTAMP(cpq.embargo) <= UNIX_TIMESTAMP(NOW()) OR cpq.embargo IS NULL)\r\n\t\t\t    \t     \t   \t     AND cpq.slave IS NULL \r\n\t\t\t    \t     \t   \t  \t AND (cpq.mailserver IS NULL OR cpq.mailserver = " . $server['id'] . ") \r\n\t\t\t             \t   \t  \t AND cpq.executed IS NULL\r\n\t\t\t\t    \t\t   \t  \t AND cpq.sender_domain_id = " . $domain['id'] . "\r\n\t\t\t\t\t     \t\t  \t AND EXISTS (SELECT cpr.id FROM " . $wpdb->prefix . "cptn_po_recipient cpr WHERE cpr.id = cpq.recipient_id AND cpr.status = 1 AND cpr.recipient_status = 'OK' AND (cpr.embargo IS NULL OR UNIX_TIMESTAMP(cpr.embargo) <= UNIX_TIMESTAMP(NOW())))\r\n\t\t\t\t\t     \t   \t  \t AND EXISTS (SELECT cpsd.id FROM " . $wpdb->prefix . "cptn_po_sender_domain cpsd WHERE cpsd.id = cpq.sender_domain_id AND cpsd.domain_status = 'OK' AND cpsd.status=1)\r\n\t\t\t\t\t\t\t\t  \t AND cpq.errors <= " . CPTN_PO_MAXRETRIES . "\r\n\t\t\t\t\t\t\t\t  \t ";
                                $query .= " ORDER BY cpq.priority DESC  \r\n\t\t\t\t\t         \t    LIMIT 1";
                                if ( $wpdb->query( $query ) ) {
                                    $createdjobs++;
                                }
                            }
                            
                            if ( $createdjobs ) {
                                // collect data for slave
                                $starttime = microtime( true );
                                // select all mails with slave = id
                                $query = "SELECT cpq.*, cpsd.envelope_address, cpsd.unsubscribe_address  \r\n               \t\t\t            FROM " . $wpdb->prefix . "cptn_po_queue cpq\r\n              \t\t\t\t\t   INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain cpsd  ON cpsd.id = cpq.sender_domain_id\r\n\t\t      \t\t\t\t\t   WHERE cpq.slave = " . $slave_id . " \r\n\t\t\t    \t\t\t\t     AND cpq.mailserver = " . $server['id'] . " \r\n\t\t\t    \t\t\t\t\t AND (UNIX_TIMESTAMP(cpq.embargo) <= UNIX_TIMESTAMP(NOW()) OR cpq.embargo IS NULL)\r\n\t\t\t    \t\t\t\t\t AND cpq.executed IS NULL\r\n\t\t\t\t\t\t\t\t\t AND cpsd.domain_status = 'OK'\r\n\t\t\t\t\t\t\t\t\t AND cpsd.status = 1\r\n\t\t\t\t\t\t\t\t\t AND cpq.errors <= " . CPTN_PO_MAXRETRIES . "\r\n\t\t\t  \t\t\t\t\t   ORDER BY cpq.priority DESC\t\r\n\t\t\t   \t\t\t\t\t   ";
                                $messages_slave = $wpdb->get_results( $query, ARRAY_A );
                                
                                if ( $messages_slave ) {
                                    $mailstart = microtime( true );
                                    $messagesout = array();
                                    foreach ( $messages_slave as $message_slave ) {
                                        $message_slave['domain_id'] = $domain['id'];
                                        
                                        if ( strpos( $message_slave['headers'], "text/plain" ) === false ) {
                                            $is_html_mail = true;
                                        } else {
                                            $is_html_mail = false;
                                        }
                                        
                                        if ( $message_slave['attachments'] ) {
                                            $message_slave['attachments'] = json_decode( $message_slave['attachments'], true );
                                        }
                                        $message_slave['headers'] = json_decode( $message_slave['headers'], true );
                                        $message_slave['headers'][] = "X-Campation-PO: " . $message_slave['id'];
                                        // id from cptn_po_queue
                                        if ( $message_slave['mailcategory'] == "bulk" or $message_slave['mailcategory'] == "cold" or $message_slave['mailcategory'] == "marke" ) {
                                            $message_slave['headers'][] = "Precedence: bulk";
                                        }
                                        // we need a lowercase </body>
                                        $message_slave['mail_content'] = str_replace( "</BODY>", "</body>", $message_slave['mail_content'] );
                                        $message_slave['mail_content'] = str_replace( "</BODY/>", "</body>", $message_slave['mail_content'] );
                                        $message_slave['mail_content'] = str_replace( "</BODY />", "</body>", $message_slave['mail_content'] );
                                        $message_slave['mail_content'] = str_replace( "</Body>", "</body>", $message_slave['mail_content'] );
                                        $message_slave['mail_content'] = str_replace( "</Body/>", "</body>", $message_slave['mail_content'] );
                                        $message_slave['mail_content'] = str_replace( "</Body />", "</body>", $message_slave['mail_content'] );
                                        // add open image
                                        
                                        if ( $is_html_mail and !empty($message_slave['mail_content']) ) {
                                            $openimage = '<img style="margin-top:20px;width:100%;" src="' . esc_url_raw( get_home_url() . '/cptnmaildesign-' . esc_attr( $message_slave['id'] ) ) . '.png" loading="eager" alt="">';
                                            
                                            if ( strpos( strtolower( $message_slave['mail_content'] ), "</body>" ) !== false ) {
                                                $message_slave['mail_content'] = str_replace( "</body>", PHP_EOL . "<br><br>" . $openimage . PHP_EOL . "</body>", $message_slave['mail_content'] );
                                            } else {
                                                $message_slave['mail_content'] .= PHP_EOL . $openimage . PHP_EOL;
                                            }
                                        
                                        }
                                        
                                        // add affiliate footer
                                        
                                        if ( $is_html_mail and intval( get_option( "cptn_po_opt_affiliate_footer" ) ) == 1 and !empty(esc_html( get_option( "cptn_po_opt_affiliate_id" ) )) ) {
                                            $affiliate_footer = '<br><br><center><small>' . htmlspecialchars_decode( esc_html__( "Sent with love by", "campation-postoffice" ) ) . ' <a href="' . CPTNPOAFFILIATEURL . esc_html( get_option( "cptn_po_opt_affiliate_id" ) ) . '">WP Campation PostOffice</a>&trade;</small></center>';
                                            
                                            if ( strpos( strtolower( $message_slave['mail_content'] ), "</body>" ) !== false ) {
                                                $message_slave['mail_content'] = str_replace( '</body>', PHP_EOL . '<!-- affiliate footer -->' . PHP_EOL . $affiliate_footer . PHP_EOL . "</body>", $message_slave['mail_content'] );
                                            } else {
                                                $message_slave['mail_content'] .= PHP_EOL . '<!-- affiliate footer -->' . PHP_EOL . $affiliate_footer . PHP_EOL;
                                            }
                                        
                                        }
                                        
                                        // add 2 final empty lines
                                        if ( $is_html_mail ) {
                                            
                                            if ( strpos( strtolower( $message_slave['mail_content'] ), "</body>" ) !== false ) {
                                                $message_slave['mail_content'] = str_replace( "</body>", PHP_EOL . "<br><br>" . PHP_EOL . "</body>", $message_slave['mail_content'] );
                                            } else {
                                                $message_slave['mail_content'] .= PHP_EOL . "<br><br>" . PHP_EOL;
                                            }
                                        
                                        }
                                        $message_slave['from_email'] = apply_filters( 'wp_mail_from', $message_slave['from_email'] );
                                        $message_slave['from_name'] = apply_filters( 'wp_mail_from_name', $message_slave['from_name'] );
                                        $message_slave['bcc_email'] = "";
                                        if ( esc_html( get_option( 'cptn_po_opt_email_bcc' ) ) and $message_slave['mailcategory'] == "trans" ) {
                                            $message_slave['bcc_email'] = esc_html( get_option( 'cptn_po_opt_email_bcc' ) );
                                        }
                                        $subject = $message_slave['mail_subject'];
                                        $messages = $message_slave['mail_content'];
                                        $headers = $message_slave['headers'];
                                        $attachments = $message_slave['attachments'];
                                        $atts = apply_filters( 'wp_mail', compact(
                                            'subject',
                                            'messages',
                                            'headers',
                                            'attachments'
                                        ) );
                                        if ( isset( $atts['subject'] ) ) {
                                            $message_slave['mail_subject'] = $atts['subject'];
                                        }
                                        if ( isset( $atts['message'] ) ) {
                                            $message_slave['mail_content'] = $atts['messages'];
                                        }
                                        if ( isset( $atts['headers'] ) ) {
                                            $message_slave['headers'] = $atts['headers'];
                                        }
                                        if ( isset( $atts['attachments'] ) ) {
                                            $message_slave['attachments'] = $atts['attachments'];
                                        }
                                        // add subject marker
                                        if ( $message_slave['mailcategory'] == "alert" ) {
                                            $message_slave['mail_subject'] = "❌ " . $message_slave['mail_subject'];
                                        }
                                        if ( $message_slave['mailcategory'] == "report" ) {
                                            $message_slave['mail_subject'] = "▶ " . $message_slave['mail_subject'];
                                        }
                                        if ( $message_slave['mailcategory'] == "test" ) {
                                            $message_slave['mail_subject'] = "✅ " . $message_slave['mail_subject'];
                                        }
                                        if ( $message_slave['mailcategory'] == "support" ) {
                                            $message_slave['mail_subject'] = "✅ " . $message_slave['mail_subject'];
                                        }
                                        $messagesout[] = $message_slave;
                                    }
                                    // start slave
                                    $query = "UPDATE " . $wpdb->prefix . "cptn_po_slave\r\n\t\t\t\t      \t                SET start = NOW(),\r\n\t\t\t\t\t\t\t\t\t     \tmails = " . $createdjobs . "\r\n\t\t\t\t\t                  WHERE id = " . $slave_id;
                                    $wpdb->query( $query );
                                    // call slave url
                                    cptn_po_start_message_slave(
                                        $slave_id,
                                        $createdjobs,
                                        $server,
                                        $messagesout
                                    );
                                    $newslaves++;
                                    $messages_sent += $createdjobs;
                                    if ( $newslaves >= $slavenew ) {
                                        break 2;
                                    }
                                }
                            
                            }
                        
                        }
                    }
                }
                
                // end "we have mail server capacity - send all mails for one domain"
            }
            // end loop throug all domains
        }
        
        // end "select domains with mail server"
        if ( $startscript < intval( cptn_po_get_option( "cptn_po_message_cron" ) ) ) {
            // new process was started by WP cron
            break;
        }
        sleep( 3 );
    }
    // main loop every 3 seconds for 55 seconds
    wp_die();
}

// start a new local / remote message slave for $mailsperjob mails
function cptn_po_start_message_slave(
    $slave_id,
    $createdjobs,
    $server,
    $messages
)
{
    global  $wpdb ;
    // there are real messages left to send
    
    if ( count( $messages ) > 0 ) {
        
        if ( $server['server_type'] !== "remote" ) {
            $url = esc_url( home_url( "/", "https" ) . "cptnpomessageslave" );
        } else {
            $url = esc_url( $server['plugin_url'] . 'webhook/remote-slave.php' );
        }
        
        $slavearray = array(
            'slave_id'    => $slave_id,
            'server'      => $server,
            'createdjobs' => $createdjobs,
            'messages'    => json_encode( $messages ),
            'server'      => json_encode( $server ),
            'secretkey'   => get_option( "cptn_po_scret_key" ),
        );
        $starttime = microtime( true );
        $output = wp_remote_post( $url, array(
            'method'      => 'POST',
            'sslverify'   => false,
            'timeout'     => 1,
            'redirection' => 5,
            'httpversion' => '1.0',
            'blocking'    => false,
            'headers'     => array(),
            'body'        => $slavearray,
            'cookies'     => array(),
        ) );
    }

}
