<?php
// minute cron check new recipients email addresses: well formed, have MX record?
// recipient_status can be
// - OK = email address technically ok
// - MALF = malformed email address
// - NOMX = No MX Server in DNS found for Email address
// - BOUNCE = Email was returned to ReturnPah with error (not set by this script)
// - UNSUB = unsubscribed (not set by this script)
// - INACT = inactive - rules of InaGuard


function cptn_po_cron_recipient_check($recipient_id=0) 
   {      
   global $wpdb;

   if($wpdb->get_var("SHOW TABLES LIKE '".$wpdb->prefix."cptn_po_recipient'") != $wpdb->prefix."cptn_po_recipient") wp_die();

   $startscript = intval(microtime(true));
   cptn_po_update_option("cptn_po_recipient_cron",$startscript);

   while($startscript >= intval(cptn_po_get_option("cptn_po_recipient_cron")) AND intval(cptn_po_get_option("cptn_po_cron_running"))==1)
      {
	  // was email blocked by Admin?
	  if(intval(cptn_po_get_option("cptn_po_opt_email_blocked"))==1)  break;

	  
   	  $query = "SELECT * FROM ".$wpdb->prefix."cptn_po_recipient
			   	 ";
      if($recipient_id)
	     $query .= " WHERE id = ".$recipient_id;
	  else
	     $query .= " WHERE recipient_status IS NULL";
      $recipients = $wpdb->get_results($query, ARRAY_A);
      if($recipients)
	     {
         foreach($recipients AS $recipient)
            {
			$starttime = microtime(true);	  
			$recipient_status = "";
			$mxhost = "";
			
			if(!filter_var($recipient['recipient_email'], FILTER_VALIDATE_EMAIL))        // mal formed email address
   	           $recipient_status = "MALF";
			else
			   {
        	   $mxhosts = array(); 
        	   $mxweights = array(); 
        	   if (getmxrr($recipient['domain'], $mxhosts, $mxweights) === FALSE)           // no MX record
   	              $recipient_status = "NOMX";
               else					  		 	 		   			   	   					// email address technically ok                                                                
			      $recipient_status = "OK";
			   }

            $query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
	                     SET recipient_status = '".esc_sql($recipient_status)."'
			           WHERE id = ".$recipient['id'];  
   	        $wpdb->query($query);

            // check if relation mailserver-mxdomain is already known
	  		$query = "SELECT id 
                        FROM ".$wpdb->prefix."cptn_po_mailserver ms
                       WHERE NOT EXISTS (SELECT * FROM ".$wpdb->prefix."cptn_po_mailserver_mxdomain WHERE mxdomain = '".esc_sql($recipient['domain'])."' AND mailserver = ms.id)
					   ORDER BY id
					   "; 
   	        $missing = $wpdb->get_results($query, ARRAY_A);
			foreach($missing AS $toadd)
			   {
			   $query = "INSERT INTO ".$wpdb->prefix."cptn_po_mailserver_mxdomain
			   		  	    SET mailserver = ".$toadd['id'].",
							    mxdomain = '".esc_sql($recipient['domain'])."',
								minute_allowed = ".get_option("cptn_po_opt_throttle_max_min")."
								";
   	           $wpdb->query($query);
			   }


			}
	     }
		 

      if($recipient_id)
	     break;	 
      else
	     {
      	 if($startscript < intval(cptn_po_get_option("cptn_po_recipient_cron")))         // new process was started by WP cron
	        break;
         sleep(3);
		 }
	  }
   }
?>