<?php
// 15min update of all averages and best times / DOW

function cptn_po_cron_update_statistics() 
   {      
   global $wpdb;

   if($wpdb->get_var("SHOW TABLES LIKE '".$wpdb->prefix."cptn_po_recipient'") != $wpdb->prefix."cptn_po_recipient") wp_die();
      
   if(!intval(get_option("cptn_po_opt_statistics_days")>0)) 
      update_option("cptn_po_opt_statistics_days","30");
   
   // get average open delay of recipient
   $query = "SELECT recipient_id, 
   		  			AVG( UNIX_TIMESTAMP(opened) - UNIX_TIMESTAMP(executed) ) AS avg,
   		  			MAX(opened) AS last_opened
               FROM ".$wpdb->prefix."cptn_po_queue
              WHERE opened IS NOT NULL
		        AND executed IS NOT NULL
			  GROUP BY recipient_id
				  ";
   $recipients = $wpdb->get_results($query,ARRAY_A);
   foreach($recipients AS $recipient)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
	               SET open_delay = ".$recipient['avg'].",
				       last_opened = '".esc_sql($recipient['last_opened'])."'
				 WHERE id = ".$recipient['recipient_id'];   
      $wpdb->query($query);
	  }				  	  		 


   // get average click delay of recipient
   $query = "SELECT recipient_id, 
   		            AVG( UNIX_TIMESTAMP(clicked) - UNIX_TIMESTAMP(executed) ) AS avg,
   		  			MAX(clicked) AS last_clicked 
	           FROM ".$wpdb->prefix."cptn_po_queue
	          WHERE clicked IS NOT NULL
		        AND executed IS NOT NULL
			  GROUP BY recipient_id
				  ";	  		 
   $recipients = $wpdb->get_results($query,ARRAY_A);
   foreach($recipients AS $recipient)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
	               SET click_delay = ".$recipient['avg'].",
				       last_clicked = '".esc_sql($recipient['last_clicked'])."'
				 WHERE id = ".$recipient['recipient_id'];   
      $wpdb->query($query);
	  }				  	  		 


   // this has to be redone - see mail to Timo 1.12.2021 ################################
   // get last click / open hour of recipient
   $query = "SELECT q.recipient_id, 
       	            (SELECT ROUND(HOUR(clicked)) FROM ".$wpdb->prefix."cptn_po_queue WHERE recipient_id = q.recipient_id AND clicked IS NOT NULL ORDER BY id DESC LIMIT 1) AS best_time_click, 
       				(SELECT ROUND(HOUR(opened)) FROM ".$wpdb->prefix."cptn_po_queue WHERE recipient_id = q.recipient_id AND opened IS NOT NULL ORDER BY id DESC LIMIT 1) AS best_time_open
	           FROM ".$wpdb->prefix."cptn_po_queue q
		      WHERE (q.opened IS NOT NULL OR q.clicked IS NOT NULL)
			    AND q.executed IS NOT NULL
			  GROUP BY q.recipient_id
				  ";	  		 
   $recipients = $wpdb->get_results($query,ARRAY_A);
   foreach($recipients AS $recipient)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
	               SET best_time_open = '".esc_sql($recipient['best_time_open'])."',
	                   best_time_click = '".esc_sql($recipient['best_time_click'])."'
				 WHERE id = ".$recipient['recipient_id'];   
      $wpdb->query($query);
	  }				  	  		 

	  
   // update countable data domain	  
   $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
	            SET mails_sent = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain.id),
					mails_error = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE errors>0 AND errors < 9999 AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain.id),
					mails_opened = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND opened IS NOT NULL AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain.id),
					mails_unsubscribed = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND unsubscribed = 1 AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain.id),
					mails_clicked = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND clicked IS NOT NULL AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain.id),
					mails_bounced = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND errors=9999 AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain.id)
					";   
   $wpdb->query($query);
	  
				  
   // update countable data mailserver	  
   $query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
	            SET sent = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND mailserver = ".$wpdb->prefix."cptn_po_mailserver.id),
					errors = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE errors>0 AND errors < 9999 AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND mailserver = ".$wpdb->prefix."cptn_po_mailserver.id),
					opened = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND opened IS NOT NULL AND mailserver = ".$wpdb->prefix."cptn_po_mailserver.id),
					unsubscribed = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND unsubscribed = 1 AND mailserver = ".$wpdb->prefix."cptn_po_mailserver.id),
					clicked = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND clicked IS NOT NULL AND mailserver = ".$wpdb->prefix."cptn_po_mailserver.id),
					bounced = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND errors=9999 AND mailserver = ".$wpdb->prefix."cptn_po_mailserver.id)
					";   
   $wpdb->query($query);


   // update countable data domain-mailserver	  
   $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain_mailserver
	            SET mails_sent = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND mailserver = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.mailserver_id  AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.domain_id),
					mails_error = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE errors>0 AND errors < 9999 AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND mailserver = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.mailserver_id  AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.domain_id),
					mails_opened = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND opened IS NOT NULL AND mailserver = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.mailserver_id  AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.domain_id),
					mails_unsubscribed = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND unsubscribed = 1 AND mailserver = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.mailserver_id  AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.domain_id),
					mails_clicked = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND clicked IS NOT NULL AND mailserver = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.mailserver_id  AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.domain_id),
					mails_bounced = (SELECT COUNT(*) FROM ".$wpdb->prefix."cptn_po_queue WHERE executed IS NOT NULL AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day) AND errors=9999 AND mailserver = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.mailserver_id  AND sender_domain_id = ".$wpdb->prefix."cptn_po_sender_domain_mailserver.domain_id)
					";   
   $wpdb->query($query);




   // get average open delay of domain last month
   $query = "SELECT sender_domain_id, AVG( UNIX_TIMESTAMP(opened) - UNIX_TIMESTAMP(executed) ) AS avg
               FROM ".$wpdb->prefix."cptn_po_queue
              WHERE opened IS NOT NULL
		        AND executed IS NOT NULL
				AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day)
			  GROUP BY sender_domain_id
				  ";
   $domains = $wpdb->get_results($query,ARRAY_A);
   foreach($domains AS $domain)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
	               SET open_delay = ".$domain['avg']."
				 WHERE id = ".$domain['sender_domain_id'];   
      $wpdb->query($query);
	  }				  	  		 


   // get average click delay of domain last month
   $query = "SELECT sender_domain_id, AVG( UNIX_TIMESTAMP(clicked) - UNIX_TIMESTAMP(executed) ) AS avg 
	           FROM ".$wpdb->prefix."cptn_po_queue
	          WHERE clicked IS NOT NULL
		        AND executed IS NOT NULL
				AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day)
			  GROUP BY sender_domain_id
				  ";	  		 
   $domains = $wpdb->get_results($query,ARRAY_A);
   foreach($domains AS $domain)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
	               SET click_delay = ".$domain['avg']."
				 WHERE id = ".$domain['sender_domain_id'];   
      $wpdb->query($query);
	  }				  	  		 


   // get average open hour of domain last month
   $query = "SELECT sender_domain_id, ROUND(AVG(HOUR(opened))) AS best_time_open 
	           FROM ".$wpdb->prefix."cptn_po_queue
		      WHERE opened IS NOT NULL
			    AND executed IS NOT NULL
				AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day)
			  GROUP BY sender_domain_id
				  ";	  		 
   $domains = $wpdb->get_results($query,ARRAY_A);
   foreach($domains AS $domain)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
	               SET best_time_open = ".$domain['best_time_open']."
				 WHERE id = ".$domain['sender_domain_id'];   
      $wpdb->query($query);
	  }				  	  		 
   // get average click hour of domain last month
   $query = "SELECT sender_domain_id, ROUND(AVG(HOUR(clicked))) AS best_time_click 
	           FROM ".$wpdb->prefix."cptn_po_queue
		      WHERE clicked IS NOT NULL
			    AND executed IS NOT NULL
				AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day)
			  GROUP BY sender_domain_id
				  ";	  		 
   $domains = $wpdb->get_results($query,ARRAY_A);
   foreach($domains AS $domain)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
	               SET best_time_click = '".esc_sql($domain['best_time_click'])."'
				 WHERE id = ".$domain['sender_domain_id'];   
      $wpdb->query($query);
	  }				  	  		 

				  
   // get average click DOW of domain - 1=Sunday - last month
   $query = "SELECT sender_domain_id, ROUND(AVG(DAYOFWEEK(opened))) AS avg 
	           FROM ".$wpdb->prefix."cptn_po_queue
	          WHERE opened IS NOT NULL
			    AND executed IS NOT NULL
				AND executed >= DATE_SUB(NOW(), INTERVAL ".esc_html(get_option("cptn_po_opt_statistics_days"))." day)
			  GROUP BY sender_domain_id
				  ";	  		 
   $domains = $wpdb->get_results($query,ARRAY_A);
   foreach($domains AS $domain)
      {
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
	               SET best_dow = ".$domain['avg']."
				 WHERE id = ".$domain['sender_domain_id'];   
      $wpdb->query($query);
	  }				  	  		 


						  
   }
   
   
?>