<?php

// close connection early, but keep executing script
// https://stackoverflow.com/a/141026/5157195
// ob_end_clean();
add_action( 'template_redirect', 'cptn_po_message_slave_url', -99 );
function cptn_po_message_slave_url()
{
    global  $wpdb, $wp_query ;
    // check for pseudo url
    
    if ( $wp_query->is_404() ) {
        $code = trim( substr( parse_url( esc_url_raw( $_SERVER["REQUEST_URI"] ), PHP_URL_PATH ), 1, 1000 ) );
        // leading slash
        if ( substr( $code, strlen( $code ) - 1, 1 ) == "/" ) {
            // trailing slash
            $code = substr( $code, 0, -1 );
        }
        
        if ( ($code == "cptnpomessageslave" or trim( substr( $code, 0, strpos( $code, "?" ) ) ) == "cptnpomessageslave") and isset( $_POST['secretkey'] ) and $_POST['secretkey'] == get_option( "cptn_po_scret_key" ) ) {
            status_header( 200 );
            $slave_id = intval( $_POST['slave_id'] );
            $createdjobs = intval( $_POST['createdjobs'] );
            $messages = json_decode( stripslashes( $_POST['messages'] ), true );
            $server = cptn_recursive_sanitize_array( json_decode( stripslashes( $_POST['server'] ), true ) );
            $server_id = $server['id'];
            header( "Connection: close" );
            ignore_user_abort( true );
            ob_start();
            echo  'xxx' ;
            $size = ob_get_length();
            header( "Content-Length: {$size}" );
            header( "Content-Encoding: none" );
            ob_end_flush();
            flush();
            // connection is closed at this point
            // start actual processing here
            
            if ( $slave_id and $createdjobs ) {
                
                if ( $messages ) {
                    $output = array();
                    foreach ( $messages as $message ) {
                        $mailstart = microtime( true );
                        // send mail through cptn_po_send_one_mail()
                        $result = json_decode( cptn_po_send_one_mail(
                            $message['from_email'],
                            $message['from_name'],
                            $message['mail_subject'],
                            $message['to_email'],
                            $message['to_name'],
                            $message['mail_content'],
                            $message['headers'],
                            $message['attachments'],
                            $message['mailcategory'],
                            $message['envelope_address'],
                            $server
                        ), true );
                        $output[] = array(
                            'message_id'       => $message['id'],
                            'result'           => $result,
                            'executiontime'    => cptn_number_format( (microtime( true ) - $mailstart) * 1000, 0, false ),
                            'mailserver'       => $server_id,
                            'recipient_id'     => $message['recipient_id'],
                            'sender_domain_id' => $message['sender_domain_id'],
                            'slave_id'         => $slave_id,
                            'message_sent'     => $message['mail_content'],
                        );
                        // update slave data
                        $query = "UPDATE " . $wpdb->prefix . "cptn_po_slave\n\t\t\t\t      \t      SET seconds = TIME_TO_SEC(TIMEDIFF(NOW(), start)),\n\t\t\t\t          \t  \t  mailspersec = (sent+1)/TIME_TO_SEC(TIMEDIFF(NOW(), start)),\n\t\t\t\t       \t  \t\t  sent = sent+1\n\t\t\t\t            WHERE id = " . $slave_id;
                        $wpdb->query( $query );
                        // wait 0,01 sec
                        usleep( 10000 );
                    }
                    // end foreach
                    // save result in database
                    cptn_po_send_result( $slave_id, $output );
                }
                
                // reset slave @ left messages that have not been sent
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_queue\n   \t\t                 SET slave = NULL\n\t\t               WHERE slave = " . $slave_id . " \n\t\t\t             AND executed IS NULL\n\t\t\t             AND (UNIX_TIMESTAMP(embargo) <= UNIX_TIMESTAMP(NOW()) OR embargo IS NULL)\n\t\t\t   \t\t\t ";
                $wpdb->query( $query );
                // remove slave from list
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_slave\n   \t\t                 SET executed = NOW()\n\t\t               WHERE id = '" . esc_sql( $slave_id ) . "'\n\t\t\t  \t\t   ";
                $wpdb->query( $query );
                if ( $wpdb->last_error ) {
                    error_log( $wpdb->last_error );
                }
            }
        
        }
    
    }

}
