<?php
// send one mail
// this function is called by PostOffice Cron Slave
// included in PostOffice includes AND PostOffice Remote webhook/includes 
//
// ===================================================================================
//    adjust textdomain after copying!  "campation-postoffice" / "wp-campation-po-remote"
// ===================================================================================

if(!function_exists("cptn_po_send_one_mail"))
   {

function cptn_po_send_one_mail($from_email="", $from_name="", $subject="", $recipient_email="", $recipient_name="", $message="", $headers="", $attachments="", $mailcategory = "", $envelope_address=NULL, $server = array())
   {
   global $wpdb;

   if(!$server)   
      return (cptn_json_output(array("result"=>"error","error_reason"=>htmlspecialchars_decode(esc_html__("no mail server","campation-postoffice")),"error_full"=>htmlspecialchars_decode(esc_html__("mail server is blocked or misconfigured","campation-postoffice")))));
   $server_id = $server['id'];
   
   if($recipient_name)
      $to = esc_html($recipient_name)." <".esc_html($recipient_email).">";
   else	  
      $to = esc_html($recipient_email);
   

   // *****************************************************
   // ***************** more or less the original wp_mail()
   // *****************************************************

   $atts = apply_filters( 'wp_mail', compact( 'to', 'subject', 'message', 'headers', 'attachments' ) );
   if (isset($atts['to']))
      $to = $atts['to'];
   if (!is_array($to))
      $to = explode( ',', $to );
   if(isset($atts['subject'])) 
      $subject = $atts['subject'];
   if(isset($atts['message'])) 
      $message = $atts['message'];
   if(isset($atts['headers']))
      $headers = $atts['headers'];
   if(isset($atts['attachments'])) 
      $attachments = $atts['attachments'];
   if (isset($attachments) AND !is_array($attachments)) 
      $attachments = explode( "\n", str_replace( "\r\n", "\n", $attachments ) );

   // Headers.
   $cc       = array();
   $bcc      = array();
   $reply_to = array();

   if(empty($headers))
      $headers = array();
   else 
      {
	  if (!is_array($headers))
         $tempheaders = explode( "\n", str_replace( "\r\n", "\n", $headers ) );
      else
		 $tempheaders = $headers;
      $headers = array();
      }

   if(!empty($tempheaders)) 
      {
      // Iterate through the raw headers.
	  foreach ( (array) $tempheaders as $header ) 
	     {
		 if(strpos($header, ':' ) === false) 
		    {
			if(false!==stripos($header, 'boundary=')) 
			   {
			   $parts    = preg_split( '/boundary=/i', trim( $header ) );
			   $boundary = trim( str_replace( array( "'", '"' ), '', $parts[1] ) );
			   }
			continue;
			}

		 list( $name, $content ) = explode( ':', trim( $header ), 2 );
		 $name    = trim( $name );
		 $content = trim( $content );

		 switch ( strtolower( $name ) ) 
		    {
			case 'from':
							$bracket_pos = strpos( $content, '<' );
							if ( false !== $bracket_pos ) 
							   {
							   if ( $bracket_pos > 0 ) 
							      {
								   $from_name = substr( $content, 0, $bracket_pos - 1 );
								   $from_name = str_replace( '"', '', $from_name );
								   $from_name = trim( $from_name );
								   }

							   $from_email = substr( $content, $bracket_pos + 1 );
							   $from_email = str_replace( '>', '', $from_email );
							   $from_email = trim( $from_email );

								// Avoid setting an empty $from_email.
							} elseif ( '' !== trim( $content ) ) {
								$from_email = trim( $content );
							}
							break;
			case 'content-type':
							if ( strpos( $content, ';' ) !== false ) {
								list( $type, $charset_content ) = explode( ';', $content );
								$content_type                   = trim( $type );
								if ( false !== stripos( $charset_content, 'charset=' ) ) {
									$charset = trim( str_replace( array( 'charset=', '"' ), '', $charset_content ) );
								} elseif ( false !== stripos( $charset_content, 'boundary=' ) ) {
									$boundary = trim( str_replace( array( 'BOUNDARY=', 'boundary=', '"' ), '', $charset_content ) );
									$charset  = '';
								}

								// Avoid setting an empty $content_type.
							} elseif ( '' !== trim( $content ) ) {
								$content_type = trim( $content );
							}
							break;
			case 'cc':
							$cc = array_merge( (array) $cc, explode( ',', $content ) );
							break;
			case 'bcc':
							$bcc = array_merge( (array) $bcc, explode( ',', $content ) );
							break;
			case 'reply-to':
							$reply_to = array_merge( (array) $reply_to, explode( ',', $content ) );
							break;
			default:
							// Add it to our grand headers array.
							$headers[ trim( $name ) ] = trim( $content );
							break;
		    }
         }
	  }

  
   // SENDER
   $from_email = apply_filters( 'wp_mail_from', $from_email );
   $from_name = apply_filters( 'wp_mail_from_name', $from_name );
   if(empty($envelope_address))
      $envelope_address    = $from_email;    
	  

   // RECIPIENTS
   $address_headers = compact( 'to', 'cc', 'bcc', 'reply_to' );

	  
   // CONTENT TYPE
   if (!isset($content_type)) 
      $content_type = 'text/plain';
   $content_type = apply_filters( 'wp_mail_content_type', $content_type );

	  
   // CHARSET	  
   if(!isset($charset))
      $charset = get_bloginfo( 'charset' );


   

   // *****************************************************
   // ***************** CAMPATION POSTOFFICE
   // *****************************************************


   // initiate PHPMAILER   
   if(get_option("cptn_opt_timezone_server"))
      date_default_timezone_set(get_option("cptn_opt_timezone_server"));
   else	  
      date_default_timezone_set("UTC");
	  
   global $phpmailer; // define the global variable
   if (!($phpmailer instanceof PHPMailer)) 
	  {
	  global $wp_version;
	  if(version_compare($wp_version, '5.5', '<' )) 
	     {			      
		 require_once ABSPATH . WPINC . '/class-phpmailer.php';
		 require_once ABSPATH . WPINC . '/class-smtp.php';
		 $phpmailer = new PHPMailer( true );
		 }
	  else
		 {
		 require_once ABSPATH . WPINC . '/PHPMailer/PHPMailer.php';
		 require_once ABSPATH . WPINC . '/PHPMailer/SMTP.php';
		 require_once ABSPATH . WPINC . '/PHPMailer/Exception.php';
    	 $phpmailer = new PHPMailer\PHPMailer\PHPMailer();
		 }	  
	  }
  

   // set outgoing IP
   $ip = get_option("cptn_po_server_ip");
   if($ip)
      $phpmailer->SMTPOptions = [
                                 'socket' => [
        						    'bindto' => $ip,
    							 	],
      						    ];


   // CLEAR ALL
   $phpmailer->clearAllRecipients();
   $phpmailer->clearAttachments();
   $phpmailer->clearCustomHeaders();
   $phpmailer->clearReplyTos();
   


   // CONTENT TYPE
   $phpmailer->ContentType = $content_type;
   if('text/plain' !== $content_type)
      $phpmailer->isHTML(true);


   // CHARSET
   $phpmailer->CharSet = apply_filters( 'wp_mail_charset', $charset );


   // HEADERS
   if(!empty($headers)) 
      {
	  foreach((array) $headers as $name => $content) 
	     {
		 // Only add custom headers not added automatically by PHPMailer.
		 if(!in_array($name, array( 'MIME-Version', 'X-Mailer'))) 
            $phpmailer->addCustomHeader( sprintf( '%1$s: %2$s', $name, $content ) );
		 }

      if(false !== stripos($content_type, 'multipart' ) && ! empty($boundary)) 
	     $phpmailer->addCustomHeader( sprintf( "Content-Type: %s;\n\t boundary=\"%s\"", $content_type, $boundary ) );
	  }



   // SENDER / ENVELOPE
   if($server['server_type']=="remote")
      $phpmailer->XMailer     = 'Campation RemoteMail (via '.esc_html($server['address']).')';
   else
      $phpmailer->XMailer     = 'Campation PostOffice (via '.esc_html($server['address']).')';
   $phpmailer->Sender 	   = $envelope_address;

   try 
      {
   	  $phpmailer->SetFrom($from_email, $from_name, true);
	  } 
   catch (phpmailerException $e) 
      {
	  $mail_error_data                             = compact( 'to', 'subject', 'message', 'headers', 'attachments' );
	  $mail_error_data['phpmailer_exception_code'] = $e->getCode();
	  do_action( 'wp_mail_failed', new WP_Error( 'wp_mail_failed', $e->getMessage(), $mail_error_data ) );
      return (cptn_json_output(array("result"=>"error","mailserver"=>$server_id,"error_reason"=>htmlspecialchars_decode(esc_html__("Server failure","campation-postoffice"))." 1","error_full"=>$e->getMessage()."\r\n".$mail_error_data)));
	  }


   // RECIPIENTS   
   foreach ( $address_headers as $address_header => $addresses ) 
      {
	  if(empty($addresses)) 
	     continue;

      foreach((array) $addresses as $address) 
	     {
		 try 
		    {
			$recipient_name = '';
			if ( preg_match( '/(.*)<(.+)>/', $address, $matches ) ) 
			   {
			   if(count($matches) == 3) 
			      {
				  $recipient_name = $matches[1];
				  $address        = $matches[2];
                  }
			   }

            switch ( $address_header ) 
			   {
			   case 'to':
							$phpmailer->addAddress( $address, $recipient_name );
							break;
               case 'cc':
							$phpmailer->addCc( $address, $recipient_name );
							break;
               case 'bcc':
							$phpmailer->addBcc( $address, $recipient_name );
							break;
               case 'reply_to':
							$phpmailer->addReplyTo( $address, $recipient_name );
							break;
		       }
			} 
		 catch ( phpmailerException $e ) 
		    {
			continue;
			}
		 }
	  }	  


   // SUBJECT
   $phpmailer->Subject = $subject;


   // BODY
   $phpmailer->Body    = $message;
	  

   // ATTACHMENTS
   if (!empty($attachments)) 
      {
	  foreach ( $attachments as $attachment ) 
	     {
		 try 
		    {
			$phpmailer->addAttachment( $attachment );
			} 
		 catch ( phpmailerException $e ) 
		    {
			continue;
			}
		 }
	  }


   // we use an SMTP server 
   if($server AND $server['address'] AND $server['server_type']=="smtp")               
	  {
	  $phpmailer->isSMTP();
	  $phpmailer->Mailer      = 'smtp';
	  $phpmailer->Timeout     = 5;
	  $phpmailer->getSMTPInstance()->Timelimit = 5;
	  $phpmailer->SMTPDebug   = 2;
   	  $debugoutput = "";
	  $phpmailer->Debugoutput = function($str, $level) {
	     global $debugoutput;
         $debugoutput .= $str;
		 };
	  $phpmailer->SMTPOptions = array(
                                        'ssl' => array(
        						     	   'verify_peer' => false,
        							 	   'verify_peer_name' => false,
        							 	   'allow_self_signed' => true
    								       )
									    ); 	 	   
      $phpmailer->Host         = $server['address'];                  // could be set to alternative IP on same server with multiple IP?
  	  $phpmailer->Port         = $server['port'];
	  if($server['account'])
		 {
	     $phpmailer->SMTPAuth  = true; 
	     $phpmailer->Username  = $server['account'];
	     $phpmailer->Password  = $server['password'];
	     $phpmailer->AuthType  = "PLAIN";
		 }
	  else
	     $phpmailer->SMTPAuth  = false;	   	  

      if(!empty($server['encryption']))
	     $phpmailer->SMTPSecure= strtolower($server['encryption']);
	  }


   // we use PHPMail and set DKIM - test with https://www.appmaildev.com/en/dkimfile
   elseif($server AND ($server['server_type']=="spmail" OR $server['server_type']=="remote"))               
      {
	  $phpmailer->isMail();
	  $phpmailer->DKIM_domain           = $server['domain'];
	  $phpmailer->DKIM_private_string   = $server['dkim_private_key'];
	  $phpmailer->DKIM_selector 		= $server['dkim_selector'];
	  $phpmailer->DKIM_passphrase 	    = '';
	  $phpmailer->DKIM_identity 		= $from_email; // $server['envelope_address'];
	  $phpmailer->DKIM_copyHeaderFields = false;
	  }
			



   // *****************************************************
   // ***************** more or less the original wp_mail()
   // *****************************************************


   do_action_ref_array( 'phpmailer_init', array(&$phpmailer));

   $phpmailer->preSend();
   
   // Send!
   try 
      {
      if($phpmailer->send())
	     {
         return (cptn_json_output(array("result"=>"ok","mailserver"=>$server_id,"sandbox"=>"0")));
		 }
	  else
	     {	 
         return (cptn_json_output(array("result"=>"error","mailserver"=>$server_id,"error_reason"=>htmlspecialchars_decode(esc_html__("Server failure","campation-postoffice"))." 2","error_full"=>str_replace("https://github.com/PHPMailer/PHPMailer/wiki/Troubleshooting","",$phpmailer->ErrorInfo))));
		 }
	  } 
   catch ( phpmailerException $e ) 
      {
	  $mail_error_data                             = compact( 'to', 'subject', 'message', 'headers', 'attachments' );
	  $mail_error_data['phpmailer_exception_code'] = $e->getCode();
	  do_action( 'wp_mail_failed', new WP_Error( 'wp_mail_failed', $e->getMessage(), $mail_error_data ) );
      return (cptn_json_output(array("result"=>"error","mailserver"=>$server_id,"error_reason"=>htmlspecialchars_decode(esc_html__("Server failure","campation-postoffice"))." 3","error_full"=>$e->getMessage()."\r\n".$mail_error_data)));
	  }

   }   // EOF()

   



// write result after slave sending all mails to database   
function cptn_po_send_result($slave_id, $outputs)
   {
   global $wpdb;
   $sent = 0;
   foreach($outputs AS $output)
      {
      $sent++;

   	  if($output['result']['result']=="ok")
	     {
	  	 // QUEUE
	  	 $query = "UPDATE ".$wpdb->prefix."cptn_po_queue
		              SET executiontime = '".esc_sql($output['executiontime'])."',
				       	  embargo = NULL,
					   	  embargo_reason = NULL,
					   	  errors = 0,
				       	  error_date = NULL,
					   	  error_reason = NULL,
					   	  error_full = NULL,
					   	  slave = NULL,
					   	  mailserver = ".$output['mailserver'].",
					   	  mail_content_sent = '".esc_sql($output['message_sent'])."',
					   	  retry = 0,
				       	  executed = NOW()
			        WHERE id = ".$output['message_id'];	  		 
	     $wpdb->query($query);

		 if(!isset($output['result']['sandbox']) OR $output['result']['sandbox']!="1")
		    {
	  	 	// Mail Server 
	  	 	if(isset($output['mailserver']))
	           {
		 	   $query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
		                    SET sent = sent+1, 
						  	 	errors = 0,
					   	  	 	lasterror = NULL
					      WHERE id = ".$output['mailserver'];	  		 
               $wpdb->query($query);

	           }

	        // Recipient
	  	 	if($output['recipient_id'])
               {
		 	   $query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
		                    SET mails_sent = mails_sent+1,
						  	 	mails_error = 0,
						  	 	mails_error_last = NULL
					      WHERE id = ".$output['recipient_id'];	  		 
               $wpdb->query($query);
         	   }
			   
	        // Sender Domain
	  	 	if($output['sender_domain_id'])
		       {
		 	   $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
		                    SET mails_sent = mails_sent+1
			              WHERE id = ".$output['sender_domain_id'];	  		 
               $wpdb->query($query);
	     	   }

	        // Domain - Mailserver
	  	 	if($output['sender_domain_id'] AND isset($output['mailserver']))
		       {
		 	   $query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain_mailserver
		                    SET mails_sent = mails_sent+1
			              WHERE domain_id = ".$output['sender_domain_id']."
					        AND mailserver_id = ".$output['mailserver'];	  		 
               $wpdb->query($query);
	           }
            }
         }	  

      else
	     {
	  	 // QUEUE

	     $query = "SELECT *  
		             FROM ".$wpdb->prefix."cptn_po_mailserver
			        WHERE id = ".$output['message_id'];	  		 
         $message = $wpdb->get_row($query, ARRAY_A);

	     if($message['errors'] < CPTN_PO_MAXRETRIES)
		    {
		 	$query = "UPDATE ".$wpdb->prefix."cptn_po_queue
		                 SET executiontime = NULL,
					   	  	 executed = NULL,
					 	  	 slave = NULL,
						  	 errors = errors+1,
						  	 error_date = NOW(),
					 	  	 error_reason = '".esc_sql(trim($output['result']['error_reason']))."',
					 	  	 error_full = '".esc_sql(trim($output['result']['error_full']))."',
					 	  	 embargo = DATE_ADD(NOW(), INTERVAL ".CPTN_PO_RETRY_MIN[$message['errors']]." minute),
					 	  	 embargo_reason = '".htmlspecialchars_decode(esc_html__("Retry in","campation-postoffice"))." ".CPTN_PO_RETRY_MIN[$message['errors']]."min',
					 	  	 retry = 1
					   WHERE id = ".$output['id'];	  		 
            $wpdb->query($query);
		 	$action_taken = htmlspecialchars_decode(esc_html__("soft bounced -> retrying in","campation-postoffice"))." ".CPTN_PO_RETRY_MIN[$message['errors']]."min";
		 	}			  
         else
		    {
		 	$query = "UPDATE ".$wpdb->prefix."cptn_po_queue
		                 SET executiontime = NULL,
			     	 	  	 executed = NULL,
					 	  	 slave = NULL,
						  	 errors = 9999,
						  	 error_date = NOW(),
					 	  	 error_reason = '".esc_sql(trim($output['result']['error_reason']))."',
					 	  	 error_full = '".esc_sql(trim($output['result']['error_full']))."',
					 	  	 embargo = NULL,
					 	  	 embargo_reason = NULL,
					      	 retry = 0
					   WHERE id = ".$output['id'];	  		 
            $wpdb->query($query);
	     	$action_taken = htmlspecialchars_decode(esc_html__("soft bounced -> message blocked after retries","campation-postoffice"))." ".CPTN_PO_MAXRETRIES;
	     	}


	     // Mail Server
	  	 if(isset($output['mailserver']))
	        {
		 	$query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
		                 SET sent = sent+1, 
				 	 	  	 errors = errors+1,
					      	 lasterror = '".esc_sql($output['result']['error_full'])."'
			           WHERE id = ".$output['mailserver'];	  		 
            $wpdb->query($query);

		    $query = "INSERT INTO ".$wpdb->prefix."cptn_po_mailserver_error
		 	                  SET mailserver = ".$output['mailserver'].",
							      error_date = NOW(),
							 	  error_reason = '".esc_sql(trim($output['result']['error_reason']))."',
							 	  error_full = '".esc_sql(trim($output['result']['error_full']))."'
								  ";	  		 
            $wpdb->query($query);

		 	// block mail server on too many errors
		 	$query = "SELECT *  
			            FROM ".$wpdb->prefix."cptn_po_mailserver
			           WHERE id = ".$output['mailserver'];	  		 
            $ms = $wpdb->get_row($query, ARRAY_A);

		    if(intval(get_option("cptn_po_opt_mailserver_off_errors")) > 0 AND $ms['errors'] >= intval(get_option("cptn_po_opt_mailserver_off_errors")))
			   {  
		 	   $query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
		 	                SET status = 0 
			              WHERE id = ".$output['mailserver'];	  		 
               $wpdb->query($query);

 	           $query = "INSERT INTO ".$wpdb->prefix."cptn_po_mailserver_error
		 	                SET mailserver = ".$output['mailserver'].",
							 	error_date = NOW(),
							 	error_reason = '".htmlspecialchars_decode(esc_html__("Mail server stopped","campation-postoffice"))."',
							 	error_full = '".htmlspecialchars_decode(esc_html__("too many errors","campation-postoffice"))." (".esc_sql($ms['errors']).")'
							 	";	  		 
               $wpdb->query($query);

               // alert to admin
			   if(intval(get_option("cptn_po_opt_admin_alerts")))
			      {
		       	  $content = "<p>".$ms['address'].": ".htmlspecialchars_decode(esc_html__("Mail server stopped due too many errors","campation-postoffice")).": ".$ms['errors']." ".htmlspecialchars_decode(esc_html__("errors","campation-postoffice"))."</p>";
	       	   	  $content = "<center><img src='".CPTNPOPATH."img/campation-postoffice-logo-mail.png'><br><br>".$content."</center>"; 	  
		 	   	  $content = '<body style="max-width:600px;margin:20px auto;">'.$content."</body>";
   		 	   	  mail(esc_html(get_option("cptn_po_opt_admin_alerts_to")), '=?UTF-8?Q?=E2=9D=8C?= '.mb_encode_mimeheader(htmlspecialchars_decode(esc_html__("Mail server stopped","campation-postoffice"))), wp_kses_post($content), CPTNPOHEADERS);
		       	  }
			   }
            }
			   
	     // Recipient
	  	 if($output['recipient_id'])
		    {
		 	$query = "UPDATE ".$wpdb->prefix."cptn_po_recipient
		                 SET mails_sent = mails_sent+1,
		   	   	 	 	  	 mails_error = mails_error+1,
					 	  	 mails_error_last = NOW()
					   WHERE id = ".$output['recipient_id'];	  		 
            $wpdb->query($query);

	        // add to history of recipient errors
   	  	    $query = "INSERT INTO ".$wpdb->prefix."cptn_po_queue_error
                              SET  queue_id = ".$output['message_id'].",
					  	  	 	   recipient_id = ".$output['recipient_id'].",
						  	 	   mailserver = ".$output['mailserver'].", 
						  	 	   sender_domain_id = ".$output['sender_domain_id'].",
					   	  	 	   recipient_status = 'ERROR',
						  	 	   recipient_email = '".esc_sql($message['to_email'])."',
					  	  	 	   mail_date = NOW(),
					  	  	 	   mail_category = '".esc_sql($message['mailcategory'])."',
					  	  	 	   mail_subject = '".esc_sql($message['mail_subject'])."',
					      	 	   error_date = NOW(),
				       	  	 	   error_code = '',
				       	  	 	   error_type = '".esc_sql(trim($output['result']['error_reason']))."',
				       	  	 	   error_cat = 'server',
				   	   	  	 	   error_full = '".esc_sql(trim($output['result']['error_full']))."',
							 	   action_taken = '".esc_sql($action_taken)."'
						  	 	   ";
            $wpdb->query($query);
      	 	if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
	     	}

			
	     // Sender Domain
	  	 if($output['sender_domain_id'])
		    {
		 	$query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain
		                 SET mails_sent = mails_sent+1,
		   	   	 	 	  	 mails_error = mails_error+1
					   WHERE id = ".$output['sender_domain_id'];	  		 
            $wpdb->query($query);
	     	}

	     // Domain - Mailserver
	  	 if($output['sender_domain_id'] AND isset($output['mailserver']))
		    {
		 	$query = "UPDATE ".$wpdb->prefix."cptn_po_sender_domain_mailserver
		                 SET mails_sent = mails_sent+1,
		  	   	  		  	 mails_error = mails_error+1
			           WHERE domain_id = ".$output['sender_domain_id']."
					     AND mailserver_id = ".$output['mailserver'];	  		 
            $wpdb->query($query);
	        }

         }	  
      }   

      // update slave data
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_slave
	               SET seconds = TIME_TO_SEC(TIMEDIFF(NOW(), start)),
				 	   mailspersec = ".$sent."/TIME_TO_SEC(TIMEDIFF(NOW(), start)),
				 	   sent = ".$sent.",
	             	   executed = NOW()
		         WHERE id = ".$slave_id;
      $wpdb->query($query);

      // reset slave @ left messages that have not been sent
   	  $query = "UPDATE ".$wpdb->prefix."cptn_po_queue
	               SET slave = NULL,
				       mailserver = NULL
		         WHERE slave = ".$slave_id." 
			       AND executed IS NULL
			       AND embargo <= NOW()
			 	   ";
      $wpdb->query($query);

      }


   }   
?>