<?php

// check sender domains and mail server - also used by cron
function cptn_po_sender_check( $checkdomain = 0, $checkserver = 0, $recreatekeys = 0 )
{
    global  $wpdb ;
    $important = '&nbsp; <span style="color:#aa0000;font-weight:bold;float:right;">' . htmlspecialchars_decode( esc_html__( "IMPORTANT", "campation-postoffice" ) ) . '</span>';
    set_include_path( get_include_path() . PATH_SEPARATOR . CPTNPODIR . "includes/" );
    require_once "Net/DNS2.php";
    $dnsresolver = new Net_DNS2_Resolver( array(
        'nameservers'      => array(
        '8.8.8.8',
        '8.8.4.4',
        '1.1.1.1',
        '1.0.0.1'
    ),
        'use_tcp'          => true,
        'timeout'          => 2,
        'ns_random'        => true,
        'cache_type'       => 'file',
        'cache_file'       => CPTNPODIR . 'tmp/net_dns2.cache',
        'cache_size'       => 10000000,
        'cache_serializer' => 'json',
    ) );
    //   **********************************************************************
    //   check mail servers and update IP
    //   **********************************************************************
    $reverse_lookup_error = "";
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n              WHERE server_type = 'spmail' \r\n\t\t\t     OR server_type = 'remote'\r\n\t\t\t     OR ip IS NOT NULL \r\n\t\t\t\tAND status = 1 \r\n\t\t\t";
    $mailservers = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
        error_log( $wpdb->print_error() );
        wp_die();
    }
    
    
    if ( $mailservers ) {
        foreach ( $mailservers as $mailserver ) {
            // spmail
            
            if ( $mailserver['id'] == 0 ) {
                $check_mta = cptn_po_check_mta();
                
                if ( $check_mta['mta'] == "NOMTA" ) {
                    $connectable = 0;
                } elseif ( $check_mta['mta'] == "NOMAIL" ) {
                    $connectable = 0;
                } elseif ( $check_mta['mta'] == "NOPORT" ) {
                    $connectable = 0;
                } elseif ( empty($mailserver['test_mail_success']) ) {
                    $connectable = 0;
                } else {
                    $connectable = 1;
                }
                
                $ip = CPTNPOIP;
                // delete blacklist after change of IP
                
                if ( $ip !== $mailserver['ip'] ) {
                    $query = "DELETE FROM " . $wpdb->prefix . "cptn_po_mailserver_dnsbl\r\n\t\t\t              WHERE mailserver = " . $mailserver['id'];
                    $wpdb->query( $query );
                    
                    if ( $wpdb->last_error !== '' ) {
                        $wpdb->print_error();
                        error_log( $wpdb->print_error() );
                        wp_die();
                    }
                    
                    $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t                    SET dnsbl = 0,\r\n\t\t\t\t\t\t\t    rdns = 0,\r\n\t\t\t\t\t\t\t    rdns_record = ''\r\n\t\t\t              WHERE id = " . $mailserver['id'];
                    $wpdb->query( $query );
                    
                    if ( $wpdb->last_error !== '' ) {
                        $wpdb->print_error();
                        error_log( $wpdb->print_error() );
                        wp_die();
                    }
                
                }
                
                // get hostname from external server to avoid local name resolution
                $hostname = cptn_po_check_rdns( $ip );
                
                if ( $ip and $hostname ) {
                    $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n                            SET address = '" . esc_sql( $hostname ) . "',\r\n\t\t\t\t\t\t\t \tip = '" . esc_sql( $ip ) . "',\r\n\t\t\t\t\t\t\t\tconnectable = " . $connectable . ",\r\n\t\t\t\t\t\t\t \tupdated = NOW()\r\n\t\t\t\t\t      WHERE id = " . $mailserver['id'];
                    $wpdb->query( $query );
                    
                    if ( $wpdb->last_error !== '' ) {
                        $wpdb->print_error();
                        error_log( $wpdb->print_error() );
                        wp_die();
                    }
                
                }
                
                $mailserver['address'] = $hostname;
                $mailserver['ip'] = $ip;
            }
            
            // check reverse PTR for spmail on external server to avoid local name resolution
            // Commercial mail services do not publish sending IP / hostname
            $reverse_found = 0;
            $host = cptn_po_check_rdns( $mailserver['ip'] );
            
            if ( $host ) {
                if ( trim( $mailserver['address'] ) == trim( $host ) ) {
                    $reverse_found = 1;
                }
                if ( !$reverse_found ) {
                    $reverse_lookup_error = "<li>" . htmlspecialchars_decode( esc_html__( "DNS: mail server does not have a matching reverse PTR record", "campation-postoffice" ) ) . ": " . esc_html( $mailserver['shortname'] ) . " (<strong>" . esc_html( $mailserver['address'] ) . "</strong>) -> <strong>" . esc_html( $host ) . "</strong> (PTR)" . $important . "</li> " . PHP_EOL;
                }
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n                         SET rdns = " . $reverse_found . ",\r\n\t\t\t\t\t         rdns_record = '" . esc_sql( $host ) . "',\r\n\t\t\t\t\t\t\t updated = NOW()\r\n\t\t\t\t\t   WHERE id = " . $mailserver['id'];
                $wpdb->query( $query );
                
                if ( $wpdb->last_error !== '' ) {
                    $wpdb->print_error();
                    error_log( $wpdb->print_error() );
                    wp_die();
                }
            
            } else {
                // log errors
                $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\r\n\t  \t\t             SET mailserver = " . $mailserver['id'] . ",\r\n\t\t\t\t   \t   \t \t error_date = NOW(),\r\n\t\t\t\t\t   \t\t error_reason = '" . esc_html__( "Setup error", "campation-postoffice" ) . "',\r\n\t\t\t\t\t   \t\t error_full = '" . $mailserver['ip'] . " " . esc_html__( "no FQDN / rDNS for server", "campation-postoffice" ) . "'\r\n\t\t\t\t\t   \t\t ";
                $wpdb->query( $query );
            }
        
        }
        // next mail server
    }
    
    //   **********************************************************************
    //   check connectivity of mail servers
    //   **********************************************************************
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n              WHERE id > 0\r\n\t\t\t    AND status = 1\r\n\t\t\t  ";
    $mailservers = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
        error_log( $wpdb->print_error() );
        wp_die();
    }
    
    $connect_error = "";
    if ( $mailservers ) {
        foreach ( $mailservers as $mailserver ) {
            $connectable = 0;
            
            if ( $mailserver['server_type'] == "smtp" ) {
                $servercheckresult = cptn_po_check_smtp_server( $mailserver );
                
                if ( !empty($servercheckresult) ) {
                    $connect_error = "<li>" . $servercheckresult . ": " . esc_html( $mailserver['shortname'] ) . " (<strong>" . esc_html( $mailserver['address'] ) . "</strong>)" . $important . "</li> " . PHP_EOL;
                    $connectable = 0;
                } else {
                    $connectable = 1;
                }
            
            } elseif ( $mailserver['server_type'] == "remote" and $mailserver['plugin_url'] ) {
                $context = stream_context_create( array(
                    "http" => array(
                    "follow_location" => true,
                ),
                    "ssl"  => array(
                    "verify_peer"      => false,
                    "verify_peer_name" => false,
                ),
                ) );
                $check = @file_get_contents( $mailserver['plugin_url'] . "webhook/connectiontest.php", false, $context );
                
                if ( $check === false ) {
                    $connect_error = "<li>" . htmlspecialchars_decode( esc_html__( "CONNECT: The url of Campation RemoteMail&trade; plugin cannot be connected, please reconnect with main plugin", "campation-postoffice" ) ) . ": " . esc_html( $mailserver['shortname'] ) . " (<strong>" . esc_html( $mailserver['address'] ) . "</strong>)" . $important . "</li> " . PHP_EOL;
                    $connectable = 0;
                } elseif ( $check == "NOMTA" ) {
                    $connect_error = "<li>" . htmlspecialchars_decode( esc_html__( "CONNECT: Campation RemoteMail&trade; plugin cannot connect to Mail Transport Agent (MTA)", "campation-postoffice" ) ) . ": " . esc_html( $mailserver['shortname'] ) . " (<strong>" . esc_html( $mailserver['address'] ) . "</strong>)" . $important . "</li> " . PHP_EOL;
                    $connectable = 0;
                } else {
                    $connectable = 1;
                }
            
            }
            
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_mailserver\r\n                      SET connectable = " . $connectable . ",\r\n\t\t\t\t\t      lasterror = '" . esc_sql( $connect_error ) . "',\r\n\t\t\t\t\t\t  updated = NOW()\r\n\t\t\t\t\tWHERE id = " . $mailserver['id'];
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            
            if ( $connectable == 0 ) {
                $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_error\r\n                         SET error_date = NOW(),\r\n\t\t\t\t\t\t \t error_reason = '" . htmlspecialchars_decode( esc_html__( "Connect check", "campation-postoffice" ) ) . "',\r\n\t\t\t\t\t      \t error_full = '" . esc_sql( $connect_error ) . "',\r\n\t\t\t\t\t         mailserver = " . $mailserver['id'];
                $wpdb->query( $query );
                
                if ( $wpdb->last_error !== '' ) {
                    $wpdb->print_error();
                    error_log( $wpdb->print_error() );
                    wp_die();
                }
            
            }
        
        }
    }
    //   **********************************************************************
    //   reset all DNS records of checked sender domains
    //   **********************************************************************
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n   \t\t          SET mx_record = NULL,\r\n\t\t\t\t\t  spf_record = NULL,\r\n\t\t\t\t\t  dmarc_record = NULL,\r\n\t\t\t\t\t  bimi_record = NULL\r\n\t\t\t\t\t  ";
    if ( $checkdomain > 0 and $checkdomain < 9999 ) {
        $query .= " WHERE id = " . $checkdomain;
    }
    $wpdb->query( $query );
    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n   \t\t          SET dkim = 0,\r\n\t\t\t\t      dkim_record = NULL\r\n\t\t\t\t\t  ";
    if ( $checkdomain > 0 and $checkdomain < 9999 ) {
        $query .= " WHERE id = " . $checkdomain;
    }
    $wpdb->query( $query );
    //   **********************************************************************
    //   check sender domains
    //   **********************************************************************
    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t\t\t   \t ";
    if ( $checkdomain > 0 and $checkdomain < 9999 ) {
        $query .= " WHERE id = " . $checkdomain;
    }
    $domains = $wpdb->get_results( $query, ARRAY_A );
    
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
        error_log( $wpdb->print_error() );
        wp_die();
    }
    
    
    if ( $domains ) {
        $zonefile = array();
        foreach ( $domains as $domain ) {
            //   **********************************************************************
            //   check one sender domain
            //   **********************************************************************
            $zonefile[$domain['domain']] = ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";; Domain      " . $domain['domain'] . "." . PHP_EOL;
            $zonefile[$domain['domain']] .= ";; Date        " . date( "Y-m-d H:i:s" ) . PHP_EOL;
            $zonefile[$domain['domain']] .= ";; Generator   Campation PostOffice" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";; " . esc_html__( "Please note that importing this file into the DNS may result in duplicates" ) . PHP_EOL;
            $zonefile[$domain['domain']] .= ";;   " . esc_html__( "if entries of the same name already exist!" ) . PHP_EOL;
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $domain_status = "OK";
            $domain_full_error = "";
            $check_result = "";
            if ( $connect_error or $reverse_lookup_error ) {
                $check_result = $connect_error . $reverse_lookup_error . PHP_EOL;
            }
            // check if we have all table records to connect all mailservers to this domain
            $query = "SELECT * \r\n\t\t \t\t     FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n\t\t\t\t\t ";
            $mailservers = $wpdb->get_results( $query, ARRAY_A );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            if ( $mailservers ) {
                foreach ( $mailservers as $mailserver ) {
                    $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver WHERE domain_id = " . $domain['id'] . " AND mailserver_id = " . $mailserver['id'];
                    $dkimrecord = $wpdb->get_row( $query, ARRAY_A );
                    
                    if ( $wpdb->last_error !== '' ) {
                        $wpdb->print_error();
                        error_log( $wpdb->print_error() );
                        wp_die();
                    }
                    
                    
                    if ( !$dkimrecord ) {
                        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain_mailserver SET domain_id = " . $domain['id'] . ", mailserver_id = " . $mailserver['id'] . ", status = 1, server_status = 'OK', created = NOW(), updated = NOW()";
                        
                        if ( $mailserver['server_type'] == 'spmail' ) {
                            $query .= ", dkim_selector = 'po'";
                        } elseif ( $mailserver['server_type'] == 'remote' ) {
                            $query .= ", dkim_selector = 'po_r" . esc_sql( $mailserver['id'] ) . "'";
                        } else {
                            $query .= ", dkim_selector = 'po_s" . esc_sql( $mailserver['id'] ) . "'";
                        }
                        
                        $wpdb->query( $query );
                        
                        if ( $wpdb->last_error !== '' ) {
                            $wpdb->print_error();
                            error_log( $wpdb->print_error() );
                            wp_die();
                        }
                    
                    }
                
                }
            }
            // reset all mail server data of this domain to positive
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver \r\n\t\t \t\t      SET server_status = 'OK', \r\n\t\t\t\t\t  \t  last_error = NULL, \r\n\t\t\t\t\t\t  spf = 1, \r\n\t\t\t\t\t\t  dkim = 1, \r\n\t\t\t\t\t\t  dkim_record = NULL \r\n\t\t\t\t\tWHERE domain_id = " . $domain['id'];
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            //   **********************************************************************
            //   check email addresses of one sender domain
            //   **********************************************************************
            // returnpath is set?
            
            if ( empty($domain['envelope_address']) ) {
                $domain_status = "ERR";
                $domain_error = htmlspecialchars_decode( esc_html__( "No envelope address defined", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            } elseif ( trim( substr( $domain['envelope_address'], strpos( $domain['envelope_address'], "@" ) + 1, 100 ) ) != $domain['domain'] ) {
                $domain_status = "ERR";
                $domain_error = htmlspecialchars_decode( esc_html__( "Envelope address is not contained in sender domain and not allowed ", "campation-postoffice" ) ) . ": <strong><u>" . esc_html( $domain['envelope_address'] ) . "</u></strong> not in sender domain <strong><u>" . esc_html( $domain['domain'] ) . "</u></strong>";
                $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            }
            
            //   **********************************************************************
            //   select active mailservers for this domain for further investigation
            //   **********************************************************************
            $query = "SELECT cps.* \r\n\t\t \t\t     FROM " . $wpdb->prefix . "cptn_po_mailserver cps\r\n\t\t\t\t    INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm ON sdm.domain_id = " . $domain['id'] . " AND sdm.mailserver_id = cps.id AND sdm.status = 1 AND sdm.server_status = 'OK'\r\n\t\t\t\t\tWHERE cps.status = 1\t \r\n\t\t\t    \t  AND cps.connectable = 1\r\n\t\t\t\t\t  AND IF(cps.server_type!='smtp',cps.test_mail_success IS NOT NULL,1)\r\n\t\t\t\t\t ";
            $mailservers = $wpdb->get_results( $query, ARRAY_A );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            
            if ( !$mailservers ) {
                //			$domain_status = "ERR";
                $domain_error = htmlspecialchars_decode( esc_html__( "<strong><u>No active mail servers</u></strong> found for this domain - please activate or eliminate issues", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            }
            
            //   **********************************************************************
            //   get all DNS records for this domain
            //   **********************************************************************
            // get server IP for PHP Mail Server 0
            $serverip = CPTNPOIP;
            // get A-record for domain - may be on CDN, to be ignored later
            $a_record = gethostbyname( $domain['domain'] );
            $a_flag = true;
            if ( $serverip != $a_record ) {
                // behind CDN - do not set "a" flag which is CDN
                $a_flag = false;
            }
            // get MX-records for domain
            $mx_records = array();
            $mx_flag = false;
            $strange_mx = "";
            $server_in_mx_record = 0;
            $mx_record_string = "";
            $dnserror = "";
            try {
                $mx_records = json_decode( json_encode( $dnsresolver->query( $domain['domain'], 'MX' ) ), true );
            } catch ( Net_DNS2_Exception $e ) {
                $dnserror = $e->getMessage();
            }
            
            if ( $mx_records ) {
                if ( count( $mx_records['answer'] ) > 0 ) {
                    $mx_flag = true;
                }
                if ( $mx_flag ) {
                    foreach ( $mx_records['answer'] as $mxrr ) {
                        $mx_record_string .= $mxrr['exchange'] . " [" . $mxrr['preference'] . "] TTL " . $mxrr['ttl'] . "<br>";
                        $mx_ip = trim( gethostbyname( $mxrr['exchange'] ) );
                        
                        if ( !$mx_ip or $mxrr['exchange'] == $mx_ip ) {
                            //				  	 $domain_status = "ERR";
                            $domain_error = htmlspecialchars_decode( esc_html__( "DNS: Mail server", "campation-postoffice" ) ) . " " . esc_html( $mxrr['exchange'] ) . ' ' . htmlspecialchars_decode( esc_html__( "does not have an A-record - your domain cannot receive emails", "campation-postoffice" ) );
                            $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                            $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
                        }
                    
                    }
                }
            }
            
            
            if ( !$mx_flag ) {
                $strange_mx = "";
                $server_in_mx_record = 0;
                $mx_record_string = "";
                $mx_records = dns_get_record( $domain['domain'], DNS_MX );
                if ( count( $mx_records ) > 0 ) {
                    $mx_flag = true;
                }
                
                if ( !$mx_flag ) {
                    //			   $domain_status = "ERR";
                    $domain_error = htmlspecialchars_decode( esc_html__( "DNS: no MX record found for sender domain - your domain cannot receive emails", "campation-postoffice" ) );
                    $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                    $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
                } else {
                    foreach ( $mx_records as $rec ) {
                        $mx_record_string .= $rec['target'] . " [" . $rec['pri'] . "] TTL " . $rec['ttl'] . "<br>";
                        $mx_records['answer'][] = array(
                            'preference' => $mx_records[0]['pri'],
                            'exchange'   => $mx_records[0]['target'],
                            'ttl'        => $mx_records[0]['ttl'],
                            'name'       => $mx_records[0]['host'],
                        );
                        $mx_ip = trim( gethostbyname( $rec['target'] ) );
                        
                        if ( !$mx_ip or $rec['target'] == $mx_ip ) {
                            //				  	 $domain_status = "ERR";
                            $domain_error = __( "DNS: Mail server", "campation-postoffice" ) . " " . $rec['target'] . ' ' . __( "does not have an A-record - your domain cannot receive emails", "campation-postoffice" );
                            $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                            $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
                        }
                    
                    }
                }
            
            }
            
            
            if ( $mx_flag ) {
                // update domain with MX information
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n                         SET mx_record = '" . esc_sql( substr( $mx_record_string, 0, -4 ) ) . "'\r\n\t\t\t\t       WHERE id = " . $domain['id'];
                $wpdb->query( $query );
                
                if ( $wpdb->last_error !== '' ) {
                    $wpdb->print_error();
                    error_log( $wpdb->print_error() );
                    wp_die();
                }
            
            }
            
            // get SPF-record for domain
            $spf_record = "";
            $dnserror = "";
            try {
                $spf_dns = json_decode( json_encode( $dnsresolver->query( $domain['domain'], 'TXT' ) ), true );
                foreach ( $spf_dns['answer'] as $rec ) {
                    
                    if ( $rec['type'] == "TXT" and substr( $rec['text'][0], 0, 5 ) == "v=spf" ) {
                        $spf_record = $rec['text'][0];
                        break;
                    }
                
                }
            } catch ( Net_DNS2_Exception $e ) {
                $dnserror = $e->getMessage();
            }
            
            if ( empty($spf_record) ) {
                $spf_dns = dns_get_record( $domain['domain'], DNS_TXT );
                foreach ( $spf_dns as $rec ) {
                    $rec = (array) $rec;
                    
                    if ( $rec['type'] == "TXT" and substr( $rec['txt'], 0, 5 ) == "v=spf" ) {
                        $spf_record = $rec['txt'];
                        break;
                    }
                
                }
            }
            
            
            if ( empty($spf_record) ) {
                $domain_error = htmlspecialchars_decode( esc_html__( "DNS: no SPF record found for sender domain - your emails might be marked as spam", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . " " . $dnserror . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            }
            
            // reset spf mark for all mailservers of domain with IP in table - no external services, spf test is done by them
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sds\r\n\t\t\t\t\tINNER JOIN " . $wpdb->prefix . "cptn_po_mailserver s ON s.id = sds.mailserver_id\r\n\t\t              SET sds.spf = 0 \r\n\t\t\t\t\tWHERE sds.domain_id = " . $domain['id'] . "\r\n\t\t\t\t      AND s.ip > ''\r\n\t\t\t\t\t\t";
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            // create recommended SPF record for in this domain active servers and mark with spf mark
            $spf_recommendation = $spf_record;
            $filtered_spf_record = str_replace( "+", " ", $spf_record );
            $filtered_spf_record = str_replace( "~", " ", $filtered_spf_record );
            $filtered_spf_record = str_replace( "?", " ", $filtered_spf_record );
            $filtered_spf_record = str_replace( ":", " ", $filtered_spf_record );
            $filtered_spf_record = str_replace( ";", " ", $filtered_spf_record );
            if ( strpos( $filtered_spf_record . " ", "v=spf1" ) === false ) {
                $spf_recommendation = 'v=spf1 ' . esc_html( $spf_recommendation );
            }
            // set "mx" flag
            if ( strpos( $filtered_spf_record . " ", " mx" ) === false and $mx_flag ) {
                $spf_recommendation = str_replace( 'v=spf1 ', 'v=spf1 mx ', $spf_recommendation );
            }
            // remove "mx" flag
            
            if ( strpos( $filtered_spf_record . " ", " mx " ) !== false and !$mx_flag ) {
                $spf_recommendation = str_replace( " +mx", " ", $spf_recommendation );
                $spf_recommendation = str_replace( " ~mx", " ", $spf_recommendation );
                $spf_recommendation = str_replace( " mx", " ", $spf_recommendation );
            }
            
            // set "a" flag
            if ( strpos( $filtered_spf_record . " ", " a " ) === false and $a_flag ) {
                $spf_recommendation = str_replace( 'v=spf1 ', 'v=spf1 a ', $spf_recommendation );
            }
            // remove "a" flag
            
            if ( strpos( $filtered_spf_record . " ", " a " ) !== false and !$a_flag ) {
                $spf_recommendation = str_replace( " +a ", " ", $spf_recommendation );
                $spf_recommendation = str_replace( " ~a ", " ", $spf_recommendation );
                $spf_recommendation = str_replace( " a ", " ", $spf_recommendation );
            }
            
            // remove the "all" flag, will be added finally
            $spf_recommendation = str_replace( " all ", "", $spf_recommendation . " " );
            $spf_recommendation = str_replace( " +all ", "", $spf_recommendation . " " );
            $spf_recommendation = str_replace( " ~all ", "", $spf_recommendation . " " );
            $spf_recommendation = str_replace( " -all ", "", $spf_recommendation . " " );
            // check all mail servers
            $spf_missing_ips = "";
            $query = "SELECT cps.* \r\n\t\t             FROM " . $wpdb->prefix . "cptn_po_mailserver cps\r\n\t\t\t\t    INNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm ON sdm.domain_id = " . $domain['id'] . " AND sdm.mailserver_id = cps.id AND sdm.status = 1 \t \r\n\t\t\t\t\tWHERE cps.status = 1\t \r\n\t\t\t\t\t";
            $mailservers = $wpdb->get_results( $query, ARRAY_A );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            
            if ( $mailservers ) {
                // check all Mail servers for SPF status
                $spf_known_ip_count = 0;
                foreach ( $mailservers as $mailserver ) {
                    $spfstatus = 0;
                    $spfmissing = 1;
                    // exists in a record?
                    
                    if ( $a_record == $mailserver['ip'] and $a_flag ) {
                        $spfstatus = 1;
                        $spfmissing = 0;
                        $spf_recommendation = str_replace( "ip4:" . trim( $mailserver['ip'] ), " ", $spf_recommendation );
                        // remove from record if IP is mentioned, not neccessary
                        $spf_recommendation = str_replace( "ip6:" . trim( $mailserver['ip'] ), " ", $spf_recommendation );
                        // remove from record if IP is mentioned, not neccessary
                    }
                    
                    // exists in mx record? Do not list separately
                    if ( $mx_flag ) {
                        foreach ( $mx_records['answer'] as $mxrr ) {
                            $mx_ip = trim( gethostbyname( $mxrr['exchange'] ) );
                            
                            if ( $mx_ip == $mailserver['ip'] or $mxrr['exchange'] == $mailserver['address'] ) {
                                $spfstatus = 1;
                                $spfmissing = 0;
                                $server_in_mx_record++;
                            }
                            
                            // remove all MX ip from record if IP is mentioned
                            $spf_recommendation = str_replace( "ip4:" . $mx_ip, " ", $spf_recommendation );
                            $spf_recommendation = str_replace( "ip6:" . $mx_ip, " ", $spf_recommendation );
                            // reverse check if mx record exist in mail servers
                            $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n              \t\t \t\t    WHERE address = '" . esc_sql( $mxrr['exchange'] ) . "' \r\n\t\t\t\t\t\t\t\t";
                            $mxserver = $wpdb->get_row( $query, ARRAY_A );
                            if ( !$mxserver ) {
                                $strange_mx .= "<li>" . esc_html( $mxrr['exchange'] ) . "</li> " . PHP_EOL;
                            }
                        }
                    }
                    
                    if ( $server_in_mx_record == 0 ) {
                        $spf_recommendation = str_replace( " +mx", " ", $spf_recommendation );
                        $spf_recommendation = str_replace( " ~mx", " ", $spf_recommendation );
                        $spf_recommendation = str_replace( " mx", " ", $spf_recommendation );
                    }
                    
                    // already in spf record?
                    
                    if ( $mailserver['ip'] and strpos( $spf_recommendation, $mailserver['ip'] ) !== false ) {
                        $spfstatus = 1;
                        $spfmissing = 0;
                        $spf_known_ip_count++;
                    }
                    
                    // not in spf record and not in a / mx record so add
                    
                    if ( $mailserver['ip'] and strpos( $spf_recommendation, $mailserver['ip'] ) === false and $spfstatus == 0 and !$a_flag ) {
                        $spf_recommendation .= " ip4:" . esc_html( $mailserver['ip'] ) . " ";
                        $spf_known_ip_count++;
                    }
                    
                    
                    if ( $spfmissing == 1 ) {
                        $spf_missing_ips .= "<li>" . esc_html( $mailserver['shortname'] ) . " (" . esc_html( $mailserver['address'] ) . ") -> " . esc_html( $mailserver['ip'] );
                        if ( $mailserver['server_type'] == "spmail" or $mailserver['server_type'] == "remote" ) {
                            $spf_missing_ips .= " " . $important;
                        }
                        $spf_missing_ips .= "</li> " . PHP_EOL;
                    }
                    
                    // write SPF result to records with mail server IP
                    if ( empty($spf_record) ) {
                        $spfstatus = 0;
                    }
                    // if no SPF record -> spf has to be zero
                    $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver \r\n\t\t\t                SET spf = " . $spfstatus . " \r\n\t\t\t\t\t\t  WHERE domain_id = " . $domain['id'] . " \r\n\t\t\t\t\t\t    AND mailserver_id = " . $mailserver['id'];
                    $wpdb->query( $query );
                    
                    if ( $wpdb->last_error !== '' ) {
                        $wpdb->print_error();
                        error_log( $wpdb->print_error() );
                        wp_die();
                    }
                
                }
                
                if ( substr_count( strtolower( $spf_recommendation ), 'ip4:' ) + substr_count( strtolower( $spf_recommendation ), 'ip6:' ) > $spf_known_ip_count ) {
                    $all_ips = explode( " ", str_replace( "+", "", $spf_recommendation ) );
                    $strange_ips = "";
                    foreach ( $all_ips as $ip_record ) {
                        
                        if ( substr( trim( strtolower( $ip_record ) ), 0, 4 ) === "ip4:" or substr( trim( strtolower( $ip_record ) ), 0, 4 ) === "ip6:" ) {
                            $ip = substr( trim( $ip_record ), 4, 50 );
                            $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver\r\n              \t\t \t\t    WHERE ip = '" . esc_sql( $ip ) . "' \r\n\t\t\t\t\t\t\t\t";
                            if ( !$wpdb->get_row( $query, ARRAY_A ) ) {
                                $strange_ips .= "<li>" . esc_html( $ip ) . "</li> " . PHP_EOL;
                            }
                        }
                    
                    }
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: There are more IP listed in the public SPF record than defined in Campation PostOffice&trade; - please check them!", "campation-postoffice" ) );
                    if ( $strange_ips ) {
                        $check_result .= '<ul class="cptn-ul">  ' . PHP_EOL . $strange_ips . "</ul>  " . PHP_EOL;
                    }
                    $check_result .= "</li> " . PHP_EOL;
                }
            
            }
            
            $spf_recommendation = trim( $spf_recommendation ) . ' -all';
            $spf_recommendation = str_replace( "+", " ", $spf_recommendation );
            $spf_recommendation = str_replace( "  ", " ", $spf_recommendation );
            $spf_recommendation = str_replace( "  ", " ", $spf_recommendation );
            $spf_recommendation = str_replace( "  ", " ", $spf_recommendation );
            
            if ( $server_in_mx_record == 0 ) {
                $spf_recommendation = str_replace( " +mx", " ", $spf_recommendation );
                $spf_recommendation = str_replace( " ~mx", " ", $spf_recommendation );
                $spf_recommendation = str_replace( " mx", " ", $spf_recommendation );
            } elseif ( strpos( $spf_recommendation, " mx" ) === false ) {
                $spf_recommendation = str_replace( "v=spf1 ", "v=spf1 mx ", $spf_recommendation );
            }
            
            $spf_missing_ips = trim( $spf_missing_ips );
            if ( $spf_missing_ips and !empty($spf_record) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: The following mail server IP are missing in the public SPF record of the sender domain - please apply the recommended SPF record in DNS", "campation-postoffice" ) ) . ': ' . PHP_EOL . '<ul class="cptn-ul">' . PHP_EOL . $spf_missing_ips . "</ul>" . PHP_EOL . "</li> " . PHP_EOL;
            }
            
            if ( $strange_mx and !empty($spf_record) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: There are mail servers defined in the public MX record that are not used by Campation PostOffice&trade; - please check them!", "campation-postoffice" ) );
                $check_result .= '<ul class="cptn-ul">  ' . PHP_EOL . $strange_mx . "</ul>  " . PHP_EOL;
                $check_result .= "</li> " . PHP_EOL;
            }
            
            // add mx anywhere if MX record exists - needed for email traffic outside of PostOffice
            if ( strpos( $spf_recommendation . " ", " mx" ) === false and $mx_flag ) {
                $spf_recommendation = str_replace( 'v=spf1 ', 'v=spf1 mx ', $spf_recommendation );
            }
            $spf_recommendation = str_replace( '  ', ' ', $spf_recommendation );
            // update domain with SPF information
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n                      SET spf_record = '" . esc_sql( $spf_record ) . "',\r\n\t\t\t\t\t  \t  spf_missing_ips = '" . esc_sql( $spf_missing_ips ) . "',\r\n\t\t\t\t\t      spf_recommendation = '" . esc_sql( $spf_recommendation ) . "'\r\n\t\t\t\t\tWHERE id = " . $domain['id'];
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            if ( cptn_po_clean_dns_record( $spf_record ) !== cptn_po_clean_dns_record( $spf_recommendation ) and !empty($spf_record) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: SPF record does not correspond to the recommendation", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
            }
            $zonefile[$domain['domain']] .= ";; SPF record" . PHP_EOL;
            $zonefile[$domain['domain']] .= $domain['domain'] . ".\t1\tIN\tTXT\t" . '"' . $spf_recommendation . '"' . PHP_EOL;
            // BIMI - only check if BIMI logo is published
            
            if ( !empty($domain['bimi_logo_url']) and intval( get_option( "cptn_po_opt_bimi" ) ) == 1 and cptn_po_fs()->is_plan( 'business' ) ) {
                $bimi_record = "";
                $dnserror = "";
                try {
                    $bimi_dns = json_decode( json_encode( $dnsresolver->query( 'default._bimi.' . esc_html( $domain['domain'] ), 'TXT' ) ), true );
                    foreach ( $spf_dns['answer'] as $rec ) {
                        
                        if ( $rec['type'] == "TXT" and substr( strtolower( $rec['text'][0] ), 0, 5 ) == "v=BIMI1" ) {
                            $bimi_record = $rec['text'][0];
                            break;
                        }
                    
                    }
                } catch ( Net_DNS2_Exception $e ) {
                    $dnserror = $e->getMessage();
                }
                
                if ( empty($bimi_record) ) {
                    $bimi_dns = dns_get_record( 'default._bimi.' . esc_html( $domain['domain'] ), DNS_TXT );
                    if ( isset( $bimi_dns[0]['txt'] ) and $bimi_dns[0]['txt'] ) {
                        $bimi_record = $bimi_dns[0]['txt'];
                    }
                }
                
                
                if ( empty($bimi_record) ) {
                    $domain_error = htmlspecialchars_decode( esc_html__( "DNS: no BIMI record found for sender domain - please apply the recommended BIMI record in DNS", "campation-postoffice" ) );
                    $domain_full_error .= "<li>" . $domain_error . " " . $dnserror . "</li> " . PHP_EOL;
                    $check_result .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                } else {
                    if ( strpos( $bimi_record, "v=" ) === false ) {
                        $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI record is missing version (v=BIMI1)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                    }
                    if ( strpos( $bimi_record, "l=" ) === false ) {
                        $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI record is missing logo URL (l=)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                    }
                    if ( strpos( $bimi_record, "rua=" ) === false ) {
                        $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI record is missing certificate URL (a=)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                    }
                }
                
                
                if ( @file_get_contents( $domain['bimi_logo_url'] ) ) {
                    $bimi_recommendation = "v=BIMI1; l=" . esc_url_raw( $domain['bimi_logo_url'] );
                    
                    if ( !empty($domain['bimi_certificate_url']) ) {
                        $context = stream_context_create( array(
                            "http" => array(
                            "follow_location" => true,
                        ),
                            "ssl"  => array(
                            "verify_peer"      => false,
                            "verify_peer_name" => false,
                        ),
                        ) );
                        
                        if ( @file_get_contents( esc_url_raw( $domain['bimi_certificate_url'] ), false, $context ) ) {
                            $bimi_recommendation .= ";a=" . esc_url_raw( $domain['bimi_certificate_url'] );
                        } else {
                            $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI certificate URL not found", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                        }
                    
                    }
                    
                    if ( !empty($bimi_record) ) {
                        if ( cptn_po_clean_dns_record( $bimi_record ) !== cptn_po_clean_dns_record( $bimi_recommendation ) ) {
                            $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: The BIMI record does not correspond to the recommendation", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                        }
                    }
                } else {
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI logo URL not found", "campation-postoffice" ) ) . " -> <u><strong>" . esc_url_raw( $domain['bimi_logo_url'] ) . "</u></strong></li> " . PHP_EOL;
                }
                
                $bimi_recommendation = trim( $bimi_recommendation );
                // update domain with bimi information
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n                         SET bimi_recommendation = '" . esc_sql( $bimi_recommendation ) . "'";
                if ( $bimi_record ) {
                    $query .= ", bimi_record = '" . esc_sql( $bimi_record ) . "' ";
                }
                $query .= "WHERE id = " . $domain['id'];
                $wpdb->query( $query );
                
                if ( $wpdb->last_error !== '' ) {
                    $wpdb->print_error();
                    error_log( $wpdb->print_error() );
                    wp_die();
                }
                
                $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
                $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
                $zonefile[$domain['domain']] .= ";; BIMI record" . PHP_EOL;
                $zonefile[$domain['domain']] .= $domain['domain'] . "\t1\tIN\tTXT\t" . '"' . $bimi_recommendation . '"' . PHP_EOL;
            }
            
            // DMARC
            $dmarc_record = "";
            $dnserror = "";
            try {
                $dmarc_dns = json_decode( json_encode( $dnsresolver->query( '_dmarc.' . $domain['domain'], 'TXT' ) ), true );
                foreach ( $dmarc_dns['answer'] as $rec ) {
                    
                    if ( $rec['type'] == "TXT" ) {
                        $dmarc_record = $rec['text'][0];
                        break;
                    }
                
                }
            } catch ( Net_DNS2_Exception $e ) {
                $dnserror = $e->getMessage();
            }
            
            if ( empty($dmarc_record) ) {
                $dmarc_dns = dns_get_record( '_dmarc.' . esc_html( $domain['domain'] ), DNS_TXT );
                if ( isset( $dmarc_dns[0]['txt'] ) and $dmarc_dns[0]['txt'] ) {
                    $dmarc_record = $dmarc_dns[0]['txt'];
                }
            }
            
            
            if ( empty($dmarc_record) ) {
                //			$domain_status = "ERR";
                $domain_error = htmlspecialchars_decode( esc_html__( "DNS: no DMARC record found for sender domain - your emails might be marked as spam", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . " " . $dnserror . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            } else {
                if ( strpos( $dmarc_record, "v=" ) === false ) {
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: DMARC record is missing version (v=)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                }
                if ( strpos( $dmarc_record, "p=" ) === false ) {
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: DMARC record is missing policy (p=)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                }
                if ( strpos( $dmarc_record, "rua=" ) === false ) {
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: DMARC record is missing reporting address (rua=) - DMARC reporting will not work", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                }
            }
            
            // create recommended DMARC record
            $dmarc_recommendation = "v=DMARC1; p=" . esc_html( $domain['dmarc_policy'] ) . "; pct=" . esc_html( $domain['dmarc_percent'] ) . "; fo=1; aspf=" . esc_html( $domain['dmarc_aspf'] ) . "; adkim=" . esc_html( $domain['dmarc_adkim'] ) . "; ri=86400; ";
            
            if ( !empty($domain['dmarc_address']) ) {
                $dmarc_recommendation .= "rua=mailto:" . esc_html( $domain['dmarc_address'] ) . "; ";
            } elseif ( !empty($domain['envelope_address']) ) {
                $dmarc_recommendation .= "rua=mailto:" . esc_html( $domain['envelope_address'] ) . "; ";
            } else {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: No DMARC / envelope address set - DMARC record cannot use report address (rua=)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
            }
            
            $dmarc_recommendation = trim( $dmarc_recommendation );
            // update domain with DMARC information
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n                      SET dmarc_record = '" . esc_sql( $dmarc_record ) . "',\r\n\t\t\t\t\t      dmarc_recommendation = '" . esc_sql( $dmarc_recommendation ) . "'\r\n\t\t\t\t\tWHERE id = " . $domain['id'];
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            if ( cptn_po_clean_dns_record( $dmarc_record ) !== cptn_po_clean_dns_record( $dmarc_recommendation ) and !empty($dmarc_record) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: DMARC record does not correspond to the recommendation", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
            }
            if ( !empty($domain['bimi_logo_url']) and $domain['dmarc_policy'] == "none" and intval( get_option( "cptn_po_opt_bimi" ) ) == 1 and cptn_po_fs()->is_plan( 'business' ) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI requires the DMARC policy set to 'quarantine' or 'reject' - please change the DMARC configuration", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
            }
            if ( !empty($domain['bimi_logo_url']) and $domain['dmarc_policy'] != "none" and intval( get_option( "cptn_po_opt_bimi" ) ) == 1 and intval( $domain['dmarc_percent'] ) != 100 and cptn_po_fs()->is_plan( 'business' ) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: BIMI requires the DMARC policy set to 'quarantine' or 'reject' and the percentage to 100 - please change the DMARC configuration", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
            }
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";; DMARC record" . PHP_EOL;
            $zonefile[$domain['domain']] .= "_dmarc." . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . ".\t1\tIN\tTXT\t" . '"' . htmlspecialchars_decode( esc_html( $dmarc_recommendation ) ) . '"' . PHP_EOL;
            // DKIM policy
            $dnserror = "";
            $dkim_policy = "";
            try {
                $dkim_dns = json_decode( json_encode( $dnsresolver->query( '_domainkey.' . $domain['domain'], 'TXT' ) ), true );
                foreach ( $dkim_dns['answer'] as $rec ) {
                    if ( $rec['type'] == "TXT" ) {
                        foreach ( $rec['text'] as $text ) {
                            $dkim_policy .= $text;
                        }
                    }
                }
            } catch ( Net_DNS2_Exception $e ) {
                $dnserror = $e->getMessage();
            }
            
            if ( empty($dkim_policy) ) {
                $dkim_dns = dns_get_record( '_domainkey.' . $domain['domain'], DNS_TXT );
                if ( isset( $dkim_dns[0]['entries'][0] ) and $dkim_dns[0]['entries'][0] ) {
                    $dkim_policy = $dkim_dns[0]['entries'][0];
                }
            }
            
            
            if ( empty($dkim_policy) ) {
                $domain_error = htmlspecialchars_decode( esc_html__( "DNS: no DKIM policy record found for sender domain - your emails might be marked as spam", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . " " . $dnserror . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            } else {
                if ( strpos( $dkim_policy, "o=" ) === false ) {
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: DKIM policy record is missing policy value (o=)", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
                }
            }
            
            // create recommended DKIM policy record
            $dkim_policy_recommendation = "o=-";
            // update domain with DKIM policy information
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n                      SET dkim_policy = '" . esc_sql( $dkim_policy ) . "',\r\n\t\t\t\t\t      dkim_policy_recommendation = '" . esc_sql( $dkim_policy_recommendation ) . "'\r\n\t\t\t\t\tWHERE id = " . $domain['id'];
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            if ( cptn_po_clean_dns_record( $dkim_policy ) !== cptn_po_clean_dns_record( $dkim_policy_recommendation ) and !empty($dkim_policy) ) {
                $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: DKIM policy does not correspond to the recommendation", "campation-postoffice" ) ) . "</li> " . PHP_EOL;
            }
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";;" . PHP_EOL;
            $zonefile[$domain['domain']] .= ";; DKIM policy and selector records" . PHP_EOL;
            $zonefile[$domain['domain']] .= "_domainkey." . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . ".\t1\tIN\tTXT\t" . '"o=-"' . PHP_EOL;
            // DKIM each Domain / Mail-Server combination
            // supports CNAME-Selektors from email providers
            // excludes error handling for SMTP server
            // reset DKIM DNS records
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n   \t\t              SET dkim_record = NULL\r\n                    WHERE domain_id = " . $domain['id'];
            $wpdb->query( $query );
            $query = "SELECT sds.*, sd.domain, sd.spf_missing_ips, s.address, s.server_type, s.connectable, s.ip, s.test_mail_success \r\n\t\t \t\t     FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sds\r\n\t\t\t\t\tINNER JOIN " . $wpdb->prefix . "cptn_po_mailserver s ON s.id = sds.mailserver_id\r\n\t\t\t\t\tINNER JOIN " . $wpdb->prefix . "cptn_po_sender_domain sd ON sd.id = sds.domain_id\r\n\t\t\t\t    WHERE sds.domain_id = " . $domain['id'];
            $dkims = $wpdb->get_results( $query, ARRAY_A );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            foreach ( $dkims as $dkim ) {
                $server_status = "OK";
                $server_error = "";
                $server_full_error = "";
                $dkim_record = "";
                // create dkim keys and dkim_recommendation for PHP servers
                if ( $dkim['server_type'] == 'spmail' or $dkim['server_type'] == 'remote' ) {
                    
                    if ( $recreatekeys == 1 and $dkim['id'] == $checkserver or empty($dkim['dkim_public_key']) or empty($dkim['dkim_private_key']) or empty($dkim['dkim_recommendation']) ) {
                        // generate new keys and recommendation
                        //Create a 2048-bit RSA key with an SHA256 digest
                        $pk = openssl_pkey_new( [
                            'digest_alg'       => 'sha256',
                            'private_key_bits' => 2048,
                            'private_key_type' => OPENSSL_KEYTYPE_RSA,
                        ] );
                        //Save private key
                        openssl_pkey_export( $pk, $dkim_private_key );
                        $pubKey = openssl_pkey_get_details( $pk );
                        $dkim_public_key = $pubKey['key'];
                        //Remove PEM wrapper
                        $dkim_public_key = preg_replace( '/^-+.*?-+$/m', '', $dkim_public_key );
                        //Strip line breaks
                        $dkim_public_key = str_replace( [ "\r\n", "\n" ], '', $dkim_public_key );
                        $dkim_public_key = str_replace( [ "\r", "\n" ], '', $dkim_public_key );
                        $dkim_recommendation = 'v=DKIM1;k=rsa;h=sha256;p=' . $dkim_public_key;
                        $keyparts = str_split( $dkim_recommendation, 253 );
                        // Split public key into chunks Becomes 255 when quotes are included
                        $dkim_recommendation = "";
                        foreach ( $keyparts as $keypart ) {
                            $dkim_recommendation .= '"' . trim( $keypart ) . '" ';
                        }
                        $dkim_recommendation = trim( $dkim_recommendation );
                        $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t               \t           SET dkim_private_key = '" . $dkim_private_key . "',\r\n\t\t\t\t\t\t\t   \t   dkim_public_key = '" . $dkim_public_key . "',\r\n\t\t\t\t\t\t\t\t   dkim_recommendation = '" . esc_sql( $dkim_recommendation ) . "',\r\n\t\t\t\t\t      \t       updated = NOW()\r\n\t\t\t                 WHERE id = " . $dkim['id'];
                        $wpdb->query( $query );
                        
                        if ( $wpdb->last_error !== '' ) {
                            $wpdb->print_error();
                            error_log( $wpdb->print_error() );
                            wp_die();
                        }
                    
                    }
                
                }
                //			$server_status = $dkim['server_status'];
                //			$server_error = "";
                //			$server_full_error .= $dkim['last_error'];
                
                if ( $dkim['ip'] and strpos( $spf_missing_ips, $dkim['ip'] ) !== false ) {
                    $server_error = htmlspecialchars_decode( esc_html__( "Server is missing in SPF record of the domain - your emails might be marked as spam", "campation-postoffice" ) ) . ": " . esc_html( $dkim['address'] );
                    $server_full_error .= "<li>" . $server_error . $important . "</li> " . PHP_EOL;
                }
                
                
                if ( $dkim['connectable'] == 0 ) {
                    $server_status = "ERR";
                    $server_error = htmlspecialchars_decode( esc_html__( "Server is not connectable", "campation-postoffice" ) ) . ": " . esc_html( $dkim['address'] );
                    $server_full_error .= "<li>" . $server_error . "</li> " . PHP_EOL;
                }
                
                
                if ( empty($dkim['test_mail_success']) and $dkim['server_type'] != "smtp" ) {
                    $server_status = "ERR";
                    $server_error = htmlspecialchars_decode( esc_html__( "Server could not send test email", "campation-postoffice" ) ) . ": " . esc_html( $dkim['address'] );
                    $server_full_error .= "<li>" . $server_error . "</li> " . PHP_EOL;
                }
                
                
                if ( empty($dkim['dkim_selector']) and $dkim['server_type'] != "smtp" ) {
                    $server_error = htmlspecialchars_decode( esc_html__( "DKIM selector not set in plugin configuration for mail server and domain - your emails might be marked as spam", "campation-postoffice" ) ) . " <strong><u>" . esc_html( $dkim['address'] ) . "</u></strong> -> <strong><u>" . esc_html( $dkim['domain'] ) . "</u></strong>";
                    $server_full_error .= "<li>" . $server_error . "</li> " . PHP_EOL;
                    $check_result .= "<li>" . $server_error . $important . "</li> " . PHP_EOL;
                } else {
                    $dnserror = "";
                    try {
                        $dkim_dns = json_decode( json_encode( $dnsresolver->query( $dkim['dkim_selector'] . '._domainkey.' . $domain['domain'], 'TXT' ) ), true );
                        foreach ( $dkim_dns['answer'] as $rec ) {
                            if ( $rec['type'] == "TXT" ) {
                                foreach ( $rec['text'] as $text ) {
                                    $dkim_record .= $text;
                                }
                            }
                        }
                    } catch ( Net_DNS2_Exception $e ) {
                        $dnserror = $e->getMessage();
                    }
                    
                    if ( empty($dkim_record) ) {
                        $dkim_dns = dns_get_record( $dkim['dkim_selector'] . '._domainkey.' . esc_html( $domain['domain'] ), DNS_TXT );
                        foreach ( $dkim_dns as $rec ) {
                            
                            if ( $rec['type'] == "TXT" ) {
                                $dkim_record = $rec['txt'];
                                break;
                            }
                        
                        }
                    }
                    
                    
                    if ( empty($dkim_record) ) {
                        $server_error = htmlspecialchars_decode( esc_html__( "DNS: DKIM record not found", "campation-postoffice" ) ) . ": <strong><u>" . esc_html( $dkim['dkim_selector'] ) . '._domainkey.' . esc_html( $domain['domain'] ) . "</u></strong> -> <strong><u>" . esc_html( $dkim['address'] ) . " (" . esc_html( $dkim['server_type'] ) . ")</u></strong>";
                        
                        if ( $dkim['server_type'] != 'smtp' ) {
                            $server_error .= " - " . htmlspecialchars_decode( esc_html__( "your emails cannot be signed digitally and might be marked as spam", "campation-postoffice" ) );
                        } else {
                            $server_error .= " - " . htmlspecialchars_decode( esc_html__( "check selector name, ask your mail service provider for assistance or deactivate this mail server for this sending domain - your emails cannot be signed digitally and might be marked as spam", "campation-postoffice" ) );
                        }
                        
                        $server_full_error .= "<li>" . $server_error . "</li> " . PHP_EOL;
                        
                        if ( $dkim['server_type'] == 'spmail' or $dkim['server_type'] == 'remote' ) {
                            $check_result .= "<li>" . $server_error . $important . "</li> " . PHP_EOL;
                        } else {
                            $check_result .= "<li>" . $server_error . "</li> " . PHP_EOL;
                        }
                        
                        $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t                  \t       SET dkim_record = NULL,\r\n\t\t\t\t\t\t\t       dkim = 0,\r\n\t\t\t\t\t      \t       updated = NOW()\r\n\t\t\t                 WHERE id = " . $dkim['id'];
                        $wpdb->query( $query );
                        
                        if ( $wpdb->last_error !== '' ) {
                            $wpdb->print_error();
                            error_log( $wpdb->print_error() );
                            wp_die();
                        }
                    
                    } else {
                        $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t                  \t       SET dkim_record = '" . esc_sql( $dkim_record ) . "',\r\n\t\t\t\t\t\t\t       dkim = 1,\r\n\t\t\t\t\t      \t       updated = NOW()\r\n\t\t\t                 WHERE id = " . $dkim['id'];
                        $wpdb->query( $query );
                        
                        if ( $wpdb->last_error !== '' ) {
                            $wpdb->print_error();
                            error_log( $wpdb->print_error() );
                            wp_die();
                        }
                    
                    }
                
                }
                
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t               \t     SET server_status = '" . esc_sql( $server_status ) . "',\r\n\t\t\t\t\t\t     last_error = '" . esc_sql( $server_full_error ) . "',\r\n\t\t\t\t\t      \t updated = NOW()\r\n\t\t\t           WHERE id = " . $dkim['id'];
                $wpdb->query( $query );
                
                if ( $wpdb->last_error !== '' ) {
                    $wpdb->print_error();
                    error_log( $wpdb->print_error() );
                    wp_die();
                }
                
                $query = "SELECT * FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t                   WHERE id = " . $dkim['id'];
                $dkim_values = $wpdb->get_row( $query, ARRAY_A );
                if ( !empty($dkim_values['dkim_record']) and cptn_po_clean_dns_record( $dkim_values['dkim_record'] ) !== cptn_po_clean_dns_record( $dkim_values['dkim_recommendation'] ) and strtolower( $dkim['server_type'] ) != 'smtp' ) {
                    $check_result .= "<li>" . htmlspecialchars_decode( esc_html__( "DNS: The DKIM record does not correspond to the recommendation", "campation-postoffice" ) ) . ": <strong><u>" . esc_html( $dkim['dkim_selector'] ) . '._domainkey.' . esc_html( $domain['domain'] ) . "</u></strong> -> <strong><u>" . esc_html( $dkim['address'] ) . " (" . esc_html( $dkim['server_type'] ) . ")</u></strong></li> " . PHP_EOL;
                }
                if ( strtolower( $dkim['server_type'] ) != 'smtp' ) {
                    $zonefile[$domain['domain']] .= esc_html( $dkim['dkim_selector'] ) . "._domainkey." . htmlspecialchars_decode( esc_html( $domain['domain'] ) ) . ".\t1\tIN\tTXT\t" . htmlspecialchars_decode( esc_html( $dkim_values['dkim_recommendation'] ) ) . PHP_EOL;
                }
            }
            $query = "SELECT COUNT(*)  \r\n\t\t \t\t     FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n\t\t\t\t    WHERE domain_id = " . $domain['id'] . "\r\n\t\t\t\t\t  AND dkim_selector >''\r\n\t\t\t\t\t  AND dkim_record >''\r\n\t\t\t\t\t  AND status = 1\r\n\t\t\t\t\t  ";
            $dkims = $wpdb->get_var( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            
            if ( $dkims == 0 ) {
                $domain_error = htmlspecialchars_decode( esc_html__( "DNS: no DKIM records found at all for your domain - your emails cannot be signed digitally and might be marked as spam", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            }
            
            // is there at least 1 server active?
            $query = "SELECT COUNT(*) FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver\r\n                    WHERE server_status = 'OK'\r\n\t\t\t\t\t  AND status = 1\r\n\t\t\t\t\t  AND domain_id = " . $domain['id'];
            $servercount = $wpdb->get_var( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            
            if ( $servercount == 0 ) {
                //			$domain_status = "ERR";
                $domain_error = htmlspecialchars_decode( esc_html__( "No active / valid mail servers found for sender domain", "campation-postoffice" ) );
                $domain_full_error .= "<li>" . $domain_error . "</li> " . PHP_EOL;
                $check_result .= "<li>" . $domain_error . " " . $important . "</li> " . PHP_EOL;
            }
            
            // finally update domain
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_sender_domain\r\n\t                  SET domain_status = '" . esc_sql( $domain_status ) . "',\r\n\t\t\t\t\t      last_error = '" . esc_sql( $domain_full_error ) . "',\r\n\t\t\t\t\t      last_checked = NOW(),\r\n\t\t\t\t\t\t  last_check_result = '" . esc_sql( $check_result ) . "'\r\n\t\t\t        WHERE id = " . $domain['id'];
            $wpdb->query( $query );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            // list all mail server with status for this domain
            $query = "SELECT cps.address, cps.shortname, cps.server_type, dms.server_status \r\n\t\t             FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver dms\r\n\t\t\t\t    INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver cps ON cps.id = dms.mailserver_id  \r\n\t\t\t\t\tWHERE dms.domain_id = " . $domain['id'] . "\r\n\t\t\t\t\t  AND dms.status = 1\t \r\n\t\t\t\t\t";
            $mailservers = $wpdb->get_results( $query, ARRAY_A );
            
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
                error_log( $wpdb->print_error() );
                wp_die();
            }
            
            $mailserverlist = "<p><center>" . htmlspecialchars_decode( esc_html__( "Status of active mail servers for sender domain", "campation-postoffice" ) ) . " " . esc_html( $domain['domain'] ) . "</center></p>";
            
            if ( $mailservers ) {
                $mailserverlist .= "<table cellpadding=5 align=center> " . PHP_EOL;
                $mailserverlist .= "<tr><th align=left>" . htmlspecialchars_decode( esc_html__( "Mail server name", "campation-postoffice" ) ) . "</th><th align=left>" . htmlspecialchars_decode( esc_html__( "Mail server address", "campation-postoffice" ) ) . "</th><th align=left>" . htmlspecialchars_decode( esc_html__( "Type", "campation-postoffice" ) ) . "</th><th align=left>" . htmlspecialchars_decode( esc_html__( "Status", "campation-postoffice" ) ) . "</th></tr> " . PHP_EOL;
                foreach ( $mailservers as $mailserver ) {
                    
                    if ( $mailserver['server_status'] == "OK" ) {
                        $status_style = "color:green;font-weight:bold;";
                    } else {
                        $status_style = "color:#aa0000;font-weight:bold;";
                    }
                    
                    $mailserverlist .= "<tr><td>" . esc_html( $mailserver['shortname'] ) . "</td><td>" . esc_html( $mailserver['address'] ) . "</td><td>" . esc_html( $mailserver['server_type'] ) . "</td><td style='" . $status_style . "'>" . esc_html( $mailserver['server_status'] ) . "</td></tr> " . PHP_EOL;
                }
                $mailserverlist .= "</table> " . PHP_EOL;
            }
            
            // write BIND file to disk
            $bindfile = fopen( CPTNPODIR . "bind-dns/BIND-DNS-" . $domain['domain'] . ".txt", "w" );
            
            if ( $bindfile ) {
                fwrite( $bindfile, $zonefile[$domain['domain']] );
                fclose( $bindfile );
            }
            
            $zonefile[$domain['domain']] = "";
            // call by ajax for 1 domain
            return $check_result;
        }
    }

}
