<?php
// test if email is blocked by ISP
function cptn_po_check_mta()
   {
   $mtacheck = array();
   $mtacheck['mta'] = "NOMTA";
   $sendmail_path = ini_get('sendmail_path');
   if(!empty($sendmail_path))
      {
      if(function_exists('mail'))
	     {
		 if(strpos(strtolower(ini_get('disable_functions')),"mail")===false)
		    {
			
   	  		$fp = @stream_socket_client("tcp://smtp-relay.gmail.com:25", $errno, $errstr, 3);
			if($fp) 
			   {
			   $mtacheck['smtp'] = true;
			   stream_socket_shutdown($fp, STREAM_SHUT_WR);
			   }
			else 	
			   $mtacheck['smtp'] = false;
			
			$context_ssl = stream_context_create();
			stream_context_set_option($context_ssl, 'ssl', 'local_cert',CPTNPODIR.'common/cert.pem');
			stream_context_set_option($context_ssl, 'ssl', 'passphrase', 'postoffice');
			stream_context_set_option($context_ssl, 'ssl', 'allow_self_signed', TRUE);
			stream_context_set_option($context_ssl, 'ssl', 'verify_peer', FALSE);
			$fp = @stream_socket_client('ssl://smtp-relay.gmail.com:465', $errno, $errstr, 30, STREAM_CLIENT_CONNECT, $context_ssl);
			if($fp)
			   {
			   $mtacheck['ssl'] = true;
			   stream_socket_shutdown($fp, STREAM_SHUT_WR);
			   }
			else
			   $mtacheck['ssl'] = false;
   
			$fp = @stream_socket_client('tcp://smtp-relay.gmail.com:587', $errno, $errstr, 3);
			if($fp) 
			   {
			   $mtacheck['tls'] = true;
			   stream_socket_shutdown($fp, STREAM_SHUT_WR);
			   }
			else 
			   $mtacheck['tls'] = false;

			if(!$mtacheck['smtp'] AND !$mtacheck['ssl'] AND !$mtacheck['tls'])               
	           $mtacheck['mta'] = "NOPORT";
			else   
	           $mtacheck['mta'] = "OK";
			}
		 else
	        $mtacheck['mta'] = "NOMAIL";
         }
	  else
	     $mtacheck['mta'] = "NOMAIL";
	  }
   return($mtacheck);	  
   }


   
Function cptn_po_check_rdns($ip)
   {
   if($ip)
      {
   	  $fields = ['ip' => $ip];
	  $result = wp_remote_post(CPTNPOAPIURL."rdns.php", array(
            'method'      => 'POST',
			'sslverify'   => false,
    	 	'timeout'     => 45,
    	 	'redirection' => 5,
    	 	'httpversion' => '1.0',
    	 	'blocking'    => true,
    	 	'headers'     => array(),
    	 	'body'        => $fields,
    	 	'cookies'     => array()
    	 	)
         );
      $hostname = $result['body'];
  	  if($hostname AND $hostname !== "ERROR" AND trim($ip) != trim($hostname))
         return($hostname);
      }

   return("");	  
   }   

   
   
function cptn_po_check_smtp_server ($mailserver)
   {   
   $connect_error = "";
   $fp = @stream_socket_client("tcp://".$mailserver['address'].":".$mailserver['port'], $errno, $errstr, 3);
   if (!$fp) 
	  $connect_error = htmlspecialchars_decode(esc_html__("Connect error - check address / port","campation-postoffice")); 
   else
	  {
      // check credentials
   	  global $phpmailer; // define the global variable
      if (!($phpmailer instanceof PHPMailer)) 
         {
	  	 global $wp_version;
	  	 if(version_compare($wp_version, '5.5', '<' )) 
	        {			      
		 	require_once ABSPATH . WPINC . '/class-phpmailer.php';
		 	require_once ABSPATH . WPINC . '/class-smtp.php';
		 	$phpmailer = new PHPMailer( true );
		 	}
	     else
		    {
		  	require_once ABSPATH . WPINC . '/PHPMailer/PHPMailer.php';
		 	require_once ABSPATH . WPINC . '/PHPMailer/SMTP.php';
		 	require_once ABSPATH . WPINC . '/PHPMailer/Exception.php';
    	 	$phpmailer = new PHPMailer\PHPMailer\PHPMailer();
		 	}	  
	     }

      $phpmailer->isSMTP();
	  $phpmailer->Mailer      = 'smtp';
	  $phpmailer->Timeout     = 3;
	  $phpmailer->getSMTPInstance()->Timelimit = 5;
	  $phpmailer->SMTPDebug   = 2;
   	  $debugoutput = "";
	  $phpmailer->Debugoutput = function($str, $level) {
	     global $debugoutput;
         $debugoutput .= $str;
		 };
	  $phpmailer->SMTPOptions = array(
                                      'ssl' => array(
        						         'verify_peer' => false,
        							 	 'verify_peer_name' => false,
        							 	 'allow_self_signed' => true
    								     )
									  ); 	 	   
	  $phpmailer->Host        = $mailserver['address'];                  
  	  $phpmailer->Port        = $mailserver['port'];
	  if($mailserver['account'])
		 {
	     $phpmailer->SMTPAuth = true; 
	     $phpmailer->Username = $mailserver['account'];
	     $phpmailer->Password = $mailserver['password'];
	     $phpmailer->AuthType = "PLAIN";
		 }
	  else
	     $phpmailer->SMTPAuth = false;	   	  
      if($mailserver['encryption'])
	     $phpmailer->SMTPSecure = strtolower($mailserver['encryption']);

      $validCredentials = false;
      try 
		 {
         $validCredentials    = $phpmailer->SmtpConnect();
	     if(!$validCredentials)
	  		$connect_error = htmlspecialchars_decode(esc_html__("Login error - check security, port, account, password","campation-postoffice")); 
		 }
      catch (phpmailerException $e) 
	     {
	     $connect_error = $e->errorMessage();
		 } 		 
      catch(Exception $error) 
		 {
	     $connect_error = $e->getMessage();
		 }
      }
   return $connect_error; 
   }



function cptn_po_check_imap_server ($imapaccount)
   {   
   $connect_error = "";
   if(empty($imapaccount['server']) OR empty($imapaccount['port']))
	  $connect_error = htmlspecialchars_decode(esc_html__("No IMAP account defined","campation-postoffice")); 
   else   
      {
   	  $fp = @stream_socket_client("tcp://".$imapaccount['server'].":".$imapaccount['port'], $errno, $errstr, 5);
   	  if (!$fp) 
	     $connect_error = htmlspecialchars_decode(esc_html__("Connect error - check address / port","campation-postoffice")); 
      else
	     {
      	 // check credentials
	  	 imap_timeout(IMAP_OPENTIMEOUT, 5);
	  	 imap_timeout(IMAP_READTIMEOUT, 5);
	  	 imap_timeout(IMAP_WRITETIMEOUT, 5);
	  	 imap_timeout(IMAP_CLOSETIMEOUT, 5);
   	  	 $mailbox = "{".$imapaccount['server'].":".$imapaccount['port']."/imap/".strtolower($imapaccount['security'])."}"; 
   	  	 $inbox = @imap_open($mailbox, $imapaccount['account'], $imapaccount['password'], OP_HALFOPEN);
 	  	 if(!$inbox) 
	        {
	  	 	imap_errors();   // close error stack
	     	$connect_error = htmlspecialchars_decode(esc_html__("Login error - check security, port, account, password","campation-postoffice"));
		 	} 
	     else
	        {
      	 	imap_errors();   // close error stack
  	  	 	imap_close($inbox);		 
		    }	 
         }
      }
   if(intval(get_option("cptn_po_opt_sandbox_mode"))==1)
      {
	  if(empty($connect_error))
	     $connect_error = htmlspecialchars_decode(esc_html__("IMAP account is accessible but cannot be used: <u>Sandbox mode is active</u>","campation-postoffice"));
	  else
	     $connect_error .= " - <u>".htmlspecialchars_decode(esc_html__("Sandbox mode is active","campation-postoffice"))."</u>";
	  }	  
   return $connect_error; 
   }



?>