<?php 
function cptn_po_uninstall_cleanup()
   {
   global $wpdb;

   if (!defined('WP_UNINSTALL_PLUGIN'))
      wp_die();

   if(get_option("cptn_po_opt_delete_data_uninstall")!=1)
      wp_die();
   	  
	  
   // Freemius uninstall
   cptn_po_fs()->add_action('after_uninstall', 'wcp_fs_uninstall_cleanup');


   // delete pages created by this plugin
   $plugin_pages = get_option('cptn_po_pages');
   if (is_array($plugin_pages) && !empty($plugin_pages)) 
      {
   	  foreach ($plugin_pages as $plugin_page) 
	     {
	     wp_trash_post($plugin_page);
	  	 }
      }


   // delete user meta
   $query = "DELETE 
	           FROM ".$wpdb->prefix."usermeta
		      WHERE meta_key like 'cptn_po_%'
		   		";
   $wpdb->query($query);					


   // delete database tables
   $plugin_tables = get_option('cptn_po_db_tables');
   if (is_array($plugin_tables) && !empty($plugin_tables)) 
      {
      foreach ($plugin_tables as $plugin_table) {
         $wpdb->query("DROP TABLE IF EXISTS ".$plugin_table);	  
         }
      }


   // remove plugin options
   $query = "DELETE 
	           FROM ".$wpdb->prefix."options
		      WHERE option_name like 'cptn_po_%'
		   		";
   $wpdb->query($query);					


   // was this the only Campation plugin installed? Then remove all general Campation data
   $nomorecampationplugins = true;
   $plugins = get_plugins();
   foreach($plugins AS $key => $plugin)
      {
   	  if(substr($plugin['Name'],0,9)=="Campation" AND $plugin['Name'] != "Campation PostOffice")    // there is another Campation plugin installed
         $nomorecampationplugins = false;
      }

   if($nomorecampationplugins)
      {
   	  // delete database tables
      $plugin_tables = get_option('cptn_db_tables');
   	  if (is_array($plugin_tables) && !empty($plugin_tables)) 
         {
   	  	 foreach ($plugin_tables as $plugin_table) {
            $wpdb->query("DROP TABLE IF EXISTS ".$plugin_table);	  
      	    }
         }

      // remove plugin options
      $query = "DELETE 
	              FROM ".$wpdb->prefix."options
		         WHERE option_name like 'cptn_%'
		   		 ";
      $wpdb->query($query);					
   	  }   

   }

?>