<?php

// overwrite pluggable WP function wp_mail()
// and write mail to cptn_po_mail( $to, $subject, $message, $headers = '', $attachments = array() )

if ( !function_exists( "wp_mail" ) ) {
    if ( intval( get_option( "cptn_po_opt_cockpit_switch_general" ) ) == 1 ) {
        function wp_mail(
            $to,
            $subject = '',
            $message = '',
            $headers = '',
            $attachments = array()
        )
        {
            global  $wpdb ;
            $mailcategory = "";
            $source = "wp_mail";
            // from where the mail was sent? // configuration/mail shows all plugins to classify mailcategory for plugin
            $backtrace = debug_backtrace();
            
            if ( !empty($backtrace[0]) && is_array( $backtrace[0] ) ) {
                $source = $backtrace[0]['file'];
                
                if ( strpos( $source, "/plugins/" ) !== false ) {
                    $source = substr( $source, strpos( $source, "/plugins/" ) + 9, 100 );
                    $source = substr( $source, 0, strpos( $source, "/" ) );
                    $query = "SELECT mailcategory \r\n\t\t \t\t           FROM " . $wpdb->prefix . "cptn_po_plugin_mailcategory\r\n\t\t\t\t\t      WHERE pluginslug = '" . esc_sql( $source ) . "'";
                    $mailcategory = $wpdb->get_var( $query );
                }
                
                
                if ( empty($mailcategory) and $source == "campation-postoffice-test" ) {
                    $mailcategory = "test";
                } elseif ( empty($mailcategory) ) {
                    $mailcategory = "wordpress";
                }
            
            }
            
            // correct comma problem in $to: comma in recipient name has to be treated different to comma as separator of recipients
            
            if ( !is_array( $to ) ) {
                $recipients = explode( ">,", $to );
                $new_to = "";
                foreach ( $recipients as $recipient ) {
                    $new_to .= str_replace( "  ", " ", str_replace( ",", " - ", trim( $recipient ) ) ) . ">,";
                }
                $to = substr( $new_to, 0, -2 );
            }
            
            return cptn_po_mail(
                $to,
                $subject,
                $message,
                $headers,
                $attachments,
                $mailcategory,
                $source,
                0
            );
            // always true = sucessfull
        }
    
    }
} else {
    deactivate_plugins( CPTNPODIR . 'campation-postoffice.php' );
    add_action( 'admin_notices', 'cptn_admin_notice_error_other_plugin' );
    function cptn_admin_notice_error_other_plugin()
    {
        $class = 'notice notice-error';
        $message = htmlspecialchars_decode( esc_html__( "There is another email plugin active - Campation PostOffice&trade; cannot be used - please deactivate the other email plugin and retry to activate Campation PostOffice&trade;", "campation-postoffice" ) );
        printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), esc_html( $message ) );
    }

}

// add one mail to PostOffice queue - pendant to wp_mail()
// $mailcategory can be trans, marke, bulk, cold, test
function cptn_po_mail(
    $to_array,
    $subject = "",
    $message = "",
    $headers = "",
    $attachments = "",
    $mailcategory = "",
    $source = "",
    $cptn_message_id = 0
)
{
    global  $wpdb ;
    $domain_protect = false;
    if ( !is_array( $to_array ) ) {
        $to_array = explode( ",", $to_array );
    }
    if ( !is_array( $headers ) ) {
        $headers = explode( "\n", str_replace( "\r\n", "\n", $headers ) );
    }
    if ( !is_array( $attachments ) ) {
        $attachments = explode( ",", $attachments );
    }
    $to_array = array_filter( $to_array );
    // delete empty elements
    $headers = array_filter( $headers );
    // delete empty elements
    $attachments = array_filter( $attachments );
    // delete empty elements
    $from_name = "";
    $from_email = "";
    $replyto = "";
    $cc = "";
    $bcc = "";
    $mime = "";
    $content_type = "";
    // STEP 1: read headers into variables - highest priority, data from sending plugin
    
    if ( $headers ) {
        $tempheaders = $headers;
        if ( !empty($tempheaders) ) {
            foreach ( (array) $tempheaders as $header ) {
                list( $name, $content ) = explode( ':', trim( $header ), 2 );
                $name = trim( $name );
                $content = trim( $content );
                
                if ( strtolower( $name ) == 'from' ) {
                    $bracket_pos = strpos( $content, '<' );
                    
                    if ( false !== $bracket_pos ) {
                        
                        if ( $bracket_pos > 0 ) {
                            $from_name = substr( $content, 0, $bracket_pos - 1 );
                            $from_name = str_replace( '"', '', $from_name );
                            $from_name = trim( $from_name );
                        }
                        
                        $from_email = substr( $content, $bracket_pos + 1 );
                        $from_email = str_replace( '>', '', $from_email );
                        $from_email = trim( $from_email );
                    } elseif ( '' !== trim( $content ) ) {
                        $from_email = trim( $content );
                    }
                
                }
                
                if ( strtolower( $name ) == 'reply-to' ) {
                    $replyto = trim( $content );
                }
                if ( strtolower( $name ) == 'cc' ) {
                    $cc = trim( $content );
                }
                if ( strtolower( $name ) == 'bcc' ) {
                    $bcc = trim( $content );
                }
                if ( strtolower( $name ) == 'content-type' ) {
                    $content_type = trim( $content );
                }
                if ( strtolower( $name ) == 'mime-version' ) {
                    $mime = trim( $content );
                }
            }
        }
    }
    
    // STEP 2: fill missing header fields from default options
    // Fill header fields
    $fromdefault = false;
    if ( empty($from_name) ) {
        $from_name = esc_html( get_option( 'cptn_opt_email_sendername' ) );
    }
    
    if ( empty($from_email) ) {
        $from_email = esc_html( get_option( 'cptn_opt_email_sender' ) );
        $fromdefault = true;
    }
    
    $from_email = apply_filters( 'wp_mail_from', $from_email );
    $from_name = apply_filters( 'wp_mail_from_name', $from_name );
    // STEP 3: fill missing headers from sender domain
    // do we know the sender domain? if not, add to table sender_domain
    $sender_domain = substr( $from_email, strpos( $from_email, "@" ) + 1, 100 );
    $query = "SELECT id, mailcategory \r\n   \t\t       FROM " . $wpdb->prefix . "cptn_po_sender_domain   \r\n\t\t\t  WHERE domain = '" . esc_sql( $sender_domain ) . "'";
    $domain = $wpdb->get_row( $query, ARRAY_A );
    if ( $wpdb->last_error !== '' ) {
        $wpdb->print_error();
    }
    // allowed new domain?
    $allowed_new_domain = true;
    $query = "SELECT count(*) FROM " . $wpdb->prefix . "cptn_po_sender_domain";
    $domaincount = $wpdb->get_var( $query );
    if ( $domaincount ) {
        $allowed_new_domain = false;
    }
    
    if ( $domain ) {
        $domain_id = $domain['id'];
    } elseif ( $allowed_new_domain ) {
        // there are free allowed additional domains
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_sender_domain   \r\n\t\t\t       SET domain = '" . esc_sql( $sender_domain ) . "',\r\n\t\t\t\t\t   status = 1,\r\n\t\t\t\t       created = NOW()\r\n\t\t\t\t   ";
        $wpdb->query( $query );
        if ( $wpdb->last_error !== '' ) {
            $wpdb->print_error();
        }
        $domain_id = $wpdb->insert_id;
        cptn_po_sender_check( $domain_id );
        // send mail to admin for check of new domain
        
        if ( intval( get_option( "cptn_po_opt_admin_alerts" ) ) ) {
            $output = htmlspecialchars_decode( esc_html__( "Review the domain in Campation PostOffice&trade; Admin. The email message(s) sent from this domain will be delivered after domain verification", "campation-postoffice" ) );
            $output .= "<br><br> \r\n";
            $output = "<center><img src='" . CPTNPOPATH . "img/campation-postoffice-logo-mail.png'></center><br><br>\r\n" . $output;
            $output = '<body style="max-width:600px;margin:20px auto;">' . $output . "</body>";
            mail(
                esc_html( get_option( "cptn_po_opt_admin_alerts_to" ) ),
                htmlspecialchars_decode( esc_html__( "A new sender domain has been detected", "campation-postoffice" ) ) . " '" . $sender_domain . "'",
                wp_kses_post( $output ),
                CPTNPOHEADERS
            );
        }
    
    } else {
        $domain_id = 0;
        
        if ( intval( get_option( "cptn_po_opt_admin_alerts" ) ) ) {
            $output = htmlspecialchars_decode( esc_html__( "Unfortunately, your license does not allow you to create another sender domain - the email could not be sent. Please use a different sender domain for your email or upgrade to a higher license level.", "campation-postoffice" ) );
            $output .= "<br><br> \r\n";
            $output = "<center><img src='" . CPTNPOPATH . "img/campation-postoffice-logo-mail.png'></center><br><br>\r\n" . $output;
            $output = '<body style="max-width:600px;margin:20px auto;">' . $output . "</body>";
            mail(
                esc_html( get_option( "cptn_po_opt_admin_alerts_to" ) ),
                htmlspecialchars_decode( esc_html__( "A new sender domain has been detected", "campation-postoffice" ) ) . " '" . $sender_domain . "'",
                wp_kses_post( $output ),
                CPTNPOHEADERS
            );
        }
    
    }
    
    // is the domain active?
    $query = "SELECT sd.domain, sd.id, sd.from_address, sd.replyto_address,\r\n       \t\t\t\t   (SELECT count(*) \r\n\t      \t\t\t      FROM " . $wpdb->prefix . "cptn_po_sender_domain_mailserver sdm \r\n\t\t  \t\t\t\t  INNER JOIN " . $wpdb->prefix . "cptn_po_mailserver ms ON ms.id = sdm.mailserver_id AND ms.rdns = 1 AND ms.connectable = 1 AND ms.status = 1 \r\n\t\t  \t\t\t\t  WHERE sdm.domain_id = sd.id\r\n            \t\t\t  AND sdm.status = 1 \r\n            \t\t\t  AND sdm.server_status = 'OK'\r\n\t\t\t\t\t\t  ) AS server \r\n                 FROM " . $wpdb->prefix . "cptn_po_sender_domain sd \r\n\t\t\t\t WHERE sd.id = " . $domain_id . "\r\n\t\t\t\t   AND sd.domain_status = 'OK'\r\n\t\t\t\t   AND sd.status = 1\r\n\t\t\t\t   LIMIT 1\t  \r\n\t  \t\t\t ";
    $domain = $wpdb->get_row( $query, ARRAY_A );
    
    if ( isset( $domain['server'] ) and $domain['server'] > 0 ) {
        // we have a valid server - overwrite sender data (from, reply-to) from domain fields
        // set new header values
        if ( (empty($from_email) or $fromdefault) and $domain['from_address'] ) {
            $from_email = $domain['from_address'];
        }
        if ( empty($replyto) and $domain['replyto_address'] ) {
            $replyto = $domain['replyto_address'];
        }
    }
    
    if ( empty($from_email) ) {
        wp_die();
    }
    // STEP 4: Recreate headers
    $headers = array();
    
    if ( !empty($from_name) ) {
        $headers[] = 'From: ' . $from_name . ' <' . $from_email . '>';
    } else {
        $headers[] = "From: " . $from_email;
    }
    
    if ( !empty($replyto) ) {
        
        if ( strpos( $replyto, "<" ) === false ) {
            $headers[] = 'Reply-To: ' . $from_name . ' <' . $replyto . '>';
        } else {
            $headers[] = 'Reply-To: ' . $replyto;
        }
    
    }
    if ( !empty($cc) ) {
        $headers[] = "Cc: " . $cc;
    }
    if ( get_option( 'cptn_po_opt_email_bcc' ) and $mailcategory == "trans" ) {
        
        if ( !empty($bcc) ) {
            $bcc .= ", " . get_option( 'cptn_po_opt_email_bcc' );
        } else {
            $bcc = get_option( 'cptn_po_opt_email_bcc' );
        }
    
    }
    if ( !empty($bcc) ) {
        $headers[] = "Bcc: " . $bcc;
    }
    
    if ( !empty($mime) ) {
        $headers[] = "MIME-Version: " . $mime;
    } else {
        $headers[] = "MIME-Version: 1.0";
    }
    
    if ( empty($content_type) ) {
        
        if ( preg_match( '/<\\s?[^\\>]*\\/?\\s?>/i', $message ) ) {
            // this is a html message
            $content_type = "text/html; charset=UTF-8";
        } else {
            $content_type = "text/plain; charset=UTF-8";
        }
    
    }
    if ( !empty($content_type) ) {
        $headers[] = "Content-Type: " . $content_type;
    }
    // create a mail in queue for all recipients (if more than 1)
    $to_name = "";
    $to_email = "";
    foreach ( $to_array as $recipient ) {
        // split recipient into name and email
        $bracket_pos = strpos( $recipient, '<' );
        
        if ( false !== $bracket_pos ) {
            
            if ( $bracket_pos > 0 ) {
                $to_name = substr( $recipient, 0, $bracket_pos - 1 );
                $to_name = str_replace( '"', '', $to_name );
                $to_name = trim( $to_name );
            }
            
            $to_email = substr( $recipient, $bracket_pos + 1 );
            $to_email = str_replace( '>', '', $to_email );
            $to_email = trim( $to_email );
        } elseif ( $recipient ) {
            $to_email = trim( $recipient );
        }
        
        // a wordpress user?
        $user_id = 0;
        $query = "SELECT ID \r\n   \t\t          FROM " . $wpdb->prefix . "users   \r\n\t\t\t     WHERE user_email  = '" . esc_sql( $to_email ) . "'";
        $user = $wpdb->get_row( $query, ARRAY_A );
        if ( $wpdb->last_error !== '' ) {
            $wpdb->print_error();
        }
        if ( $user ) {
            $user_id = $user['ID'];
        }
        // do we know the recipient? if not add to table for check
        $query = "SELECT id, embargo, recipient_status, status \r\n   \t\t          FROM " . $wpdb->prefix . "cptn_po_recipient   \r\n\t\t\t     WHERE recipient_email  = '" . esc_sql( $to_email ) . "'";
        $receiver = $wpdb->get_row( $query, ARRAY_A );
        if ( $wpdb->last_error !== '' ) {
            $wpdb->print_error();
        }
        
        if ( $receiver ) {
            $recipient_id = $receiver['id'];
        } else {
            $recipient_domain = substr( $to_email, strpos( $to_email, "@" ) + 1, 100 );
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_recipient   \r\n\t\t\t          SET status = 1,\r\n\t\t\t\t\t      domain = '" . esc_sql( $recipient_domain ) . "',\r\n\t\t\t\t          recipient_email = '" . esc_sql( $to_email ) . "',\r\n\t\t\t\t\t\t  user_id = " . $user_id . ",\r\n\t\t\t\t       \t  created = NOW(),\r\n\t\t\t\t\t\t  updated = NOW()\r\n\t\t\t\t   ";
            $wpdb->query( $query );
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
            }
            $recipient_id = $wpdb->insert_id;
            cptn_po_cron_recipient_check( $recipient_id );
        }
        
        $query = "SELECT pr.id, pr.embargo, pr.recipient_status, pr.status, pr.domain\r\n   \t\t          FROM " . $wpdb->prefix . "cptn_po_recipient pr   \r\n\t\t\t     WHERE pr.recipient_email  = '" . esc_sql( $to_email ) . "'";
        $receiver = $wpdb->get_row( $query, ARRAY_A );
        if ( $wpdb->last_error !== '' ) {
            $wpdb->print_error();
        }
        // check if relation mailserver-mxdomain is already known
        $query = "SELECT id \r\n                  FROM " . $wpdb->prefix . "cptn_po_mailserver ms\r\n                 WHERE NOT EXISTS (SELECT * FROM " . $wpdb->prefix . "cptn_po_mailserver_mxdomain WHERE mxdomain = '" . esc_sql( $receiver['domain'] ) . "' AND mailserver = ms.id)\r\n\t\t\t     ORDER BY id\r\n\t\t\t\t\t   ";
        $missing = $wpdb->get_results( $query, ARRAY_A );
        foreach ( $missing as $toadd ) {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_mailserver_mxdomain\r\n\t\t\t   \t\t  SET mailserver = " . $toadd['id'] . ",\r\n\t\t\t\t\t      mxdomain = '" . esc_sql( $receiver['domain'] ) . "'\r\n\t\t\t\t\t\t  ";
            if ( get_option( "cptn_po_opt_throttle_max_min" ) > 0 ) {
                $query .= ", minute_allowed = " . get_option( "cptn_po_opt_throttle_max_min" ) . " ";
            }
            $wpdb->query( $query );
        }
        $queue_error = "";
        // this recipient is blocked by status?
        if ( $receiver['recipient_status'] and $receiver['recipient_status'] == "BOUNCE" ) {
            // blocked due to invalid address
            $queue_error = "BOUNCE";
        }
        if ( $receiver['recipient_status'] and $receiver['recipient_status'] == "INACT" ) {
            
            if ( $mailcategory !== "trans" ) {
                $queue_error = "INACT";
            } else {
                $query = "UPDATE " . $wpdb->prefix . "cptn_po_recipient\t\t\t\t\t\t\t\t\t\t\t // unblock missing activity on receipt of transactional mail\r\n\t\t                 SET recipient_status = 'OK'   \r\n\t\t\t           WHERE pr.id  = " . $receiver['id'];
                $wpdb->query( $query );
                if ( $wpdb->last_error !== '' ) {
                    $wpdb->print_error();
                }
                $receiver['recipient_status'] = "OK";
            }
        
        }
        if ( $receiver['recipient_status'] and $receiver['recipient_status'] == "UNSUB" and $mailcategory !== "trans" ) {
            // blocked due to unsubscribe, only allow transactional emails
            $queue_error = "UNSUB";
        }
        if ( $receiver['status'] == 0 and $mailcategory !== "trans" ) {
            // user paused, only allow transactional emails
            $queue_error = "PAUSED";
        }
        $priority = 1;
        $embargo_reason = "";
        $embargo = new DateTime();
        // we start with embargo = NOW()
        $timezone = new DateTimeZone( esc_html( get_option( "cptn_opt_timezone_server" ) ) );
        $embargo->setTimezone( $timezone );
        $embargo = $embargo->format( 'Y-m-d H:i:s' );
        $embargostart = $embargo;
        
        if ( $embargostart == $embargo ) {
            // nothing changed
            $embargo = "";
            $embargo_reason = "";
        }
        
        // insert into mail queue
        $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_queue\r\n   \t\t           SET priority = " . $priority . ",\r\n\t\t\t\t       source = '" . esc_sql( $source ) . "',\r\n\t\t\t\t\t   mailcategory = '" . esc_sql( $mailcategory ) . "',\r\n\t\t\t\t\t   from_email = '" . esc_sql( $from_email ) . "',\r\n\t\t\t\t\t   from_name = '" . esc_sql( $from_name ) . "',\r\n\t\t\t\t\t   sender_domain_id = " . $domain_id . ",\r\n\t\t\t\t\t   to_email = '" . esc_sql( $to_email ) . "',\r\n\t\t\t\t\t   to_name = '" . esc_sql( $to_name ) . "',\r\n\t\t\t\t\t   recipient_id = " . $recipient_id . ",\r\n\t\t\t\t\t   recipient_domain = '" . esc_sql( $receiver['domain'] ) . "',\r\n\t\t\t\t\t   mail_subject = '" . esc_sql( $subject ) . "',\r\n\t\t\t\t\t   mail_content = '" . esc_sql( $message ) . "',\r\n\t\t\t\t\t   message_id = '" . esc_sql( $cptn_message_id ) . "',\r\n\t\t\t\t\t   created = NOW()\r\n\t\t\t\t\t   ";
        if ( $user_id ) {
            $query .= ", user_id = " . $user_id;
        }
        if ( $attachments ) {
            $query .= ", attachments = '" . json_encode( $attachments, JSON_UNESCAPED_UNICODE ) . "'";
        }
        if ( $headers ) {
            $query .= ", headers = '" . json_encode( $headers, JSON_UNESCAPED_UNICODE ) . "'";
        }
        
        if ( $queue_error and $receiver['recipient_status'] ) {
            $query .= ", errors = 9999,\r\n\t\t            error_date = NOW()";
            
            if ( $queue_error == "BOUNCE" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "bounced before", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "Email to bounced user", "campation-postoffice" ) ) ) . "' ";
            } elseif ( $queue_error == "UNSUB" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "is unsubscribed", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "User unsubscribed", "campation-postoffice" ) ) ) . "' ";
            } elseif ( $queue_error == "EMBARGO" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "under embargo", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "User under embargo", "campation-postoffice" ) ) ) . "' ";
            } elseif ( $queue_error == "PAUSED" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "recipient paused", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "User paused manually", "campation-postoffice" ) ) ) . "' ";
            }
        
        } elseif ( $embargo ) {
            $query .= ", embargo = '" . esc_sql( $embargo ) . "',\r\n\t\t              embargo_reason = '" . esc_sql( $embargo_reason ) . "'";
        }
        
        if ( $domain_protect ) {
            $query .= ", domain_protect = 1 ";
        }
        $wpdb->query( $query );
        if ( $wpdb->last_error !== '' ) {
            $wpdb->print_error();
        }
        $queue_id = $wpdb->insert_id;
        // if illegitimate add to queue errors
        
        if ( $queue_error and $receiver['recipient_status'] ) {
            $query = "INSERT INTO " . $wpdb->prefix . "cptn_po_queue_error\r\n   \t\t              SET recipient_id = " . $recipient_id . ",\r\n\t\t\t\t       \t  queue_id = " . $queue_id . ",\r\n\t\t\t\t\t   \t  sender_domain_id = " . $domain_id . ",\r\n\t\t\t\t\t   \t  recipient_status = '" . esc_sql( $receiver['recipient_status'] ) . "', \r\n\t\t\t\t\t   \t  recipient_email = '" . esc_sql( $to_email ) . "',\r\n\t\t\t\t\t   \t  mail_date = NOW(),\r\n\t\t\t\t\t   \t  mail_category = '" . esc_sql( $mailcategory ) . "',\r\n\t\t\t\t\t   \t  mail_subject = '" . esc_sql( $subject ) . "',\r\n\t\t               \t  error_date = NOW(),\r\n\t\t\t\t\t\t  error_code = '9.9.9',\r\n\t\t\t\t\t   \t  error_type = '" . esc_sql( htmlspecialchars_decode( esc_html__( "system", "campation-postoffice" ) ) ) . "',\r\n\t\t\t\t\t   \t  error_cat = '" . esc_sql( htmlspecialchars_decode( esc_html__( "illegitimate", "campation-postoffice" ) ) ) . "'\r\n\t\t\t\t\t   \t  ";
            
            if ( $queue_error == "BOUNCE" ) {
                $query .= ", error_reason = '', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "Email to user bounced before", "campation-postoffice" ) ) ) . "' ";
            } elseif ( $queue_error == "UNSUB" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "is unsubscribed", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "User unsubscribed before", "campation-postoffice" ) ) ) . "' ";
            } elseif ( $queue_error == "EMBARGO" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "under embargo", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "User has embargo", "campation-postoffice" ) ) ) . "' ";
            } elseif ( $queue_error == "PAUSED" ) {
                $query .= ", error_reason = '" . esc_sql( htmlspecialchars_decode( esc_html__( "recipient paused", "campation-postoffice" ) ) ) . "', error_full = '" . esc_sql( htmlspecialchars_decode( esc_html__( "User was paused manually", "campation-postoffice" ) ) ) . "' ";
            }
            
            $wpdb->query( $query );
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
            }
        }
        
        // shorten all urls in html message for click measuring
        
        if ( strpos( $message, "<!-- cptn_short_urls -->" ) === false and strpos( $message, " href" ) !== false ) {
            // was not shortened by other campation plugin
            $message = str_replace( "http://", "https://", $message );
            $htmlDom = new DOMDocument();
            @$htmlDom->loadHTML( $message );
            $links = $htmlDom->getElementsByTagName( 'a' );
            $extractedLinks = array();
            foreach ( $links as $link ) {
                $linkText = $link->nodeValue;
                $linkHref = $link->getAttribute( 'href' );
                if ( strlen( trim( $linkHref ) ) == 0 ) {
                    continue;
                }
                if ( strpos( $linkHref, "cptnunsubscribe" ) !== false ) {
                    continue;
                }
                if ( strpos( $linkHref, "mailto:" ) !== false ) {
                    continue;
                }
                if ( strpos( $linkHref, "tel:" ) !== false ) {
                    continue;
                }
                if ( $linkHref == '#' ) {
                    continue;
                }
                $extractedLinks[] = array(
                    'href' => $linkHref,
                );
            }
            foreach ( $extractedLinks as $link ) {
                $short_url = esc_url_raw( cptn_short_url( str_replace( '&amp;', '&', $link['href'] ) ) . "?cptnpoi=" . $queue_id );
                // replace all possible formats of href=
                $message = str_replace( '"' . $link['href'] . '"', '"' . $short_url . '"', $message );
                $message = str_replace( "'" . $link['href'] . "'", "'" . $short_url . "'", $message );
                $message = str_replace( $link['href'] . ' ', $short_url . " ", $message );
                $message = str_replace( $link['href'] . '>', $short_url . ">", $message );
            }
            // mark message as "has shortened urls"
            
            if ( strpos( strtolower( $message ), "</body>" ) !== false ) {
                $message = str_replace( "</body>", PHP_EOL . "<!-- cptn_short_urls -->" . PHP_EOL . "</body>", $message );
            } else {
                $message .= PHP_EOL . "<!-- cptn_short_urls -->" . PHP_EOL;
            }
            
            // update message with shortened URLs
            $query = "UPDATE " . $wpdb->prefix . "cptn_po_queue\r\n   \t\t              SET mail_content = '" . esc_sql( $message ) . "'\r\n\t\t\t\t    WHERE id = " . $queue_id;
            $wpdb->query( $query );
            if ( $wpdb->last_error !== '' ) {
                $wpdb->print_error();
            }
        }
    
    }
    return true;
}
