<?php
   header("Access-Control-Allow-Origin: *");

   ob_start();
   require_once( $_SERVER['DOCUMENT_ROOT'] . '/wp-load.php' );
   ob_end_clean();

   global $wpdb, $wp_query;

   $code = "";
   if(!isset($_POST['code'])) echo "ERROR";
   else
      $code = sanitize_text_field($_POST['code']);

   if($code == "cptnporegisterremote")
	  {
      $domain        = sanitize_text_field($_POST['domain']);		 
	  $hostname    	 = sanitize_text_field($_POST['hostname']);
	  $plugin_url	 = esc_url_raw($_POST['plugin_url']);
	  $ip			 = sanitize_text_field($_POST['ip']);
	  if(strlen($ip)<7)
         $ip = gethostbyname($hostname);

	  $connectable = 1;
	  if($plugin_url)
   		 {
   		 $context = stream_context_create(array("http"=>array("follow_location" => true),"ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false)));
   		 $check = trim(@file_get_contents($plugin_url."webhook/connectiontest.php", false, $context));
   		 if($check !=="OK")
      		{
      		$output = htmlspecialchars_decode(esc_html__('Remote plugin not connectable for master plugin',"campation-postoffice"));
	  		$connectable = 0;
	  		}

		 $query = "SELECT * FROM ".$wpdb->prefix."cptn_po_mailserver
	   	            WHERE plugin_url = '".esc_sql($plugin_url)."'";
		 $mailserver = $wpdb->get_row($query, ARRAY_A);
		 if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

		 if($mailserver)
      	    {
   	        $query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
	                     SET address = '".esc_sql($hostname)."',
				             connectable = '".esc_sql($connectable)."',
					   		 processes = IF(processes IS NULL,1,processes),
							 test_mail_success = NOW(),
				       		 ip = '".esc_sql($ip)."',
							 status = 1
	   	               WHERE plugin_url = '".esc_sql($plugin_url)."'
				 	   	  ";
		    $wpdb->query($query);
	  	 	if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
	  	 	}			  
		 else		   
      	    {
   	  		$query = "INSERT INTO ".$wpdb->prefix."cptn_po_mailserver
	                     SET shortname = 'Remote',
			       	 	     server_type = 'remote',
				       		 address = '".esc_sql($hostname)."',
				       		 connectable = '".esc_sql($connectable)."',
				       		 ip = '".esc_sql($ip)."',
					   		 processes = 1,
							 status = 1,
							 test_mail_success = NOW(),
					   		 plugin_url = '".esc_sql($plugin_url)."webhook/remote-slave.php'
					   		 ";
   	  		$wpdb->query($query);
	  		if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
	  		$mailserver = array();
	  		$mailserver['id'] = $wpdb->insert_id;
	  		$mailserver['ip'] = $ip;
	  		}			  

		 // delete rDNS / blacklists on change of IP
		 if($ip !== $mailserver['ip'])
      	    {
	  		$query = "DELETE FROM ".$wpdb->prefix."cptn_po_mailserver_dnsbl
		               WHERE mailserver = ".$mailserver['id'];
            $wpdb->query($query);
   	        if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

            $query = "UPDATE ".$wpdb->prefix."cptn_po_mailserver
		                 SET dnsbl = 0,
			  	   	 	 	 rdns = 0,
					   		 rdns_record = ''
			           WHERE id = ".$mailserver['id'];
            $wpdb->query($query);
   	  		if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
	  		}    


		 // connect mail server to all domains   
   		 $query = "SELECT * FROM ".$wpdb->prefix."cptn_po_sender_domain";
   		 $domains = $wpdb->get_results($query, ARRAY_A);
   		 foreach($domains AS $domain)
      	    {
   	  		$query = "SELECT * FROM ".$wpdb->prefix."cptn_po_sender_domain_mailserver WHERE domain_id = ".$domain['id']." AND mailserver_id = ".$mailserver['id'];
   	  		$ms = $wpdb->get_row($query, ARRAY_A);
      		if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
      		if(!$ms)
         	   {
		 	   $query = "INSERT INTO ".$wpdb->prefix."cptn_po_sender_domain_mailserver SET domain_id = ".$domain['id'].", mailserver_id = ".$mailserver['id'].", status = 1, server_status = 'OK', dkim_selector = 'po_r".$mailserver['id']."', created = NOW(), updated = NOW()";
   	  	 	   $wpdb->query($query);
   		 	   if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
		 	   }			      
            }

         cptn_po_sender_check();

         }

      else
         $output = "ERROR";

      if(empty($output))
         echo esc_url_raw(CPTNPOPATH.'webhook/cptn-po-remote.php');
      else
         echo esc_html($output);

	  
	  }



      if($code == "cptnporesultremote")
	     {
   		 $slave_id     = sanitize_text_field($_POST['slave_id']);		 
   		 $output       = cptn_recursive_sanitize_array(json_decode(stripslashes($_POST['output']),true));

   		 // save result in database
   		 cptn_po_send_result($slave_id, $output);

   		 // reset slave @ left messages that have not been sent
   		 $query = "UPDATE ".$wpdb->prefix."cptn_po_queue
   		              SET slave = NULL
		            WHERE slave = ".$slave_id." 
			    	  AND executed IS NULL
			    	  AND (UNIX_TIMESTAMP(embargo) <= UNIX_TIMESTAMP(NOW()) OR embargo IS NULL)
			   		  ";
         $wpdb->query($query);

   		 // remove slave from list	  
   		 $query = "UPDATE ".$wpdb->prefix."cptn_po_slave
   		              SET executed = NOW()
		            WHERE id = ".$slave_id;
         $wpdb->query($query);
   		 if($wpdb->last_error) error_log($wpdb->last_error);
		 }




      if($code == "cptnpounregisterremote")
	     {
		 $output = "OK";
		 $plugin_url = esc_url_raw($_POST['plugin_url']);

		 if($plugin_url)
   		    {
   			$query = "SELECT * FROM ".$wpdb->prefix."cptn_po_mailserver
	   	               WHERE plugin_url = '".esc_sql($plugin_url)."'";
            $mailserver = $wpdb->get_row($query, ARRAY_A);
   			if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

   			if($mailserver)
      		   {
   	  		   $query = "DELETE FROM  ".$wpdb->prefix."cptn_po_mailserver
		                  WHERE id = ".$mailserver['id'];
               $wpdb->query($query);
	  		   if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

	  		   $query = "DELETE FROM ".$wpdb->prefix."cptn_po_mailserver_dnsbl
		                  WHERE mailserver = ".$mailserver['id'];
               $wpdb->query($query);
   	  		   if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

	  		   $query = "DELETE FROM ".$wpdb->prefix."cptn_po_mailserver_error
		                  WHERE mailserver = ".$mailserver['id'];
               $wpdb->query($query);
   	  		   if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

	  		   $query = "DELETE FROM ".$wpdb->prefix."cptn_po_mailserver_mxdomain
		                  WHERE mailserver = ".$mailserver['id'];
               $wpdb->query($query);
   	  		   if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}

               // delete mail server from all domains   
   	  		   $query = "SELECT * FROM ".$wpdb->prefix."cptn_po_sender_domain";
   	  		   $domains = $wpdb->get_results($query, ARRAY_A);
   	  		   foreach($domains AS $domain)
         	      {
   	  	 		  $query = "DELETE FROM ".$wpdb->prefix."cptn_po_sender_domain_mailserver WHERE domain_id = ".$domain['id']." AND mailserver_id = ".$mailserver['id'];
   	  	 		  $wpdb->query($query);
      	 		  if($wpdb->last_error !== '') {$wpdb->print_error();error_log($wpdb->print_error());wp_die();}
         		  }
               }
            else	  
      		   $output = "ERROR ".htmlspecialchars_decode(esc_html__("Remote server unknown","campation-postoffice"));
            } 
         else
   		    $output = "ERROR ".htmlspecialchars_decode(esc_html__("Communication error","campation-postoffice"));

         echo esc_html($output);

		 
		 }

   	  	 

?>